# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct RateCardApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `RateCardApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ RateCardApi }) = "https://management.azure.com"

const _returntypes_rate_card_get_RateCardApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ResourceRateCardInfo,
    Regex("^" * replace("0", "x"=>".") * "\$") => ErrorResponse,
)

function _oacinternal_rate_card_get(_api::RateCardApi, filter::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_rate_card_get_RateCardApi, "/subscriptions/{subscriptionId}/providers/Microsoft.Commerce/RateCard", [])
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "\$filter", filter)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", "text/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Enables you to query for the resource/meter metadata and related prices used in a given subscription by Offer ID, Currency, Locale and Region. The metadata associated with the billing meters, including but not limited to service names, types, resources, units of measure, and regions, is subject to change at any time and without notice. If you intend to use this billing data in an automated fashion, please use the billing meter GUID to uniquely identify each billable item. If the billing meter GUID is scheduled to change due to a new billing model, you will be notified in advance of the change. 

Params:
- filter::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: ResourceRateCardInfo, OpenAPI.Clients.ApiResponse
"""
function rate_card_get(_api::RateCardApi, filter::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_rate_card_get(_api, filter, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function rate_card_get(_api::RateCardApi, response_stream::Channel, filter::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_rate_card_get(_api, filter, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export rate_card_get
