# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""RecurringCharge
Indicates a recurring charge is present for this offer.

    RecurringCharge(;
        RecurringCharge=nothing,
        Name=nothing,
        EffectiveDate=nothing,
    )

    - RecurringCharge::Int64 : The amount of recurring charge as per the offer term.
    - Name::String : Name of the offer term
    - EffectiveDate::ZonedDateTime : Indicates the date from which the offer term is effective.
"""
Base.@kwdef mutable struct RecurringCharge <: OpenAPI.APIModel
    RecurringCharge::Union{Nothing, Int64} = nothing
    Name::Union{Nothing, String} = nothing
    EffectiveDate::Union{Nothing, ZonedDateTime} = nothing

    function RecurringCharge(RecurringCharge, Name, EffectiveDate, )
        OpenAPI.validate_property(RecurringCharge, Symbol("RecurringCharge"), RecurringCharge)
        OpenAPI.validate_property(RecurringCharge, Symbol("Name"), Name)
        OpenAPI.validate_property(RecurringCharge, Symbol("EffectiveDate"), EffectiveDate)
        return new(RecurringCharge, Name, EffectiveDate, )
    end
end # type RecurringCharge

const _property_types_RecurringCharge = Dict{Symbol,String}(Symbol("RecurringCharge")=>"Int64", Symbol("Name")=>"String", Symbol("EffectiveDate")=>"ZonedDateTime", )
OpenAPI.property_type(::Type{ RecurringCharge }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_RecurringCharge[name]))}

function check_required(o::RecurringCharge)
    o.Name === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ RecurringCharge }, name::Symbol, val)
    if name === Symbol("Name")
        OpenAPI.validate_param(name, "RecurringCharge", :enum, val, ["Recurring Charge", "Monetary Commitment", "Monetary Credit"])
    end
    if name === Symbol("EffectiveDate")
        OpenAPI.validate_param(name, "RecurringCharge", :format, val, "date-time")
    end
end
