# Julia API client for ComputeManagementClient

The Compute Management Client.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 2020-06-01
- Build package: org.openapitools.codegen.languages.JuliaClientCodegen


## Installation
Place the Julia files generated under the `src` folder in your Julia project. Include ComputeManagementClient.jl in the project code.
It would include the module named ComputeManagementClient.

Documentation is generated as markdown files under the `docs` folder. You can include them in your project documentation.
Documentation is also embedded in Julia which can be used with a Julia specific documentation generator.

## API Endpoints

Class | Method
------------ | -------------
*AvailabilitySetsApi* | [**availability_sets_create_or_update**](docs/AvailabilitySetsApi.md#availability_sets_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/availabilitySets/{availabilitySetName}<br/>
*AvailabilitySetsApi* | [**availability_sets_delete**](docs/AvailabilitySetsApi.md#availability_sets_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/availabilitySets/{availabilitySetName}<br/>
*AvailabilitySetsApi* | [**availability_sets_get**](docs/AvailabilitySetsApi.md#availability_sets_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/availabilitySets/{availabilitySetName}<br/>
*AvailabilitySetsApi* | [**availability_sets_list**](docs/AvailabilitySetsApi.md#availability_sets_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/availabilitySets<br/>
*AvailabilitySetsApi* | [**availability_sets_list_available_sizes**](docs/AvailabilitySetsApi.md#availability_sets_list_available_sizes)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/availabilitySets/{availabilitySetName}/vmSizes<br/>
*AvailabilitySetsApi* | [**availability_sets_list_by_subscription**](docs/AvailabilitySetsApi.md#availability_sets_list_by_subscription)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/availabilitySets<br/>
*AvailabilitySetsApi* | [**availability_sets_update**](docs/AvailabilitySetsApi.md#availability_sets_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/availabilitySets/{availabilitySetName}<br/>
*ComputeOperationsApi* | [**operations_list**](docs/ComputeOperationsApi.md#operations_list)<br/>**GET** /providers/Microsoft.Compute/operations<br/>
*DedicatedHostApi* | [**dedicated_hosts_list_by_host_group**](docs/DedicatedHostApi.md#dedicated_hosts_list_by_host_group)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/hostGroups/{hostGroupName}/hosts<br/>
*DedicatedHostGroupsApi* | [**dedicated_host_groups_create_or_update**](docs/DedicatedHostGroupsApi.md#dedicated_host_groups_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/hostGroups/{hostGroupName}<br/>
*DedicatedHostGroupsApi* | [**dedicated_host_groups_delete**](docs/DedicatedHostGroupsApi.md#dedicated_host_groups_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/hostGroups/{hostGroupName}<br/>
*DedicatedHostGroupsApi* | [**dedicated_host_groups_get**](docs/DedicatedHostGroupsApi.md#dedicated_host_groups_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/hostGroups/{hostGroupName}<br/>
*DedicatedHostGroupsApi* | [**dedicated_host_groups_list_by_resource_group**](docs/DedicatedHostGroupsApi.md#dedicated_host_groups_list_by_resource_group)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/hostGroups<br/>
*DedicatedHostGroupsApi* | [**dedicated_host_groups_list_by_subscription**](docs/DedicatedHostGroupsApi.md#dedicated_host_groups_list_by_subscription)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/hostGroups<br/>
*DedicatedHostGroupsApi* | [**dedicated_host_groups_update**](docs/DedicatedHostGroupsApi.md#dedicated_host_groups_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/hostGroups/{hostGroupName}<br/>
*DedicatedHostsApi* | [**dedicated_hosts_create_or_update**](docs/DedicatedHostsApi.md#dedicated_hosts_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/hostGroups/{hostGroupName}/hosts/{hostName}<br/>
*DedicatedHostsApi* | [**dedicated_hosts_delete**](docs/DedicatedHostsApi.md#dedicated_hosts_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/hostGroups/{hostGroupName}/hosts/{hostName}<br/>
*DedicatedHostsApi* | [**dedicated_hosts_get**](docs/DedicatedHostsApi.md#dedicated_hosts_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/hostGroups/{hostGroupName}/hosts/{hostName}<br/>
*DedicatedHostsApi* | [**dedicated_hosts_update**](docs/DedicatedHostsApi.md#dedicated_hosts_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/hostGroups/{hostGroupName}/hosts/{hostName}<br/>
*ImagesApi* | [**images_create_or_update**](docs/ImagesApi.md#images_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/images/{imageName}<br/>
*ImagesApi* | [**images_delete**](docs/ImagesApi.md#images_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/images/{imageName}<br/>
*ImagesApi* | [**images_get**](docs/ImagesApi.md#images_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/images/{imageName}<br/>
*ImagesApi* | [**images_list**](docs/ImagesApi.md#images_list)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/images<br/>
*ImagesApi* | [**images_list_by_resource_group**](docs/ImagesApi.md#images_list_by_resource_group)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/images<br/>
*ImagesApi* | [**images_update**](docs/ImagesApi.md#images_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/images/{imageName}<br/>
*LogAnalyticsApi* | [**log_analytics_export_request_rate_by_interval**](docs/LogAnalyticsApi.md#log_analytics_export_request_rate_by_interval)<br/>**POST** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/logAnalytics/apiAccess/getRequestRateByInterval<br/>
*LogAnalyticsApi* | [**log_analytics_export_throttled_requests**](docs/LogAnalyticsApi.md#log_analytics_export_throttled_requests)<br/>**POST** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/logAnalytics/apiAccess/getThrottledRequests<br/>
*ProximityPlacementGroupsApi* | [**proximity_placement_groups_create_or_update**](docs/ProximityPlacementGroupsApi.md#proximity_placement_groups_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/proximityPlacementGroups/{proximityPlacementGroupName}<br/>
*ProximityPlacementGroupsApi* | [**proximity_placement_groups_delete**](docs/ProximityPlacementGroupsApi.md#proximity_placement_groups_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/proximityPlacementGroups/{proximityPlacementGroupName}<br/>
*ProximityPlacementGroupsApi* | [**proximity_placement_groups_get**](docs/ProximityPlacementGroupsApi.md#proximity_placement_groups_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/proximityPlacementGroups/{proximityPlacementGroupName}<br/>
*ProximityPlacementGroupsApi* | [**proximity_placement_groups_list_by_resource_group**](docs/ProximityPlacementGroupsApi.md#proximity_placement_groups_list_by_resource_group)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/proximityPlacementGroups<br/>
*ProximityPlacementGroupsApi* | [**proximity_placement_groups_list_by_subscription**](docs/ProximityPlacementGroupsApi.md#proximity_placement_groups_list_by_subscription)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/proximityPlacementGroups<br/>
*ProximityPlacementGroupsApi* | [**proximity_placement_groups_update**](docs/ProximityPlacementGroupsApi.md#proximity_placement_groups_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/proximityPlacementGroups/{proximityPlacementGroupName}<br/>
*SshPublicKeysApi* | [**ssh_public_keys_create**](docs/SshPublicKeysApi.md#ssh_public_keys_create)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/sshPublicKeys/{sshPublicKeyName}<br/>
*SshPublicKeysApi* | [**ssh_public_keys_delete**](docs/SshPublicKeysApi.md#ssh_public_keys_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/sshPublicKeys/{sshPublicKeyName}<br/>
*SshPublicKeysApi* | [**ssh_public_keys_generate_key_pair**](docs/SshPublicKeysApi.md#ssh_public_keys_generate_key_pair)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/sshPublicKeys/{sshPublicKeyName}/generateKeyPair<br/>
*SshPublicKeysApi* | [**ssh_public_keys_get**](docs/SshPublicKeysApi.md#ssh_public_keys_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/sshPublicKeys/{sshPublicKeyName}<br/>
*SshPublicKeysApi* | [**ssh_public_keys_list_by_resource_group**](docs/SshPublicKeysApi.md#ssh_public_keys_list_by_resource_group)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/sshPublicKeys<br/>
*SshPublicKeysApi* | [**ssh_public_keys_list_by_subscription**](docs/SshPublicKeysApi.md#ssh_public_keys_list_by_subscription)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/sshPublicKeys<br/>
*SshPublicKeysApi* | [**ssh_public_keys_update**](docs/SshPublicKeysApi.md#ssh_public_keys_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/sshPublicKeys/{sshPublicKeyName}<br/>
*UsageApi* | [**usage_list**](docs/UsageApi.md#usage_list)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/usages<br/>
*VirtualMachineExtensionImagesApi* | [**virtual_machine_extension_images_get**](docs/VirtualMachineExtensionImagesApi.md#virtual_machine_extension_images_get)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/publishers/{publisherName}/artifacttypes/vmextension/types/{type}/versions/{version}<br/>
*VirtualMachineExtensionImagesApi* | [**virtual_machine_extension_images_list_types**](docs/VirtualMachineExtensionImagesApi.md#virtual_machine_extension_images_list_types)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/publishers/{publisherName}/artifacttypes/vmextension/types<br/>
*VirtualMachineExtensionImagesApi* | [**virtual_machine_extension_images_list_versions**](docs/VirtualMachineExtensionImagesApi.md#virtual_machine_extension_images_list_versions)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/publishers/{publisherName}/artifacttypes/vmextension/types/{type}/versions<br/>
*VirtualMachineExtensionsApi* | [**virtual_machine_extensions_create_or_update**](docs/VirtualMachineExtensionsApi.md#virtual_machine_extensions_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/extensions/{vmExtensionName}<br/>
*VirtualMachineExtensionsApi* | [**virtual_machine_extensions_delete**](docs/VirtualMachineExtensionsApi.md#virtual_machine_extensions_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/extensions/{vmExtensionName}<br/>
*VirtualMachineExtensionsApi* | [**virtual_machine_extensions_get**](docs/VirtualMachineExtensionsApi.md#virtual_machine_extensions_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/extensions/{vmExtensionName}<br/>
*VirtualMachineExtensionsApi* | [**virtual_machine_extensions_list**](docs/VirtualMachineExtensionsApi.md#virtual_machine_extensions_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/extensions<br/>
*VirtualMachineExtensionsApi* | [**virtual_machine_extensions_update**](docs/VirtualMachineExtensionsApi.md#virtual_machine_extensions_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/extensions/{vmExtensionName}<br/>
*VirtualMachineImagesApi* | [**virtual_machine_images_get**](docs/VirtualMachineImagesApi.md#virtual_machine_images_get)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/publishers/{publisherName}/artifacttypes/vmimage/offers/{offer}/skus/{skus}/versions/{version}<br/>
*VirtualMachineImagesApi* | [**virtual_machine_images_list**](docs/VirtualMachineImagesApi.md#virtual_machine_images_list)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/publishers/{publisherName}/artifacttypes/vmimage/offers/{offer}/skus/{skus}/versions<br/>
*VirtualMachineImagesApi* | [**virtual_machine_images_list_offers**](docs/VirtualMachineImagesApi.md#virtual_machine_images_list_offers)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/publishers/{publisherName}/artifacttypes/vmimage/offers<br/>
*VirtualMachineImagesApi* | [**virtual_machine_images_list_publishers**](docs/VirtualMachineImagesApi.md#virtual_machine_images_list_publishers)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/publishers<br/>
*VirtualMachineImagesApi* | [**virtual_machine_images_list_skus**](docs/VirtualMachineImagesApi.md#virtual_machine_images_list_skus)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/publishers/{publisherName}/artifacttypes/vmimage/offers/{offer}/skus<br/>
*VirtualMachineScaleSetExtensionsApi* | [**virtual_machine_scale_set_extensions_create_or_update**](docs/VirtualMachineScaleSetExtensionsApi.md#virtual_machine_scale_set_extensions_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/extensions/{vmssExtensionName}<br/>
*VirtualMachineScaleSetExtensionsApi* | [**virtual_machine_scale_set_extensions_delete**](docs/VirtualMachineScaleSetExtensionsApi.md#virtual_machine_scale_set_extensions_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/extensions/{vmssExtensionName}<br/>
*VirtualMachineScaleSetExtensionsApi* | [**virtual_machine_scale_set_extensions_get**](docs/VirtualMachineScaleSetExtensionsApi.md#virtual_machine_scale_set_extensions_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/extensions/{vmssExtensionName}<br/>
*VirtualMachineScaleSetExtensionsApi* | [**virtual_machine_scale_set_extensions_list**](docs/VirtualMachineScaleSetExtensionsApi.md#virtual_machine_scale_set_extensions_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/extensions<br/>
*VirtualMachineScaleSetExtensionsApi* | [**virtual_machine_scale_set_extensions_update**](docs/VirtualMachineScaleSetExtensionsApi.md#virtual_machine_scale_set_extensions_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/extensions/{vmssExtensionName}<br/>
*VirtualMachineScaleSetRollingUpgradesApi* | [**virtual_machine_scale_set_rolling_upgrades_cancel**](docs/VirtualMachineScaleSetRollingUpgradesApi.md#virtual_machine_scale_set_rolling_upgrades_cancel)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/rollingUpgrades/cancel<br/>
*VirtualMachineScaleSetRollingUpgradesApi* | [**virtual_machine_scale_set_rolling_upgrades_get_latest**](docs/VirtualMachineScaleSetRollingUpgradesApi.md#virtual_machine_scale_set_rolling_upgrades_get_latest)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/rollingUpgrades/latest<br/>
*VirtualMachineScaleSetRollingUpgradesApi* | [**virtual_machine_scale_set_rolling_upgrades_start_extension_upgrade**](docs/VirtualMachineScaleSetRollingUpgradesApi.md#virtual_machine_scale_set_rolling_upgrades_start_extension_upgrade)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/extensionRollingUpgrade<br/>
*VirtualMachineScaleSetRollingUpgradesApi* | [**virtual_machine_scale_set_rolling_upgrades_start_o_s_upgrade**](docs/VirtualMachineScaleSetRollingUpgradesApi.md#virtual_machine_scale_set_rolling_upgrades_start_o_s_upgrade)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/osRollingUpgrade<br/>
*VirtualMachineScaleSetVMExtensionsApi* | [**virtual_machine_scale_set_v_m_extensions_create_or_update**](docs/VirtualMachineScaleSetVMExtensionsApi.md#virtual_machine_scale_set_v_m_extensions_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualMachines/{instanceId}/extensions/{vmExtensionName}<br/>
*VirtualMachineScaleSetVMExtensionsApi* | [**virtual_machine_scale_set_v_m_extensions_delete**](docs/VirtualMachineScaleSetVMExtensionsApi.md#virtual_machine_scale_set_v_m_extensions_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualMachines/{instanceId}/extensions/{vmExtensionName}<br/>
*VirtualMachineScaleSetVMExtensionsApi* | [**virtual_machine_scale_set_v_m_extensions_get**](docs/VirtualMachineScaleSetVMExtensionsApi.md#virtual_machine_scale_set_v_m_extensions_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualMachines/{instanceId}/extensions/{vmExtensionName}<br/>
*VirtualMachineScaleSetVMExtensionsApi* | [**virtual_machine_scale_set_v_m_extensions_list**](docs/VirtualMachineScaleSetVMExtensionsApi.md#virtual_machine_scale_set_v_m_extensions_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualMachines/{instanceId}/extensions<br/>
*VirtualMachineScaleSetVMExtensionsApi* | [**virtual_machine_scale_set_v_m_extensions_update**](docs/VirtualMachineScaleSetVMExtensionsApi.md#virtual_machine_scale_set_v_m_extensions_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualMachines/{instanceId}/extensions/{vmExtensionName}<br/>
*VirtualMachineScaleSetVMsApi* | [**virtual_machine_scale_set_v_ms_deallocate**](docs/VirtualMachineScaleSetVMsApi.md#virtual_machine_scale_set_v_ms_deallocate)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/deallocate<br/>
*VirtualMachineScaleSetVMsApi* | [**virtual_machine_scale_set_v_ms_delete**](docs/VirtualMachineScaleSetVMsApi.md#virtual_machine_scale_set_v_ms_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}<br/>
*VirtualMachineScaleSetVMsApi* | [**virtual_machine_scale_set_v_ms_get**](docs/VirtualMachineScaleSetVMsApi.md#virtual_machine_scale_set_v_ms_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}<br/>
*VirtualMachineScaleSetVMsApi* | [**virtual_machine_scale_set_v_ms_get_instance_view**](docs/VirtualMachineScaleSetVMsApi.md#virtual_machine_scale_set_v_ms_get_instance_view)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/instanceView<br/>
*VirtualMachineScaleSetVMsApi* | [**virtual_machine_scale_set_v_ms_list**](docs/VirtualMachineScaleSetVMsApi.md#virtual_machine_scale_set_v_ms_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{virtualMachineScaleSetName}/virtualMachines<br/>
*VirtualMachineScaleSetVMsApi* | [**virtual_machine_scale_set_v_ms_perform_maintenance**](docs/VirtualMachineScaleSetVMsApi.md#virtual_machine_scale_set_v_ms_perform_maintenance)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/performMaintenance<br/>
*VirtualMachineScaleSetVMsApi* | [**virtual_machine_scale_set_v_ms_power_off**](docs/VirtualMachineScaleSetVMsApi.md#virtual_machine_scale_set_v_ms_power_off)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/poweroff<br/>
*VirtualMachineScaleSetVMsApi* | [**virtual_machine_scale_set_v_ms_redeploy**](docs/VirtualMachineScaleSetVMsApi.md#virtual_machine_scale_set_v_ms_redeploy)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/redeploy<br/>
*VirtualMachineScaleSetVMsApi* | [**virtual_machine_scale_set_v_ms_reimage**](docs/VirtualMachineScaleSetVMsApi.md#virtual_machine_scale_set_v_ms_reimage)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/reimage<br/>
*VirtualMachineScaleSetVMsApi* | [**virtual_machine_scale_set_v_ms_reimage_all**](docs/VirtualMachineScaleSetVMsApi.md#virtual_machine_scale_set_v_ms_reimage_all)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/reimageall<br/>
*VirtualMachineScaleSetVMsApi* | [**virtual_machine_scale_set_v_ms_restart**](docs/VirtualMachineScaleSetVMsApi.md#virtual_machine_scale_set_v_ms_restart)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/restart<br/>
*VirtualMachineScaleSetVMsApi* | [**virtual_machine_scale_set_v_ms_retrieve_boot_diagnostics_data**](docs/VirtualMachineScaleSetVMsApi.md#virtual_machine_scale_set_v_ms_retrieve_boot_diagnostics_data)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/retrieveBootDiagnosticsData<br/>
*VirtualMachineScaleSetVMsApi* | [**virtual_machine_scale_set_v_ms_simulate_eviction**](docs/VirtualMachineScaleSetVMsApi.md#virtual_machine_scale_set_v_ms_simulate_eviction)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualMachines/{instanceId}/simulateEviction<br/>
*VirtualMachineScaleSetVMsApi* | [**virtual_machine_scale_set_v_ms_start**](docs/VirtualMachineScaleSetVMsApi.md#virtual_machine_scale_set_v_ms_start)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/start<br/>
*VirtualMachineScaleSetVMsApi* | [**virtual_machine_scale_set_v_ms_update**](docs/VirtualMachineScaleSetVMsApi.md#virtual_machine_scale_set_v_ms_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_convert_to_single_placement_group**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_convert_to_single_placement_group)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/convertToSinglePlacementGroup<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_create_or_update**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_deallocate**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_deallocate)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/deallocate<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_delete**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_delete_instances**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_delete_instances)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/delete<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_force_recovery_service_fabric_platform_update_domain_walk**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_force_recovery_service_fabric_platform_update_domain_walk)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/forceRecoveryServiceFabricPlatformUpdateDomainWalk<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_get**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_get_instance_view**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_get_instance_view)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/instanceView<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_get_o_s_upgrade_history**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_get_o_s_upgrade_history)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/osUpgradeHistory<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_list**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_list_all**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_list_all)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/virtualMachineScaleSets<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_list_skus**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_list_skus)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/skus<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_perform_maintenance**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_perform_maintenance)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/performMaintenance<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_power_off**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_power_off)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/poweroff<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_redeploy**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_redeploy)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/redeploy<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_reimage**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_reimage)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/reimage<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_reimage_all**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_reimage_all)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/reimageall<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_restart**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_restart)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/restart<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_set_orchestration_service_state**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_set_orchestration_service_state)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/setOrchestrationServiceState<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_start**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_start)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/start<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_update**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}<br/>
*VirtualMachineScaleSetsApi* | [**virtual_machine_scale_sets_update_instances**](docs/VirtualMachineScaleSetsApi.md#virtual_machine_scale_sets_update_instances)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/manualupgrade<br/>
*VirtualMachineSizesApi* | [**virtual_machine_sizes_list**](docs/VirtualMachineSizesApi.md#virtual_machine_sizes_list)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/vmSizes<br/>
*VirtualMachinesApi* | [**virtual_machines_assess_patches**](docs/VirtualMachinesApi.md#virtual_machines_assess_patches)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/assessPatches<br/>
*VirtualMachinesApi* | [**virtual_machines_capture**](docs/VirtualMachinesApi.md#virtual_machines_capture)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/capture<br/>
*VirtualMachinesApi* | [**virtual_machines_convert_to_managed_disks**](docs/VirtualMachinesApi.md#virtual_machines_convert_to_managed_disks)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/convertToManagedDisks<br/>
*VirtualMachinesApi* | [**virtual_machines_create_or_update**](docs/VirtualMachinesApi.md#virtual_machines_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}<br/>
*VirtualMachinesApi* | [**virtual_machines_deallocate**](docs/VirtualMachinesApi.md#virtual_machines_deallocate)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/deallocate<br/>
*VirtualMachinesApi* | [**virtual_machines_delete**](docs/VirtualMachinesApi.md#virtual_machines_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}<br/>
*VirtualMachinesApi* | [**virtual_machines_generalize**](docs/VirtualMachinesApi.md#virtual_machines_generalize)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/generalize<br/>
*VirtualMachinesApi* | [**virtual_machines_get**](docs/VirtualMachinesApi.md#virtual_machines_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}<br/>
*VirtualMachinesApi* | [**virtual_machines_instance_view**](docs/VirtualMachinesApi.md#virtual_machines_instance_view)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/instanceView<br/>
*VirtualMachinesApi* | [**virtual_machines_list**](docs/VirtualMachinesApi.md#virtual_machines_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines<br/>
*VirtualMachinesApi* | [**virtual_machines_list_all**](docs/VirtualMachinesApi.md#virtual_machines_list_all)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/virtualMachines<br/>
*VirtualMachinesApi* | [**virtual_machines_list_available_sizes**](docs/VirtualMachinesApi.md#virtual_machines_list_available_sizes)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/vmSizes<br/>
*VirtualMachinesApi* | [**virtual_machines_list_by_location**](docs/VirtualMachinesApi.md#virtual_machines_list_by_location)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/virtualMachines<br/>
*VirtualMachinesApi* | [**virtual_machines_perform_maintenance**](docs/VirtualMachinesApi.md#virtual_machines_perform_maintenance)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/performMaintenance<br/>
*VirtualMachinesApi* | [**virtual_machines_power_off**](docs/VirtualMachinesApi.md#virtual_machines_power_off)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/powerOff<br/>
*VirtualMachinesApi* | [**virtual_machines_reapply**](docs/VirtualMachinesApi.md#virtual_machines_reapply)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/reapply<br/>
*VirtualMachinesApi* | [**virtual_machines_redeploy**](docs/VirtualMachinesApi.md#virtual_machines_redeploy)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/redeploy<br/>
*VirtualMachinesApi* | [**virtual_machines_reimage**](docs/VirtualMachinesApi.md#virtual_machines_reimage)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/reimage<br/>
*VirtualMachinesApi* | [**virtual_machines_restart**](docs/VirtualMachinesApi.md#virtual_machines_restart)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/restart<br/>
*VirtualMachinesApi* | [**virtual_machines_retrieve_boot_diagnostics_data**](docs/VirtualMachinesApi.md#virtual_machines_retrieve_boot_diagnostics_data)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/retrieveBootDiagnosticsData<br/>
*VirtualMachinesApi* | [**virtual_machines_simulate_eviction**](docs/VirtualMachinesApi.md#virtual_machines_simulate_eviction)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/simulateEviction<br/>
*VirtualMachinesApi* | [**virtual_machines_start**](docs/VirtualMachinesApi.md#virtual_machines_start)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}/start<br/>
*VirtualMachinesApi* | [**virtual_machines_update**](docs/VirtualMachinesApi.md#virtual_machines_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachines/{vmName}<br/>


## Models

 - [AdditionalCapabilities](docs/AdditionalCapabilities.md)
 - [AdditionalUnattendContent](docs/AdditionalUnattendContent.md)
 - [ApiEntityReference](docs/ApiEntityReference.md)
 - [ApiError](docs/ApiError.md)
 - [ApiErrorBase](docs/ApiErrorBase.md)
 - [AutomaticOSUpgradePolicy](docs/AutomaticOSUpgradePolicy.md)
 - [AutomaticOSUpgradeProperties](docs/AutomaticOSUpgradeProperties.md)
 - [AutomaticRepairsPolicy](docs/AutomaticRepairsPolicy.md)
 - [AvailabilitySet](docs/AvailabilitySet.md)
 - [AvailabilitySetAllOf](docs/AvailabilitySetAllOf.md)
 - [AvailabilitySetListResult](docs/AvailabilitySetListResult.md)
 - [AvailabilitySetProperties](docs/AvailabilitySetProperties.md)
 - [AvailabilitySetSkuType](docs/AvailabilitySetSkuType.md)
 - [AvailabilitySetUpdate](docs/AvailabilitySetUpdate.md)
 - [BillingProfile](docs/BillingProfile.md)
 - [BootDiagnostics](docs/BootDiagnostics.md)
 - [BootDiagnosticsInstanceView](docs/BootDiagnosticsInstanceView.md)
 - [Caching](docs/Caching.md)
 - [CloudError](docs/CloudError.md)
 - [ComputeOperationListResult](docs/ComputeOperationListResult.md)
 - [ComputeOperationValue](docs/ComputeOperationValue.md)
 - [ComputeOperationValueDisplay](docs/ComputeOperationValueDisplay.md)
 - [CreateOption](docs/CreateOption.md)
 - [DataDisk](docs/DataDisk.md)
 - [DataDiskImage](docs/DataDiskImage.md)
 - [DedicatedHost](docs/DedicatedHost.md)
 - [DedicatedHostAllocatableVM](docs/DedicatedHostAllocatableVM.md)
 - [DedicatedHostAvailableCapacity](docs/DedicatedHostAvailableCapacity.md)
 - [DedicatedHostGroup](docs/DedicatedHostGroup.md)
 - [DedicatedHostGroupInstanceView](docs/DedicatedHostGroupInstanceView.md)
 - [DedicatedHostGroupListResult](docs/DedicatedHostGroupListResult.md)
 - [DedicatedHostGroupProperties](docs/DedicatedHostGroupProperties.md)
 - [DedicatedHostGroupUpdate](docs/DedicatedHostGroupUpdate.md)
 - [DedicatedHostInstanceView](docs/DedicatedHostInstanceView.md)
 - [DedicatedHostInstanceViewWithName](docs/DedicatedHostInstanceViewWithName.md)
 - [DedicatedHostLicenseType](docs/DedicatedHostLicenseType.md)
 - [DedicatedHostListResult](docs/DedicatedHostListResult.md)
 - [DedicatedHostProperties](docs/DedicatedHostProperties.md)
 - [DedicatedHostUpdate](docs/DedicatedHostUpdate.md)
 - [DiagnosticsProfile](docs/DiagnosticsProfile.md)
 - [DiffDiskOption](docs/DiffDiskOption.md)
 - [DiffDiskPlacement](docs/DiffDiskPlacement.md)
 - [DiffDiskSettings](docs/DiffDiskSettings.md)
 - [DisallowedConfiguration](docs/DisallowedConfiguration.md)
 - [DiskEncryptionSetParameters](docs/DiskEncryptionSetParameters.md)
 - [DiskEncryptionSettings](docs/DiskEncryptionSettings.md)
 - [DiskInstanceView](docs/DiskInstanceView.md)
 - [EvictionPolicy](docs/EvictionPolicy.md)
 - [HardwareProfile](docs/HardwareProfile.md)
 - [HyperVGenerationType](docs/HyperVGenerationType.md)
 - [Image](docs/Image.md)
 - [ImageAllOf](docs/ImageAllOf.md)
 - [ImageDataDisk](docs/ImageDataDisk.md)
 - [ImageDisk](docs/ImageDisk.md)
 - [ImageListResult](docs/ImageListResult.md)
 - [ImageOSDisk](docs/ImageOSDisk.md)
 - [ImageProperties](docs/ImageProperties.md)
 - [ImageReference](docs/ImageReference.md)
 - [ImageReferenceAllOf](docs/ImageReferenceAllOf.md)
 - [ImageStorageProfile](docs/ImageStorageProfile.md)
 - [ImageUpdate](docs/ImageUpdate.md)
 - [InnerError](docs/InnerError.md)
 - [InstanceViewStatus](docs/InstanceViewStatus.md)
 - [KeyVaultKeyReference](docs/KeyVaultKeyReference.md)
 - [KeyVaultSecretReference](docs/KeyVaultSecretReference.md)
 - [LinuxConfiguration](docs/LinuxConfiguration.md)
 - [ListUsagesResult](docs/ListUsagesResult.md)
 - [LogAnalyticsInputBase](docs/LogAnalyticsInputBase.md)
 - [LogAnalyticsOperationResult](docs/LogAnalyticsOperationResult.md)
 - [LogAnalyticsOutput](docs/LogAnalyticsOutput.md)
 - [MaintenanceRedeployStatus](docs/MaintenanceRedeployStatus.md)
 - [ManagedDiskParameters](docs/ManagedDiskParameters.md)
 - [ManagedDiskParametersAllOf](docs/ManagedDiskParametersAllOf.md)
 - [NetworkInterfaceReference](docs/NetworkInterfaceReference.md)
 - [NetworkInterfaceReferenceAllOf](docs/NetworkInterfaceReferenceAllOf.md)
 - [NetworkInterfaceReferenceProperties](docs/NetworkInterfaceReferenceProperties.md)
 - [NetworkProfile](docs/NetworkProfile.md)
 - [OSDisk](docs/OSDisk.md)
 - [OSDiskImage](docs/OSDiskImage.md)
 - [OSProfile](docs/OSProfile.md)
 - [OrchestrationServiceStateInput](docs/OrchestrationServiceStateInput.md)
 - [OrchestrationServiceSummary](docs/OrchestrationServiceSummary.md)
 - [PatchSettings](docs/PatchSettings.md)
 - [Plan](docs/Plan.md)
 - [Priority](docs/Priority.md)
 - [ProximityPlacementGroup](docs/ProximityPlacementGroup.md)
 - [ProximityPlacementGroupListResult](docs/ProximityPlacementGroupListResult.md)
 - [ProximityPlacementGroupProperties](docs/ProximityPlacementGroupProperties.md)
 - [ProximityPlacementGroupUpdate](docs/ProximityPlacementGroupUpdate.md)
 - [PurchasePlan](docs/PurchasePlan.md)
 - [RecoveryWalkResponse](docs/RecoveryWalkResponse.md)
 - [RequestRateByIntervalInput](docs/RequestRateByIntervalInput.md)
 - [Resource](docs/Resource.md)
 - [RetrieveBootDiagnosticsDataResult](docs/RetrieveBootDiagnosticsDataResult.md)
 - [RollbackStatusInfo](docs/RollbackStatusInfo.md)
 - [RollingUpgradePolicy](docs/RollingUpgradePolicy.md)
 - [RollingUpgradeProgressInfo](docs/RollingUpgradeProgressInfo.md)
 - [RollingUpgradeRunningStatus](docs/RollingUpgradeRunningStatus.md)
 - [RollingUpgradeStatusInfo](docs/RollingUpgradeStatusInfo.md)
 - [RollingUpgradeStatusInfoProperties](docs/RollingUpgradeStatusInfoProperties.md)
 - [ScaleInPolicy](docs/ScaleInPolicy.md)
 - [ScheduledEventsProfile](docs/ScheduledEventsProfile.md)
 - [SecurityProfile](docs/SecurityProfile.md)
 - [Sku](docs/Sku.md)
 - [SshConfiguration](docs/SshConfiguration.md)
 - [SshPublicKey](docs/SshPublicKey.md)
 - [SshPublicKeyGenerateKeyPairResult](docs/SshPublicKeyGenerateKeyPairResult.md)
 - [SshPublicKeyResource](docs/SshPublicKeyResource.md)
 - [SshPublicKeyResourceProperties](docs/SshPublicKeyResourceProperties.md)
 - [SshPublicKeyUpdateResource](docs/SshPublicKeyUpdateResource.md)
 - [SshPublicKeysGroupListResult](docs/SshPublicKeysGroupListResult.md)
 - [StorageAccountType](docs/StorageAccountType.md)
 - [StorageProfile](docs/StorageProfile.md)
 - [SubResource](docs/SubResource.md)
 - [SubResourceReadOnly](docs/SubResourceReadOnly.md)
 - [SubResourceWithColocationStatus](docs/SubResourceWithColocationStatus.md)
 - [TerminateNotificationProfile](docs/TerminateNotificationProfile.md)
 - [ThrottledRequestsInput](docs/ThrottledRequestsInput.md)
 - [UpdateResource](docs/UpdateResource.md)
 - [UpgradeOperationHistoricalStatusInfo](docs/UpgradeOperationHistoricalStatusInfo.md)
 - [UpgradeOperationHistoricalStatusInfoProperties](docs/UpgradeOperationHistoricalStatusInfoProperties.md)
 - [UpgradeOperationHistoryStatus](docs/UpgradeOperationHistoryStatus.md)
 - [UpgradePolicy](docs/UpgradePolicy.md)
 - [Usage](docs/Usage.md)
 - [UsageName](docs/UsageName.md)
 - [VMScaleSetConvertToSinglePlacementGroupInput](docs/VMScaleSetConvertToSinglePlacementGroupInput.md)
 - [VaultCertificate](docs/VaultCertificate.md)
 - [VaultSecretGroup](docs/VaultSecretGroup.md)
 - [VirtualHardDisk](docs/VirtualHardDisk.md)
 - [VirtualMachine](docs/VirtualMachine.md)
 - [VirtualMachineAgentInstanceView](docs/VirtualMachineAgentInstanceView.md)
 - [VirtualMachineAllOf](docs/VirtualMachineAllOf.md)
 - [VirtualMachineAssessPatchesResult](docs/VirtualMachineAssessPatchesResult.md)
 - [VirtualMachineCaptureParameters](docs/VirtualMachineCaptureParameters.md)
 - [VirtualMachineCaptureResult](docs/VirtualMachineCaptureResult.md)
 - [VirtualMachineCaptureResultAllOf](docs/VirtualMachineCaptureResultAllOf.md)
 - [VirtualMachineExtension](docs/VirtualMachineExtension.md)
 - [VirtualMachineExtensionAllOf](docs/VirtualMachineExtensionAllOf.md)
 - [VirtualMachineExtensionHandlerInstanceView](docs/VirtualMachineExtensionHandlerInstanceView.md)
 - [VirtualMachineExtensionImage](docs/VirtualMachineExtensionImage.md)
 - [VirtualMachineExtensionImageAllOf](docs/VirtualMachineExtensionImageAllOf.md)
 - [VirtualMachineExtensionImageProperties](docs/VirtualMachineExtensionImageProperties.md)
 - [VirtualMachineExtensionInstanceView](docs/VirtualMachineExtensionInstanceView.md)
 - [VirtualMachineExtensionProperties](docs/VirtualMachineExtensionProperties.md)
 - [VirtualMachineExtensionUpdate](docs/VirtualMachineExtensionUpdate.md)
 - [VirtualMachineExtensionUpdateProperties](docs/VirtualMachineExtensionUpdateProperties.md)
 - [VirtualMachineExtensionsListResult](docs/VirtualMachineExtensionsListResult.md)
 - [VirtualMachineHealthStatus](docs/VirtualMachineHealthStatus.md)
 - [VirtualMachineIdentity](docs/VirtualMachineIdentity.md)
 - [VirtualMachineIdentityUserAssignedIdentitiesValue](docs/VirtualMachineIdentityUserAssignedIdentitiesValue.md)
 - [VirtualMachineImage](docs/VirtualMachineImage.md)
 - [VirtualMachineImageAllOf](docs/VirtualMachineImageAllOf.md)
 - [VirtualMachineImageProperties](docs/VirtualMachineImageProperties.md)
 - [VirtualMachineImageResource](docs/VirtualMachineImageResource.md)
 - [VirtualMachineImageResourceAllOf](docs/VirtualMachineImageResourceAllOf.md)
 - [VirtualMachineInstanceView](docs/VirtualMachineInstanceView.md)
 - [VirtualMachineListResult](docs/VirtualMachineListResult.md)
 - [VirtualMachineProperties](docs/VirtualMachineProperties.md)
 - [VirtualMachineReimageParameters](docs/VirtualMachineReimageParameters.md)
 - [VirtualMachineScaleSet](docs/VirtualMachineScaleSet.md)
 - [VirtualMachineScaleSetAllOf](docs/VirtualMachineScaleSetAllOf.md)
 - [VirtualMachineScaleSetDataDisk](docs/VirtualMachineScaleSetDataDisk.md)
 - [VirtualMachineScaleSetExtension](docs/VirtualMachineScaleSetExtension.md)
 - [VirtualMachineScaleSetExtensionAllOf](docs/VirtualMachineScaleSetExtensionAllOf.md)
 - [VirtualMachineScaleSetExtensionListResult](docs/VirtualMachineScaleSetExtensionListResult.md)
 - [VirtualMachineScaleSetExtensionProfile](docs/VirtualMachineScaleSetExtensionProfile.md)
 - [VirtualMachineScaleSetExtensionProperties](docs/VirtualMachineScaleSetExtensionProperties.md)
 - [VirtualMachineScaleSetExtensionUpdate](docs/VirtualMachineScaleSetExtensionUpdate.md)
 - [VirtualMachineScaleSetIPConfiguration](docs/VirtualMachineScaleSetIPConfiguration.md)
 - [VirtualMachineScaleSetIPConfigurationAllOf](docs/VirtualMachineScaleSetIPConfigurationAllOf.md)
 - [VirtualMachineScaleSetIPConfigurationProperties](docs/VirtualMachineScaleSetIPConfigurationProperties.md)
 - [VirtualMachineScaleSetIdentity](docs/VirtualMachineScaleSetIdentity.md)
 - [VirtualMachineScaleSetInstanceView](docs/VirtualMachineScaleSetInstanceView.md)
 - [VirtualMachineScaleSetInstanceViewStatusesSummary](docs/VirtualMachineScaleSetInstanceViewStatusesSummary.md)
 - [VirtualMachineScaleSetIpTag](docs/VirtualMachineScaleSetIpTag.md)
 - [VirtualMachineScaleSetListOSUpgradeHistory](docs/VirtualMachineScaleSetListOSUpgradeHistory.md)
 - [VirtualMachineScaleSetListResult](docs/VirtualMachineScaleSetListResult.md)
 - [VirtualMachineScaleSetListSkusResult](docs/VirtualMachineScaleSetListSkusResult.md)
 - [VirtualMachineScaleSetListWithLinkResult](docs/VirtualMachineScaleSetListWithLinkResult.md)
 - [VirtualMachineScaleSetManagedDiskParameters](docs/VirtualMachineScaleSetManagedDiskParameters.md)
 - [VirtualMachineScaleSetNetworkConfiguration](docs/VirtualMachineScaleSetNetworkConfiguration.md)
 - [VirtualMachineScaleSetNetworkConfigurationAllOf](docs/VirtualMachineScaleSetNetworkConfigurationAllOf.md)
 - [VirtualMachineScaleSetNetworkConfigurationDnsSettings](docs/VirtualMachineScaleSetNetworkConfigurationDnsSettings.md)
 - [VirtualMachineScaleSetNetworkConfigurationProperties](docs/VirtualMachineScaleSetNetworkConfigurationProperties.md)
 - [VirtualMachineScaleSetNetworkProfile](docs/VirtualMachineScaleSetNetworkProfile.md)
 - [VirtualMachineScaleSetOSDisk](docs/VirtualMachineScaleSetOSDisk.md)
 - [VirtualMachineScaleSetOSProfile](docs/VirtualMachineScaleSetOSProfile.md)
 - [VirtualMachineScaleSetProperties](docs/VirtualMachineScaleSetProperties.md)
 - [VirtualMachineScaleSetPublicIPAddressConfiguration](docs/VirtualMachineScaleSetPublicIPAddressConfiguration.md)
 - [VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettings](docs/VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettings.md)
 - [VirtualMachineScaleSetPublicIPAddressConfigurationProperties](docs/VirtualMachineScaleSetPublicIPAddressConfigurationProperties.md)
 - [VirtualMachineScaleSetReimageParameters](docs/VirtualMachineScaleSetReimageParameters.md)
 - [VirtualMachineScaleSetSku](docs/VirtualMachineScaleSetSku.md)
 - [VirtualMachineScaleSetSkuCapacity](docs/VirtualMachineScaleSetSkuCapacity.md)
 - [VirtualMachineScaleSetStorageProfile](docs/VirtualMachineScaleSetStorageProfile.md)
 - [VirtualMachineScaleSetUpdate](docs/VirtualMachineScaleSetUpdate.md)
 - [VirtualMachineScaleSetUpdateIPConfiguration](docs/VirtualMachineScaleSetUpdateIPConfiguration.md)
 - [VirtualMachineScaleSetUpdateIPConfigurationProperties](docs/VirtualMachineScaleSetUpdateIPConfigurationProperties.md)
 - [VirtualMachineScaleSetUpdateNetworkConfiguration](docs/VirtualMachineScaleSetUpdateNetworkConfiguration.md)
 - [VirtualMachineScaleSetUpdateNetworkConfigurationProperties](docs/VirtualMachineScaleSetUpdateNetworkConfigurationProperties.md)
 - [VirtualMachineScaleSetUpdateNetworkProfile](docs/VirtualMachineScaleSetUpdateNetworkProfile.md)
 - [VirtualMachineScaleSetUpdateOSDisk](docs/VirtualMachineScaleSetUpdateOSDisk.md)
 - [VirtualMachineScaleSetUpdateOSProfile](docs/VirtualMachineScaleSetUpdateOSProfile.md)
 - [VirtualMachineScaleSetUpdateProperties](docs/VirtualMachineScaleSetUpdateProperties.md)
 - [VirtualMachineScaleSetUpdatePublicIPAddressConfiguration](docs/VirtualMachineScaleSetUpdatePublicIPAddressConfiguration.md)
 - [VirtualMachineScaleSetUpdatePublicIPAddressConfigurationProperties](docs/VirtualMachineScaleSetUpdatePublicIPAddressConfigurationProperties.md)
 - [VirtualMachineScaleSetUpdateStorageProfile](docs/VirtualMachineScaleSetUpdateStorageProfile.md)
 - [VirtualMachineScaleSetUpdateVMProfile](docs/VirtualMachineScaleSetUpdateVMProfile.md)
 - [VirtualMachineScaleSetVM](docs/VirtualMachineScaleSetVM.md)
 - [VirtualMachineScaleSetVMAllOf](docs/VirtualMachineScaleSetVMAllOf.md)
 - [VirtualMachineScaleSetVMExtensionsSummary](docs/VirtualMachineScaleSetVMExtensionsSummary.md)
 - [VirtualMachineScaleSetVMInstanceIDs](docs/VirtualMachineScaleSetVMInstanceIDs.md)
 - [VirtualMachineScaleSetVMInstanceRequiredIDs](docs/VirtualMachineScaleSetVMInstanceRequiredIDs.md)
 - [VirtualMachineScaleSetVMInstanceView](docs/VirtualMachineScaleSetVMInstanceView.md)
 - [VirtualMachineScaleSetVMListResult](docs/VirtualMachineScaleSetVMListResult.md)
 - [VirtualMachineScaleSetVMNetworkProfileConfiguration](docs/VirtualMachineScaleSetVMNetworkProfileConfiguration.md)
 - [VirtualMachineScaleSetVMProfile](docs/VirtualMachineScaleSetVMProfile.md)
 - [VirtualMachineScaleSetVMProperties](docs/VirtualMachineScaleSetVMProperties.md)
 - [VirtualMachineScaleSetVMProtectionPolicy](docs/VirtualMachineScaleSetVMProtectionPolicy.md)
 - [VirtualMachineScaleSetVMReimageParameters](docs/VirtualMachineScaleSetVMReimageParameters.md)
 - [VirtualMachineSize](docs/VirtualMachineSize.md)
 - [VirtualMachineSizeListResult](docs/VirtualMachineSizeListResult.md)
 - [VirtualMachineSoftwarePatchProperties](docs/VirtualMachineSoftwarePatchProperties.md)
 - [VirtualMachineStatusCodeCount](docs/VirtualMachineStatusCodeCount.md)
 - [VirtualMachineUpdate](docs/VirtualMachineUpdate.md)
 - [WinRMConfiguration](docs/WinRMConfiguration.md)
 - [WinRMListener](docs/WinRMListener.md)
 - [WindowsConfiguration](docs/WindowsConfiguration.md)


## Authorization

## azure_auth
- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://login.microsoftonline.com/common/oauth2/authorize
- **Scopes**: 
 - **user_impersonation**: impersonate your user account

Example
```
    using OpenAPI
    using OpenAPI.Clients
    import OpenAPI.Clients: Client, set_header
    client = Client(server_uri)
    set_header(client, "Authorization", "Bearer $bearer_auth")
    api = MyApi(client)
    result = callApi(api, args...; api_key)
```

## Author



