# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct ProximityPlacementGroupsApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `ProximityPlacementGroupsApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ ProximityPlacementGroupsApi }) = "https://management.azure.com"

const _returntypes_proximity_placement_groups_create_or_update_ProximityPlacementGroupsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ProximityPlacementGroup,
    Regex("^" * replace("201", "x"=>".") * "\$") => ProximityPlacementGroup,
)

function _oacinternal_proximity_placement_groups_create_or_update(_api::ProximityPlacementGroupsApi, resource_group_name::String, proximity_placement_group_name::String, api_version::String, subscription_id::String, parameters::ProximityPlacementGroup; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_proximity_placement_groups_create_or_update_ProximityPlacementGroupsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/proximityPlacementGroups/{proximityPlacementGroupName}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "proximityPlacementGroupName", proximity_placement_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Create or update a proximity placement group.

Params:
- resource_group_name::String (required)
- proximity_placement_group_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::ProximityPlacementGroup (required)

Return: ProximityPlacementGroup, OpenAPI.Clients.ApiResponse
"""
function proximity_placement_groups_create_or_update(_api::ProximityPlacementGroupsApi, resource_group_name::String, proximity_placement_group_name::String, api_version::String, subscription_id::String, parameters::ProximityPlacementGroup; _mediaType=nothing)
    _ctx = _oacinternal_proximity_placement_groups_create_or_update(_api, resource_group_name, proximity_placement_group_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function proximity_placement_groups_create_or_update(_api::ProximityPlacementGroupsApi, response_stream::Channel, resource_group_name::String, proximity_placement_group_name::String, api_version::String, subscription_id::String, parameters::ProximityPlacementGroup; _mediaType=nothing)
    _ctx = _oacinternal_proximity_placement_groups_create_or_update(_api, resource_group_name, proximity_placement_group_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_proximity_placement_groups_delete_ProximityPlacementGroupsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_proximity_placement_groups_delete(_api::ProximityPlacementGroupsApi, resource_group_name::String, proximity_placement_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_proximity_placement_groups_delete_ProximityPlacementGroupsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/proximityPlacementGroups/{proximityPlacementGroupName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "proximityPlacementGroupName", proximity_placement_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Delete a proximity placement group.

Params:
- resource_group_name::String (required)
- proximity_placement_group_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function proximity_placement_groups_delete(_api::ProximityPlacementGroupsApi, resource_group_name::String, proximity_placement_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_proximity_placement_groups_delete(_api, resource_group_name, proximity_placement_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function proximity_placement_groups_delete(_api::ProximityPlacementGroupsApi, response_stream::Channel, resource_group_name::String, proximity_placement_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_proximity_placement_groups_delete(_api, resource_group_name, proximity_placement_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_proximity_placement_groups_get_ProximityPlacementGroupsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ProximityPlacementGroup,
)

function _oacinternal_proximity_placement_groups_get(_api::ProximityPlacementGroupsApi, resource_group_name::String, proximity_placement_group_name::String, api_version::String, subscription_id::String; include_colocation_status=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_proximity_placement_groups_get_ProximityPlacementGroupsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/proximityPlacementGroups/{proximityPlacementGroupName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "proximityPlacementGroupName", proximity_placement_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "includeColocationStatus", include_colocation_status)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Retrieves information about a proximity placement group .

Params:
- resource_group_name::String (required)
- proximity_placement_group_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- include_colocation_status::String

Return: ProximityPlacementGroup, OpenAPI.Clients.ApiResponse
"""
function proximity_placement_groups_get(_api::ProximityPlacementGroupsApi, resource_group_name::String, proximity_placement_group_name::String, api_version::String, subscription_id::String; include_colocation_status=nothing, _mediaType=nothing)
    _ctx = _oacinternal_proximity_placement_groups_get(_api, resource_group_name, proximity_placement_group_name, api_version, subscription_id; include_colocation_status=include_colocation_status, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function proximity_placement_groups_get(_api::ProximityPlacementGroupsApi, response_stream::Channel, resource_group_name::String, proximity_placement_group_name::String, api_version::String, subscription_id::String; include_colocation_status=nothing, _mediaType=nothing)
    _ctx = _oacinternal_proximity_placement_groups_get(_api, resource_group_name, proximity_placement_group_name, api_version, subscription_id; include_colocation_status=include_colocation_status, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_proximity_placement_groups_list_by_resource_group_ProximityPlacementGroupsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ProximityPlacementGroupListResult,
)

function _oacinternal_proximity_placement_groups_list_by_resource_group(_api::ProximityPlacementGroupsApi, resource_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_proximity_placement_groups_list_by_resource_group_ProximityPlacementGroupsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/proximityPlacementGroups", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Lists all proximity placement groups in a resource group.

Params:
- resource_group_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: ProximityPlacementGroupListResult, OpenAPI.Clients.ApiResponse
"""
function proximity_placement_groups_list_by_resource_group(_api::ProximityPlacementGroupsApi, resource_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_proximity_placement_groups_list_by_resource_group(_api, resource_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function proximity_placement_groups_list_by_resource_group(_api::ProximityPlacementGroupsApi, response_stream::Channel, resource_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_proximity_placement_groups_list_by_resource_group(_api, resource_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_proximity_placement_groups_list_by_subscription_ProximityPlacementGroupsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ProximityPlacementGroupListResult,
)

function _oacinternal_proximity_placement_groups_list_by_subscription(_api::ProximityPlacementGroupsApi, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_proximity_placement_groups_list_by_subscription_ProximityPlacementGroupsApi, "/subscriptions/{subscriptionId}/providers/Microsoft.Compute/proximityPlacementGroups", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Lists all proximity placement groups in a subscription.

Params:
- api_version::String (required)
- subscription_id::String (required)

Return: ProximityPlacementGroupListResult, OpenAPI.Clients.ApiResponse
"""
function proximity_placement_groups_list_by_subscription(_api::ProximityPlacementGroupsApi, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_proximity_placement_groups_list_by_subscription(_api, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function proximity_placement_groups_list_by_subscription(_api::ProximityPlacementGroupsApi, response_stream::Channel, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_proximity_placement_groups_list_by_subscription(_api, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_proximity_placement_groups_update_ProximityPlacementGroupsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ProximityPlacementGroup,
)

function _oacinternal_proximity_placement_groups_update(_api::ProximityPlacementGroupsApi, resource_group_name::String, proximity_placement_group_name::String, api_version::String, subscription_id::String, parameters::ProximityPlacementGroupUpdate; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PATCH", _returntypes_proximity_placement_groups_update_ProximityPlacementGroupsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/proximityPlacementGroups/{proximityPlacementGroupName}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "proximityPlacementGroupName", proximity_placement_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Update a proximity placement group.

Params:
- resource_group_name::String (required)
- proximity_placement_group_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::ProximityPlacementGroupUpdate (required)

Return: ProximityPlacementGroup, OpenAPI.Clients.ApiResponse
"""
function proximity_placement_groups_update(_api::ProximityPlacementGroupsApi, resource_group_name::String, proximity_placement_group_name::String, api_version::String, subscription_id::String, parameters::ProximityPlacementGroupUpdate; _mediaType=nothing)
    _ctx = _oacinternal_proximity_placement_groups_update(_api, resource_group_name, proximity_placement_group_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function proximity_placement_groups_update(_api::ProximityPlacementGroupsApi, response_stream::Channel, resource_group_name::String, proximity_placement_group_name::String, api_version::String, subscription_id::String, parameters::ProximityPlacementGroupUpdate; _mediaType=nothing)
    _ctx = _oacinternal_proximity_placement_groups_update(_api, resource_group_name, proximity_placement_group_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export proximity_placement_groups_create_or_update
export proximity_placement_groups_delete
export proximity_placement_groups_get
export proximity_placement_groups_list_by_resource_group
export proximity_placement_groups_list_by_subscription
export proximity_placement_groups_update
