# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct VirtualMachineScaleSetExtensionsApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `VirtualMachineScaleSetExtensionsApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ VirtualMachineScaleSetExtensionsApi }) = "https://management.azure.com"

const _returntypes_virtual_machine_scale_set_extensions_create_or_update_VirtualMachineScaleSetExtensionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualMachineScaleSetExtension,
    Regex("^" * replace("201", "x"=>".") * "\$") => VirtualMachineScaleSetExtension,
)

function _oacinternal_virtual_machine_scale_set_extensions_create_or_update(_api::VirtualMachineScaleSetExtensionsApi, resource_group_name::String, vm_scale_set_name::String, vmss_extension_name::String, api_version::String, subscription_id::String, extension_parameters::VirtualMachineScaleSetExtension; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_virtual_machine_scale_set_extensions_create_or_update_VirtualMachineScaleSetExtensionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/extensions/{vmssExtensionName}", ["azure_auth", ], extension_parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmssExtensionName", vmss_extension_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""The operation to create or update an extension.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- vmss_extension_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- extension_parameters::VirtualMachineScaleSetExtension (required)

Return: VirtualMachineScaleSetExtension, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_extensions_create_or_update(_api::VirtualMachineScaleSetExtensionsApi, resource_group_name::String, vm_scale_set_name::String, vmss_extension_name::String, api_version::String, subscription_id::String, extension_parameters::VirtualMachineScaleSetExtension; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_extensions_create_or_update(_api, resource_group_name, vm_scale_set_name, vmss_extension_name, api_version, subscription_id, extension_parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_extensions_create_or_update(_api::VirtualMachineScaleSetExtensionsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, vmss_extension_name::String, api_version::String, subscription_id::String, extension_parameters::VirtualMachineScaleSetExtension; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_extensions_create_or_update(_api, resource_group_name, vm_scale_set_name, vmss_extension_name, api_version, subscription_id, extension_parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_extensions_delete_VirtualMachineScaleSetExtensionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_set_extensions_delete(_api::VirtualMachineScaleSetExtensionsApi, resource_group_name::String, vm_scale_set_name::String, vmss_extension_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_virtual_machine_scale_set_extensions_delete_VirtualMachineScaleSetExtensionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/extensions/{vmssExtensionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmssExtensionName", vmss_extension_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""The operation to delete the extension.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- vmss_extension_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_extensions_delete(_api::VirtualMachineScaleSetExtensionsApi, resource_group_name::String, vm_scale_set_name::String, vmss_extension_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_extensions_delete(_api, resource_group_name, vm_scale_set_name, vmss_extension_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_extensions_delete(_api::VirtualMachineScaleSetExtensionsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, vmss_extension_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_extensions_delete(_api, resource_group_name, vm_scale_set_name, vmss_extension_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_extensions_get_VirtualMachineScaleSetExtensionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualMachineScaleSetExtension,
)

function _oacinternal_virtual_machine_scale_set_extensions_get(_api::VirtualMachineScaleSetExtensionsApi, resource_group_name::String, vm_scale_set_name::String, vmss_extension_name::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_virtual_machine_scale_set_extensions_get_VirtualMachineScaleSetExtensionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/extensions/{vmssExtensionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmssExtensionName", vmss_extension_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "\$expand", expand)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""The operation to get the extension.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- vmss_extension_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- expand::String

Return: VirtualMachineScaleSetExtension, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_extensions_get(_api::VirtualMachineScaleSetExtensionsApi, resource_group_name::String, vm_scale_set_name::String, vmss_extension_name::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_extensions_get(_api, resource_group_name, vm_scale_set_name, vmss_extension_name, api_version, subscription_id; expand=expand, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_extensions_get(_api::VirtualMachineScaleSetExtensionsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, vmss_extension_name::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_extensions_get(_api, resource_group_name, vm_scale_set_name, vmss_extension_name, api_version, subscription_id; expand=expand, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_extensions_list_VirtualMachineScaleSetExtensionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualMachineScaleSetExtensionListResult,
)

function _oacinternal_virtual_machine_scale_set_extensions_list(_api::VirtualMachineScaleSetExtensionsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_virtual_machine_scale_set_extensions_list_VirtualMachineScaleSetExtensionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/extensions", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets a list of all extensions in a VM scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: VirtualMachineScaleSetExtensionListResult, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_extensions_list(_api::VirtualMachineScaleSetExtensionsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_extensions_list(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_extensions_list(_api::VirtualMachineScaleSetExtensionsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_extensions_list(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_extensions_update_VirtualMachineScaleSetExtensionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualMachineScaleSetExtension,
    Regex("^" * replace("201", "x"=>".") * "\$") => VirtualMachineScaleSetExtension,
)

function _oacinternal_virtual_machine_scale_set_extensions_update(_api::VirtualMachineScaleSetExtensionsApi, resource_group_name::String, vm_scale_set_name::String, vmss_extension_name::String, api_version::String, subscription_id::String, extension_parameters::VirtualMachineScaleSetExtensionUpdate; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PATCH", _returntypes_virtual_machine_scale_set_extensions_update_VirtualMachineScaleSetExtensionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/extensions/{vmssExtensionName}", ["azure_auth", ], extension_parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmssExtensionName", vmss_extension_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""The operation to update an extension.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- vmss_extension_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- extension_parameters::VirtualMachineScaleSetExtensionUpdate (required)

Return: VirtualMachineScaleSetExtension, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_extensions_update(_api::VirtualMachineScaleSetExtensionsApi, resource_group_name::String, vm_scale_set_name::String, vmss_extension_name::String, api_version::String, subscription_id::String, extension_parameters::VirtualMachineScaleSetExtensionUpdate; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_extensions_update(_api, resource_group_name, vm_scale_set_name, vmss_extension_name, api_version, subscription_id, extension_parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_extensions_update(_api::VirtualMachineScaleSetExtensionsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, vmss_extension_name::String, api_version::String, subscription_id::String, extension_parameters::VirtualMachineScaleSetExtensionUpdate; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_extensions_update(_api, resource_group_name, vm_scale_set_name, vmss_extension_name, api_version, subscription_id, extension_parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export virtual_machine_scale_set_extensions_create_or_update
export virtual_machine_scale_set_extensions_delete
export virtual_machine_scale_set_extensions_get
export virtual_machine_scale_set_extensions_list
export virtual_machine_scale_set_extensions_update
