# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct VirtualMachineScaleSetRollingUpgradesApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `VirtualMachineScaleSetRollingUpgradesApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ VirtualMachineScaleSetRollingUpgradesApi }) = "https://management.azure.com"

const _returntypes_virtual_machine_scale_set_rolling_upgrades_cancel_VirtualMachineScaleSetRollingUpgradesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_set_rolling_upgrades_cancel(_api::VirtualMachineScaleSetRollingUpgradesApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_set_rolling_upgrades_cancel_VirtualMachineScaleSetRollingUpgradesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/rollingUpgrades/cancel", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Cancels the current virtual machine scale set rolling upgrade.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_rolling_upgrades_cancel(_api::VirtualMachineScaleSetRollingUpgradesApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_rolling_upgrades_cancel(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_rolling_upgrades_cancel(_api::VirtualMachineScaleSetRollingUpgradesApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_rolling_upgrades_cancel(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_rolling_upgrades_get_latest_VirtualMachineScaleSetRollingUpgradesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => RollingUpgradeStatusInfo,
)

function _oacinternal_virtual_machine_scale_set_rolling_upgrades_get_latest(_api::VirtualMachineScaleSetRollingUpgradesApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_virtual_machine_scale_set_rolling_upgrades_get_latest_VirtualMachineScaleSetRollingUpgradesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/rollingUpgrades/latest", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets the status of the latest virtual machine scale set rolling upgrade.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: RollingUpgradeStatusInfo, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_rolling_upgrades_get_latest(_api::VirtualMachineScaleSetRollingUpgradesApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_rolling_upgrades_get_latest(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_rolling_upgrades_get_latest(_api::VirtualMachineScaleSetRollingUpgradesApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_rolling_upgrades_get_latest(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_rolling_upgrades_start_extension_upgrade_VirtualMachineScaleSetRollingUpgradesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_set_rolling_upgrades_start_extension_upgrade(_api::VirtualMachineScaleSetRollingUpgradesApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_set_rolling_upgrades_start_extension_upgrade_VirtualMachineScaleSetRollingUpgradesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/extensionRollingUpgrade", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Starts a rolling upgrade to move all extensions for all virtual machine scale set instances to the latest available extension version. Instances which are already running the latest extension versions are not affected.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_rolling_upgrades_start_extension_upgrade(_api::VirtualMachineScaleSetRollingUpgradesApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_rolling_upgrades_start_extension_upgrade(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_rolling_upgrades_start_extension_upgrade(_api::VirtualMachineScaleSetRollingUpgradesApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_rolling_upgrades_start_extension_upgrade(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_rolling_upgrades_start_o_s_upgrade_VirtualMachineScaleSetRollingUpgradesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_set_rolling_upgrades_start_o_s_upgrade(_api::VirtualMachineScaleSetRollingUpgradesApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_set_rolling_upgrades_start_o_s_upgrade_VirtualMachineScaleSetRollingUpgradesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/osRollingUpgrade", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Starts a rolling upgrade to move all virtual machine scale set instances to the latest available Platform Image OS version. Instances which are already running the latest available OS version are not affected.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_rolling_upgrades_start_o_s_upgrade(_api::VirtualMachineScaleSetRollingUpgradesApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_rolling_upgrades_start_o_s_upgrade(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_rolling_upgrades_start_o_s_upgrade(_api::VirtualMachineScaleSetRollingUpgradesApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_rolling_upgrades_start_o_s_upgrade(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export virtual_machine_scale_set_rolling_upgrades_cancel
export virtual_machine_scale_set_rolling_upgrades_get_latest
export virtual_machine_scale_set_rolling_upgrades_start_extension_upgrade
export virtual_machine_scale_set_rolling_upgrades_start_o_s_upgrade
