# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct VirtualMachineScaleSetVMsApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `VirtualMachineScaleSetVMsApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ VirtualMachineScaleSetVMsApi }) = "https://management.azure.com"

const _returntypes_virtual_machine_scale_set_v_ms_deallocate_VirtualMachineScaleSetVMsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_set_v_ms_deallocate(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_set_v_ms_deallocate_VirtualMachineScaleSetVMsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/deallocate", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "instanceId", instance_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Deallocates a specific virtual machine in a VM scale set. Shuts down the virtual machine and releases the compute resources it uses. You are not billed for the compute resources of this virtual machine once it is deallocated.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- instance_id::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_v_ms_deallocate(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_deallocate(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_v_ms_deallocate(_api::VirtualMachineScaleSetVMsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_deallocate(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_v_ms_delete_VirtualMachineScaleSetVMsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_set_v_ms_delete(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_virtual_machine_scale_set_v_ms_delete_VirtualMachineScaleSetVMsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "instanceId", instance_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Deletes a virtual machine from a VM scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- instance_id::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_v_ms_delete(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_delete(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_v_ms_delete(_api::VirtualMachineScaleSetVMsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_delete(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_v_ms_get_VirtualMachineScaleSetVMsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualMachineScaleSetVM,
)

function _oacinternal_virtual_machine_scale_set_v_ms_get(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_virtual_machine_scale_set_v_ms_get_VirtualMachineScaleSetVMsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "instanceId", instance_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "\$expand", expand)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets a virtual machine from a VM scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- instance_id::String (required)
- api_version::String (required)
- subscription_id::String (required)
- expand::String

Return: VirtualMachineScaleSetVM, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_v_ms_get(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_get(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; expand=expand, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_v_ms_get(_api::VirtualMachineScaleSetVMsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_get(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; expand=expand, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_v_ms_get_instance_view_VirtualMachineScaleSetVMsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualMachineScaleSetVMInstanceView,
)

function _oacinternal_virtual_machine_scale_set_v_ms_get_instance_view(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_virtual_machine_scale_set_v_ms_get_instance_view_VirtualMachineScaleSetVMsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/instanceView", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "instanceId", instance_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets the status of a virtual machine from a VM scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- instance_id::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: VirtualMachineScaleSetVMInstanceView, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_v_ms_get_instance_view(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_get_instance_view(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_v_ms_get_instance_view(_api::VirtualMachineScaleSetVMsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_get_instance_view(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_v_ms_list_VirtualMachineScaleSetVMsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualMachineScaleSetVMListResult,
)

function _oacinternal_virtual_machine_scale_set_v_ms_list(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, virtual_machine_scale_set_name::String, api_version::String, subscription_id::String; filter=nothing, select=nothing, expand=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_virtual_machine_scale_set_v_ms_list_VirtualMachineScaleSetVMsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{virtualMachineScaleSetName}/virtualMachines", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualMachineScaleSetName", virtual_machine_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "\$filter", filter)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "\$select", select)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "\$expand", expand)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets a list of all virtual machines in a VM scale sets.

Params:
- resource_group_name::String (required)
- virtual_machine_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- filter::String
- select::String
- expand::String

Return: VirtualMachineScaleSetVMListResult, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_v_ms_list(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, virtual_machine_scale_set_name::String, api_version::String, subscription_id::String; filter=nothing, select=nothing, expand=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_list(_api, resource_group_name, virtual_machine_scale_set_name, api_version, subscription_id; filter=filter, select=select, expand=expand, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_v_ms_list(_api::VirtualMachineScaleSetVMsApi, response_stream::Channel, resource_group_name::String, virtual_machine_scale_set_name::String, api_version::String, subscription_id::String; filter=nothing, select=nothing, expand=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_list(_api, resource_group_name, virtual_machine_scale_set_name, api_version, subscription_id; filter=filter, select=select, expand=expand, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_v_ms_perform_maintenance_VirtualMachineScaleSetVMsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_set_v_ms_perform_maintenance(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_set_v_ms_perform_maintenance_VirtualMachineScaleSetVMsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/performMaintenance", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "instanceId", instance_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Performs maintenance on a virtual machine in a VM scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- instance_id::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_v_ms_perform_maintenance(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_perform_maintenance(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_v_ms_perform_maintenance(_api::VirtualMachineScaleSetVMsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_perform_maintenance(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_v_ms_power_off_VirtualMachineScaleSetVMsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_set_v_ms_power_off(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; skip_shutdown=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_set_v_ms_power_off_VirtualMachineScaleSetVMsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/poweroff", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "instanceId", instance_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "skipShutdown", skip_shutdown)  # type Bool
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Power off (stop) a virtual machine in a VM scale set. Note that resources are still attached and you are getting charged for the resources. Instead, use deallocate to release resources and avoid charges.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- instance_id::String (required)
- api_version::String (required)
- subscription_id::String (required)
- skip_shutdown::Bool

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_v_ms_power_off(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; skip_shutdown=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_power_off(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; skip_shutdown=skip_shutdown, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_v_ms_power_off(_api::VirtualMachineScaleSetVMsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; skip_shutdown=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_power_off(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; skip_shutdown=skip_shutdown, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_v_ms_redeploy_VirtualMachineScaleSetVMsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_set_v_ms_redeploy(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_set_v_ms_redeploy_VirtualMachineScaleSetVMsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/redeploy", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "instanceId", instance_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Shuts down the virtual machine in the virtual machine scale set, moves it to a new node, and powers it back on.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- instance_id::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_v_ms_redeploy(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_redeploy(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_v_ms_redeploy(_api::VirtualMachineScaleSetVMsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_redeploy(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_v_ms_reimage_VirtualMachineScaleSetVMsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_set_v_ms_reimage(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; vm_scale_set_v_m_reimage_input=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_set_v_ms_reimage_VirtualMachineScaleSetVMsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/reimage", ["azure_auth", ], vm_scale_set_v_m_reimage_input)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "instanceId", instance_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Reimages (upgrade the operating system) a specific virtual machine in a VM scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- instance_id::String (required)
- api_version::String (required)
- subscription_id::String (required)
- vm_scale_set_v_m_reimage_input::VirtualMachineScaleSetVMReimageParameters

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_v_ms_reimage(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; vm_scale_set_v_m_reimage_input=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_reimage(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; vm_scale_set_v_m_reimage_input=vm_scale_set_v_m_reimage_input, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_v_ms_reimage(_api::VirtualMachineScaleSetVMsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; vm_scale_set_v_m_reimage_input=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_reimage(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; vm_scale_set_v_m_reimage_input=vm_scale_set_v_m_reimage_input, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_v_ms_reimage_all_VirtualMachineScaleSetVMsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_set_v_ms_reimage_all(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_set_v_ms_reimage_all_VirtualMachineScaleSetVMsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/reimageall", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "instanceId", instance_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Allows you to re-image all the disks ( including data disks ) in the a VM scale set instance. This operation is only supported for managed disks.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- instance_id::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_v_ms_reimage_all(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_reimage_all(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_v_ms_reimage_all(_api::VirtualMachineScaleSetVMsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_reimage_all(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_v_ms_restart_VirtualMachineScaleSetVMsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_set_v_ms_restart(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_set_v_ms_restart_VirtualMachineScaleSetVMsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/restart", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "instanceId", instance_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Restarts a virtual machine in a VM scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- instance_id::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_v_ms_restart(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_restart(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_v_ms_restart(_api::VirtualMachineScaleSetVMsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_restart(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_v_ms_retrieve_boot_diagnostics_data_VirtualMachineScaleSetVMsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => RetrieveBootDiagnosticsDataResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_virtual_machine_scale_set_v_ms_retrieve_boot_diagnostics_data(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; sas_uri_expiration_time_in_minutes=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_set_v_ms_retrieve_boot_diagnostics_data_VirtualMachineScaleSetVMsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/retrieveBootDiagnosticsData", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "instanceId", instance_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "sasUriExpirationTimeInMinutes", sas_uri_expiration_time_in_minutes)  # type Int64
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""The operation to retrieve SAS URIs of boot diagnostic logs for a virtual machine in a VM scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- instance_id::String (required)
- api_version::String (required)
- subscription_id::String (required)
- sas_uri_expiration_time_in_minutes::Int64

Return: RetrieveBootDiagnosticsDataResult, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_v_ms_retrieve_boot_diagnostics_data(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; sas_uri_expiration_time_in_minutes=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_retrieve_boot_diagnostics_data(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; sas_uri_expiration_time_in_minutes=sas_uri_expiration_time_in_minutes, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_v_ms_retrieve_boot_diagnostics_data(_api::VirtualMachineScaleSetVMsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; sas_uri_expiration_time_in_minutes=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_retrieve_boot_diagnostics_data(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; sas_uri_expiration_time_in_minutes=sas_uri_expiration_time_in_minutes, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_v_ms_simulate_eviction_VirtualMachineScaleSetVMsApi = Dict{Regex,Type}(
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_set_v_ms_simulate_eviction(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_set_v_ms_simulate_eviction_VirtualMachineScaleSetVMsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualMachines/{instanceId}/simulateEviction", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "instanceId", instance_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""The operation to simulate the eviction of spot virtual machine in a VM scale set. The eviction will occur within 30 minutes of calling the API

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- instance_id::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_v_ms_simulate_eviction(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_simulate_eviction(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_v_ms_simulate_eviction(_api::VirtualMachineScaleSetVMsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_simulate_eviction(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_v_ms_start_VirtualMachineScaleSetVMsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_set_v_ms_start(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_set_v_ms_start_VirtualMachineScaleSetVMsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/start", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "instanceId", instance_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Starts a virtual machine in a VM scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- instance_id::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_v_ms_start(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_start(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_v_ms_start(_api::VirtualMachineScaleSetVMsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_start(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_set_v_ms_update_VirtualMachineScaleSetVMsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualMachineScaleSetVM,
    Regex("^" * replace("202", "x"=>".") * "\$") => VirtualMachineScaleSetVM,
)

function _oacinternal_virtual_machine_scale_set_v_ms_update(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String, parameters::VirtualMachineScaleSetVM; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_virtual_machine_scale_set_v_ms_update_VirtualMachineScaleSetVMsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "instanceId", instance_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Updates a virtual machine of a VM scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- instance_id::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::VirtualMachineScaleSetVM (required)

Return: VirtualMachineScaleSetVM, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_v_ms_update(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String, parameters::VirtualMachineScaleSetVM; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_update(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_v_ms_update(_api::VirtualMachineScaleSetVMsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String, parameters::VirtualMachineScaleSetVM; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_update(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export virtual_machine_scale_set_v_ms_deallocate
export virtual_machine_scale_set_v_ms_delete
export virtual_machine_scale_set_v_ms_get
export virtual_machine_scale_set_v_ms_get_instance_view
export virtual_machine_scale_set_v_ms_list
export virtual_machine_scale_set_v_ms_perform_maintenance
export virtual_machine_scale_set_v_ms_power_off
export virtual_machine_scale_set_v_ms_redeploy
export virtual_machine_scale_set_v_ms_reimage
export virtual_machine_scale_set_v_ms_reimage_all
export virtual_machine_scale_set_v_ms_restart
export virtual_machine_scale_set_v_ms_retrieve_boot_diagnostics_data
export virtual_machine_scale_set_v_ms_simulate_eviction
export virtual_machine_scale_set_v_ms_start
export virtual_machine_scale_set_v_ms_update
