# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct VirtualMachineScaleSetsApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `VirtualMachineScaleSetsApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ VirtualMachineScaleSetsApi }) = "https://management.azure.com"

const _returntypes_virtual_machine_scale_sets_convert_to_single_placement_group_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_sets_convert_to_single_placement_group(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, parameters::VMScaleSetConvertToSinglePlacementGroupInput; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_sets_convert_to_single_placement_group_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/convertToSinglePlacementGroup", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Converts SinglePlacementGroup property to false for a existing virtual machine scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::VMScaleSetConvertToSinglePlacementGroupInput (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_convert_to_single_placement_group(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, parameters::VMScaleSetConvertToSinglePlacementGroupInput; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_convert_to_single_placement_group(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_convert_to_single_placement_group(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, parameters::VMScaleSetConvertToSinglePlacementGroupInput; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_convert_to_single_placement_group(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_create_or_update_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualMachineScaleSet,
    Regex("^" * replace("201", "x"=>".") * "\$") => VirtualMachineScaleSet,
)

function _oacinternal_virtual_machine_scale_sets_create_or_update(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, parameters::VirtualMachineScaleSet; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_virtual_machine_scale_sets_create_or_update_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Create or update a VM scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::VirtualMachineScaleSet (required)

Return: VirtualMachineScaleSet, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_create_or_update(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, parameters::VirtualMachineScaleSet; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_create_or_update(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_create_or_update(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, parameters::VirtualMachineScaleSet; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_create_or_update(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_deallocate_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_sets_deallocate(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_sets_deallocate_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/deallocate", ["azure_auth", ], vm_instance_i_ds)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Deallocates specific virtual machines in a VM scale set. Shuts down the virtual machines and releases the compute resources. You are not billed for the compute resources that this virtual machine scale set deallocates.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- vm_instance_i_ds::VirtualMachineScaleSetVMInstanceIDs

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_deallocate(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_deallocate(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; vm_instance_i_ds=vm_instance_i_ds, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_deallocate(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_deallocate(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; vm_instance_i_ds=vm_instance_i_ds, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_delete_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_sets_delete(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_virtual_machine_scale_sets_delete_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Deletes a VM scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_delete(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_delete(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_delete(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_delete(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_delete_instances_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_sets_delete_instances(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, vm_instance_i_ds::VirtualMachineScaleSetVMInstanceRequiredIDs; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_sets_delete_instances_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/delete", ["azure_auth", ], vm_instance_i_ds)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Deletes virtual machines in a VM scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- vm_instance_i_ds::VirtualMachineScaleSetVMInstanceRequiredIDs (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_delete_instances(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, vm_instance_i_ds::VirtualMachineScaleSetVMInstanceRequiredIDs; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_delete_instances(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id, vm_instance_i_ds; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_delete_instances(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, vm_instance_i_ds::VirtualMachineScaleSetVMInstanceRequiredIDs; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_delete_instances(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id, vm_instance_i_ds; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_force_recovery_service_fabric_platform_update_domain_walk_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => RecoveryWalkResponse,
)

function _oacinternal_virtual_machine_scale_sets_force_recovery_service_fabric_platform_update_domain_walk(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, platform_update_domain::Int64; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_sets_force_recovery_service_fabric_platform_update_domain_walk_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/forceRecoveryServiceFabricPlatformUpdateDomainWalk", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "platformUpdateDomain", platform_update_domain)  # type Int64
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Manual platform update domain walk to update virtual machines in a service fabric virtual machine scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- platform_update_domain::Int64 (required)

Return: RecoveryWalkResponse, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_force_recovery_service_fabric_platform_update_domain_walk(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, platform_update_domain::Int64; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_force_recovery_service_fabric_platform_update_domain_walk(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id, platform_update_domain; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_force_recovery_service_fabric_platform_update_domain_walk(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, platform_update_domain::Int64; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_force_recovery_service_fabric_platform_update_domain_walk(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id, platform_update_domain; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_get_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualMachineScaleSet,
)

function _oacinternal_virtual_machine_scale_sets_get(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_virtual_machine_scale_sets_get_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Display information about a virtual machine scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: VirtualMachineScaleSet, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_get(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_get(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_get(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_get(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_get_instance_view_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualMachineScaleSetInstanceView,
)

function _oacinternal_virtual_machine_scale_sets_get_instance_view(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_virtual_machine_scale_sets_get_instance_view_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/instanceView", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets the status of a VM scale set instance.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: VirtualMachineScaleSetInstanceView, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_get_instance_view(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_get_instance_view(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_get_instance_view(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_get_instance_view(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_get_o_s_upgrade_history_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualMachineScaleSetListOSUpgradeHistory,
)

function _oacinternal_virtual_machine_scale_sets_get_o_s_upgrade_history(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_virtual_machine_scale_sets_get_o_s_upgrade_history_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/osUpgradeHistory", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets list of OS upgrades on a VM scale set instance.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: VirtualMachineScaleSetListOSUpgradeHistory, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_get_o_s_upgrade_history(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_get_o_s_upgrade_history(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_get_o_s_upgrade_history(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_get_o_s_upgrade_history(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_list_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualMachineScaleSetListResult,
)

function _oacinternal_virtual_machine_scale_sets_list(_api::VirtualMachineScaleSetsApi, resource_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_virtual_machine_scale_sets_list_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets a list of all VM scale sets under a resource group.

Params:
- resource_group_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: VirtualMachineScaleSetListResult, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_list(_api::VirtualMachineScaleSetsApi, resource_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_list(_api, resource_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_list(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_list(_api, resource_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_list_all_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualMachineScaleSetListWithLinkResult,
)

function _oacinternal_virtual_machine_scale_sets_list_all(_api::VirtualMachineScaleSetsApi, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_virtual_machine_scale_sets_list_all_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/providers/Microsoft.Compute/virtualMachineScaleSets", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets a list of all VM Scale Sets in the subscription, regardless of the associated resource group. Use nextLink property in the response to get the next page of VM Scale Sets. Do this till nextLink is null to fetch all the VM Scale Sets.

Params:
- api_version::String (required)
- subscription_id::String (required)

Return: VirtualMachineScaleSetListWithLinkResult, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_list_all(_api::VirtualMachineScaleSetsApi, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_list_all(_api, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_list_all(_api::VirtualMachineScaleSetsApi, response_stream::Channel, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_list_all(_api, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_list_skus_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualMachineScaleSetListSkusResult,
)

function _oacinternal_virtual_machine_scale_sets_list_skus(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_virtual_machine_scale_sets_list_skus_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/skus", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets a list of SKUs available for your VM scale set, including the minimum and maximum VM instances allowed for each SKU.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: VirtualMachineScaleSetListSkusResult, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_list_skus(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_list_skus(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_list_skus(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_list_skus(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_perform_maintenance_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_sets_perform_maintenance(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_sets_perform_maintenance_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/performMaintenance", ["azure_auth", ], vm_instance_i_ds)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Perform maintenance on one or more virtual machines in a VM scale set. Operation on instances which are not eligible for perform maintenance will be failed. Please refer to best practices for more details: https://docs.microsoft.com/en-us/azure/virtual-machine-scale-sets/virtual-machine-scale-sets-maintenance-notifications

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- vm_instance_i_ds::VirtualMachineScaleSetVMInstanceIDs

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_perform_maintenance(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_perform_maintenance(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; vm_instance_i_ds=vm_instance_i_ds, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_perform_maintenance(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_perform_maintenance(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; vm_instance_i_ds=vm_instance_i_ds, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_power_off_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_sets_power_off(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; skip_shutdown=nothing, vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_sets_power_off_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/poweroff", ["azure_auth", ], vm_instance_i_ds)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "skipShutdown", skip_shutdown)  # type Bool
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Power off (stop) one or more virtual machines in a VM scale set. Note that resources are still attached and you are getting charged for the resources. Instead, use deallocate to release resources and avoid charges.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- skip_shutdown::Bool
- vm_instance_i_ds::VirtualMachineScaleSetVMInstanceIDs

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_power_off(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; skip_shutdown=nothing, vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_power_off(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; skip_shutdown=skip_shutdown, vm_instance_i_ds=vm_instance_i_ds, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_power_off(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; skip_shutdown=nothing, vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_power_off(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; skip_shutdown=skip_shutdown, vm_instance_i_ds=vm_instance_i_ds, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_redeploy_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_sets_redeploy(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_sets_redeploy_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/redeploy", ["azure_auth", ], vm_instance_i_ds)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Shuts down all the virtual machines in the virtual machine scale set, moves them to a new node, and powers them back on.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- vm_instance_i_ds::VirtualMachineScaleSetVMInstanceIDs

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_redeploy(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_redeploy(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; vm_instance_i_ds=vm_instance_i_ds, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_redeploy(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_redeploy(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; vm_instance_i_ds=vm_instance_i_ds, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_reimage_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_sets_reimage(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_scale_set_reimage_input=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_sets_reimage_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/reimage", ["azure_auth", ], vm_scale_set_reimage_input)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Reimages (upgrade the operating system) one or more virtual machines in a VM scale set which don't have a ephemeral OS disk, for virtual machines who have a ephemeral OS disk the virtual machine is reset to initial state.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- vm_scale_set_reimage_input::VirtualMachineScaleSetReimageParameters

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_reimage(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_scale_set_reimage_input=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_reimage(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; vm_scale_set_reimage_input=vm_scale_set_reimage_input, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_reimage(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_scale_set_reimage_input=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_reimage(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; vm_scale_set_reimage_input=vm_scale_set_reimage_input, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_reimage_all_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_sets_reimage_all(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_sets_reimage_all_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/reimageall", ["azure_auth", ], vm_instance_i_ds)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Reimages all the disks ( including data disks ) in the virtual machines in a VM scale set. This operation is only supported for managed disks.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- vm_instance_i_ds::VirtualMachineScaleSetVMInstanceIDs

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_reimage_all(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_reimage_all(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; vm_instance_i_ds=vm_instance_i_ds, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_reimage_all(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_reimage_all(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; vm_instance_i_ds=vm_instance_i_ds, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_restart_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_sets_restart(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_sets_restart_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/restart", ["azure_auth", ], vm_instance_i_ds)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Restarts one or more virtual machines in a VM scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- vm_instance_i_ds::VirtualMachineScaleSetVMInstanceIDs

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_restart(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_restart(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; vm_instance_i_ds=vm_instance_i_ds, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_restart(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_restart(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; vm_instance_i_ds=vm_instance_i_ds, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_set_orchestration_service_state_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_sets_set_orchestration_service_state(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, parameters::OrchestrationServiceStateInput; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_sets_set_orchestration_service_state_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/setOrchestrationServiceState", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Changes ServiceState property for a given service

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::OrchestrationServiceStateInput (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_set_orchestration_service_state(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, parameters::OrchestrationServiceStateInput; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_set_orchestration_service_state(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_set_orchestration_service_state(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, parameters::OrchestrationServiceStateInput; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_set_orchestration_service_state(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_start_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_sets_start(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_sets_start_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/start", ["azure_auth", ], vm_instance_i_ds)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Starts one or more virtual machines in a VM scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- vm_instance_i_ds::VirtualMachineScaleSetVMInstanceIDs

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_start(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_start(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; vm_instance_i_ds=vm_instance_i_ds, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_start(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String; vm_instance_i_ds=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_start(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id; vm_instance_i_ds=vm_instance_i_ds, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_update_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualMachineScaleSet,
)

function _oacinternal_virtual_machine_scale_sets_update(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, parameters::VirtualMachineScaleSetUpdate; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PATCH", _returntypes_virtual_machine_scale_sets_update_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Update a VM scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::VirtualMachineScaleSetUpdate (required)

Return: VirtualMachineScaleSet, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_update(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, parameters::VirtualMachineScaleSetUpdate; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_update(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_update(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, parameters::VirtualMachineScaleSetUpdate; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_update(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_machine_scale_sets_update_instances_VirtualMachineScaleSetsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_sets_update_instances(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, vm_instance_i_ds::VirtualMachineScaleSetVMInstanceRequiredIDs; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_sets_update_instances_VirtualMachineScaleSetsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/manualupgrade", ["azure_auth", ], vm_instance_i_ds)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Upgrades one or more virtual machines to the latest SKU set in the VM scale set model.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- vm_instance_i_ds::VirtualMachineScaleSetVMInstanceRequiredIDs (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_sets_update_instances(_api::VirtualMachineScaleSetsApi, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, vm_instance_i_ds::VirtualMachineScaleSetVMInstanceRequiredIDs; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_update_instances(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id, vm_instance_i_ds; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_sets_update_instances(_api::VirtualMachineScaleSetsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, api_version::String, subscription_id::String, vm_instance_i_ds::VirtualMachineScaleSetVMInstanceRequiredIDs; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_sets_update_instances(_api, resource_group_name, vm_scale_set_name, api_version, subscription_id, vm_instance_i_ds; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export virtual_machine_scale_sets_convert_to_single_placement_group
export virtual_machine_scale_sets_create_or_update
export virtual_machine_scale_sets_deallocate
export virtual_machine_scale_sets_delete
export virtual_machine_scale_sets_delete_instances
export virtual_machine_scale_sets_force_recovery_service_fabric_platform_update_domain_walk
export virtual_machine_scale_sets_get
export virtual_machine_scale_sets_get_instance_view
export virtual_machine_scale_sets_get_o_s_upgrade_history
export virtual_machine_scale_sets_list
export virtual_machine_scale_sets_list_all
export virtual_machine_scale_sets_list_skus
export virtual_machine_scale_sets_perform_maintenance
export virtual_machine_scale_sets_power_off
export virtual_machine_scale_sets_redeploy
export virtual_machine_scale_sets_reimage
export virtual_machine_scale_sets_reimage_all
export virtual_machine_scale_sets_restart
export virtual_machine_scale_sets_set_orchestration_service_state
export virtual_machine_scale_sets_start
export virtual_machine_scale_sets_update
export virtual_machine_scale_sets_update_instances
