# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""AdditionalUnattendContent
Specifies additional XML formatted information that can be included in the Unattend.xml file, which is used by Windows Setup. Contents are defined by setting name, component name, and the pass in which the content is applied.

    AdditionalUnattendContent(;
        passName=nothing,
        componentName=nothing,
        settingName=nothing,
        content=nothing,
    )

    - passName::String : The pass name. Currently, the only allowable value is OobeSystem.
    - componentName::String : The component name. Currently, the only allowable value is Microsoft-Windows-Shell-Setup.
    - settingName::String : Specifies the name of the setting to which the content applies. Possible values are: FirstLogonCommands and AutoLogon.
    - content::String : Specifies the XML formatted content that is added to the unattend.xml file for the specified path and component. The XML must be less than 4KB and must include the root element for the setting or feature that is being inserted.
"""
Base.@kwdef mutable struct AdditionalUnattendContent <: OpenAPI.APIModel
    passName::Union{Nothing, String} = nothing
    componentName::Union{Nothing, String} = nothing
    settingName::Union{Nothing, String} = nothing
    content::Union{Nothing, String} = nothing

    function AdditionalUnattendContent(passName, componentName, settingName, content, )
        OpenAPI.validate_property(AdditionalUnattendContent, Symbol("passName"), passName)
        OpenAPI.validate_property(AdditionalUnattendContent, Symbol("componentName"), componentName)
        OpenAPI.validate_property(AdditionalUnattendContent, Symbol("settingName"), settingName)
        OpenAPI.validate_property(AdditionalUnattendContent, Symbol("content"), content)
        return new(passName, componentName, settingName, content, )
    end
end # type AdditionalUnattendContent

const _property_types_AdditionalUnattendContent = Dict{Symbol,String}(Symbol("passName")=>"String", Symbol("componentName")=>"String", Symbol("settingName")=>"String", Symbol("content")=>"String", )
OpenAPI.property_type(::Type{ AdditionalUnattendContent }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_AdditionalUnattendContent[name]))}

function check_required(o::AdditionalUnattendContent)
    true
end

function OpenAPI.validate_property(::Type{ AdditionalUnattendContent }, name::Symbol, val)
    if name === Symbol("passName")
        OpenAPI.validate_param(name, "AdditionalUnattendContent", :enum, val, ["OobeSystem"])
    end
    if name === Symbol("componentName")
        OpenAPI.validate_param(name, "AdditionalUnattendContent", :enum, val, ["Microsoft-Windows-Shell-Setup"])
    end
    if name === Symbol("settingName")
        OpenAPI.validate_param(name, "AdditionalUnattendContent", :enum, val, ["AutoLogon", "FirstLogonCommands"])
    end
end
