# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""AutomaticOSUpgradePolicy
The configuration parameters used for performing automatic OS upgrade.

    AutomaticOSUpgradePolicy(;
        enableAutomaticOSUpgrade=nothing,
        disableAutomaticRollback=nothing,
    )

    - enableAutomaticOSUpgrade::Bool : Indicates whether OS upgrades should automatically be applied to scale set instances in a rolling fashion when a newer version of the OS image becomes available. Default value is false. &lt;br&gt;&lt;br&gt; If this is set to true for Windows based scale sets, [enableAutomaticUpdates](https://docs.microsoft.com/dotnet/api/microsoft.azure.management.compute.models.windowsconfiguration.enableautomaticupdates?view&#x3D;azure-dotnet) is automatically set to false and cannot be set to true.
    - disableAutomaticRollback::Bool : Whether OS image rollback feature should be disabled. Default value is false.
"""
Base.@kwdef mutable struct AutomaticOSUpgradePolicy <: OpenAPI.APIModel
    enableAutomaticOSUpgrade::Union{Nothing, Bool} = nothing
    disableAutomaticRollback::Union{Nothing, Bool} = nothing

    function AutomaticOSUpgradePolicy(enableAutomaticOSUpgrade, disableAutomaticRollback, )
        OpenAPI.validate_property(AutomaticOSUpgradePolicy, Symbol("enableAutomaticOSUpgrade"), enableAutomaticOSUpgrade)
        OpenAPI.validate_property(AutomaticOSUpgradePolicy, Symbol("disableAutomaticRollback"), disableAutomaticRollback)
        return new(enableAutomaticOSUpgrade, disableAutomaticRollback, )
    end
end # type AutomaticOSUpgradePolicy

const _property_types_AutomaticOSUpgradePolicy = Dict{Symbol,String}(Symbol("enableAutomaticOSUpgrade")=>"Bool", Symbol("disableAutomaticRollback")=>"Bool", )
OpenAPI.property_type(::Type{ AutomaticOSUpgradePolicy }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_AutomaticOSUpgradePolicy[name]))}

function check_required(o::AutomaticOSUpgradePolicy)
    true
end

function OpenAPI.validate_property(::Type{ AutomaticOSUpgradePolicy }, name::Symbol, val)
end
