# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""AutomaticRepairsPolicy
Specifies the configuration parameters for automatic repairs on the virtual machine scale set.

    AutomaticRepairsPolicy(;
        enabled=nothing,
        gracePeriod=nothing,
    )

    - enabled::Bool : Specifies whether automatic repairs should be enabled on the virtual machine scale set. The default value is false.
    - gracePeriod::String : The amount of time for which automatic repairs are suspended due to a state change on VM. The grace time starts after the state change has completed. This helps avoid premature or accidental repairs. The time duration should be specified in ISO 8601 format. The minimum allowed grace period is 30 minutes (PT30M), which is also the default value. The maximum allowed grace period is 90 minutes (PT90M).
"""
Base.@kwdef mutable struct AutomaticRepairsPolicy <: OpenAPI.APIModel
    enabled::Union{Nothing, Bool} = nothing
    gracePeriod::Union{Nothing, String} = nothing

    function AutomaticRepairsPolicy(enabled, gracePeriod, )
        OpenAPI.validate_property(AutomaticRepairsPolicy, Symbol("enabled"), enabled)
        OpenAPI.validate_property(AutomaticRepairsPolicy, Symbol("gracePeriod"), gracePeriod)
        return new(enabled, gracePeriod, )
    end
end # type AutomaticRepairsPolicy

const _property_types_AutomaticRepairsPolicy = Dict{Symbol,String}(Symbol("enabled")=>"Bool", Symbol("gracePeriod")=>"String", )
OpenAPI.property_type(::Type{ AutomaticRepairsPolicy }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_AutomaticRepairsPolicy[name]))}

function check_required(o::AutomaticRepairsPolicy)
    true
end

function OpenAPI.validate_property(::Type{ AutomaticRepairsPolicy }, name::Symbol, val)
end
