# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""AvailabilitySetProperties
The instance view of a resource.

    AvailabilitySetProperties(;
        platformUpdateDomainCount=nothing,
        platformFaultDomainCount=nothing,
        virtualMachines=nothing,
        proximityPlacementGroup=nothing,
        statuses=nothing,
    )

    - platformUpdateDomainCount::Int64 : Update Domain count.
    - platformFaultDomainCount::Int64 : Fault Domain count.
    - virtualMachines::Vector{SubResource} : A list of references to all virtual machines in the availability set.
    - proximityPlacementGroup::SubResource
    - statuses::Vector{InstanceViewStatus} : The resource status information.
"""
Base.@kwdef mutable struct AvailabilitySetProperties <: OpenAPI.APIModel
    platformUpdateDomainCount::Union{Nothing, Int64} = nothing
    platformFaultDomainCount::Union{Nothing, Int64} = nothing
    virtualMachines::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{SubResource} }
    proximityPlacementGroup = nothing # spec type: Union{ Nothing, SubResource }
    statuses::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{InstanceViewStatus} }

    function AvailabilitySetProperties(platformUpdateDomainCount, platformFaultDomainCount, virtualMachines, proximityPlacementGroup, statuses, )
        OpenAPI.validate_property(AvailabilitySetProperties, Symbol("platformUpdateDomainCount"), platformUpdateDomainCount)
        OpenAPI.validate_property(AvailabilitySetProperties, Symbol("platformFaultDomainCount"), platformFaultDomainCount)
        OpenAPI.validate_property(AvailabilitySetProperties, Symbol("virtualMachines"), virtualMachines)
        OpenAPI.validate_property(AvailabilitySetProperties, Symbol("proximityPlacementGroup"), proximityPlacementGroup)
        OpenAPI.validate_property(AvailabilitySetProperties, Symbol("statuses"), statuses)
        return new(platformUpdateDomainCount, platformFaultDomainCount, virtualMachines, proximityPlacementGroup, statuses, )
    end
end # type AvailabilitySetProperties

const _property_types_AvailabilitySetProperties = Dict{Symbol,String}(Symbol("platformUpdateDomainCount")=>"Int64", Symbol("platformFaultDomainCount")=>"Int64", Symbol("virtualMachines")=>"Vector{SubResource}", Symbol("proximityPlacementGroup")=>"SubResource", Symbol("statuses")=>"Vector{InstanceViewStatus}", )
OpenAPI.property_type(::Type{ AvailabilitySetProperties }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_AvailabilitySetProperties[name]))}

function check_required(o::AvailabilitySetProperties)
    true
end

function OpenAPI.validate_property(::Type{ AvailabilitySetProperties }, name::Symbol, val)
    if name === Symbol("platformUpdateDomainCount")
        OpenAPI.validate_param(name, "AvailabilitySetProperties", :format, val, "int32")
    end
    if name === Symbol("platformFaultDomainCount")
        OpenAPI.validate_param(name, "AvailabilitySetProperties", :format, val, "int32")
    end
end
