# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""BillingProfile
Specifies the billing related details of a Azure Spot VM or VMSS. &lt;br&gt;&lt;br&gt;Minimum api-version: 2019-03-01.

    BillingProfile(;
        maxPrice=nothing,
    )

    - maxPrice::Float64 : Specifies the maximum price you are willing to pay for a Azure Spot VM/VMSS. This price is in US Dollars. &lt;br&gt;&lt;br&gt; This price will be compared with the current Azure Spot price for the VM size. Also, the prices are compared at the time of create/update of Azure Spot VM/VMSS and the operation will only succeed if  the maxPrice is greater than the current Azure Spot price. &lt;br&gt;&lt;br&gt; The maxPrice will also be used for evicting a Azure Spot VM/VMSS if the current Azure Spot price goes beyond the maxPrice after creation of VM/VMSS. &lt;br&gt;&lt;br&gt; Possible values are: &lt;br&gt;&lt;br&gt; - Any decimal value greater than zero. Example: 0.01538 &lt;br&gt;&lt;br&gt; -1 – indicates default price to be up-to on-demand. &lt;br&gt;&lt;br&gt; You can set the maxPrice to -1 to indicate that the Azure Spot VM/VMSS should not be evicted for price reasons. Also, the default max price is -1 if it is not provided by you. &lt;br&gt;&lt;br&gt;Minimum api-version: 2019-03-01.
"""
Base.@kwdef mutable struct BillingProfile <: OpenAPI.APIModel
    maxPrice::Union{Nothing, Float64} = nothing

    function BillingProfile(maxPrice, )
        OpenAPI.validate_property(BillingProfile, Symbol("maxPrice"), maxPrice)
        return new(maxPrice, )
    end
end # type BillingProfile

const _property_types_BillingProfile = Dict{Symbol,String}(Symbol("maxPrice")=>"Float64", )
OpenAPI.property_type(::Type{ BillingProfile }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_BillingProfile[name]))}

function check_required(o::BillingProfile)
    true
end

function OpenAPI.validate_property(::Type{ BillingProfile }, name::Symbol, val)
    if name === Symbol("maxPrice")
        OpenAPI.validate_param(name, "BillingProfile", :format, val, "double")
    end
end
