# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""ImageReference
Specifies information about the image to use. You can specify information about platform images, marketplace images, or virtual machine images. This element is required when you want to use a platform image, marketplace image, or virtual machine image, but is not used in other creation operations. NOTE: Image reference publisher and offer can only be set when you create the scale set.

    ImageReference(;
        id=nothing,
        publisher=nothing,
        offer=nothing,
        sku=nothing,
        version=nothing,
        exactVersion=nothing,
    )

    - id::String : Resource Id
    - publisher::String : The image publisher.
    - offer::String : Specifies the offer of the platform image or marketplace image used to create the virtual machine.
    - sku::String : The image SKU.
    - version::String : Specifies the version of the platform image or marketplace image used to create the virtual machine. The allowed formats are Major.Minor.Build or &#39;latest&#39;. Major, Minor, and Build are decimal numbers. Specify &#39;latest&#39; to use the latest version of an image available at deploy time. Even if you use &#39;latest&#39;, the VM image will not automatically update after deploy time even if a new version becomes available.
    - exactVersion::String : Specifies in decimal numbers, the version of platform image or marketplace image used to create the virtual machine. This readonly field differs from &#39;version&#39;, only if the value specified in &#39;version&#39; field is &#39;latest&#39;.
"""
Base.@kwdef mutable struct ImageReference <: OpenAPI.APIModel
    id::Union{Nothing, String} = nothing
    publisher::Union{Nothing, String} = nothing
    offer::Union{Nothing, String} = nothing
    sku::Union{Nothing, String} = nothing
    version::Union{Nothing, String} = nothing
    exactVersion::Union{Nothing, String} = nothing

    function ImageReference(id, publisher, offer, sku, version, exactVersion, )
        OpenAPI.validate_property(ImageReference, Symbol("id"), id)
        OpenAPI.validate_property(ImageReference, Symbol("publisher"), publisher)
        OpenAPI.validate_property(ImageReference, Symbol("offer"), offer)
        OpenAPI.validate_property(ImageReference, Symbol("sku"), sku)
        OpenAPI.validate_property(ImageReference, Symbol("version"), version)
        OpenAPI.validate_property(ImageReference, Symbol("exactVersion"), exactVersion)
        return new(id, publisher, offer, sku, version, exactVersion, )
    end
end # type ImageReference

const _property_types_ImageReference = Dict{Symbol,String}(Symbol("id")=>"String", Symbol("publisher")=>"String", Symbol("offer")=>"String", Symbol("sku")=>"String", Symbol("version")=>"String", Symbol("exactVersion")=>"String", )
OpenAPI.property_type(::Type{ ImageReference }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_ImageReference[name]))}

function check_required(o::ImageReference)
    true
end

function OpenAPI.validate_property(::Type{ ImageReference }, name::Symbol, val)
end
