# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""MaintenanceRedeployStatus
Maintenance Operation Status.

    MaintenanceRedeployStatus(;
        isCustomerInitiatedMaintenanceAllowed=nothing,
        preMaintenanceWindowStartTime=nothing,
        preMaintenanceWindowEndTime=nothing,
        maintenanceWindowStartTime=nothing,
        maintenanceWindowEndTime=nothing,
        lastOperationResultCode=nothing,
        lastOperationMessage=nothing,
    )

    - isCustomerInitiatedMaintenanceAllowed::Bool : True, if customer is allowed to perform Maintenance.
    - preMaintenanceWindowStartTime::ZonedDateTime : Start Time for the Pre Maintenance Window.
    - preMaintenanceWindowEndTime::ZonedDateTime : End Time for the Pre Maintenance Window.
    - maintenanceWindowStartTime::ZonedDateTime : Start Time for the Maintenance Window.
    - maintenanceWindowEndTime::ZonedDateTime : End Time for the Maintenance Window.
    - lastOperationResultCode::String : The Last Maintenance Operation Result Code.
    - lastOperationMessage::String : Message returned for the last Maintenance Operation.
"""
Base.@kwdef mutable struct MaintenanceRedeployStatus <: OpenAPI.APIModel
    isCustomerInitiatedMaintenanceAllowed::Union{Nothing, Bool} = nothing
    preMaintenanceWindowStartTime::Union{Nothing, ZonedDateTime} = nothing
    preMaintenanceWindowEndTime::Union{Nothing, ZonedDateTime} = nothing
    maintenanceWindowStartTime::Union{Nothing, ZonedDateTime} = nothing
    maintenanceWindowEndTime::Union{Nothing, ZonedDateTime} = nothing
    lastOperationResultCode::Union{Nothing, String} = nothing
    lastOperationMessage::Union{Nothing, String} = nothing

    function MaintenanceRedeployStatus(isCustomerInitiatedMaintenanceAllowed, preMaintenanceWindowStartTime, preMaintenanceWindowEndTime, maintenanceWindowStartTime, maintenanceWindowEndTime, lastOperationResultCode, lastOperationMessage, )
        OpenAPI.validate_property(MaintenanceRedeployStatus, Symbol("isCustomerInitiatedMaintenanceAllowed"), isCustomerInitiatedMaintenanceAllowed)
        OpenAPI.validate_property(MaintenanceRedeployStatus, Symbol("preMaintenanceWindowStartTime"), preMaintenanceWindowStartTime)
        OpenAPI.validate_property(MaintenanceRedeployStatus, Symbol("preMaintenanceWindowEndTime"), preMaintenanceWindowEndTime)
        OpenAPI.validate_property(MaintenanceRedeployStatus, Symbol("maintenanceWindowStartTime"), maintenanceWindowStartTime)
        OpenAPI.validate_property(MaintenanceRedeployStatus, Symbol("maintenanceWindowEndTime"), maintenanceWindowEndTime)
        OpenAPI.validate_property(MaintenanceRedeployStatus, Symbol("lastOperationResultCode"), lastOperationResultCode)
        OpenAPI.validate_property(MaintenanceRedeployStatus, Symbol("lastOperationMessage"), lastOperationMessage)
        return new(isCustomerInitiatedMaintenanceAllowed, preMaintenanceWindowStartTime, preMaintenanceWindowEndTime, maintenanceWindowStartTime, maintenanceWindowEndTime, lastOperationResultCode, lastOperationMessage, )
    end
end # type MaintenanceRedeployStatus

const _property_types_MaintenanceRedeployStatus = Dict{Symbol,String}(Symbol("isCustomerInitiatedMaintenanceAllowed")=>"Bool", Symbol("preMaintenanceWindowStartTime")=>"ZonedDateTime", Symbol("preMaintenanceWindowEndTime")=>"ZonedDateTime", Symbol("maintenanceWindowStartTime")=>"ZonedDateTime", Symbol("maintenanceWindowEndTime")=>"ZonedDateTime", Symbol("lastOperationResultCode")=>"String", Symbol("lastOperationMessage")=>"String", )
OpenAPI.property_type(::Type{ MaintenanceRedeployStatus }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_MaintenanceRedeployStatus[name]))}

function check_required(o::MaintenanceRedeployStatus)
    true
end

function OpenAPI.validate_property(::Type{ MaintenanceRedeployStatus }, name::Symbol, val)
    if name === Symbol("preMaintenanceWindowStartTime")
        OpenAPI.validate_param(name, "MaintenanceRedeployStatus", :format, val, "date-time")
    end
    if name === Symbol("preMaintenanceWindowEndTime")
        OpenAPI.validate_param(name, "MaintenanceRedeployStatus", :format, val, "date-time")
    end
    if name === Symbol("maintenanceWindowStartTime")
        OpenAPI.validate_param(name, "MaintenanceRedeployStatus", :format, val, "date-time")
    end
    if name === Symbol("maintenanceWindowEndTime")
        OpenAPI.validate_param(name, "MaintenanceRedeployStatus", :format, val, "date-time")
    end
    if name === Symbol("lastOperationResultCode")
        OpenAPI.validate_param(name, "MaintenanceRedeployStatus", :enum, val, ["None", "RetryLater", "MaintenanceAborted", "MaintenanceCompleted"])
    end
end
