# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""RequestRateByIntervalInput
Api request input for LogAnalytics getRequestRateByInterval Api.

    RequestRateByIntervalInput(;
        intervalLength=nothing,
        blobContainerSasUri=nothing,
        fromTime=nothing,
        toTime=nothing,
        groupByThrottlePolicy=nothing,
        groupByOperationName=nothing,
        groupByResourceName=nothing,
    )

    - intervalLength::String : Interval value in minutes used to create LogAnalytics call rate logs.
    - blobContainerSasUri::String : SAS Uri of the logging blob container to which LogAnalytics Api writes output logs to.
    - fromTime::ZonedDateTime : From time of the query
    - toTime::ZonedDateTime : To time of the query
    - groupByThrottlePolicy::Bool : Group query result by Throttle Policy applied.
    - groupByOperationName::Bool : Group query result by Operation Name.
    - groupByResourceName::Bool : Group query result by Resource Name.
"""
Base.@kwdef mutable struct RequestRateByIntervalInput <: OpenAPI.APIModel
    intervalLength::Union{Nothing, String} = nothing
    blobContainerSasUri::Union{Nothing, String} = nothing
    fromTime::Union{Nothing, ZonedDateTime} = nothing
    toTime::Union{Nothing, ZonedDateTime} = nothing
    groupByThrottlePolicy::Union{Nothing, Bool} = nothing
    groupByOperationName::Union{Nothing, Bool} = nothing
    groupByResourceName::Union{Nothing, Bool} = nothing

    function RequestRateByIntervalInput(intervalLength, blobContainerSasUri, fromTime, toTime, groupByThrottlePolicy, groupByOperationName, groupByResourceName, )
        OpenAPI.validate_property(RequestRateByIntervalInput, Symbol("intervalLength"), intervalLength)
        OpenAPI.validate_property(RequestRateByIntervalInput, Symbol("blobContainerSasUri"), blobContainerSasUri)
        OpenAPI.validate_property(RequestRateByIntervalInput, Symbol("fromTime"), fromTime)
        OpenAPI.validate_property(RequestRateByIntervalInput, Symbol("toTime"), toTime)
        OpenAPI.validate_property(RequestRateByIntervalInput, Symbol("groupByThrottlePolicy"), groupByThrottlePolicy)
        OpenAPI.validate_property(RequestRateByIntervalInput, Symbol("groupByOperationName"), groupByOperationName)
        OpenAPI.validate_property(RequestRateByIntervalInput, Symbol("groupByResourceName"), groupByResourceName)
        return new(intervalLength, blobContainerSasUri, fromTime, toTime, groupByThrottlePolicy, groupByOperationName, groupByResourceName, )
    end
end # type RequestRateByIntervalInput

const _property_types_RequestRateByIntervalInput = Dict{Symbol,String}(Symbol("intervalLength")=>"String", Symbol("blobContainerSasUri")=>"String", Symbol("fromTime")=>"ZonedDateTime", Symbol("toTime")=>"ZonedDateTime", Symbol("groupByThrottlePolicy")=>"Bool", Symbol("groupByOperationName")=>"Bool", Symbol("groupByResourceName")=>"Bool", )
OpenAPI.property_type(::Type{ RequestRateByIntervalInput }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_RequestRateByIntervalInput[name]))}

function check_required(o::RequestRateByIntervalInput)
    o.intervalLength === nothing && (return false)
    o.blobContainerSasUri === nothing && (return false)
    o.fromTime === nothing && (return false)
    o.toTime === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ RequestRateByIntervalInput }, name::Symbol, val)
    if name === Symbol("intervalLength")
        OpenAPI.validate_param(name, "RequestRateByIntervalInput", :enum, val, ["ThreeMins", "FiveMins", "ThirtyMins", "SixtyMins"])
    end
    if name === Symbol("fromTime")
        OpenAPI.validate_param(name, "RequestRateByIntervalInput", :format, val, "date-time")
    end
    if name === Symbol("toTime")
        OpenAPI.validate_param(name, "RequestRateByIntervalInput", :format, val, "date-time")
    end
end
