# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""SshPublicKeyGenerateKeyPairResult
Response from generation of an SSH key pair.

    SshPublicKeyGenerateKeyPairResult(;
        privateKey=nothing,
        publicKey=nothing,
        id=nothing,
    )

    - privateKey::String : Private key portion of the key pair used to authenticate to a virtual machine through ssh. The private key is returned in RFC3447 format and should be treated as a secret.
    - publicKey::String : Public key portion of the key pair used to authenticate to a virtual machine through ssh. The public key is in ssh-rsa format.
    - id::String : The ARM resource id in the form of /subscriptions/{SubscriptionId}/resourceGroups/{ResourceGroupName}/providers/Microsoft.Compute/sshPublicKeys/{SshPublicKeyName}
"""
Base.@kwdef mutable struct SshPublicKeyGenerateKeyPairResult <: OpenAPI.APIModel
    privateKey::Union{Nothing, String} = nothing
    publicKey::Union{Nothing, String} = nothing
    id::Union{Nothing, String} = nothing

    function SshPublicKeyGenerateKeyPairResult(privateKey, publicKey, id, )
        OpenAPI.validate_property(SshPublicKeyGenerateKeyPairResult, Symbol("privateKey"), privateKey)
        OpenAPI.validate_property(SshPublicKeyGenerateKeyPairResult, Symbol("publicKey"), publicKey)
        OpenAPI.validate_property(SshPublicKeyGenerateKeyPairResult, Symbol("id"), id)
        return new(privateKey, publicKey, id, )
    end
end # type SshPublicKeyGenerateKeyPairResult

const _property_types_SshPublicKeyGenerateKeyPairResult = Dict{Symbol,String}(Symbol("privateKey")=>"String", Symbol("publicKey")=>"String", Symbol("id")=>"String", )
OpenAPI.property_type(::Type{ SshPublicKeyGenerateKeyPairResult }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_SshPublicKeyGenerateKeyPairResult[name]))}

function check_required(o::SshPublicKeyGenerateKeyPairResult)
    o.privateKey === nothing && (return false)
    o.publicKey === nothing && (return false)
    o.id === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ SshPublicKeyGenerateKeyPairResult }, name::Symbol, val)
end
