# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""VirtualMachineExtensionProperties
Describes the properties of a Virtual Machine Extension.

    VirtualMachineExtensionProperties(;
        forceUpdateTag=nothing,
        publisher=nothing,
        type=nothing,
        typeHandlerVersion=nothing,
        autoUpgradeMinorVersion=nothing,
        settings=nothing,
        protectedSettings=nothing,
        provisioningState=nothing,
        instanceView=nothing,
    )

    - forceUpdateTag::String : How the extension handler should be forced to update even if the extension configuration has not changed.
    - publisher::String : The name of the extension handler publisher.
    - type::String : Specifies the type of the extension; an example is \&quot;CustomScriptExtension\&quot;.
    - typeHandlerVersion::String : Specifies the version of the script handler.
    - autoUpgradeMinorVersion::Bool : Indicates whether the extension should use a newer minor version if one is available at deployment time. Once deployed, however, the extension will not upgrade minor versions unless redeployed, even with this property set to true.
    - settings::Any : Json formatted public settings for the extension.
    - protectedSettings::Any : The extension can contain either protectedSettings or protectedSettingsFromKeyVault or no protected settings at all.
    - provisioningState::String : The provisioning state, which only appears in the response.
    - instanceView::VirtualMachineExtensionInstanceView
"""
Base.@kwdef mutable struct VirtualMachineExtensionProperties <: OpenAPI.APIModel
    forceUpdateTag::Union{Nothing, String} = nothing
    publisher::Union{Nothing, String} = nothing
    type::Union{Nothing, String} = nothing
    typeHandlerVersion::Union{Nothing, String} = nothing
    autoUpgradeMinorVersion::Union{Nothing, Bool} = nothing
    settings::Union{Nothing, Any} = nothing
    protectedSettings::Union{Nothing, Any} = nothing
    provisioningState::Union{Nothing, String} = nothing
    instanceView = nothing # spec type: Union{ Nothing, VirtualMachineExtensionInstanceView }

    function VirtualMachineExtensionProperties(forceUpdateTag, publisher, type, typeHandlerVersion, autoUpgradeMinorVersion, settings, protectedSettings, provisioningState, instanceView, )
        OpenAPI.validate_property(VirtualMachineExtensionProperties, Symbol("forceUpdateTag"), forceUpdateTag)
        OpenAPI.validate_property(VirtualMachineExtensionProperties, Symbol("publisher"), publisher)
        OpenAPI.validate_property(VirtualMachineExtensionProperties, Symbol("type"), type)
        OpenAPI.validate_property(VirtualMachineExtensionProperties, Symbol("typeHandlerVersion"), typeHandlerVersion)
        OpenAPI.validate_property(VirtualMachineExtensionProperties, Symbol("autoUpgradeMinorVersion"), autoUpgradeMinorVersion)
        OpenAPI.validate_property(VirtualMachineExtensionProperties, Symbol("settings"), settings)
        OpenAPI.validate_property(VirtualMachineExtensionProperties, Symbol("protectedSettings"), protectedSettings)
        OpenAPI.validate_property(VirtualMachineExtensionProperties, Symbol("provisioningState"), provisioningState)
        OpenAPI.validate_property(VirtualMachineExtensionProperties, Symbol("instanceView"), instanceView)
        return new(forceUpdateTag, publisher, type, typeHandlerVersion, autoUpgradeMinorVersion, settings, protectedSettings, provisioningState, instanceView, )
    end
end # type VirtualMachineExtensionProperties

const _property_types_VirtualMachineExtensionProperties = Dict{Symbol,String}(Symbol("forceUpdateTag")=>"String", Symbol("publisher")=>"String", Symbol("type")=>"String", Symbol("typeHandlerVersion")=>"String", Symbol("autoUpgradeMinorVersion")=>"Bool", Symbol("settings")=>"Any", Symbol("protectedSettings")=>"Any", Symbol("provisioningState")=>"String", Symbol("instanceView")=>"VirtualMachineExtensionInstanceView", )
OpenAPI.property_type(::Type{ VirtualMachineExtensionProperties }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_VirtualMachineExtensionProperties[name]))}

function check_required(o::VirtualMachineExtensionProperties)
    true
end

function OpenAPI.validate_property(::Type{ VirtualMachineExtensionProperties }, name::Symbol, val)
end
