# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""VirtualMachineImageProperties
Describes the properties of a Virtual Machine Image.

    VirtualMachineImageProperties(;
        plan=nothing,
        osDiskImage=nothing,
        dataDiskImages=nothing,
        automaticOSUpgradeProperties=nothing,
        hyperVGeneration=nothing,
        disallowed=nothing,
    )

    - plan::PurchasePlan
    - osDiskImage::OSDiskImage
    - dataDiskImages::Vector{DataDiskImage}
    - automaticOSUpgradeProperties::AutomaticOSUpgradeProperties
    - hyperVGeneration::HyperVGenerationType
    - disallowed::DisallowedConfiguration
"""
Base.@kwdef mutable struct VirtualMachineImageProperties <: OpenAPI.APIModel
    plan = nothing # spec type: Union{ Nothing, PurchasePlan }
    osDiskImage = nothing # spec type: Union{ Nothing, OSDiskImage }
    dataDiskImages::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{DataDiskImage} }
    automaticOSUpgradeProperties = nothing # spec type: Union{ Nothing, AutomaticOSUpgradeProperties }
    hyperVGeneration = nothing # spec type: Union{ Nothing, HyperVGenerationType }
    disallowed = nothing # spec type: Union{ Nothing, DisallowedConfiguration }

    function VirtualMachineImageProperties(plan, osDiskImage, dataDiskImages, automaticOSUpgradeProperties, hyperVGeneration, disallowed, )
        OpenAPI.validate_property(VirtualMachineImageProperties, Symbol("plan"), plan)
        OpenAPI.validate_property(VirtualMachineImageProperties, Symbol("osDiskImage"), osDiskImage)
        OpenAPI.validate_property(VirtualMachineImageProperties, Symbol("dataDiskImages"), dataDiskImages)
        OpenAPI.validate_property(VirtualMachineImageProperties, Symbol("automaticOSUpgradeProperties"), automaticOSUpgradeProperties)
        OpenAPI.validate_property(VirtualMachineImageProperties, Symbol("hyperVGeneration"), hyperVGeneration)
        OpenAPI.validate_property(VirtualMachineImageProperties, Symbol("disallowed"), disallowed)
        return new(plan, osDiskImage, dataDiskImages, automaticOSUpgradeProperties, hyperVGeneration, disallowed, )
    end
end # type VirtualMachineImageProperties

const _property_types_VirtualMachineImageProperties = Dict{Symbol,String}(Symbol("plan")=>"PurchasePlan", Symbol("osDiskImage")=>"OSDiskImage", Symbol("dataDiskImages")=>"Vector{DataDiskImage}", Symbol("automaticOSUpgradeProperties")=>"AutomaticOSUpgradeProperties", Symbol("hyperVGeneration")=>"HyperVGenerationType", Symbol("disallowed")=>"DisallowedConfiguration", )
OpenAPI.property_type(::Type{ VirtualMachineImageProperties }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_VirtualMachineImageProperties[name]))}

function check_required(o::VirtualMachineImageProperties)
    true
end

function OpenAPI.validate_property(::Type{ VirtualMachineImageProperties }, name::Symbol, val)
end
