# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""VirtualMachineScaleSetExtensionProfile
Describes a virtual machine scale set extension profile.

    VirtualMachineScaleSetExtensionProfile(;
        extensions=nothing,
        extensionsTimeBudget=nothing,
    )

    - extensions::Vector{VirtualMachineScaleSetExtension} : The virtual machine scale set child extension resources.
    - extensionsTimeBudget::String : Specifies the time alloted for all extensions to start. The time duration should be between 15 minutes and 120 minutes (inclusive) and should be specified in ISO 8601 format. The default value is 90 minutes (PT1H30M). &lt;br&gt;&lt;br&gt; Minimum api-version: 2020-06-01
"""
Base.@kwdef mutable struct VirtualMachineScaleSetExtensionProfile <: OpenAPI.APIModel
    extensions::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{VirtualMachineScaleSetExtension} }
    extensionsTimeBudget::Union{Nothing, String} = nothing

    function VirtualMachineScaleSetExtensionProfile(extensions, extensionsTimeBudget, )
        OpenAPI.validate_property(VirtualMachineScaleSetExtensionProfile, Symbol("extensions"), extensions)
        OpenAPI.validate_property(VirtualMachineScaleSetExtensionProfile, Symbol("extensionsTimeBudget"), extensionsTimeBudget)
        return new(extensions, extensionsTimeBudget, )
    end
end # type VirtualMachineScaleSetExtensionProfile

const _property_types_VirtualMachineScaleSetExtensionProfile = Dict{Symbol,String}(Symbol("extensions")=>"Vector{VirtualMachineScaleSetExtension}", Symbol("extensionsTimeBudget")=>"String", )
OpenAPI.property_type(::Type{ VirtualMachineScaleSetExtensionProfile }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_VirtualMachineScaleSetExtensionProfile[name]))}

function check_required(o::VirtualMachineScaleSetExtensionProfile)
    true
end

function OpenAPI.validate_property(::Type{ VirtualMachineScaleSetExtensionProfile }, name::Symbol, val)
end
