# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""VirtualMachineScaleSetNetworkConfigurationProperties
Describes a virtual machine scale set network profile&#39;s IP configuration.

    VirtualMachineScaleSetNetworkConfigurationProperties(;
        primary=nothing,
        enableAcceleratedNetworking=nothing,
        networkSecurityGroup=nothing,
        dnsSettings=nothing,
        ipConfigurations=nothing,
        enableIPForwarding=nothing,
    )

    - primary::Bool : Specifies the primary network interface in case the virtual machine has more than 1 network interface.
    - enableAcceleratedNetworking::Bool : Specifies whether the network interface is accelerated networking-enabled.
    - networkSecurityGroup::SubResource
    - dnsSettings::VirtualMachineScaleSetNetworkConfigurationDnsSettings
    - ipConfigurations::Vector{VirtualMachineScaleSetIPConfiguration} : Specifies the IP configurations of the network interface.
    - enableIPForwarding::Bool : Whether IP forwarding enabled on this NIC.
"""
Base.@kwdef mutable struct VirtualMachineScaleSetNetworkConfigurationProperties <: OpenAPI.APIModel
    primary::Union{Nothing, Bool} = nothing
    enableAcceleratedNetworking::Union{Nothing, Bool} = nothing
    networkSecurityGroup = nothing # spec type: Union{ Nothing, SubResource }
    dnsSettings = nothing # spec type: Union{ Nothing, VirtualMachineScaleSetNetworkConfigurationDnsSettings }
    ipConfigurations::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{VirtualMachineScaleSetIPConfiguration} }
    enableIPForwarding::Union{Nothing, Bool} = nothing

    function VirtualMachineScaleSetNetworkConfigurationProperties(primary, enableAcceleratedNetworking, networkSecurityGroup, dnsSettings, ipConfigurations, enableIPForwarding, )
        OpenAPI.validate_property(VirtualMachineScaleSetNetworkConfigurationProperties, Symbol("primary"), primary)
        OpenAPI.validate_property(VirtualMachineScaleSetNetworkConfigurationProperties, Symbol("enableAcceleratedNetworking"), enableAcceleratedNetworking)
        OpenAPI.validate_property(VirtualMachineScaleSetNetworkConfigurationProperties, Symbol("networkSecurityGroup"), networkSecurityGroup)
        OpenAPI.validate_property(VirtualMachineScaleSetNetworkConfigurationProperties, Symbol("dnsSettings"), dnsSettings)
        OpenAPI.validate_property(VirtualMachineScaleSetNetworkConfigurationProperties, Symbol("ipConfigurations"), ipConfigurations)
        OpenAPI.validate_property(VirtualMachineScaleSetNetworkConfigurationProperties, Symbol("enableIPForwarding"), enableIPForwarding)
        return new(primary, enableAcceleratedNetworking, networkSecurityGroup, dnsSettings, ipConfigurations, enableIPForwarding, )
    end
end # type VirtualMachineScaleSetNetworkConfigurationProperties

const _property_types_VirtualMachineScaleSetNetworkConfigurationProperties = Dict{Symbol,String}(Symbol("primary")=>"Bool", Symbol("enableAcceleratedNetworking")=>"Bool", Symbol("networkSecurityGroup")=>"SubResource", Symbol("dnsSettings")=>"VirtualMachineScaleSetNetworkConfigurationDnsSettings", Symbol("ipConfigurations")=>"Vector{VirtualMachineScaleSetIPConfiguration}", Symbol("enableIPForwarding")=>"Bool", )
OpenAPI.property_type(::Type{ VirtualMachineScaleSetNetworkConfigurationProperties }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_VirtualMachineScaleSetNetworkConfigurationProperties[name]))}

function check_required(o::VirtualMachineScaleSetNetworkConfigurationProperties)
    o.ipConfigurations === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ VirtualMachineScaleSetNetworkConfigurationProperties }, name::Symbol, val)
end
