# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""VirtualMachineScaleSetPublicIPAddressConfigurationProperties
Describes a virtual machines scale set IP Configuration&#39;s PublicIPAddress configuration

    VirtualMachineScaleSetPublicIPAddressConfigurationProperties(;
        idleTimeoutInMinutes=nothing,
        dnsSettings=nothing,
        ipTags=nothing,
        publicIPPrefix=nothing,
        publicIPAddressVersion=nothing,
    )

    - idleTimeoutInMinutes::Int64 : The idle timeout of the public IP address.
    - dnsSettings::VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettings
    - ipTags::Vector{VirtualMachineScaleSetIpTag} : The list of IP tags associated with the public IP address.
    - publicIPPrefix::SubResource
    - publicIPAddressVersion::String : Available from Api-Version 2019-07-01 onwards, it represents whether the specific ipconfiguration is IPv4 or IPv6. Default is taken as IPv4. Possible values are: &#39;IPv4&#39; and &#39;IPv6&#39;.
"""
Base.@kwdef mutable struct VirtualMachineScaleSetPublicIPAddressConfigurationProperties <: OpenAPI.APIModel
    idleTimeoutInMinutes::Union{Nothing, Int64} = nothing
    dnsSettings = nothing # spec type: Union{ Nothing, VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettings }
    ipTags::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{VirtualMachineScaleSetIpTag} }
    publicIPPrefix = nothing # spec type: Union{ Nothing, SubResource }
    publicIPAddressVersion::Union{Nothing, String} = nothing

    function VirtualMachineScaleSetPublicIPAddressConfigurationProperties(idleTimeoutInMinutes, dnsSettings, ipTags, publicIPPrefix, publicIPAddressVersion, )
        OpenAPI.validate_property(VirtualMachineScaleSetPublicIPAddressConfigurationProperties, Symbol("idleTimeoutInMinutes"), idleTimeoutInMinutes)
        OpenAPI.validate_property(VirtualMachineScaleSetPublicIPAddressConfigurationProperties, Symbol("dnsSettings"), dnsSettings)
        OpenAPI.validate_property(VirtualMachineScaleSetPublicIPAddressConfigurationProperties, Symbol("ipTags"), ipTags)
        OpenAPI.validate_property(VirtualMachineScaleSetPublicIPAddressConfigurationProperties, Symbol("publicIPPrefix"), publicIPPrefix)
        OpenAPI.validate_property(VirtualMachineScaleSetPublicIPAddressConfigurationProperties, Symbol("publicIPAddressVersion"), publicIPAddressVersion)
        return new(idleTimeoutInMinutes, dnsSettings, ipTags, publicIPPrefix, publicIPAddressVersion, )
    end
end # type VirtualMachineScaleSetPublicIPAddressConfigurationProperties

const _property_types_VirtualMachineScaleSetPublicIPAddressConfigurationProperties = Dict{Symbol,String}(Symbol("idleTimeoutInMinutes")=>"Int64", Symbol("dnsSettings")=>"VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettings", Symbol("ipTags")=>"Vector{VirtualMachineScaleSetIpTag}", Symbol("publicIPPrefix")=>"SubResource", Symbol("publicIPAddressVersion")=>"String", )
OpenAPI.property_type(::Type{ VirtualMachineScaleSetPublicIPAddressConfigurationProperties }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_VirtualMachineScaleSetPublicIPAddressConfigurationProperties[name]))}

function check_required(o::VirtualMachineScaleSetPublicIPAddressConfigurationProperties)
    true
end

function OpenAPI.validate_property(::Type{ VirtualMachineScaleSetPublicIPAddressConfigurationProperties }, name::Symbol, val)
    if name === Symbol("idleTimeoutInMinutes")
        OpenAPI.validate_param(name, "VirtualMachineScaleSetPublicIPAddressConfigurationProperties", :format, val, "int32")
    end
    if name === Symbol("publicIPAddressVersion")
        OpenAPI.validate_param(name, "VirtualMachineScaleSetPublicIPAddressConfigurationProperties", :enum, val, ["IPv4", "IPv6"])
    end
end
