# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""VirtualMachineScaleSetReimageParameters
Describes a Virtual Machine Scale Set VM Reimage Parameters.

    VirtualMachineScaleSetReimageParameters(;
        instanceIds=nothing,
        tempDisk=nothing,
    )

    - instanceIds::Vector{String} : The virtual machine scale set instance ids. Omitting the virtual machine scale set instance ids will result in the operation being performed on all virtual machines in the virtual machine scale set.
    - tempDisk::Bool : Specifies whether to reimage temp disk. Default value: false. Note: This temp disk reimage parameter is only supported for VM/VMSS with Ephemeral OS disk.
"""
Base.@kwdef mutable struct VirtualMachineScaleSetReimageParameters <: OpenAPI.APIModel
    instanceIds::Union{Nothing, Vector{String}} = nothing
    tempDisk::Union{Nothing, Bool} = nothing

    function VirtualMachineScaleSetReimageParameters(instanceIds, tempDisk, )
        OpenAPI.validate_property(VirtualMachineScaleSetReimageParameters, Symbol("instanceIds"), instanceIds)
        OpenAPI.validate_property(VirtualMachineScaleSetReimageParameters, Symbol("tempDisk"), tempDisk)
        return new(instanceIds, tempDisk, )
    end
end # type VirtualMachineScaleSetReimageParameters

const _property_types_VirtualMachineScaleSetReimageParameters = Dict{Symbol,String}(Symbol("instanceIds")=>"Vector{String}", Symbol("tempDisk")=>"Bool", )
OpenAPI.property_type(::Type{ VirtualMachineScaleSetReimageParameters }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_VirtualMachineScaleSetReimageParameters[name]))}

function check_required(o::VirtualMachineScaleSetReimageParameters)
    true
end

function OpenAPI.validate_property(::Type{ VirtualMachineScaleSetReimageParameters }, name::Symbol, val)
end
