# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""VirtualMachineScaleSetUpdateOSDisk
Describes virtual machine scale set operating system disk Update Object. This should be used for Updating VMSS OS Disk.

    VirtualMachineScaleSetUpdateOSDisk(;
        caching=nothing,
        writeAcceleratorEnabled=nothing,
        diskSizeGB=nothing,
        image=nothing,
        vhdContainers=nothing,
        managedDisk=nothing,
    )

    - caching::Caching
    - writeAcceleratorEnabled::Bool : Specifies whether writeAccelerator should be enabled or disabled on the disk.
    - diskSizeGB::Int64 : Specifies the size of the operating system disk in gigabytes. This element can be used to overwrite the size of the disk in a virtual machine image. &lt;br&gt;&lt;br&gt; This value cannot be larger than 1023 GB
    - image::VirtualHardDisk
    - vhdContainers::Vector{String} : The list of virtual hard disk container uris.
    - managedDisk::VirtualMachineScaleSetManagedDiskParameters
"""
Base.@kwdef mutable struct VirtualMachineScaleSetUpdateOSDisk <: OpenAPI.APIModel
    caching = nothing # spec type: Union{ Nothing, Caching }
    writeAcceleratorEnabled::Union{Nothing, Bool} = nothing
    diskSizeGB::Union{Nothing, Int64} = nothing
    image = nothing # spec type: Union{ Nothing, VirtualHardDisk }
    vhdContainers::Union{Nothing, Vector{String}} = nothing
    managedDisk = nothing # spec type: Union{ Nothing, VirtualMachineScaleSetManagedDiskParameters }

    function VirtualMachineScaleSetUpdateOSDisk(caching, writeAcceleratorEnabled, diskSizeGB, image, vhdContainers, managedDisk, )
        OpenAPI.validate_property(VirtualMachineScaleSetUpdateOSDisk, Symbol("caching"), caching)
        OpenAPI.validate_property(VirtualMachineScaleSetUpdateOSDisk, Symbol("writeAcceleratorEnabled"), writeAcceleratorEnabled)
        OpenAPI.validate_property(VirtualMachineScaleSetUpdateOSDisk, Symbol("diskSizeGB"), diskSizeGB)
        OpenAPI.validate_property(VirtualMachineScaleSetUpdateOSDisk, Symbol("image"), image)
        OpenAPI.validate_property(VirtualMachineScaleSetUpdateOSDisk, Symbol("vhdContainers"), vhdContainers)
        OpenAPI.validate_property(VirtualMachineScaleSetUpdateOSDisk, Symbol("managedDisk"), managedDisk)
        return new(caching, writeAcceleratorEnabled, diskSizeGB, image, vhdContainers, managedDisk, )
    end
end # type VirtualMachineScaleSetUpdateOSDisk

const _property_types_VirtualMachineScaleSetUpdateOSDisk = Dict{Symbol,String}(Symbol("caching")=>"Caching", Symbol("writeAcceleratorEnabled")=>"Bool", Symbol("diskSizeGB")=>"Int64", Symbol("image")=>"VirtualHardDisk", Symbol("vhdContainers")=>"Vector{String}", Symbol("managedDisk")=>"VirtualMachineScaleSetManagedDiskParameters", )
OpenAPI.property_type(::Type{ VirtualMachineScaleSetUpdateOSDisk }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_VirtualMachineScaleSetUpdateOSDisk[name]))}

function check_required(o::VirtualMachineScaleSetUpdateOSDisk)
    true
end

function OpenAPI.validate_property(::Type{ VirtualMachineScaleSetUpdateOSDisk }, name::Symbol, val)
    if name === Symbol("diskSizeGB")
        OpenAPI.validate_param(name, "VirtualMachineScaleSetUpdateOSDisk", :format, val, "int32")
    end
end
