# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""VirtualMachineScaleSetVM
Describes a virtual machine scale set virtual machine.

    VirtualMachineScaleSetVM(;
        id=nothing,
        name=nothing,
        type=nothing,
        location=nothing,
        tags=nothing,
        instanceId=nothing,
        sku=nothing,
        properties=nothing,
        plan=nothing,
        resources=nothing,
        zones=nothing,
    )

    - id::String : Resource Id
    - name::String : Resource name
    - type::String : Resource type
    - location::String : Resource location
    - tags::Dict{String, String} : Resource tags
    - instanceId::String : The virtual machine instance ID.
    - sku::Sku
    - properties::VirtualMachineScaleSetVMProperties
    - plan::Plan
    - resources::Vector{VirtualMachineExtension} : The virtual machine child extension resources.
    - zones::Vector{String} : The virtual machine zones.
"""
Base.@kwdef mutable struct VirtualMachineScaleSetVM <: OpenAPI.APIModel
    id::Union{Nothing, String} = nothing
    name::Union{Nothing, String} = nothing
    type::Union{Nothing, String} = nothing
    location::Union{Nothing, String} = nothing
    tags::Union{Nothing, Dict{String, String}} = nothing
    instanceId::Union{Nothing, String} = nothing
    sku = nothing # spec type: Union{ Nothing, Sku }
    properties = nothing # spec type: Union{ Nothing, VirtualMachineScaleSetVMProperties }
    plan = nothing # spec type: Union{ Nothing, Plan }
    resources::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{VirtualMachineExtension} }
    zones::Union{Nothing, Vector{String}} = nothing

    function VirtualMachineScaleSetVM(id, name, type, location, tags, instanceId, sku, properties, plan, resources, zones, )
        OpenAPI.validate_property(VirtualMachineScaleSetVM, Symbol("id"), id)
        OpenAPI.validate_property(VirtualMachineScaleSetVM, Symbol("name"), name)
        OpenAPI.validate_property(VirtualMachineScaleSetVM, Symbol("type"), type)
        OpenAPI.validate_property(VirtualMachineScaleSetVM, Symbol("location"), location)
        OpenAPI.validate_property(VirtualMachineScaleSetVM, Symbol("tags"), tags)
        OpenAPI.validate_property(VirtualMachineScaleSetVM, Symbol("instanceId"), instanceId)
        OpenAPI.validate_property(VirtualMachineScaleSetVM, Symbol("sku"), sku)
        OpenAPI.validate_property(VirtualMachineScaleSetVM, Symbol("properties"), properties)
        OpenAPI.validate_property(VirtualMachineScaleSetVM, Symbol("plan"), plan)
        OpenAPI.validate_property(VirtualMachineScaleSetVM, Symbol("resources"), resources)
        OpenAPI.validate_property(VirtualMachineScaleSetVM, Symbol("zones"), zones)
        return new(id, name, type, location, tags, instanceId, sku, properties, plan, resources, zones, )
    end
end # type VirtualMachineScaleSetVM

const _property_types_VirtualMachineScaleSetVM = Dict{Symbol,String}(Symbol("id")=>"String", Symbol("name")=>"String", Symbol("type")=>"String", Symbol("location")=>"String", Symbol("tags")=>"Dict{String, String}", Symbol("instanceId")=>"String", Symbol("sku")=>"Sku", Symbol("properties")=>"VirtualMachineScaleSetVMProperties", Symbol("plan")=>"Plan", Symbol("resources")=>"Vector{VirtualMachineExtension}", Symbol("zones")=>"Vector{String}", )
OpenAPI.property_type(::Type{ VirtualMachineScaleSetVM }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_VirtualMachineScaleSetVM[name]))}

function check_required(o::VirtualMachineScaleSetVM)
    o.location === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ VirtualMachineScaleSetVM }, name::Symbol, val)
end
