# Julia API client for ContainerServiceClient

The Container Service Client.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 2017-01-31
- Build package: org.openapitools.codegen.languages.JuliaClientCodegen


## Installation
Place the Julia files generated under the `src` folder in your Julia project. Include ContainerServiceClient.jl in the project code.
It would include the module named ContainerServiceClient.

Documentation is generated as markdown files under the `docs` folder. You can include them in your project documentation.
Documentation is also embedded in Julia which can be used with a Julia specific documentation generator.

## API Endpoints

Class | Method
------------ | -------------
*ContainerServiceApi* | [**container_services_delete**](docs/ContainerServiceApi.md#container_services_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ContainerService/containerServices/{containerServiceName}<br/>Deletes the specified container service.
*ContainerServiceApi* | [**container_services_get**](docs/ContainerServiceApi.md#container_services_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ContainerService/containerServices/{containerServiceName}<br/>Gets the properties of the specified container service.
*ContainerServiceApi* | [**container_services_list_by_resource_group**](docs/ContainerServiceApi.md#container_services_list_by_resource_group)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ContainerService/containerServices<br/>Gets a list of container services in the specified resource group.
*ContainerServicesApi* | [**container_services_create_or_update**](docs/ContainerServicesApi.md#container_services_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ContainerService/containerServices/{containerServiceName}<br/>Creates or updates a container service.
*ContainerServicesApi* | [**container_services_list**](docs/ContainerServicesApi.md#container_services_list)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.ContainerService/containerServices<br/>Gets a list of container services in the specified subscription.


## Models

 - [ContainerService](docs/ContainerService.md)
 - [ContainerServiceAgentPoolProfile](docs/ContainerServiceAgentPoolProfile.md)
 - [ContainerServiceCustomProfile](docs/ContainerServiceCustomProfile.md)
 - [ContainerServiceDiagnosticsProfile](docs/ContainerServiceDiagnosticsProfile.md)
 - [ContainerServiceLinuxProfile](docs/ContainerServiceLinuxProfile.md)
 - [ContainerServiceListResult](docs/ContainerServiceListResult.md)
 - [ContainerServiceMasterProfile](docs/ContainerServiceMasterProfile.md)
 - [ContainerServiceOrchestratorProfile](docs/ContainerServiceOrchestratorProfile.md)
 - [ContainerServiceProperties](docs/ContainerServiceProperties.md)
 - [ContainerServiceServicePrincipalProfile](docs/ContainerServiceServicePrincipalProfile.md)
 - [ContainerServiceSshConfiguration](docs/ContainerServiceSshConfiguration.md)
 - [ContainerServiceSshPublicKey](docs/ContainerServiceSshPublicKey.md)
 - [ContainerServiceVMDiagnostics](docs/ContainerServiceVMDiagnostics.md)
 - [ContainerServiceWindowsProfile](docs/ContainerServiceWindowsProfile.md)
 - [Resource](docs/Resource.md)


## Authorization

## azure_auth
- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://login.microsoftonline.com/common/oauth2/authorize
- **Scopes**: 
 - **user_impersonation**: impersonate your user account

Example
```
    using OpenAPI
    using OpenAPI.Clients
    import OpenAPI.Clients: Client, set_header
    client = Client(server_uri)
    set_header(client, "Authorization", "Bearer $bearer_auth")
    api = MyApi(client)
    result = callApi(api, args...; api_key)
```

## Author



