# Julia API client for DiskResourceProviderClient

The Disk Resource Provider Client.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 2020-05-01
- Build package: org.openapitools.codegen.languages.JuliaClientCodegen


## Installation
Place the Julia files generated under the `src` folder in your Julia project. Include DiskResourceProviderClient.jl in the project code.
It would include the module named DiskResourceProviderClient.

Documentation is generated as markdown files under the `docs` folder. You can include them in your project documentation.
Documentation is also embedded in Julia which can be used with a Julia specific documentation generator.

## API Endpoints

Class | Method
------------ | -------------
*DiskAccessesApi* | [**disk_accesses_create_or_update**](docs/DiskAccessesApi.md#disk_accesses_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/diskAccesses/{diskAccessName}<br/>
*DiskAccessesApi* | [**disk_accesses_delete**](docs/DiskAccessesApi.md#disk_accesses_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/diskAccesses/{diskAccessName}<br/>
*DiskAccessesApi* | [**disk_accesses_get**](docs/DiskAccessesApi.md#disk_accesses_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/diskAccesses/{diskAccessName}<br/>
*DiskAccessesApi* | [**disk_accesses_get_private_link_resources**](docs/DiskAccessesApi.md#disk_accesses_get_private_link_resources)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/diskAccesses/{diskAccessName}/privateLinkResources<br/>
*DiskAccessesApi* | [**disk_accesses_list**](docs/DiskAccessesApi.md#disk_accesses_list)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/diskAccesses<br/>
*DiskAccessesApi* | [**disk_accesses_list_by_resource_group**](docs/DiskAccessesApi.md#disk_accesses_list_by_resource_group)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/diskAccesses<br/>
*DiskAccessesApi* | [**disk_accesses_update**](docs/DiskAccessesApi.md#disk_accesses_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/diskAccesses/{diskAccessName}<br/>
*DiskEncryptionSetsApi* | [**disk_encryption_sets_create_or_update**](docs/DiskEncryptionSetsApi.md#disk_encryption_sets_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/diskEncryptionSets/{diskEncryptionSetName}<br/>
*DiskEncryptionSetsApi* | [**disk_encryption_sets_delete**](docs/DiskEncryptionSetsApi.md#disk_encryption_sets_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/diskEncryptionSets/{diskEncryptionSetName}<br/>
*DiskEncryptionSetsApi* | [**disk_encryption_sets_get**](docs/DiskEncryptionSetsApi.md#disk_encryption_sets_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/diskEncryptionSets/{diskEncryptionSetName}<br/>
*DiskEncryptionSetsApi* | [**disk_encryption_sets_list**](docs/DiskEncryptionSetsApi.md#disk_encryption_sets_list)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/diskEncryptionSets<br/>
*DiskEncryptionSetsApi* | [**disk_encryption_sets_list_by_resource_group**](docs/DiskEncryptionSetsApi.md#disk_encryption_sets_list_by_resource_group)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/diskEncryptionSets<br/>
*DiskEncryptionSetsApi* | [**disk_encryption_sets_update**](docs/DiskEncryptionSetsApi.md#disk_encryption_sets_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/diskEncryptionSets/{diskEncryptionSetName}<br/>
*DisksApi* | [**disks_create_or_update**](docs/DisksApi.md#disks_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/disks/{diskName}<br/>
*DisksApi* | [**disks_delete**](docs/DisksApi.md#disks_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/disks/{diskName}<br/>
*DisksApi* | [**disks_get**](docs/DisksApi.md#disks_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/disks/{diskName}<br/>
*DisksApi* | [**disks_grant_access**](docs/DisksApi.md#disks_grant_access)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/disks/{diskName}/beginGetAccess<br/>
*DisksApi* | [**disks_list**](docs/DisksApi.md#disks_list)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/disks<br/>
*DisksApi* | [**disks_list_by_resource_group**](docs/DisksApi.md#disks_list_by_resource_group)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/disks<br/>
*DisksApi* | [**disks_revoke_access**](docs/DisksApi.md#disks_revoke_access)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/disks/{diskName}/endGetAccess<br/>
*DisksApi* | [**disks_update**](docs/DisksApi.md#disks_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/disks/{diskName}<br/>
*SnapshotsApi* | [**snapshots_create_or_update**](docs/SnapshotsApi.md#snapshots_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/snapshots/{snapshotName}<br/>
*SnapshotsApi* | [**snapshots_delete**](docs/SnapshotsApi.md#snapshots_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/snapshots/{snapshotName}<br/>
*SnapshotsApi* | [**snapshots_get**](docs/SnapshotsApi.md#snapshots_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/snapshots/{snapshotName}<br/>
*SnapshotsApi* | [**snapshots_grant_access**](docs/SnapshotsApi.md#snapshots_grant_access)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/snapshots/{snapshotName}/beginGetAccess<br/>
*SnapshotsApi* | [**snapshots_list**](docs/SnapshotsApi.md#snapshots_list)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Compute/snapshots<br/>
*SnapshotsApi* | [**snapshots_list_by_resource_group**](docs/SnapshotsApi.md#snapshots_list_by_resource_group)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/snapshots<br/>
*SnapshotsApi* | [**snapshots_revoke_access**](docs/SnapshotsApi.md#snapshots_revoke_access)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/snapshots/{snapshotName}/endGetAccess<br/>
*SnapshotsApi* | [**snapshots_update**](docs/SnapshotsApi.md#snapshots_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/snapshots/{snapshotName}<br/>


## Models

 - [AccessUri](docs/AccessUri.md)
 - [ApiError](docs/ApiError.md)
 - [ApiErrorBase](docs/ApiErrorBase.md)
 - [CloudError](docs/CloudError.md)
 - [CreationData](docs/CreationData.md)
 - [Disk](docs/Disk.md)
 - [DiskAccess](docs/DiskAccess.md)
 - [DiskAccessList](docs/DiskAccessList.md)
 - [DiskAccessProperties](docs/DiskAccessProperties.md)
 - [DiskAccessUpdate](docs/DiskAccessUpdate.md)
 - [DiskAllOf](docs/DiskAllOf.md)
 - [DiskEncryptionSet](docs/DiskEncryptionSet.md)
 - [DiskEncryptionSetList](docs/DiskEncryptionSetList.md)
 - [DiskEncryptionSetUpdate](docs/DiskEncryptionSetUpdate.md)
 - [DiskEncryptionSetUpdateProperties](docs/DiskEncryptionSetUpdateProperties.md)
 - [DiskList](docs/DiskList.md)
 - [DiskProperties](docs/DiskProperties.md)
 - [DiskSku](docs/DiskSku.md)
 - [DiskUpdate](docs/DiskUpdate.md)
 - [DiskUpdateProperties](docs/DiskUpdateProperties.md)
 - [Encryption](docs/Encryption.md)
 - [EncryptionSetIdentity](docs/EncryptionSetIdentity.md)
 - [EncryptionSetProperties](docs/EncryptionSetProperties.md)
 - [EncryptionSettingsCollection](docs/EncryptionSettingsCollection.md)
 - [EncryptionSettingsElement](docs/EncryptionSettingsElement.md)
 - [EncryptionType](docs/EncryptionType.md)
 - [GrantAccessData](docs/GrantAccessData.md)
 - [ImageDiskReference](docs/ImageDiskReference.md)
 - [InnerError](docs/InnerError.md)
 - [KeyVaultAndKeyReference](docs/KeyVaultAndKeyReference.md)
 - [KeyVaultAndSecretReference](docs/KeyVaultAndSecretReference.md)
 - [NetworkAccessPolicy](docs/NetworkAccessPolicy.md)
 - [PrivateEndpoint](docs/PrivateEndpoint.md)
 - [PrivateEndpointConnection](docs/PrivateEndpointConnection.md)
 - [PrivateEndpointConnectionProperties](docs/PrivateEndpointConnectionProperties.md)
 - [PrivateEndpointConnectionProvisioningState](docs/PrivateEndpointConnectionProvisioningState.md)
 - [PrivateEndpointServiceConnectionStatus](docs/PrivateEndpointServiceConnectionStatus.md)
 - [PrivateLinkResource](docs/PrivateLinkResource.md)
 - [PrivateLinkResourceListResult](docs/PrivateLinkResourceListResult.md)
 - [PrivateLinkResourceProperties](docs/PrivateLinkResourceProperties.md)
 - [PrivateLinkServiceConnectionState](docs/PrivateLinkServiceConnectionState.md)
 - [Resource](docs/Resource.md)
 - [ShareInfoElement](docs/ShareInfoElement.md)
 - [Snapshot](docs/Snapshot.md)
 - [SnapshotAllOf](docs/SnapshotAllOf.md)
 - [SnapshotList](docs/SnapshotList.md)
 - [SnapshotProperties](docs/SnapshotProperties.md)
 - [SnapshotSku](docs/SnapshotSku.md)
 - [SnapshotUpdate](docs/SnapshotUpdate.md)
 - [SnapshotUpdateProperties](docs/SnapshotUpdateProperties.md)
 - [SourceVault](docs/SourceVault.md)


## Authorization

## azure_auth
- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://login.microsoftonline.com/common/oauth2/authorize
- **Scopes**: 
 - **user_impersonation**: impersonate your user account

Example
```
    using OpenAPI
    using OpenAPI.Clients
    import OpenAPI.Clients: Client, set_header
    client = Client(server_uri)
    set_header(client, "Authorization", "Bearer $bearer_auth")
    api = MyApi(client)
    result = callApi(api, args...; api_key)
```

## Author



