# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct VirtualMachineScaleSetVMsApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `VirtualMachineScaleSetVMsApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ VirtualMachineScaleSetVMsApi }) = "https://management.azure.com"

const _returntypes_virtual_machine_scale_set_v_ms_run_command_VirtualMachineScaleSetVMsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => RunCommandResult,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_virtual_machine_scale_set_v_ms_run_command(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String, parameters::RunCommandInput; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_machine_scale_set_v_ms_run_command_VirtualMachineScaleSetVMsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/virtualMachineScaleSets/{vmScaleSetName}/virtualmachines/{instanceId}/runCommand", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "vmScaleSetName", vm_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "instanceId", instance_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", "text/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", "text/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Run command on a virtual machine in a VM scale set.

Params:
- resource_group_name::String (required)
- vm_scale_set_name::String (required)
- instance_id::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::RunCommandInput (required)

Return: RunCommandResult, OpenAPI.Clients.ApiResponse
"""
function virtual_machine_scale_set_v_ms_run_command(_api::VirtualMachineScaleSetVMsApi, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String, parameters::RunCommandInput; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_run_command(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_machine_scale_set_v_ms_run_command(_api::VirtualMachineScaleSetVMsApi, response_stream::Channel, resource_group_name::String, vm_scale_set_name::String, instance_id::String, api_version::String, subscription_id::String, parameters::RunCommandInput; _mediaType=nothing)
    _ctx = _oacinternal_virtual_machine_scale_set_v_ms_run_command(_api, resource_group_name, vm_scale_set_name, instance_id, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export virtual_machine_scale_set_v_ms_run_command
