# Julia API client for DataLakeStoreAccountManagementClient

Creates an Azure Data Lake Store account management client.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 2016-11-01
- Build package: org.openapitools.codegen.languages.JuliaClientCodegen


## Installation
Place the Julia files generated under the `src` folder in your Julia project. Include DataLakeStoreAccountManagementClient.jl in the project code.
It would include the module named DataLakeStoreAccountManagementClient.

Documentation is generated as markdown files under the `docs` folder. You can include them in your project documentation.
Documentation is also embedded in Julia which can be used with a Julia specific documentation generator.

## API Endpoints

Class | Method
------------ | -------------
*AccountsApi* | [**accounts_check_name_availability**](docs/AccountsApi.md#accounts_check_name_availability)<br/>**POST** /subscriptions/{subscriptionId}/providers/Microsoft.DataLakeStore/locations/{location}/checkNameAvailability<br/>
*AccountsApi* | [**accounts_create**](docs/AccountsApi.md#accounts_create)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}<br/>
*AccountsApi* | [**accounts_delete**](docs/AccountsApi.md#accounts_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}<br/>
*AccountsApi* | [**accounts_enable_key_vault**](docs/AccountsApi.md#accounts_enable_key_vault)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/enableKeyVault<br/>
*AccountsApi* | [**accounts_get**](docs/AccountsApi.md#accounts_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}<br/>
*AccountsApi* | [**accounts_list**](docs/AccountsApi.md#accounts_list)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.DataLakeStore/accounts<br/>
*AccountsApi* | [**accounts_list_by_resource_group**](docs/AccountsApi.md#accounts_list_by_resource_group)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts<br/>
*AccountsApi* | [**accounts_update**](docs/AccountsApi.md#accounts_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}<br/>
*FirewallRulesApi* | [**firewall_rules_create_or_update**](docs/FirewallRulesApi.md#firewall_rules_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/firewallRules/{firewallRuleName}<br/>
*FirewallRulesApi* | [**firewall_rules_delete**](docs/FirewallRulesApi.md#firewall_rules_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/firewallRules/{firewallRuleName}<br/>
*FirewallRulesApi* | [**firewall_rules_get**](docs/FirewallRulesApi.md#firewall_rules_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/firewallRules/{firewallRuleName}<br/>
*FirewallRulesApi* | [**firewall_rules_list_by_account**](docs/FirewallRulesApi.md#firewall_rules_list_by_account)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/firewallRules<br/>
*FirewallRulesApi* | [**firewall_rules_update**](docs/FirewallRulesApi.md#firewall_rules_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/firewallRules/{firewallRuleName}<br/>
*LocationUsageApi* | [**locations_get_usage**](docs/LocationUsageApi.md#locations_get_usage)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.DataLakeStore/locations/{location}/usages<br/>
*LocationsApi* | [**locations_get_capability**](docs/LocationsApi.md#locations_get_capability)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.DataLakeStore/locations/{location}/capability<br/>
*OperationsApi* | [**operations_list**](docs/OperationsApi.md#operations_list)<br/>**GET** /providers/Microsoft.DataLakeStore/operations<br/>
*TrustedIdProvidersApi* | [**trusted_id_providers_create_or_update**](docs/TrustedIdProvidersApi.md#trusted_id_providers_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/trustedIdProviders/{trustedIdProviderName}<br/>
*TrustedIdProvidersApi* | [**trusted_id_providers_delete**](docs/TrustedIdProvidersApi.md#trusted_id_providers_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/trustedIdProviders/{trustedIdProviderName}<br/>
*TrustedIdProvidersApi* | [**trusted_id_providers_get**](docs/TrustedIdProvidersApi.md#trusted_id_providers_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/trustedIdProviders/{trustedIdProviderName}<br/>
*TrustedIdProvidersApi* | [**trusted_id_providers_list_by_account**](docs/TrustedIdProvidersApi.md#trusted_id_providers_list_by_account)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/trustedIdProviders<br/>
*TrustedIdProvidersApi* | [**trusted_id_providers_update**](docs/TrustedIdProvidersApi.md#trusted_id_providers_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/trustedIdProviders/{trustedIdProviderName}<br/>
*VirtualNetworkRulesApi* | [**virtual_network_rules_create_or_update**](docs/VirtualNetworkRulesApi.md#virtual_network_rules_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/virtualNetworkRules/{virtualNetworkRuleName}<br/>
*VirtualNetworkRulesApi* | [**virtual_network_rules_delete**](docs/VirtualNetworkRulesApi.md#virtual_network_rules_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/virtualNetworkRules/{virtualNetworkRuleName}<br/>
*VirtualNetworkRulesApi* | [**virtual_network_rules_get**](docs/VirtualNetworkRulesApi.md#virtual_network_rules_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/virtualNetworkRules/{virtualNetworkRuleName}<br/>
*VirtualNetworkRulesApi* | [**virtual_network_rules_list_by_account**](docs/VirtualNetworkRulesApi.md#virtual_network_rules_list_by_account)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/virtualNetworkRules<br/>
*VirtualNetworkRulesApi* | [**virtual_network_rules_update**](docs/VirtualNetworkRulesApi.md#virtual_network_rules_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/virtualNetworkRules/{virtualNetworkRuleName}<br/>


## Models

 - [CapabilityInformation](docs/CapabilityInformation.md)
 - [CheckNameAvailabilityParameters](docs/CheckNameAvailabilityParameters.md)
 - [CreateDataLakeStoreAccountParameters](docs/CreateDataLakeStoreAccountParameters.md)
 - [CreateDataLakeStoreAccountProperties](docs/CreateDataLakeStoreAccountProperties.md)
 - [CreateFirewallRuleWithAccountParameters](docs/CreateFirewallRuleWithAccountParameters.md)
 - [CreateOrUpdateFirewallRuleParameters](docs/CreateOrUpdateFirewallRuleParameters.md)
 - [CreateOrUpdateFirewallRuleProperties](docs/CreateOrUpdateFirewallRuleProperties.md)
 - [CreateOrUpdateTrustedIdProviderParameters](docs/CreateOrUpdateTrustedIdProviderParameters.md)
 - [CreateOrUpdateTrustedIdProviderProperties](docs/CreateOrUpdateTrustedIdProviderProperties.md)
 - [CreateOrUpdateVirtualNetworkRuleParameters](docs/CreateOrUpdateVirtualNetworkRuleParameters.md)
 - [CreateOrUpdateVirtualNetworkRuleProperties](docs/CreateOrUpdateVirtualNetworkRuleProperties.md)
 - [CreateTrustedIdProviderWithAccountParameters](docs/CreateTrustedIdProviderWithAccountParameters.md)
 - [CreateVirtualNetworkRuleWithAccountParameters](docs/CreateVirtualNetworkRuleWithAccountParameters.md)
 - [DataLakeStoreAccount](docs/DataLakeStoreAccount.md)
 - [DataLakeStoreAccountBasic](docs/DataLakeStoreAccountBasic.md)
 - [DataLakeStoreAccountListResult](docs/DataLakeStoreAccountListResult.md)
 - [DataLakeStoreAccountProperties](docs/DataLakeStoreAccountProperties.md)
 - [DataLakeStoreAccountPropertiesBasic](docs/DataLakeStoreAccountPropertiesBasic.md)
 - [EncryptionConfig](docs/EncryptionConfig.md)
 - [EncryptionIdentity](docs/EncryptionIdentity.md)
 - [FirewallRule](docs/FirewallRule.md)
 - [FirewallRuleListResult](docs/FirewallRuleListResult.md)
 - [FirewallRuleProperties](docs/FirewallRuleProperties.md)
 - [KeyVaultMetaInfo](docs/KeyVaultMetaInfo.md)
 - [NameAvailabilityInformation](docs/NameAvailabilityInformation.md)
 - [Operation](docs/Operation.md)
 - [OperationDisplay](docs/OperationDisplay.md)
 - [OperationListResult](docs/OperationListResult.md)
 - [Resource](docs/Resource.md)
 - [SubResource](docs/SubResource.md)
 - [TrustedIdProvider](docs/TrustedIdProvider.md)
 - [TrustedIdProviderListResult](docs/TrustedIdProviderListResult.md)
 - [TrustedIdProviderProperties](docs/TrustedIdProviderProperties.md)
 - [UpdateDataLakeStoreAccountParameters](docs/UpdateDataLakeStoreAccountParameters.md)
 - [UpdateDataLakeStoreAccountProperties](docs/UpdateDataLakeStoreAccountProperties.md)
 - [UpdateEncryptionConfig](docs/UpdateEncryptionConfig.md)
 - [UpdateFirewallRuleParameters](docs/UpdateFirewallRuleParameters.md)
 - [UpdateFirewallRuleProperties](docs/UpdateFirewallRuleProperties.md)
 - [UpdateFirewallRuleWithAccountParameters](docs/UpdateFirewallRuleWithAccountParameters.md)
 - [UpdateKeyVaultMetaInfo](docs/UpdateKeyVaultMetaInfo.md)
 - [UpdateTrustedIdProviderParameters](docs/UpdateTrustedIdProviderParameters.md)
 - [UpdateTrustedIdProviderProperties](docs/UpdateTrustedIdProviderProperties.md)
 - [UpdateTrustedIdProviderWithAccountParameters](docs/UpdateTrustedIdProviderWithAccountParameters.md)
 - [UpdateVirtualNetworkRuleParameters](docs/UpdateVirtualNetworkRuleParameters.md)
 - [UpdateVirtualNetworkRuleProperties](docs/UpdateVirtualNetworkRuleProperties.md)
 - [UpdateVirtualNetworkRuleWithAccountParameters](docs/UpdateVirtualNetworkRuleWithAccountParameters.md)
 - [Usage](docs/Usage.md)
 - [UsageListResult](docs/UsageListResult.md)
 - [UsageName](docs/UsageName.md)
 - [VirtualNetworkRule](docs/VirtualNetworkRule.md)
 - [VirtualNetworkRuleListResult](docs/VirtualNetworkRuleListResult.md)
 - [VirtualNetworkRuleProperties](docs/VirtualNetworkRuleProperties.md)


## Authorization

## azure_auth
- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://login.microsoftonline.com/common/oauth2/authorize
- **Scopes**: 
 - **user_impersonation**: impersonate your user account

Example
```
    using OpenAPI
    using OpenAPI.Clients
    import OpenAPI.Clients: Client, set_header
    client = Client(server_uri)
    set_header(client, "Authorization", "Bearer $bearer_auth")
    api = MyApi(client)
    result = callApi(api, args...; api_key)
```

## Author



