# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct FirewallRulesApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `FirewallRulesApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ FirewallRulesApi }) = "https://management.azure.com"

const _returntypes_firewall_rules_create_or_update_FirewallRulesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => FirewallRule,
)

function _oacinternal_firewall_rules_create_or_update(_api::FirewallRulesApi, subscription_id::String, resource_group_name::String, account_name::String, firewall_rule_name::String, api_version::String, parameters::CreateOrUpdateFirewallRuleParameters; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_firewall_rules_create_or_update_FirewallRulesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/firewallRules/{firewallRuleName}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "accountName", account_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "firewallRuleName", firewall_rule_name)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Creates or updates the specified firewall rule. During update, the firewall rule with the specified name will be replaced with this new firewall rule.

Params:
- subscription_id::String (required)
- resource_group_name::String (required)
- account_name::String (required)
- firewall_rule_name::String (required)
- api_version::String (required)
- parameters::CreateOrUpdateFirewallRuleParameters (required)

Return: FirewallRule, OpenAPI.Clients.ApiResponse
"""
function firewall_rules_create_or_update(_api::FirewallRulesApi, subscription_id::String, resource_group_name::String, account_name::String, firewall_rule_name::String, api_version::String, parameters::CreateOrUpdateFirewallRuleParameters; _mediaType=nothing)
    _ctx = _oacinternal_firewall_rules_create_or_update(_api, subscription_id, resource_group_name, account_name, firewall_rule_name, api_version, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function firewall_rules_create_or_update(_api::FirewallRulesApi, response_stream::Channel, subscription_id::String, resource_group_name::String, account_name::String, firewall_rule_name::String, api_version::String, parameters::CreateOrUpdateFirewallRuleParameters; _mediaType=nothing)
    _ctx = _oacinternal_firewall_rules_create_or_update(_api, subscription_id, resource_group_name, account_name, firewall_rule_name, api_version, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_firewall_rules_delete_FirewallRulesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
)

function _oacinternal_firewall_rules_delete(_api::FirewallRulesApi, subscription_id::String, resource_group_name::String, account_name::String, firewall_rule_name::String, api_version::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_firewall_rules_delete_FirewallRulesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/firewallRules/{firewallRuleName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "accountName", account_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "firewallRuleName", firewall_rule_name)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, [])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Deletes the specified firewall rule from the specified Data Lake Store account.

Params:
- subscription_id::String (required)
- resource_group_name::String (required)
- account_name::String (required)
- firewall_rule_name::String (required)
- api_version::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function firewall_rules_delete(_api::FirewallRulesApi, subscription_id::String, resource_group_name::String, account_name::String, firewall_rule_name::String, api_version::String; _mediaType=nothing)
    _ctx = _oacinternal_firewall_rules_delete(_api, subscription_id, resource_group_name, account_name, firewall_rule_name, api_version; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function firewall_rules_delete(_api::FirewallRulesApi, response_stream::Channel, subscription_id::String, resource_group_name::String, account_name::String, firewall_rule_name::String, api_version::String; _mediaType=nothing)
    _ctx = _oacinternal_firewall_rules_delete(_api, subscription_id, resource_group_name, account_name, firewall_rule_name, api_version; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_firewall_rules_get_FirewallRulesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => FirewallRule,
)

function _oacinternal_firewall_rules_get(_api::FirewallRulesApi, subscription_id::String, resource_group_name::String, account_name::String, firewall_rule_name::String, api_version::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_firewall_rules_get_FirewallRulesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/firewallRules/{firewallRuleName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "accountName", account_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "firewallRuleName", firewall_rule_name)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets the specified Data Lake Store firewall rule.

Params:
- subscription_id::String (required)
- resource_group_name::String (required)
- account_name::String (required)
- firewall_rule_name::String (required)
- api_version::String (required)

Return: FirewallRule, OpenAPI.Clients.ApiResponse
"""
function firewall_rules_get(_api::FirewallRulesApi, subscription_id::String, resource_group_name::String, account_name::String, firewall_rule_name::String, api_version::String; _mediaType=nothing)
    _ctx = _oacinternal_firewall_rules_get(_api, subscription_id, resource_group_name, account_name, firewall_rule_name, api_version; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function firewall_rules_get(_api::FirewallRulesApi, response_stream::Channel, subscription_id::String, resource_group_name::String, account_name::String, firewall_rule_name::String, api_version::String; _mediaType=nothing)
    _ctx = _oacinternal_firewall_rules_get(_api, subscription_id, resource_group_name, account_name, firewall_rule_name, api_version; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_firewall_rules_list_by_account_FirewallRulesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => FirewallRuleListResult,
)

function _oacinternal_firewall_rules_list_by_account(_api::FirewallRulesApi, subscription_id::String, resource_group_name::String, account_name::String, api_version::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_firewall_rules_list_by_account_FirewallRulesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/firewallRules", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "accountName", account_name)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Lists the Data Lake Store firewall rules within the specified Data Lake Store account.

Params:
- subscription_id::String (required)
- resource_group_name::String (required)
- account_name::String (required)
- api_version::String (required)

Return: FirewallRuleListResult, OpenAPI.Clients.ApiResponse
"""
function firewall_rules_list_by_account(_api::FirewallRulesApi, subscription_id::String, resource_group_name::String, account_name::String, api_version::String; _mediaType=nothing)
    _ctx = _oacinternal_firewall_rules_list_by_account(_api, subscription_id, resource_group_name, account_name, api_version; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function firewall_rules_list_by_account(_api::FirewallRulesApi, response_stream::Channel, subscription_id::String, resource_group_name::String, account_name::String, api_version::String; _mediaType=nothing)
    _ctx = _oacinternal_firewall_rules_list_by_account(_api, subscription_id, resource_group_name, account_name, api_version; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_firewall_rules_update_FirewallRulesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => FirewallRule,
)

function _oacinternal_firewall_rules_update(_api::FirewallRulesApi, subscription_id::String, resource_group_name::String, account_name::String, firewall_rule_name::String, api_version::String; parameters=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PATCH", _returntypes_firewall_rules_update_FirewallRulesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/firewallRules/{firewallRuleName}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "accountName", account_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "firewallRuleName", firewall_rule_name)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Updates the specified firewall rule.

Params:
- subscription_id::String (required)
- resource_group_name::String (required)
- account_name::String (required)
- firewall_rule_name::String (required)
- api_version::String (required)
- parameters::UpdateFirewallRuleParameters

Return: FirewallRule, OpenAPI.Clients.ApiResponse
"""
function firewall_rules_update(_api::FirewallRulesApi, subscription_id::String, resource_group_name::String, account_name::String, firewall_rule_name::String, api_version::String; parameters=nothing, _mediaType=nothing)
    _ctx = _oacinternal_firewall_rules_update(_api, subscription_id, resource_group_name, account_name, firewall_rule_name, api_version; parameters=parameters, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function firewall_rules_update(_api::FirewallRulesApi, response_stream::Channel, subscription_id::String, resource_group_name::String, account_name::String, firewall_rule_name::String, api_version::String; parameters=nothing, _mediaType=nothing)
    _ctx = _oacinternal_firewall_rules_update(_api, subscription_id, resource_group_name, account_name, firewall_rule_name, api_version; parameters=parameters, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export firewall_rules_create_or_update
export firewall_rules_delete
export firewall_rules_get
export firewall_rules_list_by_account
export firewall_rules_update
