# Julia API client for DataLakeStoreFileSystemManagementClient

Creates an Azure Data Lake Store filesystem client.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 2016-11-01
- Build package: org.openapitools.codegen.languages.JuliaClientCodegen


## Installation
Place the Julia files generated under the `src` folder in your Julia project. Include DataLakeStoreFileSystemManagementClient.jl in the project code.
It would include the module named DataLakeStoreFileSystemManagementClient.

Documentation is generated as markdown files under the `docs` folder. You can include them in your project documentation.
Documentation is also embedded in Julia which can be used with a Julia specific documentation generator.

## API Endpoints

Class | Method
------------ | -------------
*FileSystemApi* | [**file_system_check_access**](docs/FileSystemApi.md#file_system_check_access)<br/>**GET** /webhdfs/v1/{path}<br/>
*FileSystemApi* | [**file_system_concurrent_append**](docs/FileSystemApi.md#file_system_concurrent_append)<br/>**POST** /WebHdfsExt/{path}<br/>
*FileSystemApi* | [**file_system_set_file_expiry**](docs/FileSystemApi.md#file_system_set_file_expiry)<br/>**PUT** /WebHdfsExt/{path}<br/>


## Models

 - [AclStatus](docs/AclStatus.md)
 - [AclStatusResult](docs/AclStatusResult.md)
 - [AdlsAccessControlException](docs/AdlsAccessControlException.md)
 - [AdlsBadOffsetException](docs/AdlsBadOffsetException.md)
 - [AdlsError](docs/AdlsError.md)
 - [AdlsFileAlreadyExistsException](docs/AdlsFileAlreadyExistsException.md)
 - [AdlsFileNotFoundException](docs/AdlsFileNotFoundException.md)
 - [AdlsIOException](docs/AdlsIOException.md)
 - [AdlsIllegalArgumentException](docs/AdlsIllegalArgumentException.md)
 - [AdlsRemoteException](docs/AdlsRemoteException.md)
 - [AdlsRuntimeException](docs/AdlsRuntimeException.md)
 - [AdlsSecurityException](docs/AdlsSecurityException.md)
 - [AdlsThrottledException](docs/AdlsThrottledException.md)
 - [AdlsUnsupportedOperationException](docs/AdlsUnsupportedOperationException.md)
 - [ContentSummary](docs/ContentSummary.md)
 - [ContentSummaryResult](docs/ContentSummaryResult.md)
 - [FileOperationResult](docs/FileOperationResult.md)
 - [FileStatusProperties](docs/FileStatusProperties.md)
 - [FileStatusResult](docs/FileStatusResult.md)
 - [FileStatuses](docs/FileStatuses.md)
 - [FileStatusesResult](docs/FileStatusesResult.md)


## Authorization
 Endpoints do not require authorization.


## Author



