# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""AdlsIOException
A WebHDFS exception thrown indicating there was an IO (read or write) error. Thrown when a 403 error response code is returned (forbidden).

    AdlsIOException(;
        exception=nothing,
        javaClassName=nothing,
        message=nothing,
    )

    - exception::String : the class name of the exception thrown, such as &#39;IllegalArgumentException&#39;.
    - javaClassName::String : the full class package name for the exception thrown, such as &#39;java.lang.IllegalArgumentException&#39;.
    - message::String : the message associated with the exception that was thrown, such as &#39;Invalid value for webhdfs parameter \&quot;permission\&quot;:...&#39;.
"""
Base.@kwdef mutable struct AdlsIOException <: OpenAPI.APIModel
    exception::Union{Nothing, String} = nothing
    javaClassName::Union{Nothing, String} = nothing
    message::Union{Nothing, String} = nothing

    function AdlsIOException(exception, javaClassName, message, )
        OpenAPI.validate_property(AdlsIOException, Symbol("exception"), exception)
        OpenAPI.validate_property(AdlsIOException, Symbol("javaClassName"), javaClassName)
        OpenAPI.validate_property(AdlsIOException, Symbol("message"), message)
        return new(exception, javaClassName, message, )
    end
end # type AdlsIOException

const _property_types_AdlsIOException = Dict{Symbol,String}(Symbol("exception")=>"String", Symbol("javaClassName")=>"String", Symbol("message")=>"String", )
OpenAPI.property_type(::Type{ AdlsIOException }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_AdlsIOException[name]))}

function check_required(o::AdlsIOException)
    o.exception === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ AdlsIOException }, name::Symbol, val)
end
