# Julia API client for ApplicationGatewayClient

The Microsoft Azure Network management API provides a RESTful set of web services that interact with Microsoft Azure Networks service to manage your network resources. The API has entities that capture the relationship between an end user and the Microsoft Azure Networks service.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 2020-05-01
- Build package: org.openapitools.codegen.languages.JuliaClientCodegen


## Installation
Place the Julia files generated under the `src` folder in your Julia project. Include ApplicationGatewayClient.jl in the project code.
It would include the module named ApplicationGatewayClient.

Documentation is generated as markdown files under the `docs` folder. You can include them in your project documentation.
Documentation is also embedded in Julia which can be used with a Julia specific documentation generator.

## API Endpoints

Class | Method
------------ | -------------
*ApplicationGatewayPrivateEndpointConnectionsApi* | [**application_gateway_private_endpoint_connections_delete**](docs/ApplicationGatewayPrivateEndpointConnectionsApi.md#application_gateway_private_endpoint_connections_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}/privateEndpointConnections/{connectionName}<br/>
*ApplicationGatewayPrivateEndpointConnectionsApi* | [**application_gateway_private_endpoint_connections_get**](docs/ApplicationGatewayPrivateEndpointConnectionsApi.md#application_gateway_private_endpoint_connections_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}/privateEndpointConnections/{connectionName}<br/>
*ApplicationGatewayPrivateEndpointConnectionsApi* | [**application_gateway_private_endpoint_connections_list**](docs/ApplicationGatewayPrivateEndpointConnectionsApi.md#application_gateway_private_endpoint_connections_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}/privateEndpointConnections<br/>
*ApplicationGatewayPrivateEndpointConnectionsApi* | [**application_gateway_private_endpoint_connections_update**](docs/ApplicationGatewayPrivateEndpointConnectionsApi.md#application_gateway_private_endpoint_connections_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}/privateEndpointConnections/{connectionName}<br/>
*ApplicationGatewayPrivateLinkResourcesApi* | [**application_gateway_private_link_resources_list**](docs/ApplicationGatewayPrivateLinkResourcesApi.md#application_gateway_private_link_resources_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}/privateLinkResources<br/>
*ApplicationGatewaysApi* | [**application_gateways_backend_health**](docs/ApplicationGatewaysApi.md#application_gateways_backend_health)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}/backendhealth<br/>
*ApplicationGatewaysApi* | [**application_gateways_backend_health_on_demand**](docs/ApplicationGatewaysApi.md#application_gateways_backend_health_on_demand)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}/getBackendHealthOnDemand<br/>
*ApplicationGatewaysApi* | [**application_gateways_create_or_update**](docs/ApplicationGatewaysApi.md#application_gateways_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}<br/>
*ApplicationGatewaysApi* | [**application_gateways_delete**](docs/ApplicationGatewaysApi.md#application_gateways_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}<br/>
*ApplicationGatewaysApi* | [**application_gateways_get**](docs/ApplicationGatewaysApi.md#application_gateways_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}<br/>
*ApplicationGatewaysApi* | [**application_gateways_get_ssl_predefined_policy**](docs/ApplicationGatewaysApi.md#application_gateways_get_ssl_predefined_policy)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Network/applicationGatewayAvailableSslOptions/default/predefinedPolicies/{predefinedPolicyName}<br/>
*ApplicationGatewaysApi* | [**application_gateways_list**](docs/ApplicationGatewaysApi.md#application_gateways_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways<br/>
*ApplicationGatewaysApi* | [**application_gateways_list_all**](docs/ApplicationGatewaysApi.md#application_gateways_list_all)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Network/applicationGateways<br/>
*ApplicationGatewaysApi* | [**application_gateways_list_available_request_headers**](docs/ApplicationGatewaysApi.md#application_gateways_list_available_request_headers)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Network/applicationGatewayAvailableRequestHeaders<br/>
*ApplicationGatewaysApi* | [**application_gateways_list_available_response_headers**](docs/ApplicationGatewaysApi.md#application_gateways_list_available_response_headers)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Network/applicationGatewayAvailableResponseHeaders<br/>
*ApplicationGatewaysApi* | [**application_gateways_list_available_server_variables**](docs/ApplicationGatewaysApi.md#application_gateways_list_available_server_variables)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Network/applicationGatewayAvailableServerVariables<br/>
*ApplicationGatewaysApi* | [**application_gateways_list_available_ssl_options**](docs/ApplicationGatewaysApi.md#application_gateways_list_available_ssl_options)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Network/applicationGatewayAvailableSslOptions/default<br/>
*ApplicationGatewaysApi* | [**application_gateways_list_available_ssl_predefined_policies**](docs/ApplicationGatewaysApi.md#application_gateways_list_available_ssl_predefined_policies)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Network/applicationGatewayAvailableSslOptions/default/predefinedPolicies<br/>
*ApplicationGatewaysApi* | [**application_gateways_list_available_waf_rule_sets**](docs/ApplicationGatewaysApi.md#application_gateways_list_available_waf_rule_sets)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Network/applicationGatewayAvailableWafRuleSets<br/>
*ApplicationGatewaysApi* | [**application_gateways_start**](docs/ApplicationGatewaysApi.md#application_gateways_start)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}/start<br/>
*ApplicationGatewaysApi* | [**application_gateways_stop**](docs/ApplicationGatewaysApi.md#application_gateways_stop)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}/stop<br/>
*ApplicationGatewaysApi* | [**application_gateways_update_tags**](docs/ApplicationGatewaysApi.md#application_gateways_update_tags)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}<br/>


## Models

 - [ApplicationGateway](docs/ApplicationGateway.md)
 - [ApplicationGatewayAuthenticationCertificate](docs/ApplicationGatewayAuthenticationCertificate.md)
 - [ApplicationGatewayAuthenticationCertificatePropertiesFormat](docs/ApplicationGatewayAuthenticationCertificatePropertiesFormat.md)
 - [ApplicationGatewayAutoscaleConfiguration](docs/ApplicationGatewayAutoscaleConfiguration.md)
 - [ApplicationGatewayAvailableSslOptions](docs/ApplicationGatewayAvailableSslOptions.md)
 - [ApplicationGatewayAvailableSslOptionsPropertiesFormat](docs/ApplicationGatewayAvailableSslOptionsPropertiesFormat.md)
 - [ApplicationGatewayAvailableSslPredefinedPolicies](docs/ApplicationGatewayAvailableSslPredefinedPolicies.md)
 - [ApplicationGatewayAvailableWafRuleSetsResult](docs/ApplicationGatewayAvailableWafRuleSetsResult.md)
 - [ApplicationGatewayBackendAddress](docs/ApplicationGatewayBackendAddress.md)
 - [ApplicationGatewayBackendAddress2](docs/ApplicationGatewayBackendAddress2.md)
 - [ApplicationGatewayBackendAddressPool](docs/ApplicationGatewayBackendAddressPool.md)
 - [ApplicationGatewayBackendAddressPool2](docs/ApplicationGatewayBackendAddressPool2.md)
 - [ApplicationGatewayBackendAddressPoolPropertiesFormat](docs/ApplicationGatewayBackendAddressPoolPropertiesFormat.md)
 - [ApplicationGatewayBackendAddressPoolPropertiesFormat2](docs/ApplicationGatewayBackendAddressPoolPropertiesFormat2.md)
 - [ApplicationGatewayBackendHealth](docs/ApplicationGatewayBackendHealth.md)
 - [ApplicationGatewayBackendHealthHttpSettings](docs/ApplicationGatewayBackendHealthHttpSettings.md)
 - [ApplicationGatewayBackendHealthOnDemand](docs/ApplicationGatewayBackendHealthOnDemand.md)
 - [ApplicationGatewayBackendHealthPool](docs/ApplicationGatewayBackendHealthPool.md)
 - [ApplicationGatewayBackendHealthServer](docs/ApplicationGatewayBackendHealthServer.md)
 - [ApplicationGatewayBackendHttpSettings](docs/ApplicationGatewayBackendHttpSettings.md)
 - [ApplicationGatewayBackendHttpSettingsPropertiesFormat](docs/ApplicationGatewayBackendHttpSettingsPropertiesFormat.md)
 - [ApplicationGatewayConnectionDraining](docs/ApplicationGatewayConnectionDraining.md)
 - [ApplicationGatewayCustomError](docs/ApplicationGatewayCustomError.md)
 - [ApplicationGatewayFirewallDisabledRuleGroup](docs/ApplicationGatewayFirewallDisabledRuleGroup.md)
 - [ApplicationGatewayFirewallExclusion](docs/ApplicationGatewayFirewallExclusion.md)
 - [ApplicationGatewayFirewallRule](docs/ApplicationGatewayFirewallRule.md)
 - [ApplicationGatewayFirewallRuleGroup](docs/ApplicationGatewayFirewallRuleGroup.md)
 - [ApplicationGatewayFirewallRuleSet](docs/ApplicationGatewayFirewallRuleSet.md)
 - [ApplicationGatewayFirewallRuleSetPropertiesFormat](docs/ApplicationGatewayFirewallRuleSetPropertiesFormat.md)
 - [ApplicationGatewayFrontendIPConfiguration](docs/ApplicationGatewayFrontendIPConfiguration.md)
 - [ApplicationGatewayFrontendIPConfigurationPropertiesFormat](docs/ApplicationGatewayFrontendIPConfigurationPropertiesFormat.md)
 - [ApplicationGatewayFrontendPort](docs/ApplicationGatewayFrontendPort.md)
 - [ApplicationGatewayFrontendPortPropertiesFormat](docs/ApplicationGatewayFrontendPortPropertiesFormat.md)
 - [ApplicationGatewayHeaderConfiguration](docs/ApplicationGatewayHeaderConfiguration.md)
 - [ApplicationGatewayHttpListener](docs/ApplicationGatewayHttpListener.md)
 - [ApplicationGatewayHttpListenerPropertiesFormat](docs/ApplicationGatewayHttpListenerPropertiesFormat.md)
 - [ApplicationGatewayIPConfiguration](docs/ApplicationGatewayIPConfiguration.md)
 - [ApplicationGatewayIPConfigurationPropertiesFormat](docs/ApplicationGatewayIPConfigurationPropertiesFormat.md)
 - [ApplicationGatewayListResult](docs/ApplicationGatewayListResult.md)
 - [ApplicationGatewayOnDemandProbe](docs/ApplicationGatewayOnDemandProbe.md)
 - [ApplicationGatewayPathRule](docs/ApplicationGatewayPathRule.md)
 - [ApplicationGatewayPathRulePropertiesFormat](docs/ApplicationGatewayPathRulePropertiesFormat.md)
 - [ApplicationGatewayPrivateEndpointConnection](docs/ApplicationGatewayPrivateEndpointConnection.md)
 - [ApplicationGatewayPrivateEndpointConnectionListResult](docs/ApplicationGatewayPrivateEndpointConnectionListResult.md)
 - [ApplicationGatewayPrivateEndpointConnectionProperties](docs/ApplicationGatewayPrivateEndpointConnectionProperties.md)
 - [ApplicationGatewayPrivateLinkConfiguration](docs/ApplicationGatewayPrivateLinkConfiguration.md)
 - [ApplicationGatewayPrivateLinkConfigurationProperties](docs/ApplicationGatewayPrivateLinkConfigurationProperties.md)
 - [ApplicationGatewayPrivateLinkIpConfiguration](docs/ApplicationGatewayPrivateLinkIpConfiguration.md)
 - [ApplicationGatewayPrivateLinkIpConfigurationProperties](docs/ApplicationGatewayPrivateLinkIpConfigurationProperties.md)
 - [ApplicationGatewayPrivateLinkResource](docs/ApplicationGatewayPrivateLinkResource.md)
 - [ApplicationGatewayPrivateLinkResourceListResult](docs/ApplicationGatewayPrivateLinkResourceListResult.md)
 - [ApplicationGatewayPrivateLinkResourceProperties](docs/ApplicationGatewayPrivateLinkResourceProperties.md)
 - [ApplicationGatewayProbe](docs/ApplicationGatewayProbe.md)
 - [ApplicationGatewayProbeHealthResponseMatch](docs/ApplicationGatewayProbeHealthResponseMatch.md)
 - [ApplicationGatewayProbePropertiesFormat](docs/ApplicationGatewayProbePropertiesFormat.md)
 - [ApplicationGatewayPropertiesFormat](docs/ApplicationGatewayPropertiesFormat.md)
 - [ApplicationGatewayProtocol](docs/ApplicationGatewayProtocol.md)
 - [ApplicationGatewayRedirectConfiguration](docs/ApplicationGatewayRedirectConfiguration.md)
 - [ApplicationGatewayRedirectConfigurationPropertiesFormat](docs/ApplicationGatewayRedirectConfigurationPropertiesFormat.md)
 - [ApplicationGatewayRequestRoutingRule](docs/ApplicationGatewayRequestRoutingRule.md)
 - [ApplicationGatewayRequestRoutingRulePropertiesFormat](docs/ApplicationGatewayRequestRoutingRulePropertiesFormat.md)
 - [ApplicationGatewayRewriteRule](docs/ApplicationGatewayRewriteRule.md)
 - [ApplicationGatewayRewriteRuleActionSet](docs/ApplicationGatewayRewriteRuleActionSet.md)
 - [ApplicationGatewayRewriteRuleCondition](docs/ApplicationGatewayRewriteRuleCondition.md)
 - [ApplicationGatewayRewriteRuleSet](docs/ApplicationGatewayRewriteRuleSet.md)
 - [ApplicationGatewayRewriteRuleSetPropertiesFormat](docs/ApplicationGatewayRewriteRuleSetPropertiesFormat.md)
 - [ApplicationGatewaySku](docs/ApplicationGatewaySku.md)
 - [ApplicationGatewaySslCertificate](docs/ApplicationGatewaySslCertificate.md)
 - [ApplicationGatewaySslCertificatePropertiesFormat](docs/ApplicationGatewaySslCertificatePropertiesFormat.md)
 - [ApplicationGatewaySslPolicy](docs/ApplicationGatewaySslPolicy.md)
 - [ApplicationGatewaySslPredefinedPolicy](docs/ApplicationGatewaySslPredefinedPolicy.md)
 - [ApplicationGatewaySslPredefinedPolicyPropertiesFormat](docs/ApplicationGatewaySslPredefinedPolicyPropertiesFormat.md)
 - [ApplicationGatewayTrustedRootCertificate](docs/ApplicationGatewayTrustedRootCertificate.md)
 - [ApplicationGatewayTrustedRootCertificatePropertiesFormat](docs/ApplicationGatewayTrustedRootCertificatePropertiesFormat.md)
 - [ApplicationGatewayUrlConfiguration](docs/ApplicationGatewayUrlConfiguration.md)
 - [ApplicationGatewayUrlPathMap](docs/ApplicationGatewayUrlPathMap.md)
 - [ApplicationGatewayUrlPathMapPropertiesFormat](docs/ApplicationGatewayUrlPathMapPropertiesFormat.md)
 - [ApplicationGatewayWebApplicationFirewallConfiguration](docs/ApplicationGatewayWebApplicationFirewallConfiguration.md)
 - [ApplicationSecurityGroup](docs/ApplicationSecurityGroup.md)
 - [ApplicationSecurityGroupPropertiesFormat](docs/ApplicationSecurityGroupPropertiesFormat.md)
 - [BackendAddressPool](docs/BackendAddressPool.md)
 - [BackendAddressPoolPropertiesFormat](docs/BackendAddressPoolPropertiesFormat.md)
 - [CipherSuitesEnum](docs/CipherSuitesEnum.md)
 - [CloudError](docs/CloudError.md)
 - [CloudErrorBody](docs/CloudErrorBody.md)
 - [CustomDnsConfigPropertiesFormat](docs/CustomDnsConfigPropertiesFormat.md)
 - [DdosSettings](docs/DdosSettings.md)
 - [Delegation](docs/Delegation.md)
 - [Error](docs/Error.md)
 - [ErrorDetails](docs/ErrorDetails.md)
 - [FlowLog](docs/FlowLog.md)
 - [FlowLogFormatParameters](docs/FlowLogFormatParameters.md)
 - [FlowLogPropertiesFormat](docs/FlowLogPropertiesFormat.md)
 - [FrontendIPConfiguration](docs/FrontendIPConfiguration.md)
 - [FrontendIPConfigurationPropertiesFormat](docs/FrontendIPConfigurationPropertiesFormat.md)
 - [IPAllocationMethod](docs/IPAllocationMethod.md)
 - [IPConfiguration](docs/IPConfiguration.md)
 - [IPConfigurationProfile](docs/IPConfigurationProfile.md)
 - [IPConfigurationProfilePropertiesFormat](docs/IPConfigurationProfilePropertiesFormat.md)
 - [IPConfigurationPropertiesFormat](docs/IPConfigurationPropertiesFormat.md)
 - [IPVersion](docs/IPVersion.md)
 - [InboundNatRule](docs/InboundNatRule.md)
 - [InboundNatRulePropertiesFormat](docs/InboundNatRulePropertiesFormat.md)
 - [IpTag](docs/IpTag.md)
 - [LoadBalancerBackendAddress](docs/LoadBalancerBackendAddress.md)
 - [LoadBalancerBackendAddressPropertiesFormat](docs/LoadBalancerBackendAddressPropertiesFormat.md)
 - [NetworkInterface](docs/NetworkInterface.md)
 - [NetworkInterfaceDnsSettings](docs/NetworkInterfaceDnsSettings.md)
 - [NetworkInterfaceIPConfiguration](docs/NetworkInterfaceIPConfiguration.md)
 - [NetworkInterfaceIPConfigurationPrivateLinkConnectionProperties](docs/NetworkInterfaceIPConfigurationPrivateLinkConnectionProperties.md)
 - [NetworkInterfaceIPConfigurationPropertiesFormat](docs/NetworkInterfaceIPConfigurationPropertiesFormat.md)
 - [NetworkInterfacePropertiesFormat](docs/NetworkInterfacePropertiesFormat.md)
 - [NetworkInterfaceTapConfiguration](docs/NetworkInterfaceTapConfiguration.md)
 - [NetworkInterfaceTapConfigurationPropertiesFormat](docs/NetworkInterfaceTapConfigurationPropertiesFormat.md)
 - [NetworkSecurityGroup](docs/NetworkSecurityGroup.md)
 - [NetworkSecurityGroupPropertiesFormat](docs/NetworkSecurityGroupPropertiesFormat.md)
 - [PolicyNameEnum](docs/PolicyNameEnum.md)
 - [PrivateEndpoint](docs/PrivateEndpoint.md)
 - [PrivateEndpointProperties](docs/PrivateEndpointProperties.md)
 - [PrivateLinkServiceConnection](docs/PrivateLinkServiceConnection.md)
 - [PrivateLinkServiceConnectionProperties](docs/PrivateLinkServiceConnectionProperties.md)
 - [PrivateLinkServiceConnectionState](docs/PrivateLinkServiceConnectionState.md)
 - [ProtocolsEnum](docs/ProtocolsEnum.md)
 - [ProvisioningState](docs/ProvisioningState.md)
 - [PublicIPAddress](docs/PublicIPAddress.md)
 - [PublicIPAddressDnsSettings](docs/PublicIPAddressDnsSettings.md)
 - [PublicIPAddressPropertiesFormat](docs/PublicIPAddressPropertiesFormat.md)
 - [PublicIPAddressSku](docs/PublicIPAddressSku.md)
 - [RedirectTypeEnum](docs/RedirectTypeEnum.md)
 - [Resource](docs/Resource.md)
 - [ResourceNavigationLink](docs/ResourceNavigationLink.md)
 - [ResourceNavigationLinkFormat](docs/ResourceNavigationLinkFormat.md)
 - [RetentionPolicyParameters](docs/RetentionPolicyParameters.md)
 - [Route](docs/Route.md)
 - [RouteNextHopType](docs/RouteNextHopType.md)
 - [RoutePropertiesFormat](docs/RoutePropertiesFormat.md)
 - [RouteTable](docs/RouteTable.md)
 - [RouteTablePropertiesFormat](docs/RouteTablePropertiesFormat.md)
 - [SecurityRule](docs/SecurityRule.md)
 - [SecurityRuleAccess](docs/SecurityRuleAccess.md)
 - [SecurityRuleDirection](docs/SecurityRuleDirection.md)
 - [SecurityRulePropertiesFormat](docs/SecurityRulePropertiesFormat.md)
 - [ServiceAssociationLink](docs/ServiceAssociationLink.md)
 - [ServiceAssociationLinkPropertiesFormat](docs/ServiceAssociationLinkPropertiesFormat.md)
 - [ServiceDelegationPropertiesFormat](docs/ServiceDelegationPropertiesFormat.md)
 - [ServiceEndpointPolicy](docs/ServiceEndpointPolicy.md)
 - [ServiceEndpointPolicyDefinition](docs/ServiceEndpointPolicyDefinition.md)
 - [ServiceEndpointPolicyDefinitionPropertiesFormat](docs/ServiceEndpointPolicyDefinitionPropertiesFormat.md)
 - [ServiceEndpointPolicyPropertiesFormat](docs/ServiceEndpointPolicyPropertiesFormat.md)
 - [ServiceEndpointPropertiesFormat](docs/ServiceEndpointPropertiesFormat.md)
 - [SubResource](docs/SubResource.md)
 - [Subnet](docs/Subnet.md)
 - [SubnetPropertiesFormat](docs/SubnetPropertiesFormat.md)
 - [TagsObject](docs/TagsObject.md)
 - [TrafficAnalyticsConfigurationProperties](docs/TrafficAnalyticsConfigurationProperties.md)
 - [TrafficAnalyticsProperties](docs/TrafficAnalyticsProperties.md)
 - [TransportProtocol](docs/TransportProtocol.md)
 - [VirtualNetworkTap](docs/VirtualNetworkTap.md)
 - [VirtualNetworkTapPropertiesFormat](docs/VirtualNetworkTapPropertiesFormat.md)


## Authorization

## azure_auth
- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://login.microsoftonline.com/common/oauth2/authorize
- **Scopes**: 
 - **user_impersonation**: impersonate your user account

Example
```
    using OpenAPI
    using OpenAPI.Clients
    import OpenAPI.Clients: Client, set_header
    client = Client(server_uri)
    set_header(client, "Authorization", "Bearer $bearer_auth")
    api = MyApi(client)
    result = callApi(api, args...; api_key)
```

## Author



