# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct ApplicationGatewayPrivateEndpointConnectionsApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `ApplicationGatewayPrivateEndpointConnectionsApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ ApplicationGatewayPrivateEndpointConnectionsApi }) = "https://management.azure.com"

const _returntypes_application_gateway_private_endpoint_connections_delete_ApplicationGatewayPrivateEndpointConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_application_gateway_private_endpoint_connections_delete(_api::ApplicationGatewayPrivateEndpointConnectionsApi, resource_group_name::String, application_gateway_name::String, connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_application_gateway_private_endpoint_connections_delete_ApplicationGatewayPrivateEndpointConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}/privateEndpointConnections/{connectionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "applicationGatewayName", application_gateway_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "connectionName", connection_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Deletes the specified private endpoint connection on application gateway.

Params:
- resource_group_name::String (required)
- application_gateway_name::String (required)
- connection_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function application_gateway_private_endpoint_connections_delete(_api::ApplicationGatewayPrivateEndpointConnectionsApi, resource_group_name::String, application_gateway_name::String, connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_application_gateway_private_endpoint_connections_delete(_api, resource_group_name, application_gateway_name, connection_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function application_gateway_private_endpoint_connections_delete(_api::ApplicationGatewayPrivateEndpointConnectionsApi, response_stream::Channel, resource_group_name::String, application_gateway_name::String, connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_application_gateway_private_endpoint_connections_delete(_api, resource_group_name, application_gateway_name, connection_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_application_gateway_private_endpoint_connections_get_ApplicationGatewayPrivateEndpointConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ApplicationGatewayPrivateEndpointConnection,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_application_gateway_private_endpoint_connections_get(_api::ApplicationGatewayPrivateEndpointConnectionsApi, resource_group_name::String, application_gateway_name::String, connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_application_gateway_private_endpoint_connections_get_ApplicationGatewayPrivateEndpointConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}/privateEndpointConnections/{connectionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "applicationGatewayName", application_gateway_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "connectionName", connection_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets the specified private endpoint connection on application gateway.

Params:
- resource_group_name::String (required)
- application_gateway_name::String (required)
- connection_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: ApplicationGatewayPrivateEndpointConnection, OpenAPI.Clients.ApiResponse
"""
function application_gateway_private_endpoint_connections_get(_api::ApplicationGatewayPrivateEndpointConnectionsApi, resource_group_name::String, application_gateway_name::String, connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_application_gateway_private_endpoint_connections_get(_api, resource_group_name, application_gateway_name, connection_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function application_gateway_private_endpoint_connections_get(_api::ApplicationGatewayPrivateEndpointConnectionsApi, response_stream::Channel, resource_group_name::String, application_gateway_name::String, connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_application_gateway_private_endpoint_connections_get(_api, resource_group_name, application_gateway_name, connection_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_application_gateway_private_endpoint_connections_list_ApplicationGatewayPrivateEndpointConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ApplicationGatewayPrivateEndpointConnectionListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_application_gateway_private_endpoint_connections_list(_api::ApplicationGatewayPrivateEndpointConnectionsApi, resource_group_name::String, application_gateway_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_application_gateway_private_endpoint_connections_list_ApplicationGatewayPrivateEndpointConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}/privateEndpointConnections", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "applicationGatewayName", application_gateway_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Lists all private endpoint connections on an application gateway.

Params:
- resource_group_name::String (required)
- application_gateway_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: ApplicationGatewayPrivateEndpointConnectionListResult, OpenAPI.Clients.ApiResponse
"""
function application_gateway_private_endpoint_connections_list(_api::ApplicationGatewayPrivateEndpointConnectionsApi, resource_group_name::String, application_gateway_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_application_gateway_private_endpoint_connections_list(_api, resource_group_name, application_gateway_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function application_gateway_private_endpoint_connections_list(_api::ApplicationGatewayPrivateEndpointConnectionsApi, response_stream::Channel, resource_group_name::String, application_gateway_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_application_gateway_private_endpoint_connections_list(_api, resource_group_name, application_gateway_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_application_gateway_private_endpoint_connections_update_ApplicationGatewayPrivateEndpointConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ApplicationGatewayPrivateEndpointConnection,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_application_gateway_private_endpoint_connections_update(_api::ApplicationGatewayPrivateEndpointConnectionsApi, resource_group_name::String, application_gateway_name::String, connection_name::String, api_version::String, subscription_id::String, parameters::ApplicationGatewayPrivateEndpointConnection; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_application_gateway_private_endpoint_connections_update_ApplicationGatewayPrivateEndpointConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}/privateEndpointConnections/{connectionName}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "applicationGatewayName", application_gateway_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "connectionName", connection_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Updates the specified private endpoint connection on application gateway.

Params:
- resource_group_name::String (required)
- application_gateway_name::String (required)
- connection_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::ApplicationGatewayPrivateEndpointConnection (required)

Return: ApplicationGatewayPrivateEndpointConnection, OpenAPI.Clients.ApiResponse
"""
function application_gateway_private_endpoint_connections_update(_api::ApplicationGatewayPrivateEndpointConnectionsApi, resource_group_name::String, application_gateway_name::String, connection_name::String, api_version::String, subscription_id::String, parameters::ApplicationGatewayPrivateEndpointConnection; _mediaType=nothing)
    _ctx = _oacinternal_application_gateway_private_endpoint_connections_update(_api, resource_group_name, application_gateway_name, connection_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function application_gateway_private_endpoint_connections_update(_api::ApplicationGatewayPrivateEndpointConnectionsApi, response_stream::Channel, resource_group_name::String, application_gateway_name::String, connection_name::String, api_version::String, subscription_id::String, parameters::ApplicationGatewayPrivateEndpointConnection; _mediaType=nothing)
    _ctx = _oacinternal_application_gateway_private_endpoint_connections_update(_api, resource_group_name, application_gateway_name, connection_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export application_gateway_private_endpoint_connections_delete
export application_gateway_private_endpoint_connections_get
export application_gateway_private_endpoint_connections_list
export application_gateway_private_endpoint_connections_update
