# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct ApplicationGatewayPrivateLinkResourcesApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `ApplicationGatewayPrivateLinkResourcesApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ ApplicationGatewayPrivateLinkResourcesApi }) = "https://management.azure.com"

const _returntypes_application_gateway_private_link_resources_list_ApplicationGatewayPrivateLinkResourcesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ApplicationGatewayPrivateLinkResourceListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_application_gateway_private_link_resources_list(_api::ApplicationGatewayPrivateLinkResourcesApi, resource_group_name::String, application_gateway_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_application_gateway_private_link_resources_list_ApplicationGatewayPrivateLinkResourcesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}/privateLinkResources", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "applicationGatewayName", application_gateway_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Lists all private link resources on an application gateway.

Params:
- resource_group_name::String (required)
- application_gateway_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: ApplicationGatewayPrivateLinkResourceListResult, OpenAPI.Clients.ApiResponse
"""
function application_gateway_private_link_resources_list(_api::ApplicationGatewayPrivateLinkResourcesApi, resource_group_name::String, application_gateway_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_application_gateway_private_link_resources_list(_api, resource_group_name, application_gateway_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function application_gateway_private_link_resources_list(_api::ApplicationGatewayPrivateLinkResourcesApi, response_stream::Channel, resource_group_name::String, application_gateway_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_application_gateway_private_link_resources_list(_api, resource_group_name, application_gateway_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export application_gateway_private_link_resources_list
