# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""ApplicationGatewayConnectionDraining
Connection draining allows open connections to a backend server to be active for a specified time after the backend server got removed from the configuration.

    ApplicationGatewayConnectionDraining(;
        enabled=nothing,
        drainTimeoutInSec=nothing,
    )

    - enabled::Bool : Whether connection draining is enabled or not.
    - drainTimeoutInSec::Int64 : The number of seconds connection draining is active. Acceptable values are from 1 second to 3600 seconds.
"""
Base.@kwdef mutable struct ApplicationGatewayConnectionDraining <: OpenAPI.APIModel
    enabled::Union{Nothing, Bool} = nothing
    drainTimeoutInSec::Union{Nothing, Int64} = nothing

    function ApplicationGatewayConnectionDraining(enabled, drainTimeoutInSec, )
        OpenAPI.validate_property(ApplicationGatewayConnectionDraining, Symbol("enabled"), enabled)
        OpenAPI.validate_property(ApplicationGatewayConnectionDraining, Symbol("drainTimeoutInSec"), drainTimeoutInSec)
        return new(enabled, drainTimeoutInSec, )
    end
end # type ApplicationGatewayConnectionDraining

const _property_types_ApplicationGatewayConnectionDraining = Dict{Symbol,String}(Symbol("enabled")=>"Bool", Symbol("drainTimeoutInSec")=>"Int64", )
OpenAPI.property_type(::Type{ ApplicationGatewayConnectionDraining }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_ApplicationGatewayConnectionDraining[name]))}

function check_required(o::ApplicationGatewayConnectionDraining)
    o.enabled === nothing && (return false)
    o.drainTimeoutInSec === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ ApplicationGatewayConnectionDraining }, name::Symbol, val)
    if name === Symbol("drainTimeoutInSec")
        OpenAPI.validate_param(name, "ApplicationGatewayConnectionDraining", :format, val, "int32")
    end
    if name === Symbol("drainTimeoutInSec")
        OpenAPI.validate_param(name, "ApplicationGatewayConnectionDraining", :maximum, val, 3600, false)
        OpenAPI.validate_param(name, "ApplicationGatewayConnectionDraining", :minimum, val, 1, false)
    end
end
