# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""ApplicationGatewayRewriteRule
Rewrite rule of an application gateway.

    ApplicationGatewayRewriteRule(;
        name=nothing,
        ruleSequence=nothing,
        conditions=nothing,
        actionSet=nothing,
    )

    - name::String : Name of the rewrite rule that is unique within an Application Gateway.
    - ruleSequence::Int64 : Rule Sequence of the rewrite rule that determines the order of execution of a particular rule in a RewriteRuleSet.
    - conditions::Vector{ApplicationGatewayRewriteRuleCondition} : Conditions based on which the action set execution will be evaluated.
    - actionSet::ApplicationGatewayRewriteRuleActionSet
"""
Base.@kwdef mutable struct ApplicationGatewayRewriteRule <: OpenAPI.APIModel
    name::Union{Nothing, String} = nothing
    ruleSequence::Union{Nothing, Int64} = nothing
    conditions::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{ApplicationGatewayRewriteRuleCondition} }
    actionSet = nothing # spec type: Union{ Nothing, ApplicationGatewayRewriteRuleActionSet }

    function ApplicationGatewayRewriteRule(name, ruleSequence, conditions, actionSet, )
        OpenAPI.validate_property(ApplicationGatewayRewriteRule, Symbol("name"), name)
        OpenAPI.validate_property(ApplicationGatewayRewriteRule, Symbol("ruleSequence"), ruleSequence)
        OpenAPI.validate_property(ApplicationGatewayRewriteRule, Symbol("conditions"), conditions)
        OpenAPI.validate_property(ApplicationGatewayRewriteRule, Symbol("actionSet"), actionSet)
        return new(name, ruleSequence, conditions, actionSet, )
    end
end # type ApplicationGatewayRewriteRule

const _property_types_ApplicationGatewayRewriteRule = Dict{Symbol,String}(Symbol("name")=>"String", Symbol("ruleSequence")=>"Int64", Symbol("conditions")=>"Vector{ApplicationGatewayRewriteRuleCondition}", Symbol("actionSet")=>"ApplicationGatewayRewriteRuleActionSet", )
OpenAPI.property_type(::Type{ ApplicationGatewayRewriteRule }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_ApplicationGatewayRewriteRule[name]))}

function check_required(o::ApplicationGatewayRewriteRule)
    true
end

function OpenAPI.validate_property(::Type{ ApplicationGatewayRewriteRule }, name::Symbol, val)
end
