# Julia API client for ExpressRouteCircuitClient

The Microsoft Azure Network management API provides a RESTful set of web services that interact with Microsoft Azure Networks service to manage your network resources. The API has entities that capture the relationship between an end user and the Microsoft Azure Networks service.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 2020-05-01
- Build package: org.openapitools.codegen.languages.JuliaClientCodegen


## Installation
Place the Julia files generated under the `src` folder in your Julia project. Include ExpressRouteCircuitClient.jl in the project code.
It would include the module named ExpressRouteCircuitClient.

Documentation is generated as markdown files under the `docs` folder. You can include them in your project documentation.
Documentation is also embedded in Julia which can be used with a Julia specific documentation generator.

## API Endpoints

Class | Method
------------ | -------------
*ExpressRouteCircuitArpTableApi* | [**express_route_circuits_list_arp_table**](docs/ExpressRouteCircuitArpTableApi.md#express_route_circuits_list_arp_table)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/arpTables/{devicePath}<br/>
*ExpressRouteCircuitAuthorizationsApi* | [**express_route_circuit_authorizations_create_or_update**](docs/ExpressRouteCircuitAuthorizationsApi.md#express_route_circuit_authorizations_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/authorizations/{authorizationName}<br/>
*ExpressRouteCircuitAuthorizationsApi* | [**express_route_circuit_authorizations_delete**](docs/ExpressRouteCircuitAuthorizationsApi.md#express_route_circuit_authorizations_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/authorizations/{authorizationName}<br/>
*ExpressRouteCircuitAuthorizationsApi* | [**express_route_circuit_authorizations_get**](docs/ExpressRouteCircuitAuthorizationsApi.md#express_route_circuit_authorizations_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/authorizations/{authorizationName}<br/>
*ExpressRouteCircuitAuthorizationsApi* | [**express_route_circuit_authorizations_list**](docs/ExpressRouteCircuitAuthorizationsApi.md#express_route_circuit_authorizations_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/authorizations<br/>
*ExpressRouteCircuitConnectionsApi* | [**express_route_circuit_connections_create_or_update**](docs/ExpressRouteCircuitConnectionsApi.md#express_route_circuit_connections_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/connections/{connectionName}<br/>
*ExpressRouteCircuitConnectionsApi* | [**express_route_circuit_connections_delete**](docs/ExpressRouteCircuitConnectionsApi.md#express_route_circuit_connections_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/connections/{connectionName}<br/>
*ExpressRouteCircuitConnectionsApi* | [**express_route_circuit_connections_get**](docs/ExpressRouteCircuitConnectionsApi.md#express_route_circuit_connections_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/connections/{connectionName}<br/>
*ExpressRouteCircuitConnectionsApi* | [**express_route_circuit_connections_list**](docs/ExpressRouteCircuitConnectionsApi.md#express_route_circuit_connections_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/connections<br/>
*ExpressRouteCircuitPeeringsApi* | [**express_route_circuit_peerings_create_or_update**](docs/ExpressRouteCircuitPeeringsApi.md#express_route_circuit_peerings_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}<br/>
*ExpressRouteCircuitPeeringsApi* | [**express_route_circuit_peerings_delete**](docs/ExpressRouteCircuitPeeringsApi.md#express_route_circuit_peerings_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}<br/>
*ExpressRouteCircuitPeeringsApi* | [**express_route_circuit_peerings_get**](docs/ExpressRouteCircuitPeeringsApi.md#express_route_circuit_peerings_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}<br/>
*ExpressRouteCircuitPeeringsApi* | [**express_route_circuit_peerings_list**](docs/ExpressRouteCircuitPeeringsApi.md#express_route_circuit_peerings_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings<br/>
*ExpressRouteCircuitRoutesTableApi* | [**express_route_circuits_list_routes_table**](docs/ExpressRouteCircuitRoutesTableApi.md#express_route_circuits_list_routes_table)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/routeTables/{devicePath}<br/>
*ExpressRouteCircuitRoutesTableSummaryApi* | [**express_route_circuits_list_routes_table_summary**](docs/ExpressRouteCircuitRoutesTableSummaryApi.md#express_route_circuits_list_routes_table_summary)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/routeTablesSummary/{devicePath}<br/>
*ExpressRouteCircuitStatsApi* | [**express_route_circuits_get_peering_stats**](docs/ExpressRouteCircuitStatsApi.md#express_route_circuits_get_peering_stats)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/stats<br/>
*ExpressRouteCircuitStatsApi* | [**express_route_circuits_get_stats**](docs/ExpressRouteCircuitStatsApi.md#express_route_circuits_get_stats)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/stats<br/>
*ExpressRouteCircuitsApi* | [**express_route_circuits_create_or_update**](docs/ExpressRouteCircuitsApi.md#express_route_circuits_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}<br/>
*ExpressRouteCircuitsApi* | [**express_route_circuits_delete**](docs/ExpressRouteCircuitsApi.md#express_route_circuits_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}<br/>
*ExpressRouteCircuitsApi* | [**express_route_circuits_get**](docs/ExpressRouteCircuitsApi.md#express_route_circuits_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}<br/>
*ExpressRouteCircuitsApi* | [**express_route_circuits_list**](docs/ExpressRouteCircuitsApi.md#express_route_circuits_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits<br/>
*ExpressRouteCircuitsApi* | [**express_route_circuits_list_all**](docs/ExpressRouteCircuitsApi.md#express_route_circuits_list_all)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Network/expressRouteCircuits<br/>
*ExpressRouteCircuitsApi* | [**express_route_circuits_update_tags**](docs/ExpressRouteCircuitsApi.md#express_route_circuits_update_tags)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}<br/>
*ExpressRouteServiceProvidersApi* | [**express_route_service_providers_list**](docs/ExpressRouteServiceProvidersApi.md#express_route_service_providers_list)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Network/expressRouteServiceProviders<br/>
*PeerExpressRouteCircuitConnectionsApi* | [**peer_express_route_circuit_connections_get**](docs/PeerExpressRouteCircuitConnectionsApi.md#peer_express_route_circuit_connections_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/peerConnections/{connectionName}<br/>
*PeerExpressRouteCircuitConnectionsApi* | [**peer_express_route_circuit_connections_list**](docs/PeerExpressRouteCircuitConnectionsApi.md#peer_express_route_circuit_connections_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/peerConnections<br/>


## Models

 - [AuthorizationListResult](docs/AuthorizationListResult.md)
 - [AuthorizationPropertiesFormat](docs/AuthorizationPropertiesFormat.md)
 - [CircuitConnectionStatus](docs/CircuitConnectionStatus.md)
 - [CloudError](docs/CloudError.md)
 - [CloudErrorBody](docs/CloudErrorBody.md)
 - [ExpressRouteCircuit](docs/ExpressRouteCircuit.md)
 - [ExpressRouteCircuitArpTable](docs/ExpressRouteCircuitArpTable.md)
 - [ExpressRouteCircuitAuthorization](docs/ExpressRouteCircuitAuthorization.md)
 - [ExpressRouteCircuitConnection](docs/ExpressRouteCircuitConnection.md)
 - [ExpressRouteCircuitConnectionListResult](docs/ExpressRouteCircuitConnectionListResult.md)
 - [ExpressRouteCircuitConnectionPropertiesFormat](docs/ExpressRouteCircuitConnectionPropertiesFormat.md)
 - [ExpressRouteCircuitListResult](docs/ExpressRouteCircuitListResult.md)
 - [ExpressRouteCircuitPeering](docs/ExpressRouteCircuitPeering.md)
 - [ExpressRouteCircuitPeeringConfig](docs/ExpressRouteCircuitPeeringConfig.md)
 - [ExpressRouteCircuitPeeringListResult](docs/ExpressRouteCircuitPeeringListResult.md)
 - [ExpressRouteCircuitPeeringPropertiesFormat](docs/ExpressRouteCircuitPeeringPropertiesFormat.md)
 - [ExpressRouteCircuitPropertiesFormat](docs/ExpressRouteCircuitPropertiesFormat.md)
 - [ExpressRouteCircuitRoutesTable](docs/ExpressRouteCircuitRoutesTable.md)
 - [ExpressRouteCircuitRoutesTableSummary](docs/ExpressRouteCircuitRoutesTableSummary.md)
 - [ExpressRouteCircuitServiceProviderProperties](docs/ExpressRouteCircuitServiceProviderProperties.md)
 - [ExpressRouteCircuitSku](docs/ExpressRouteCircuitSku.md)
 - [ExpressRouteCircuitStats](docs/ExpressRouteCircuitStats.md)
 - [ExpressRouteCircuitsArpTableListResult](docs/ExpressRouteCircuitsArpTableListResult.md)
 - [ExpressRouteCircuitsRoutesTableListResult](docs/ExpressRouteCircuitsRoutesTableListResult.md)
 - [ExpressRouteCircuitsRoutesTableSummaryListResult](docs/ExpressRouteCircuitsRoutesTableSummaryListResult.md)
 - [ExpressRouteConnectionId](docs/ExpressRouteConnectionId.md)
 - [ExpressRoutePeeringState](docs/ExpressRoutePeeringState.md)
 - [ExpressRoutePeeringType](docs/ExpressRoutePeeringType.md)
 - [ExpressRouteServiceProvider](docs/ExpressRouteServiceProvider.md)
 - [ExpressRouteServiceProviderBandwidthsOffered](docs/ExpressRouteServiceProviderBandwidthsOffered.md)
 - [ExpressRouteServiceProviderListResult](docs/ExpressRouteServiceProviderListResult.md)
 - [ExpressRouteServiceProviderPropertiesFormat](docs/ExpressRouteServiceProviderPropertiesFormat.md)
 - [Ipv6CircuitConnectionConfig](docs/Ipv6CircuitConnectionConfig.md)
 - [Ipv6ExpressRouteCircuitPeeringConfig](docs/Ipv6ExpressRouteCircuitPeeringConfig.md)
 - [PeerExpressRouteCircuitConnection](docs/PeerExpressRouteCircuitConnection.md)
 - [PeerExpressRouteCircuitConnectionListResult](docs/PeerExpressRouteCircuitConnectionListResult.md)
 - [PeerExpressRouteCircuitConnectionPropertiesFormat](docs/PeerExpressRouteCircuitConnectionPropertiesFormat.md)
 - [ProvisioningState](docs/ProvisioningState.md)
 - [Resource](docs/Resource.md)
 - [ServiceProviderProvisioningState](docs/ServiceProviderProvisioningState.md)
 - [SubResource](docs/SubResource.md)
 - [TagsObject](docs/TagsObject.md)


## Authorization

## azure_auth
- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://login.microsoftonline.com/common/oauth2/authorize
- **Scopes**: 
 - **user_impersonation**: impersonate your user account

Example
```
    using OpenAPI
    using OpenAPI.Clients
    import OpenAPI.Clients: Client, set_header
    client = Client(server_uri)
    set_header(client, "Authorization", "Bearer $bearer_auth")
    api = MyApi(client)
    result = callApi(api, args...; api_key)
```

## Author



