# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct ExpressRouteCircuitConnectionsApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `ExpressRouteCircuitConnectionsApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ ExpressRouteCircuitConnectionsApi }) = "https://management.azure.com"

const _returntypes_express_route_circuit_connections_create_or_update_ExpressRouteCircuitConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ExpressRouteCircuitConnection,
    Regex("^" * replace("201", "x"=>".") * "\$") => ExpressRouteCircuitConnection,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_express_route_circuit_connections_create_or_update(_api::ExpressRouteCircuitConnectionsApi, resource_group_name::String, circuit_name::String, peering_name::String, connection_name::String, api_version::String, subscription_id::String, express_route_circuit_connection_parameters::ExpressRouteCircuitConnection; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_express_route_circuit_connections_create_or_update_ExpressRouteCircuitConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/connections/{connectionName}", ["azure_auth", ], express_route_circuit_connection_parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "circuitName", circuit_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "peeringName", peering_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "connectionName", connection_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Creates or updates a Express Route Circuit Connection in the specified express route circuits.

Params:
- resource_group_name::String (required)
- circuit_name::String (required)
- peering_name::String (required)
- connection_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- express_route_circuit_connection_parameters::ExpressRouteCircuitConnection (required)

Return: ExpressRouteCircuitConnection, OpenAPI.Clients.ApiResponse
"""
function express_route_circuit_connections_create_or_update(_api::ExpressRouteCircuitConnectionsApi, resource_group_name::String, circuit_name::String, peering_name::String, connection_name::String, api_version::String, subscription_id::String, express_route_circuit_connection_parameters::ExpressRouteCircuitConnection; _mediaType=nothing)
    _ctx = _oacinternal_express_route_circuit_connections_create_or_update(_api, resource_group_name, circuit_name, peering_name, connection_name, api_version, subscription_id, express_route_circuit_connection_parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function express_route_circuit_connections_create_or_update(_api::ExpressRouteCircuitConnectionsApi, response_stream::Channel, resource_group_name::String, circuit_name::String, peering_name::String, connection_name::String, api_version::String, subscription_id::String, express_route_circuit_connection_parameters::ExpressRouteCircuitConnection; _mediaType=nothing)
    _ctx = _oacinternal_express_route_circuit_connections_create_or_update(_api, resource_group_name, circuit_name, peering_name, connection_name, api_version, subscription_id, express_route_circuit_connection_parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_express_route_circuit_connections_delete_ExpressRouteCircuitConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_express_route_circuit_connections_delete(_api::ExpressRouteCircuitConnectionsApi, resource_group_name::String, circuit_name::String, peering_name::String, connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_express_route_circuit_connections_delete_ExpressRouteCircuitConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/connections/{connectionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "circuitName", circuit_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "peeringName", peering_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "connectionName", connection_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Deletes the specified Express Route Circuit Connection from the specified express route circuit.

Params:
- resource_group_name::String (required)
- circuit_name::String (required)
- peering_name::String (required)
- connection_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function express_route_circuit_connections_delete(_api::ExpressRouteCircuitConnectionsApi, resource_group_name::String, circuit_name::String, peering_name::String, connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_express_route_circuit_connections_delete(_api, resource_group_name, circuit_name, peering_name, connection_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function express_route_circuit_connections_delete(_api::ExpressRouteCircuitConnectionsApi, response_stream::Channel, resource_group_name::String, circuit_name::String, peering_name::String, connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_express_route_circuit_connections_delete(_api, resource_group_name, circuit_name, peering_name, connection_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_express_route_circuit_connections_get_ExpressRouteCircuitConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ExpressRouteCircuitConnection,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_express_route_circuit_connections_get(_api::ExpressRouteCircuitConnectionsApi, resource_group_name::String, circuit_name::String, peering_name::String, connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_express_route_circuit_connections_get_ExpressRouteCircuitConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/connections/{connectionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "circuitName", circuit_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "peeringName", peering_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "connectionName", connection_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets the specified Express Route Circuit Connection from the specified express route circuit.

Params:
- resource_group_name::String (required)
- circuit_name::String (required)
- peering_name::String (required)
- connection_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: ExpressRouteCircuitConnection, OpenAPI.Clients.ApiResponse
"""
function express_route_circuit_connections_get(_api::ExpressRouteCircuitConnectionsApi, resource_group_name::String, circuit_name::String, peering_name::String, connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_express_route_circuit_connections_get(_api, resource_group_name, circuit_name, peering_name, connection_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function express_route_circuit_connections_get(_api::ExpressRouteCircuitConnectionsApi, response_stream::Channel, resource_group_name::String, circuit_name::String, peering_name::String, connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_express_route_circuit_connections_get(_api, resource_group_name, circuit_name, peering_name, connection_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_express_route_circuit_connections_list_ExpressRouteCircuitConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ExpressRouteCircuitConnectionListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_express_route_circuit_connections_list(_api::ExpressRouteCircuitConnectionsApi, resource_group_name::String, circuit_name::String, peering_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_express_route_circuit_connections_list_ExpressRouteCircuitConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/connections", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "circuitName", circuit_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "peeringName", peering_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets all global reach connections associated with a private peering in an express route circuit.

Params:
- resource_group_name::String (required)
- circuit_name::String (required)
- peering_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: ExpressRouteCircuitConnectionListResult, OpenAPI.Clients.ApiResponse
"""
function express_route_circuit_connections_list(_api::ExpressRouteCircuitConnectionsApi, resource_group_name::String, circuit_name::String, peering_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_express_route_circuit_connections_list(_api, resource_group_name, circuit_name, peering_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function express_route_circuit_connections_list(_api::ExpressRouteCircuitConnectionsApi, response_stream::Channel, resource_group_name::String, circuit_name::String, peering_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_express_route_circuit_connections_list(_api, resource_group_name, circuit_name, peering_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export express_route_circuit_connections_create_or_update
export express_route_circuit_connections_delete
export express_route_circuit_connections_get
export express_route_circuit_connections_list
