# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct ExpressRouteCircuitPeeringsApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `ExpressRouteCircuitPeeringsApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ ExpressRouteCircuitPeeringsApi }) = "https://management.azure.com"

const _returntypes_express_route_circuit_peerings_create_or_update_ExpressRouteCircuitPeeringsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ExpressRouteCircuitPeering,
    Regex("^" * replace("201", "x"=>".") * "\$") => ExpressRouteCircuitPeering,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_express_route_circuit_peerings_create_or_update(_api::ExpressRouteCircuitPeeringsApi, resource_group_name::String, circuit_name::String, peering_name::String, api_version::String, subscription_id::String, peering_parameters::ExpressRouteCircuitPeering; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_express_route_circuit_peerings_create_or_update_ExpressRouteCircuitPeeringsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}", ["azure_auth", ], peering_parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "circuitName", circuit_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "peeringName", peering_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Creates or updates a peering in the specified express route circuits.

Params:
- resource_group_name::String (required)
- circuit_name::String (required)
- peering_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- peering_parameters::ExpressRouteCircuitPeering (required)

Return: ExpressRouteCircuitPeering, OpenAPI.Clients.ApiResponse
"""
function express_route_circuit_peerings_create_or_update(_api::ExpressRouteCircuitPeeringsApi, resource_group_name::String, circuit_name::String, peering_name::String, api_version::String, subscription_id::String, peering_parameters::ExpressRouteCircuitPeering; _mediaType=nothing)
    _ctx = _oacinternal_express_route_circuit_peerings_create_or_update(_api, resource_group_name, circuit_name, peering_name, api_version, subscription_id, peering_parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function express_route_circuit_peerings_create_or_update(_api::ExpressRouteCircuitPeeringsApi, response_stream::Channel, resource_group_name::String, circuit_name::String, peering_name::String, api_version::String, subscription_id::String, peering_parameters::ExpressRouteCircuitPeering; _mediaType=nothing)
    _ctx = _oacinternal_express_route_circuit_peerings_create_or_update(_api, resource_group_name, circuit_name, peering_name, api_version, subscription_id, peering_parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_express_route_circuit_peerings_delete_ExpressRouteCircuitPeeringsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_express_route_circuit_peerings_delete(_api::ExpressRouteCircuitPeeringsApi, resource_group_name::String, circuit_name::String, peering_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_express_route_circuit_peerings_delete_ExpressRouteCircuitPeeringsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "circuitName", circuit_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "peeringName", peering_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Deletes the specified peering from the specified express route circuit.

Params:
- resource_group_name::String (required)
- circuit_name::String (required)
- peering_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function express_route_circuit_peerings_delete(_api::ExpressRouteCircuitPeeringsApi, resource_group_name::String, circuit_name::String, peering_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_express_route_circuit_peerings_delete(_api, resource_group_name, circuit_name, peering_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function express_route_circuit_peerings_delete(_api::ExpressRouteCircuitPeeringsApi, response_stream::Channel, resource_group_name::String, circuit_name::String, peering_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_express_route_circuit_peerings_delete(_api, resource_group_name, circuit_name, peering_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_express_route_circuit_peerings_get_ExpressRouteCircuitPeeringsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ExpressRouteCircuitPeering,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_express_route_circuit_peerings_get(_api::ExpressRouteCircuitPeeringsApi, resource_group_name::String, circuit_name::String, peering_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_express_route_circuit_peerings_get_ExpressRouteCircuitPeeringsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "circuitName", circuit_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "peeringName", peering_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets the specified peering for the express route circuit.

Params:
- resource_group_name::String (required)
- circuit_name::String (required)
- peering_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: ExpressRouteCircuitPeering, OpenAPI.Clients.ApiResponse
"""
function express_route_circuit_peerings_get(_api::ExpressRouteCircuitPeeringsApi, resource_group_name::String, circuit_name::String, peering_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_express_route_circuit_peerings_get(_api, resource_group_name, circuit_name, peering_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function express_route_circuit_peerings_get(_api::ExpressRouteCircuitPeeringsApi, response_stream::Channel, resource_group_name::String, circuit_name::String, peering_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_express_route_circuit_peerings_get(_api, resource_group_name, circuit_name, peering_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_express_route_circuit_peerings_list_ExpressRouteCircuitPeeringsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ExpressRouteCircuitPeeringListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_express_route_circuit_peerings_list(_api::ExpressRouteCircuitPeeringsApi, resource_group_name::String, circuit_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_express_route_circuit_peerings_list_ExpressRouteCircuitPeeringsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "circuitName", circuit_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets all peerings in a specified express route circuit.

Params:
- resource_group_name::String (required)
- circuit_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: ExpressRouteCircuitPeeringListResult, OpenAPI.Clients.ApiResponse
"""
function express_route_circuit_peerings_list(_api::ExpressRouteCircuitPeeringsApi, resource_group_name::String, circuit_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_express_route_circuit_peerings_list(_api, resource_group_name, circuit_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function express_route_circuit_peerings_list(_api::ExpressRouteCircuitPeeringsApi, response_stream::Channel, resource_group_name::String, circuit_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_express_route_circuit_peerings_list(_api, resource_group_name, circuit_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export express_route_circuit_peerings_create_or_update
export express_route_circuit_peerings_delete
export express_route_circuit_peerings_get
export express_route_circuit_peerings_list
