# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct ExpressRouteCircuitRoutesTableSummaryApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `ExpressRouteCircuitRoutesTableSummaryApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ ExpressRouteCircuitRoutesTableSummaryApi }) = "https://management.azure.com"

const _returntypes_express_route_circuits_list_routes_table_summary_ExpressRouteCircuitRoutesTableSummaryApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ExpressRouteCircuitsRoutesTableSummaryListResult,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_express_route_circuits_list_routes_table_summary(_api::ExpressRouteCircuitRoutesTableSummaryApi, resource_group_name::String, circuit_name::String, peering_name::String, device_path::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_express_route_circuits_list_routes_table_summary_ExpressRouteCircuitRoutesTableSummaryApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/routeTablesSummary/{devicePath}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "circuitName", circuit_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "peeringName", peering_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "devicePath", device_path)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets the currently advertised routes table summary associated with the express route circuit in a resource group.

Params:
- resource_group_name::String (required)
- circuit_name::String (required)
- peering_name::String (required)
- device_path::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: ExpressRouteCircuitsRoutesTableSummaryListResult, OpenAPI.Clients.ApiResponse
"""
function express_route_circuits_list_routes_table_summary(_api::ExpressRouteCircuitRoutesTableSummaryApi, resource_group_name::String, circuit_name::String, peering_name::String, device_path::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_express_route_circuits_list_routes_table_summary(_api, resource_group_name, circuit_name, peering_name, device_path, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function express_route_circuits_list_routes_table_summary(_api::ExpressRouteCircuitRoutesTableSummaryApi, response_stream::Channel, resource_group_name::String, circuit_name::String, peering_name::String, device_path::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_express_route_circuits_list_routes_table_summary(_api, resource_group_name, circuit_name, peering_name, device_path, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export express_route_circuits_list_routes_table_summary
