# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct ExpressRouteServiceProvidersApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `ExpressRouteServiceProvidersApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ ExpressRouteServiceProvidersApi }) = "https://management.azure.com"

const _returntypes_express_route_service_providers_list_ExpressRouteServiceProvidersApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ExpressRouteServiceProviderListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_express_route_service_providers_list(_api::ExpressRouteServiceProvidersApi, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_express_route_service_providers_list_ExpressRouteServiceProvidersApi, "/subscriptions/{subscriptionId}/providers/Microsoft.Network/expressRouteServiceProviders", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets all the available express route service providers.

Params:
- api_version::String (required)
- subscription_id::String (required)

Return: ExpressRouteServiceProviderListResult, OpenAPI.Clients.ApiResponse
"""
function express_route_service_providers_list(_api::ExpressRouteServiceProvidersApi, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_express_route_service_providers_list(_api, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function express_route_service_providers_list(_api::ExpressRouteServiceProvidersApi, response_stream::Channel, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_express_route_service_providers_list(_api, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export express_route_service_providers_list
