# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct PeerExpressRouteCircuitConnectionsApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `PeerExpressRouteCircuitConnectionsApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ PeerExpressRouteCircuitConnectionsApi }) = "https://management.azure.com"

const _returntypes_peer_express_route_circuit_connections_get_PeerExpressRouteCircuitConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => PeerExpressRouteCircuitConnection,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_peer_express_route_circuit_connections_get(_api::PeerExpressRouteCircuitConnectionsApi, resource_group_name::String, circuit_name::String, peering_name::String, connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_peer_express_route_circuit_connections_get_PeerExpressRouteCircuitConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/peerConnections/{connectionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "circuitName", circuit_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "peeringName", peering_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "connectionName", connection_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets the specified Peer Express Route Circuit Connection from the specified express route circuit.

Params:
- resource_group_name::String (required)
- circuit_name::String (required)
- peering_name::String (required)
- connection_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: PeerExpressRouteCircuitConnection, OpenAPI.Clients.ApiResponse
"""
function peer_express_route_circuit_connections_get(_api::PeerExpressRouteCircuitConnectionsApi, resource_group_name::String, circuit_name::String, peering_name::String, connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_peer_express_route_circuit_connections_get(_api, resource_group_name, circuit_name, peering_name, connection_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function peer_express_route_circuit_connections_get(_api::PeerExpressRouteCircuitConnectionsApi, response_stream::Channel, resource_group_name::String, circuit_name::String, peering_name::String, connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_peer_express_route_circuit_connections_get(_api, resource_group_name, circuit_name, peering_name, connection_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_peer_express_route_circuit_connections_list_PeerExpressRouteCircuitConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => PeerExpressRouteCircuitConnectionListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_peer_express_route_circuit_connections_list(_api::PeerExpressRouteCircuitConnectionsApi, resource_group_name::String, circuit_name::String, peering_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_peer_express_route_circuit_connections_list_PeerExpressRouteCircuitConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/expressRouteCircuits/{circuitName}/peerings/{peeringName}/peerConnections", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "circuitName", circuit_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "peeringName", peering_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets all global reach peer connections associated with a private peering in an express route circuit.

Params:
- resource_group_name::String (required)
- circuit_name::String (required)
- peering_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: PeerExpressRouteCircuitConnectionListResult, OpenAPI.Clients.ApiResponse
"""
function peer_express_route_circuit_connections_list(_api::PeerExpressRouteCircuitConnectionsApi, resource_group_name::String, circuit_name::String, peering_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_peer_express_route_circuit_connections_list(_api, resource_group_name, circuit_name, peering_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function peer_express_route_circuit_connections_list(_api::PeerExpressRouteCircuitConnectionsApi, response_stream::Channel, resource_group_name::String, circuit_name::String, peering_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_peer_express_route_circuit_connections_list(_api, resource_group_name, circuit_name, peering_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export peer_express_route_circuit_connections_get
export peer_express_route_circuit_connections_list
