# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""ExpressRouteCircuitRoutesTable
The routes table associated with the ExpressRouteCircuit.

    ExpressRouteCircuitRoutesTable(;
        network=nothing,
        nextHop=nothing,
        locPrf=nothing,
        weight=nothing,
        path=nothing,
    )

    - network::String : IP address of a network entity.
    - nextHop::String : NextHop address.
    - locPrf::String : Local preference value as set with the set local-preference route-map configuration command.
    - weight::Int64 : Route Weight.
    - path::String : Autonomous system paths to the destination network.
"""
Base.@kwdef mutable struct ExpressRouteCircuitRoutesTable <: OpenAPI.APIModel
    network::Union{Nothing, String} = nothing
    nextHop::Union{Nothing, String} = nothing
    locPrf::Union{Nothing, String} = nothing
    weight::Union{Nothing, Int64} = nothing
    path::Union{Nothing, String} = nothing

    function ExpressRouteCircuitRoutesTable(network, nextHop, locPrf, weight, path, )
        OpenAPI.validate_property(ExpressRouteCircuitRoutesTable, Symbol("network"), network)
        OpenAPI.validate_property(ExpressRouteCircuitRoutesTable, Symbol("nextHop"), nextHop)
        OpenAPI.validate_property(ExpressRouteCircuitRoutesTable, Symbol("locPrf"), locPrf)
        OpenAPI.validate_property(ExpressRouteCircuitRoutesTable, Symbol("weight"), weight)
        OpenAPI.validate_property(ExpressRouteCircuitRoutesTable, Symbol("path"), path)
        return new(network, nextHop, locPrf, weight, path, )
    end
end # type ExpressRouteCircuitRoutesTable

const _property_types_ExpressRouteCircuitRoutesTable = Dict{Symbol,String}(Symbol("network")=>"String", Symbol("nextHop")=>"String", Symbol("locPrf")=>"String", Symbol("weight")=>"Int64", Symbol("path")=>"String", )
OpenAPI.property_type(::Type{ ExpressRouteCircuitRoutesTable }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_ExpressRouteCircuitRoutesTable[name]))}

function check_required(o::ExpressRouteCircuitRoutesTable)
    true
end

function OpenAPI.validate_property(::Type{ ExpressRouteCircuitRoutesTable }, name::Symbol, val)
    if name === Symbol("weight")
        OpenAPI.validate_param(name, "ExpressRouteCircuitRoutesTable", :format, val, "int32")
    end
end
