# Julia API client for LoadBalancerClient

The Microsoft Azure Network management API provides a RESTful set of web services that interact with Microsoft Azure Networks service to manage your network resources. The API has entities that capture the relationship between an end user and the Microsoft Azure Networks service.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 2020-05-01
- Build package: org.openapitools.codegen.languages.JuliaClientCodegen


## Installation
Place the Julia files generated under the `src` folder in your Julia project. Include LoadBalancerClient.jl in the project code.
It would include the module named LoadBalancerClient.

Documentation is generated as markdown files under the `docs` folder. You can include them in your project documentation.
Documentation is also embedded in Julia which can be used with a Julia specific documentation generator.

## API Endpoints

Class | Method
------------ | -------------
*LoadBalancersApi* | [**inbound_nat_rules_create_or_update**](docs/LoadBalancersApi.md#inbound_nat_rules_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/inboundNatRules/{inboundNatRuleName}<br/>
*LoadBalancersApi* | [**inbound_nat_rules_delete**](docs/LoadBalancersApi.md#inbound_nat_rules_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/inboundNatRules/{inboundNatRuleName}<br/>
*LoadBalancersApi* | [**inbound_nat_rules_get**](docs/LoadBalancersApi.md#inbound_nat_rules_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/inboundNatRules/{inboundNatRuleName}<br/>
*LoadBalancersApi* | [**inbound_nat_rules_list**](docs/LoadBalancersApi.md#inbound_nat_rules_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/inboundNatRules<br/>
*LoadBalancersApi* | [**load_balancer_backend_address_pools_create_or_update**](docs/LoadBalancersApi.md#load_balancer_backend_address_pools_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/backendAddressPools/{backendAddressPoolName}<br/>
*LoadBalancersApi* | [**load_balancer_backend_address_pools_delete**](docs/LoadBalancersApi.md#load_balancer_backend_address_pools_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/backendAddressPools/{backendAddressPoolName}<br/>
*LoadBalancersApi* | [**load_balancer_backend_address_pools_get**](docs/LoadBalancersApi.md#load_balancer_backend_address_pools_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/backendAddressPools/{backendAddressPoolName}<br/>
*LoadBalancersApi* | [**load_balancer_backend_address_pools_list**](docs/LoadBalancersApi.md#load_balancer_backend_address_pools_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/backendAddressPools<br/>
*LoadBalancersApi* | [**load_balancer_frontend_i_p_configurations_get**](docs/LoadBalancersApi.md#load_balancer_frontend_i_p_configurations_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/frontendIPConfigurations/{frontendIPConfigurationName}<br/>
*LoadBalancersApi* | [**load_balancer_frontend_i_p_configurations_list**](docs/LoadBalancersApi.md#load_balancer_frontend_i_p_configurations_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/frontendIPConfigurations<br/>
*LoadBalancersApi* | [**load_balancer_load_balancing_rules_get**](docs/LoadBalancersApi.md#load_balancer_load_balancing_rules_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/loadBalancingRules/{loadBalancingRuleName}<br/>
*LoadBalancersApi* | [**load_balancer_load_balancing_rules_list**](docs/LoadBalancersApi.md#load_balancer_load_balancing_rules_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/loadBalancingRules<br/>
*LoadBalancersApi* | [**load_balancer_network_interfaces_list**](docs/LoadBalancersApi.md#load_balancer_network_interfaces_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/networkInterfaces<br/>
*LoadBalancersApi* | [**load_balancer_outbound_rules_get**](docs/LoadBalancersApi.md#load_balancer_outbound_rules_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/outboundRules/{outboundRuleName}<br/>
*LoadBalancersApi* | [**load_balancer_outbound_rules_list**](docs/LoadBalancersApi.md#load_balancer_outbound_rules_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/outboundRules<br/>
*LoadBalancersApi* | [**load_balancer_probes_get**](docs/LoadBalancersApi.md#load_balancer_probes_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/probes/{probeName}<br/>
*LoadBalancersApi* | [**load_balancer_probes_list**](docs/LoadBalancersApi.md#load_balancer_probes_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/probes<br/>
*LoadBalancersApi* | [**load_balancers_create_or_update**](docs/LoadBalancersApi.md#load_balancers_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}<br/>
*LoadBalancersApi* | [**load_balancers_delete**](docs/LoadBalancersApi.md#load_balancers_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}<br/>
*LoadBalancersApi* | [**load_balancers_get**](docs/LoadBalancersApi.md#load_balancers_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}<br/>
*LoadBalancersApi* | [**load_balancers_list**](docs/LoadBalancersApi.md#load_balancers_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers<br/>
*LoadBalancersApi* | [**load_balancers_list_all**](docs/LoadBalancersApi.md#load_balancers_list_all)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Network/loadBalancers<br/>
*LoadBalancersApi* | [**load_balancers_update_tags**](docs/LoadBalancersApi.md#load_balancers_update_tags)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}<br/>


## Models

 - [ApplicationGatewayBackendAddress](docs/ApplicationGatewayBackendAddress.md)
 - [ApplicationGatewayBackendAddressPool](docs/ApplicationGatewayBackendAddressPool.md)
 - [ApplicationGatewayBackendAddressPoolPropertiesFormat](docs/ApplicationGatewayBackendAddressPoolPropertiesFormat.md)
 - [ApplicationSecurityGroup](docs/ApplicationSecurityGroup.md)
 - [ApplicationSecurityGroupPropertiesFormat](docs/ApplicationSecurityGroupPropertiesFormat.md)
 - [BackendAddressPool](docs/BackendAddressPool.md)
 - [BackendAddressPool2](docs/BackendAddressPool2.md)
 - [BackendAddressPoolPropertiesFormat](docs/BackendAddressPoolPropertiesFormat.md)
 - [BackendAddressPoolPropertiesFormat2](docs/BackendAddressPoolPropertiesFormat2.md)
 - [CloudError](docs/CloudError.md)
 - [CloudErrorBody](docs/CloudErrorBody.md)
 - [CustomDnsConfigPropertiesFormat](docs/CustomDnsConfigPropertiesFormat.md)
 - [DdosSettings](docs/DdosSettings.md)
 - [Delegation](docs/Delegation.md)
 - [FlowLog](docs/FlowLog.md)
 - [FlowLogFormatParameters](docs/FlowLogFormatParameters.md)
 - [FlowLogPropertiesFormat](docs/FlowLogPropertiesFormat.md)
 - [FrontendIPConfiguration](docs/FrontendIPConfiguration.md)
 - [FrontendIPConfiguration2](docs/FrontendIPConfiguration2.md)
 - [FrontendIPConfigurationPropertiesFormat](docs/FrontendIPConfigurationPropertiesFormat.md)
 - [FrontendIPConfigurationPropertiesFormat2](docs/FrontendIPConfigurationPropertiesFormat2.md)
 - [IPAllocationMethod](docs/IPAllocationMethod.md)
 - [IPConfiguration](docs/IPConfiguration.md)
 - [IPConfigurationProfile](docs/IPConfigurationProfile.md)
 - [IPConfigurationProfilePropertiesFormat](docs/IPConfigurationProfilePropertiesFormat.md)
 - [IPConfigurationPropertiesFormat](docs/IPConfigurationPropertiesFormat.md)
 - [IPVersion](docs/IPVersion.md)
 - [InboundNatPool](docs/InboundNatPool.md)
 - [InboundNatPoolPropertiesFormat](docs/InboundNatPoolPropertiesFormat.md)
 - [InboundNatRule](docs/InboundNatRule.md)
 - [InboundNatRule2](docs/InboundNatRule2.md)
 - [InboundNatRuleListResult](docs/InboundNatRuleListResult.md)
 - [InboundNatRulePropertiesFormat](docs/InboundNatRulePropertiesFormat.md)
 - [InboundNatRulePropertiesFormat2](docs/InboundNatRulePropertiesFormat2.md)
 - [IpTag](docs/IpTag.md)
 - [LoadBalancer](docs/LoadBalancer.md)
 - [LoadBalancerBackendAddress](docs/LoadBalancerBackendAddress.md)
 - [LoadBalancerBackendAddress2](docs/LoadBalancerBackendAddress2.md)
 - [LoadBalancerBackendAddressPoolListResult](docs/LoadBalancerBackendAddressPoolListResult.md)
 - [LoadBalancerBackendAddressPropertiesFormat](docs/LoadBalancerBackendAddressPropertiesFormat.md)
 - [LoadBalancerBackendAddressPropertiesFormat2](docs/LoadBalancerBackendAddressPropertiesFormat2.md)
 - [LoadBalancerFrontendIPConfigurationListResult](docs/LoadBalancerFrontendIPConfigurationListResult.md)
 - [LoadBalancerListResult](docs/LoadBalancerListResult.md)
 - [LoadBalancerLoadBalancingRuleListResult](docs/LoadBalancerLoadBalancingRuleListResult.md)
 - [LoadBalancerOutboundRuleListResult](docs/LoadBalancerOutboundRuleListResult.md)
 - [LoadBalancerProbeListResult](docs/LoadBalancerProbeListResult.md)
 - [LoadBalancerPropertiesFormat](docs/LoadBalancerPropertiesFormat.md)
 - [LoadBalancerSku](docs/LoadBalancerSku.md)
 - [LoadBalancingRule](docs/LoadBalancingRule.md)
 - [LoadBalancingRulePropertiesFormat](docs/LoadBalancingRulePropertiesFormat.md)
 - [NetworkInterface](docs/NetworkInterface.md)
 - [NetworkInterfaceDnsSettings](docs/NetworkInterfaceDnsSettings.md)
 - [NetworkInterfaceIPConfiguration](docs/NetworkInterfaceIPConfiguration.md)
 - [NetworkInterfaceIPConfigurationPrivateLinkConnectionProperties](docs/NetworkInterfaceIPConfigurationPrivateLinkConnectionProperties.md)
 - [NetworkInterfaceIPConfigurationPropertiesFormat](docs/NetworkInterfaceIPConfigurationPropertiesFormat.md)
 - [NetworkInterfaceListResult](docs/NetworkInterfaceListResult.md)
 - [NetworkInterfacePropertiesFormat](docs/NetworkInterfacePropertiesFormat.md)
 - [NetworkInterfaceTapConfiguration](docs/NetworkInterfaceTapConfiguration.md)
 - [NetworkInterfaceTapConfigurationPropertiesFormat](docs/NetworkInterfaceTapConfigurationPropertiesFormat.md)
 - [NetworkSecurityGroup](docs/NetworkSecurityGroup.md)
 - [NetworkSecurityGroupPropertiesFormat](docs/NetworkSecurityGroupPropertiesFormat.md)
 - [OutboundRule](docs/OutboundRule.md)
 - [OutboundRulePropertiesFormat](docs/OutboundRulePropertiesFormat.md)
 - [PrivateEndpoint](docs/PrivateEndpoint.md)
 - [PrivateEndpointProperties](docs/PrivateEndpointProperties.md)
 - [PrivateLinkServiceConnection](docs/PrivateLinkServiceConnection.md)
 - [PrivateLinkServiceConnectionProperties](docs/PrivateLinkServiceConnectionProperties.md)
 - [PrivateLinkServiceConnectionState](docs/PrivateLinkServiceConnectionState.md)
 - [Probe](docs/Probe.md)
 - [ProbePropertiesFormat](docs/ProbePropertiesFormat.md)
 - [ProvisioningState](docs/ProvisioningState.md)
 - [PublicIPAddress](docs/PublicIPAddress.md)
 - [PublicIPAddressDnsSettings](docs/PublicIPAddressDnsSettings.md)
 - [PublicIPAddressPropertiesFormat](docs/PublicIPAddressPropertiesFormat.md)
 - [PublicIPAddressSku](docs/PublicIPAddressSku.md)
 - [Resource](docs/Resource.md)
 - [ResourceNavigationLink](docs/ResourceNavigationLink.md)
 - [ResourceNavigationLinkFormat](docs/ResourceNavigationLinkFormat.md)
 - [RetentionPolicyParameters](docs/RetentionPolicyParameters.md)
 - [Route](docs/Route.md)
 - [RouteNextHopType](docs/RouteNextHopType.md)
 - [RoutePropertiesFormat](docs/RoutePropertiesFormat.md)
 - [RouteTable](docs/RouteTable.md)
 - [RouteTablePropertiesFormat](docs/RouteTablePropertiesFormat.md)
 - [SecurityRule](docs/SecurityRule.md)
 - [SecurityRuleAccess](docs/SecurityRuleAccess.md)
 - [SecurityRuleDirection](docs/SecurityRuleDirection.md)
 - [SecurityRulePropertiesFormat](docs/SecurityRulePropertiesFormat.md)
 - [ServiceAssociationLink](docs/ServiceAssociationLink.md)
 - [ServiceAssociationLinkPropertiesFormat](docs/ServiceAssociationLinkPropertiesFormat.md)
 - [ServiceDelegationPropertiesFormat](docs/ServiceDelegationPropertiesFormat.md)
 - [ServiceEndpointPolicy](docs/ServiceEndpointPolicy.md)
 - [ServiceEndpointPolicyDefinition](docs/ServiceEndpointPolicyDefinition.md)
 - [ServiceEndpointPolicyDefinitionPropertiesFormat](docs/ServiceEndpointPolicyDefinitionPropertiesFormat.md)
 - [ServiceEndpointPolicyPropertiesFormat](docs/ServiceEndpointPolicyPropertiesFormat.md)
 - [ServiceEndpointPropertiesFormat](docs/ServiceEndpointPropertiesFormat.md)
 - [SubResource](docs/SubResource.md)
 - [Subnet](docs/Subnet.md)
 - [SubnetPropertiesFormat](docs/SubnetPropertiesFormat.md)
 - [TagsObject](docs/TagsObject.md)
 - [TrafficAnalyticsConfigurationProperties](docs/TrafficAnalyticsConfigurationProperties.md)
 - [TrafficAnalyticsProperties](docs/TrafficAnalyticsProperties.md)
 - [TransportProtocol](docs/TransportProtocol.md)
 - [TransportProtocol2](docs/TransportProtocol2.md)
 - [VirtualNetworkTap](docs/VirtualNetworkTap.md)
 - [VirtualNetworkTapPropertiesFormat](docs/VirtualNetworkTapPropertiesFormat.md)


## Authorization

## azure_auth
- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://login.microsoftonline.com/common/oauth2/authorize
- **Scopes**: 
 - **user_impersonation**: impersonate your user account

Example
```
    using OpenAPI
    using OpenAPI.Clients
    import OpenAPI.Clients: Client, set_header
    client = Client(server_uri)
    set_header(client, "Authorization", "Bearer $bearer_auth")
    api = MyApi(client)
    result = callApi(api, args...; api_key)
```

## Author



