# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""PublicIPAddress
Public IP address resource.

    PublicIPAddress(;
        sku=nothing,
        properties=nothing,
        etag=nothing,
        zones=nothing,
        id=nothing,
        name=nothing,
        type=nothing,
        location=nothing,
        tags=nothing,
    )

    - sku::PublicIPAddressSku
    - properties::PublicIPAddressPropertiesFormat
    - etag::String : A unique read-only string that changes whenever the resource is updated.
    - zones::Vector{String} : A list of availability zones denoting the IP allocated for the resource needs to come from.
    - id::String : Resource ID.
    - name::String : Resource name.
    - type::String : Resource type.
    - location::String : Resource location.
    - tags::Dict{String, String} : Resource tags.
"""
Base.@kwdef mutable struct PublicIPAddress <: OpenAPI.APIModel
    sku = nothing # spec type: Union{ Nothing, PublicIPAddressSku }
    properties = nothing # spec type: Union{ Nothing, PublicIPAddressPropertiesFormat }
    etag::Union{Nothing, String} = nothing
    zones::Union{Nothing, Vector{String}} = nothing
    id::Union{Nothing, String} = nothing
    name::Union{Nothing, String} = nothing
    type::Union{Nothing, String} = nothing
    location::Union{Nothing, String} = nothing
    tags::Union{Nothing, Dict{String, String}} = nothing

    function PublicIPAddress(sku, properties, etag, zones, id, name, type, location, tags, )
        OpenAPI.validate_property(PublicIPAddress, Symbol("sku"), sku)
        OpenAPI.validate_property(PublicIPAddress, Symbol("properties"), properties)
        OpenAPI.validate_property(PublicIPAddress, Symbol("etag"), etag)
        OpenAPI.validate_property(PublicIPAddress, Symbol("zones"), zones)
        OpenAPI.validate_property(PublicIPAddress, Symbol("id"), id)
        OpenAPI.validate_property(PublicIPAddress, Symbol("name"), name)
        OpenAPI.validate_property(PublicIPAddress, Symbol("type"), type)
        OpenAPI.validate_property(PublicIPAddress, Symbol("location"), location)
        OpenAPI.validate_property(PublicIPAddress, Symbol("tags"), tags)
        return new(sku, properties, etag, zones, id, name, type, location, tags, )
    end
end # type PublicIPAddress

const _property_types_PublicIPAddress = Dict{Symbol,String}(Symbol("sku")=>"PublicIPAddressSku", Symbol("properties")=>"PublicIPAddressPropertiesFormat", Symbol("etag")=>"String", Symbol("zones")=>"Vector{String}", Symbol("id")=>"String", Symbol("name")=>"String", Symbol("type")=>"String", Symbol("location")=>"String", Symbol("tags")=>"Dict{String, String}", )
OpenAPI.property_type(::Type{ PublicIPAddress }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_PublicIPAddress[name]))}

function check_required(o::PublicIPAddress)
    true
end

function OpenAPI.validate_property(::Type{ PublicIPAddress }, name::Symbol, val)
end
