# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""ManagedServiceIdentity
Identity for the resource.

    ManagedServiceIdentity(;
        principalId=nothing,
        tenantId=nothing,
        type=nothing,
        userAssignedIdentities=nothing,
    )

    - principalId::String : The principal id of the system assigned identity. This property will only be provided for a system assigned identity.
    - tenantId::String : The tenant id of the system assigned identity. This property will only be provided for a system assigned identity.
    - type::String : The type of identity used for the resource. The type &#39;SystemAssigned, UserAssigned&#39; includes both an implicitly created identity and a set of user assigned identities. The type &#39;None&#39; will remove any identities from the virtual machine.
    - userAssignedIdentities::Dict{String, ManagedServiceIdentityUserAssignedIdentitiesValue} : The list of user identities associated with resource. The user identity dictionary key references will be ARM resource ids in the form: &#39;/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}&#39;.
"""
Base.@kwdef mutable struct ManagedServiceIdentity <: OpenAPI.APIModel
    principalId::Union{Nothing, String} = nothing
    tenantId::Union{Nothing, String} = nothing
    type::Union{Nothing, String} = nothing
    userAssignedIdentities::Union{Nothing, Dict} = nothing # spec type: Union{ Nothing, Dict{String, ManagedServiceIdentityUserAssignedIdentitiesValue} }

    function ManagedServiceIdentity(principalId, tenantId, type, userAssignedIdentities, )
        OpenAPI.validate_property(ManagedServiceIdentity, Symbol("principalId"), principalId)
        OpenAPI.validate_property(ManagedServiceIdentity, Symbol("tenantId"), tenantId)
        OpenAPI.validate_property(ManagedServiceIdentity, Symbol("type"), type)
        OpenAPI.validate_property(ManagedServiceIdentity, Symbol("userAssignedIdentities"), userAssignedIdentities)
        return new(principalId, tenantId, type, userAssignedIdentities, )
    end
end # type ManagedServiceIdentity

const _property_types_ManagedServiceIdentity = Dict{Symbol,String}(Symbol("principalId")=>"String", Symbol("tenantId")=>"String", Symbol("type")=>"String", Symbol("userAssignedIdentities")=>"Dict{String, ManagedServiceIdentityUserAssignedIdentitiesValue}", )
OpenAPI.property_type(::Type{ ManagedServiceIdentity }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_ManagedServiceIdentity[name]))}

function check_required(o::ManagedServiceIdentity)
    true
end

function OpenAPI.validate_property(::Type{ ManagedServiceIdentity }, name::Symbol, val)
    if name === Symbol("type")
        OpenAPI.validate_param(name, "ManagedServiceIdentity", :enum, val, ["SystemAssigned", "UserAssigned", "SystemAssigned, UserAssigned", "None"])
    end
end
