# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct NetworkSecurityGroupsApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `NetworkSecurityGroupsApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ NetworkSecurityGroupsApi }) = "https://management.azure.com"

const _returntypes_network_security_groups_create_or_update_NetworkSecurityGroupsApi = Dict{Regex,Type}(
    Regex("^" * replace("201", "x"=>".") * "\$") => NetworkSecurityGroup,
    Regex("^" * replace("200", "x"=>".") * "\$") => NetworkSecurityGroup,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_network_security_groups_create_or_update(_api::NetworkSecurityGroupsApi, resource_group_name::String, network_security_group_name::String, api_version::String, subscription_id::String, parameters::NetworkSecurityGroup; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_network_security_groups_create_or_update_NetworkSecurityGroupsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkSecurityGroups/{networkSecurityGroupName}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "networkSecurityGroupName", network_security_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Creates or updates a network security group in the specified resource group.

Params:
- resource_group_name::String (required)
- network_security_group_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::NetworkSecurityGroup (required)

Return: NetworkSecurityGroup, OpenAPI.Clients.ApiResponse
"""
function network_security_groups_create_or_update(_api::NetworkSecurityGroupsApi, resource_group_name::String, network_security_group_name::String, api_version::String, subscription_id::String, parameters::NetworkSecurityGroup; _mediaType=nothing)
    _ctx = _oacinternal_network_security_groups_create_or_update(_api, resource_group_name, network_security_group_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function network_security_groups_create_or_update(_api::NetworkSecurityGroupsApi, response_stream::Channel, resource_group_name::String, network_security_group_name::String, api_version::String, subscription_id::String, parameters::NetworkSecurityGroup; _mediaType=nothing)
    _ctx = _oacinternal_network_security_groups_create_or_update(_api, resource_group_name, network_security_group_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_network_security_groups_delete_NetworkSecurityGroupsApi = Dict{Regex,Type}(
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_network_security_groups_delete(_api::NetworkSecurityGroupsApi, resource_group_name::String, network_security_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_network_security_groups_delete_NetworkSecurityGroupsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkSecurityGroups/{networkSecurityGroupName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "networkSecurityGroupName", network_security_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Deletes the specified network security group.

Params:
- resource_group_name::String (required)
- network_security_group_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function network_security_groups_delete(_api::NetworkSecurityGroupsApi, resource_group_name::String, network_security_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_network_security_groups_delete(_api, resource_group_name, network_security_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function network_security_groups_delete(_api::NetworkSecurityGroupsApi, response_stream::Channel, resource_group_name::String, network_security_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_network_security_groups_delete(_api, resource_group_name, network_security_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_network_security_groups_get_NetworkSecurityGroupsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => NetworkSecurityGroup,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_network_security_groups_get(_api::NetworkSecurityGroupsApi, resource_group_name::String, network_security_group_name::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_network_security_groups_get_NetworkSecurityGroupsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkSecurityGroups/{networkSecurityGroupName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "networkSecurityGroupName", network_security_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "\$expand", expand)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets the specified network security group.

Params:
- resource_group_name::String (required)
- network_security_group_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- expand::String

Return: NetworkSecurityGroup, OpenAPI.Clients.ApiResponse
"""
function network_security_groups_get(_api::NetworkSecurityGroupsApi, resource_group_name::String, network_security_group_name::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = _oacinternal_network_security_groups_get(_api, resource_group_name, network_security_group_name, api_version, subscription_id; expand=expand, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function network_security_groups_get(_api::NetworkSecurityGroupsApi, response_stream::Channel, resource_group_name::String, network_security_group_name::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = _oacinternal_network_security_groups_get(_api, resource_group_name, network_security_group_name, api_version, subscription_id; expand=expand, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_network_security_groups_list_NetworkSecurityGroupsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => NetworkSecurityGroupListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_network_security_groups_list(_api::NetworkSecurityGroupsApi, resource_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_network_security_groups_list_NetworkSecurityGroupsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkSecurityGroups", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets all network security groups in a resource group.

Params:
- resource_group_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: NetworkSecurityGroupListResult, OpenAPI.Clients.ApiResponse
"""
function network_security_groups_list(_api::NetworkSecurityGroupsApi, resource_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_network_security_groups_list(_api, resource_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function network_security_groups_list(_api::NetworkSecurityGroupsApi, response_stream::Channel, resource_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_network_security_groups_list(_api, resource_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_network_security_groups_list_all_NetworkSecurityGroupsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => NetworkSecurityGroupListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_network_security_groups_list_all(_api::NetworkSecurityGroupsApi, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_network_security_groups_list_all_NetworkSecurityGroupsApi, "/subscriptions/{subscriptionId}/providers/Microsoft.Network/networkSecurityGroups", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets all network security groups in a subscription.

Params:
- api_version::String (required)
- subscription_id::String (required)

Return: NetworkSecurityGroupListResult, OpenAPI.Clients.ApiResponse
"""
function network_security_groups_list_all(_api::NetworkSecurityGroupsApi, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_network_security_groups_list_all(_api, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function network_security_groups_list_all(_api::NetworkSecurityGroupsApi, response_stream::Channel, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_network_security_groups_list_all(_api, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_network_security_groups_update_tags_NetworkSecurityGroupsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => NetworkSecurityGroup,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_network_security_groups_update_tags(_api::NetworkSecurityGroupsApi, resource_group_name::String, network_security_group_name::String, api_version::String, subscription_id::String, parameters::TagsObject; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PATCH", _returntypes_network_security_groups_update_tags_NetworkSecurityGroupsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkSecurityGroups/{networkSecurityGroupName}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "networkSecurityGroupName", network_security_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Updates a network security group tags.

Params:
- resource_group_name::String (required)
- network_security_group_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::TagsObject (required)

Return: NetworkSecurityGroup, OpenAPI.Clients.ApiResponse
"""
function network_security_groups_update_tags(_api::NetworkSecurityGroupsApi, resource_group_name::String, network_security_group_name::String, api_version::String, subscription_id::String, parameters::TagsObject; _mediaType=nothing)
    _ctx = _oacinternal_network_security_groups_update_tags(_api, resource_group_name, network_security_group_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function network_security_groups_update_tags(_api::NetworkSecurityGroupsApi, response_stream::Channel, resource_group_name::String, network_security_group_name::String, api_version::String, subscription_id::String, parameters::TagsObject; _mediaType=nothing)
    _ctx = _oacinternal_network_security_groups_update_tags(_api, resource_group_name, network_security_group_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export network_security_groups_create_or_update
export network_security_groups_delete
export network_security_groups_get
export network_security_groups_list
export network_security_groups_list_all
export network_security_groups_update_tags
