# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct SecurityRulesApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `SecurityRulesApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ SecurityRulesApi }) = "https://management.azure.com"

const _returntypes_default_security_rules_get_SecurityRulesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => SecurityRule,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_default_security_rules_get(_api::SecurityRulesApi, resource_group_name::String, network_security_group_name::String, default_security_rule_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_default_security_rules_get_SecurityRulesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkSecurityGroups/{networkSecurityGroupName}/defaultSecurityRules/{defaultSecurityRuleName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "networkSecurityGroupName", network_security_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "defaultSecurityRuleName", default_security_rule_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Get the specified default network security rule.

Params:
- resource_group_name::String (required)
- network_security_group_name::String (required)
- default_security_rule_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: SecurityRule, OpenAPI.Clients.ApiResponse
"""
function default_security_rules_get(_api::SecurityRulesApi, resource_group_name::String, network_security_group_name::String, default_security_rule_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_default_security_rules_get(_api, resource_group_name, network_security_group_name, default_security_rule_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function default_security_rules_get(_api::SecurityRulesApi, response_stream::Channel, resource_group_name::String, network_security_group_name::String, default_security_rule_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_default_security_rules_get(_api, resource_group_name, network_security_group_name, default_security_rule_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_default_security_rules_list_SecurityRulesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => SecurityRuleListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_default_security_rules_list(_api::SecurityRulesApi, resource_group_name::String, network_security_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_default_security_rules_list_SecurityRulesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkSecurityGroups/{networkSecurityGroupName}/defaultSecurityRules", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "networkSecurityGroupName", network_security_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets all default security rules in a network security group.

Params:
- resource_group_name::String (required)
- network_security_group_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: SecurityRuleListResult, OpenAPI.Clients.ApiResponse
"""
function default_security_rules_list(_api::SecurityRulesApi, resource_group_name::String, network_security_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_default_security_rules_list(_api, resource_group_name, network_security_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function default_security_rules_list(_api::SecurityRulesApi, response_stream::Channel, resource_group_name::String, network_security_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_default_security_rules_list(_api, resource_group_name, network_security_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_security_rules_create_or_update_SecurityRulesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => SecurityRule,
    Regex("^" * replace("201", "x"=>".") * "\$") => SecurityRule,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_security_rules_create_or_update(_api::SecurityRulesApi, resource_group_name::String, network_security_group_name::String, security_rule_name::String, api_version::String, subscription_id::String, security_rule_parameters::SecurityRule; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_security_rules_create_or_update_SecurityRulesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkSecurityGroups/{networkSecurityGroupName}/securityRules/{securityRuleName}", ["azure_auth", ], security_rule_parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "networkSecurityGroupName", network_security_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "securityRuleName", security_rule_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Creates or updates a security rule in the specified network security group.

Params:
- resource_group_name::String (required)
- network_security_group_name::String (required)
- security_rule_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- security_rule_parameters::SecurityRule (required)

Return: SecurityRule, OpenAPI.Clients.ApiResponse
"""
function security_rules_create_or_update(_api::SecurityRulesApi, resource_group_name::String, network_security_group_name::String, security_rule_name::String, api_version::String, subscription_id::String, security_rule_parameters::SecurityRule; _mediaType=nothing)
    _ctx = _oacinternal_security_rules_create_or_update(_api, resource_group_name, network_security_group_name, security_rule_name, api_version, subscription_id, security_rule_parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function security_rules_create_or_update(_api::SecurityRulesApi, response_stream::Channel, resource_group_name::String, network_security_group_name::String, security_rule_name::String, api_version::String, subscription_id::String, security_rule_parameters::SecurityRule; _mediaType=nothing)
    _ctx = _oacinternal_security_rules_create_or_update(_api, resource_group_name, network_security_group_name, security_rule_name, api_version, subscription_id, security_rule_parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_security_rules_delete_SecurityRulesApi = Dict{Regex,Type}(
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_security_rules_delete(_api::SecurityRulesApi, resource_group_name::String, network_security_group_name::String, security_rule_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_security_rules_delete_SecurityRulesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkSecurityGroups/{networkSecurityGroupName}/securityRules/{securityRuleName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "networkSecurityGroupName", network_security_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "securityRuleName", security_rule_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Deletes the specified network security rule.

Params:
- resource_group_name::String (required)
- network_security_group_name::String (required)
- security_rule_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function security_rules_delete(_api::SecurityRulesApi, resource_group_name::String, network_security_group_name::String, security_rule_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_security_rules_delete(_api, resource_group_name, network_security_group_name, security_rule_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function security_rules_delete(_api::SecurityRulesApi, response_stream::Channel, resource_group_name::String, network_security_group_name::String, security_rule_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_security_rules_delete(_api, resource_group_name, network_security_group_name, security_rule_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_security_rules_get_SecurityRulesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => SecurityRule,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_security_rules_get(_api::SecurityRulesApi, resource_group_name::String, network_security_group_name::String, security_rule_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_security_rules_get_SecurityRulesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkSecurityGroups/{networkSecurityGroupName}/securityRules/{securityRuleName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "networkSecurityGroupName", network_security_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "securityRuleName", security_rule_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Get the specified network security rule.

Params:
- resource_group_name::String (required)
- network_security_group_name::String (required)
- security_rule_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: SecurityRule, OpenAPI.Clients.ApiResponse
"""
function security_rules_get(_api::SecurityRulesApi, resource_group_name::String, network_security_group_name::String, security_rule_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_security_rules_get(_api, resource_group_name, network_security_group_name, security_rule_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function security_rules_get(_api::SecurityRulesApi, response_stream::Channel, resource_group_name::String, network_security_group_name::String, security_rule_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_security_rules_get(_api, resource_group_name, network_security_group_name, security_rule_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_security_rules_list_SecurityRulesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => SecurityRuleListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_security_rules_list(_api::SecurityRulesApi, resource_group_name::String, network_security_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_security_rules_list_SecurityRulesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkSecurityGroups/{networkSecurityGroupName}/securityRules", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "networkSecurityGroupName", network_security_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets all security rules in a network security group.

Params:
- resource_group_name::String (required)
- network_security_group_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: SecurityRuleListResult, OpenAPI.Clients.ApiResponse
"""
function security_rules_list(_api::SecurityRulesApi, resource_group_name::String, network_security_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_security_rules_list(_api, resource_group_name, network_security_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function security_rules_list(_api::SecurityRulesApi, response_stream::Channel, resource_group_name::String, network_security_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_security_rules_list(_api, resource_group_name, network_security_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export default_security_rules_get
export default_security_rules_list
export security_rules_create_or_update
export security_rules_delete
export security_rules_get
export security_rules_list
