# Julia API client for NetworkWatcherClient

The Microsoft Azure Network management API provides a RESTful set of web services that interact with Microsoft Azure Networks service to manage your network resources. The API has entities that capture the relationship between an end user and the Microsoft Azure Networks service.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 2020-05-01
- Build package: org.openapitools.codegen.languages.JuliaClientCodegen


## Installation
Place the Julia files generated under the `src` folder in your Julia project. Include NetworkWatcherClient.jl in the project code.
It would include the module named NetworkWatcherClient.

Documentation is generated as markdown files under the `docs` folder. You can include them in your project documentation.
Documentation is also embedded in Julia which can be used with a Julia specific documentation generator.

## API Endpoints

Class | Method
------------ | -------------
*ConnectionMonitorsApi* | [**connection_monitors_create_or_update**](docs/ConnectionMonitorsApi.md#connection_monitors_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/connectionMonitors/{connectionMonitorName}<br/>
*ConnectionMonitorsApi* | [**connection_monitors_delete**](docs/ConnectionMonitorsApi.md#connection_monitors_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/connectionMonitors/{connectionMonitorName}<br/>
*ConnectionMonitorsApi* | [**connection_monitors_get**](docs/ConnectionMonitorsApi.md#connection_monitors_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/connectionMonitors/{connectionMonitorName}<br/>
*ConnectionMonitorsApi* | [**connection_monitors_list**](docs/ConnectionMonitorsApi.md#connection_monitors_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/connectionMonitors<br/>
*ConnectionMonitorsApi* | [**connection_monitors_query**](docs/ConnectionMonitorsApi.md#connection_monitors_query)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/connectionMonitors/{connectionMonitorName}/query<br/>
*ConnectionMonitorsApi* | [**connection_monitors_start**](docs/ConnectionMonitorsApi.md#connection_monitors_start)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/connectionMonitors/{connectionMonitorName}/start<br/>
*ConnectionMonitorsApi* | [**connection_monitors_stop**](docs/ConnectionMonitorsApi.md#connection_monitors_stop)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/connectionMonitors/{connectionMonitorName}/stop<br/>
*ConnectionMonitorsApi* | [**connection_monitors_update_tags**](docs/ConnectionMonitorsApi.md#connection_monitors_update_tags)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/connectionMonitors/{connectionMonitorName}<br/>
*FlowLogsApi* | [**flow_logs_create_or_update**](docs/FlowLogsApi.md#flow_logs_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/flowLogs/{flowLogName}<br/>
*FlowLogsApi* | [**flow_logs_delete**](docs/FlowLogsApi.md#flow_logs_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/flowLogs/{flowLogName}<br/>
*FlowLogsApi* | [**flow_logs_get**](docs/FlowLogsApi.md#flow_logs_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/flowLogs/{flowLogName}<br/>
*FlowLogsApi* | [**flow_logs_list**](docs/FlowLogsApi.md#flow_logs_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/flowLogs<br/>
*NetworkWatchersApi* | [**network_watchers_check_connectivity**](docs/NetworkWatchersApi.md#network_watchers_check_connectivity)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/connectivityCheck<br/>
*NetworkWatchersApi* | [**network_watchers_create_or_update**](docs/NetworkWatchersApi.md#network_watchers_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}<br/>
*NetworkWatchersApi* | [**network_watchers_delete**](docs/NetworkWatchersApi.md#network_watchers_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}<br/>
*NetworkWatchersApi* | [**network_watchers_get**](docs/NetworkWatchersApi.md#network_watchers_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}<br/>
*NetworkWatchersApi* | [**network_watchers_get_azure_reachability_report**](docs/NetworkWatchersApi.md#network_watchers_get_azure_reachability_report)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/azureReachabilityReport<br/>
*NetworkWatchersApi* | [**network_watchers_get_flow_log_status**](docs/NetworkWatchersApi.md#network_watchers_get_flow_log_status)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/queryFlowLogStatus<br/>
*NetworkWatchersApi* | [**network_watchers_get_network_configuration_diagnostic**](docs/NetworkWatchersApi.md#network_watchers_get_network_configuration_diagnostic)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/networkConfigurationDiagnostic<br/>
*NetworkWatchersApi* | [**network_watchers_get_next_hop**](docs/NetworkWatchersApi.md#network_watchers_get_next_hop)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/nextHop<br/>
*NetworkWatchersApi* | [**network_watchers_get_topology**](docs/NetworkWatchersApi.md#network_watchers_get_topology)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/topology<br/>
*NetworkWatchersApi* | [**network_watchers_get_troubleshooting**](docs/NetworkWatchersApi.md#network_watchers_get_troubleshooting)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/troubleshoot<br/>
*NetworkWatchersApi* | [**network_watchers_get_troubleshooting_result**](docs/NetworkWatchersApi.md#network_watchers_get_troubleshooting_result)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/queryTroubleshootResult<br/>
*NetworkWatchersApi* | [**network_watchers_get_v_m_security_rules**](docs/NetworkWatchersApi.md#network_watchers_get_v_m_security_rules)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/securityGroupView<br/>
*NetworkWatchersApi* | [**network_watchers_list**](docs/NetworkWatchersApi.md#network_watchers_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers<br/>
*NetworkWatchersApi* | [**network_watchers_list_all**](docs/NetworkWatchersApi.md#network_watchers_list_all)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Network/networkWatchers<br/>
*NetworkWatchersApi* | [**network_watchers_list_available_providers**](docs/NetworkWatchersApi.md#network_watchers_list_available_providers)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/availableProvidersList<br/>
*NetworkWatchersApi* | [**network_watchers_set_flow_log_configuration**](docs/NetworkWatchersApi.md#network_watchers_set_flow_log_configuration)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/configureFlowLog<br/>
*NetworkWatchersApi* | [**network_watchers_update_tags**](docs/NetworkWatchersApi.md#network_watchers_update_tags)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}<br/>
*NetworkWatchersApi* | [**network_watchers_verify_i_p_flow**](docs/NetworkWatchersApi.md#network_watchers_verify_i_p_flow)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/ipFlowVerify<br/>
*PacketCapturesApi* | [**packet_captures_create**](docs/PacketCapturesApi.md#packet_captures_create)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/packetCaptures/{packetCaptureName}<br/>
*PacketCapturesApi* | [**packet_captures_delete**](docs/PacketCapturesApi.md#packet_captures_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/packetCaptures/{packetCaptureName}<br/>
*PacketCapturesApi* | [**packet_captures_get**](docs/PacketCapturesApi.md#packet_captures_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/packetCaptures/{packetCaptureName}<br/>
*PacketCapturesApi* | [**packet_captures_get_status**](docs/PacketCapturesApi.md#packet_captures_get_status)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/packetCaptures/{packetCaptureName}/queryStatus<br/>
*PacketCapturesApi* | [**packet_captures_list**](docs/PacketCapturesApi.md#packet_captures_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/packetCaptures<br/>
*PacketCapturesApi* | [**packet_captures_stop**](docs/PacketCapturesApi.md#packet_captures_stop)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/packetCaptures/{packetCaptureName}/stop<br/>
*TrafficAnalyticsApi* | [**network_watchers_get_flow_log_status**](docs/TrafficAnalyticsApi.md#network_watchers_get_flow_log_status)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/queryFlowLogStatus<br/>
*TrafficAnalyticsApi* | [**network_watchers_set_flow_log_configuration**](docs/TrafficAnalyticsApi.md#network_watchers_set_flow_log_configuration)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/configureFlowLog<br/>


## Models

 - [Access](docs/Access.md)
 - [ApplicationSecurityGroup](docs/ApplicationSecurityGroup.md)
 - [ApplicationSecurityGroupPropertiesFormat](docs/ApplicationSecurityGroupPropertiesFormat.md)
 - [AvailableProvidersList](docs/AvailableProvidersList.md)
 - [AvailableProvidersListCity](docs/AvailableProvidersListCity.md)
 - [AvailableProvidersListCountry](docs/AvailableProvidersListCountry.md)
 - [AvailableProvidersListParameters](docs/AvailableProvidersListParameters.md)
 - [AvailableProvidersListState](docs/AvailableProvidersListState.md)
 - [AzureReachabilityReport](docs/AzureReachabilityReport.md)
 - [AzureReachabilityReportItem](docs/AzureReachabilityReportItem.md)
 - [AzureReachabilityReportLatencyInfo](docs/AzureReachabilityReportLatencyInfo.md)
 - [AzureReachabilityReportLocation](docs/AzureReachabilityReportLocation.md)
 - [AzureReachabilityReportParameters](docs/AzureReachabilityReportParameters.md)
 - [ConnectionMonitor](docs/ConnectionMonitor.md)
 - [ConnectionMonitorDestination](docs/ConnectionMonitorDestination.md)
 - [ConnectionMonitorEndpoint](docs/ConnectionMonitorEndpoint.md)
 - [ConnectionMonitorEndpointFilter](docs/ConnectionMonitorEndpointFilter.md)
 - [ConnectionMonitorEndpointFilterItem](docs/ConnectionMonitorEndpointFilterItem.md)
 - [ConnectionMonitorHttpConfiguration](docs/ConnectionMonitorHttpConfiguration.md)
 - [ConnectionMonitorIcmpConfiguration](docs/ConnectionMonitorIcmpConfiguration.md)
 - [ConnectionMonitorListResult](docs/ConnectionMonitorListResult.md)
 - [ConnectionMonitorOutput](docs/ConnectionMonitorOutput.md)
 - [ConnectionMonitorParameters](docs/ConnectionMonitorParameters.md)
 - [ConnectionMonitorQueryResult](docs/ConnectionMonitorQueryResult.md)
 - [ConnectionMonitorResult](docs/ConnectionMonitorResult.md)
 - [ConnectionMonitorResultProperties](docs/ConnectionMonitorResultProperties.md)
 - [ConnectionMonitorSource](docs/ConnectionMonitorSource.md)
 - [ConnectionMonitorSuccessThreshold](docs/ConnectionMonitorSuccessThreshold.md)
 - [ConnectionMonitorTcpConfiguration](docs/ConnectionMonitorTcpConfiguration.md)
 - [ConnectionMonitorTestConfiguration](docs/ConnectionMonitorTestConfiguration.md)
 - [ConnectionMonitorTestGroup](docs/ConnectionMonitorTestGroup.md)
 - [ConnectionMonitorWorkspaceSettings](docs/ConnectionMonitorWorkspaceSettings.md)
 - [ConnectionStateSnapshot](docs/ConnectionStateSnapshot.md)
 - [ConnectivityDestination](docs/ConnectivityDestination.md)
 - [ConnectivityHop](docs/ConnectivityHop.md)
 - [ConnectivityHop2](docs/ConnectivityHop2.md)
 - [ConnectivityInformation](docs/ConnectivityInformation.md)
 - [ConnectivityIssue](docs/ConnectivityIssue.md)
 - [ConnectivityIssue2](docs/ConnectivityIssue2.md)
 - [ConnectivityParameters](docs/ConnectivityParameters.md)
 - [ConnectivitySource](docs/ConnectivitySource.md)
 - [Direction](docs/Direction.md)
 - [EffectiveNetworkSecurityRule](docs/EffectiveNetworkSecurityRule.md)
 - [ErrorDetails](docs/ErrorDetails.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [ErrorResponse2](docs/ErrorResponse2.md)
 - [EvaluatedNetworkSecurityGroup](docs/EvaluatedNetworkSecurityGroup.md)
 - [FlowLog](docs/FlowLog.md)
 - [FlowLogFormatParameters](docs/FlowLogFormatParameters.md)
 - [FlowLogInformation](docs/FlowLogInformation.md)
 - [FlowLogListResult](docs/FlowLogListResult.md)
 - [FlowLogProperties](docs/FlowLogProperties.md)
 - [FlowLogPropertiesFormat](docs/FlowLogPropertiesFormat.md)
 - [FlowLogStatusParameters](docs/FlowLogStatusParameters.md)
 - [HTTPConfiguration](docs/HTTPConfiguration.md)
 - [HTTPHeader](docs/HTTPHeader.md)
 - [HopLink](docs/HopLink.md)
 - [HopLink2](docs/HopLink2.md)
 - [HopLinkProperties](docs/HopLinkProperties.md)
 - [HopLinkProperties2](docs/HopLinkProperties2.md)
 - [IPVersion](docs/IPVersion.md)
 - [MatchedRule](docs/MatchedRule.md)
 - [NetworkConfigurationDiagnosticParameters](docs/NetworkConfigurationDiagnosticParameters.md)
 - [NetworkConfigurationDiagnosticProfile](docs/NetworkConfigurationDiagnosticProfile.md)
 - [NetworkConfigurationDiagnosticResponse](docs/NetworkConfigurationDiagnosticResponse.md)
 - [NetworkConfigurationDiagnosticResult](docs/NetworkConfigurationDiagnosticResult.md)
 - [NetworkInterfaceAssociation](docs/NetworkInterfaceAssociation.md)
 - [NetworkSecurityGroupResult](docs/NetworkSecurityGroupResult.md)
 - [NetworkSecurityRulesEvaluationResult](docs/NetworkSecurityRulesEvaluationResult.md)
 - [NetworkWatcher](docs/NetworkWatcher.md)
 - [NetworkWatcherListResult](docs/NetworkWatcherListResult.md)
 - [NetworkWatcherPropertiesFormat](docs/NetworkWatcherPropertiesFormat.md)
 - [NextHopParameters](docs/NextHopParameters.md)
 - [NextHopResult](docs/NextHopResult.md)
 - [PacketCapture](docs/PacketCapture.md)
 - [PacketCaptureFilter](docs/PacketCaptureFilter.md)
 - [PacketCaptureListResult](docs/PacketCaptureListResult.md)
 - [PacketCaptureParameters](docs/PacketCaptureParameters.md)
 - [PacketCaptureQueryStatusResult](docs/PacketCaptureQueryStatusResult.md)
 - [PacketCaptureResult](docs/PacketCaptureResult.md)
 - [PacketCaptureResultProperties](docs/PacketCaptureResultProperties.md)
 - [PacketCaptureStorageLocation](docs/PacketCaptureStorageLocation.md)
 - [ProtocolConfiguration](docs/ProtocolConfiguration.md)
 - [ProvisioningState](docs/ProvisioningState.md)
 - [QueryTroubleshootingParameters](docs/QueryTroubleshootingParameters.md)
 - [Resource](docs/Resource.md)
 - [RetentionPolicyParameters](docs/RetentionPolicyParameters.md)
 - [SecurityGroupNetworkInterface](docs/SecurityGroupNetworkInterface.md)
 - [SecurityGroupViewParameters](docs/SecurityGroupViewParameters.md)
 - [SecurityGroupViewResult](docs/SecurityGroupViewResult.md)
 - [SecurityRule](docs/SecurityRule.md)
 - [SecurityRuleAccess](docs/SecurityRuleAccess.md)
 - [SecurityRuleAssociations](docs/SecurityRuleAssociations.md)
 - [SecurityRuleDirection](docs/SecurityRuleDirection.md)
 - [SecurityRulePropertiesFormat](docs/SecurityRulePropertiesFormat.md)
 - [SubResource](docs/SubResource.md)
 - [SubnetAssociation](docs/SubnetAssociation.md)
 - [TagsObject](docs/TagsObject.md)
 - [Topology](docs/Topology.md)
 - [TopologyAssociation](docs/TopologyAssociation.md)
 - [TopologyParameters](docs/TopologyParameters.md)
 - [TopologyResource](docs/TopologyResource.md)
 - [TrafficAnalyticsConfigurationProperties](docs/TrafficAnalyticsConfigurationProperties.md)
 - [TrafficAnalyticsProperties](docs/TrafficAnalyticsProperties.md)
 - [TroubleshootingDetails](docs/TroubleshootingDetails.md)
 - [TroubleshootingParameters](docs/TroubleshootingParameters.md)
 - [TroubleshootingProperties](docs/TroubleshootingProperties.md)
 - [TroubleshootingRecommendedActions](docs/TroubleshootingRecommendedActions.md)
 - [TroubleshootingResult](docs/TroubleshootingResult.md)
 - [VerificationIPFlowParameters](docs/VerificationIPFlowParameters.md)
 - [VerificationIPFlowResult](docs/VerificationIPFlowResult.md)


## Authorization

## azure_auth
- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://login.microsoftonline.com/common/oauth2/authorize
- **Scopes**: 
 - **user_impersonation**: impersonate your user account

Example
```
    using OpenAPI
    using OpenAPI.Clients
    import OpenAPI.Clients: Client, set_header
    client = Client(server_uri)
    set_header(client, "Authorization", "Bearer $bearer_auth")
    api = MyApi(client)
    result = callApi(api, args...; api_key)
```

## Author



