# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""AzureReachabilityReportParameters
Geographic and time constraints for Azure reachability report.

    AzureReachabilityReportParameters(;
        providerLocation=nothing,
        providers=nothing,
        azureLocations=nothing,
        startTime=nothing,
        endTime=nothing,
    )

    - providerLocation::AzureReachabilityReportLocation
    - providers::Vector{String} : List of Internet service providers.
    - azureLocations::Vector{String} : Optional Azure regions to scope the query to.
    - startTime::ZonedDateTime : The start time for the Azure reachability report.
    - endTime::ZonedDateTime : The end time for the Azure reachability report.
"""
Base.@kwdef mutable struct AzureReachabilityReportParameters <: OpenAPI.APIModel
    providerLocation = nothing # spec type: Union{ Nothing, AzureReachabilityReportLocation }
    providers::Union{Nothing, Vector{String}} = nothing
    azureLocations::Union{Nothing, Vector{String}} = nothing
    startTime::Union{Nothing, ZonedDateTime} = nothing
    endTime::Union{Nothing, ZonedDateTime} = nothing

    function AzureReachabilityReportParameters(providerLocation, providers, azureLocations, startTime, endTime, )
        OpenAPI.validate_property(AzureReachabilityReportParameters, Symbol("providerLocation"), providerLocation)
        OpenAPI.validate_property(AzureReachabilityReportParameters, Symbol("providers"), providers)
        OpenAPI.validate_property(AzureReachabilityReportParameters, Symbol("azureLocations"), azureLocations)
        OpenAPI.validate_property(AzureReachabilityReportParameters, Symbol("startTime"), startTime)
        OpenAPI.validate_property(AzureReachabilityReportParameters, Symbol("endTime"), endTime)
        return new(providerLocation, providers, azureLocations, startTime, endTime, )
    end
end # type AzureReachabilityReportParameters

const _property_types_AzureReachabilityReportParameters = Dict{Symbol,String}(Symbol("providerLocation")=>"AzureReachabilityReportLocation", Symbol("providers")=>"Vector{String}", Symbol("azureLocations")=>"Vector{String}", Symbol("startTime")=>"ZonedDateTime", Symbol("endTime")=>"ZonedDateTime", )
OpenAPI.property_type(::Type{ AzureReachabilityReportParameters }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_AzureReachabilityReportParameters[name]))}

function check_required(o::AzureReachabilityReportParameters)
    o.providerLocation === nothing && (return false)
    o.startTime === nothing && (return false)
    o.endTime === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ AzureReachabilityReportParameters }, name::Symbol, val)
    if name === Symbol("startTime")
        OpenAPI.validate_param(name, "AzureReachabilityReportParameters", :format, val, "date-time")
    end
    if name === Symbol("endTime")
        OpenAPI.validate_param(name, "AzureReachabilityReportParameters", :format, val, "date-time")
    end
end
