# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""TroubleshootingResult
Troubleshooting information gained from specified resource.

    TroubleshootingResult(;
        startTime=nothing,
        endTime=nothing,
        code=nothing,
        results=nothing,
    )

    - startTime::ZonedDateTime : The start time of the troubleshooting.
    - endTime::ZonedDateTime : The end time of the troubleshooting.
    - code::String : The result code of the troubleshooting.
    - results::Vector{TroubleshootingDetails} : Information from troubleshooting.
"""
Base.@kwdef mutable struct TroubleshootingResult <: OpenAPI.APIModel
    startTime::Union{Nothing, ZonedDateTime} = nothing
    endTime::Union{Nothing, ZonedDateTime} = nothing
    code::Union{Nothing, String} = nothing
    results::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{TroubleshootingDetails} }

    function TroubleshootingResult(startTime, endTime, code, results, )
        OpenAPI.validate_property(TroubleshootingResult, Symbol("startTime"), startTime)
        OpenAPI.validate_property(TroubleshootingResult, Symbol("endTime"), endTime)
        OpenAPI.validate_property(TroubleshootingResult, Symbol("code"), code)
        OpenAPI.validate_property(TroubleshootingResult, Symbol("results"), results)
        return new(startTime, endTime, code, results, )
    end
end # type TroubleshootingResult

const _property_types_TroubleshootingResult = Dict{Symbol,String}(Symbol("startTime")=>"ZonedDateTime", Symbol("endTime")=>"ZonedDateTime", Symbol("code")=>"String", Symbol("results")=>"Vector{TroubleshootingDetails}", )
OpenAPI.property_type(::Type{ TroubleshootingResult }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_TroubleshootingResult[name]))}

function check_required(o::TroubleshootingResult)
    true
end

function OpenAPI.validate_property(::Type{ TroubleshootingResult }, name::Symbol, val)
    if name === Symbol("startTime")
        OpenAPI.validate_param(name, "TroubleshootingResult", :format, val, "date-time")
    end
    if name === Symbol("endTime")
        OpenAPI.validate_param(name, "TroubleshootingResult", :format, val, "date-time")
    end
end
