# Julia API client for RouteFilterClient

The Microsoft Azure Network management API provides a RESTful set of web services that interact with Microsoft Azure Networks service to manage your network resources. The API has entities that capture the relationship between an end user and the Microsoft Azure Networks service.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 2020-05-01
- Build package: org.openapitools.codegen.languages.JuliaClientCodegen


## Installation
Place the Julia files generated under the `src` folder in your Julia project. Include RouteFilterClient.jl in the project code.
It would include the module named RouteFilterClient.

Documentation is generated as markdown files under the `docs` folder. You can include them in your project documentation.
Documentation is also embedded in Julia which can be used with a Julia specific documentation generator.

## API Endpoints

Class | Method
------------ | -------------
*RouteFilterRulesApi* | [**route_filter_rules_create_or_update**](docs/RouteFilterRulesApi.md#route_filter_rules_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/routeFilters/{routeFilterName}/routeFilterRules/{ruleName}<br/>
*RouteFilterRulesApi* | [**route_filter_rules_delete**](docs/RouteFilterRulesApi.md#route_filter_rules_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/routeFilters/{routeFilterName}/routeFilterRules/{ruleName}<br/>
*RouteFilterRulesApi* | [**route_filter_rules_get**](docs/RouteFilterRulesApi.md#route_filter_rules_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/routeFilters/{routeFilterName}/routeFilterRules/{ruleName}<br/>
*RouteFilterRulesApi* | [**route_filter_rules_list_by_route_filter**](docs/RouteFilterRulesApi.md#route_filter_rules_list_by_route_filter)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/routeFilters/{routeFilterName}/routeFilterRules<br/>
*RouteFiltersApi* | [**route_filters_create_or_update**](docs/RouteFiltersApi.md#route_filters_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/routeFilters/{routeFilterName}<br/>
*RouteFiltersApi* | [**route_filters_delete**](docs/RouteFiltersApi.md#route_filters_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/routeFilters/{routeFilterName}<br/>
*RouteFiltersApi* | [**route_filters_get**](docs/RouteFiltersApi.md#route_filters_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/routeFilters/{routeFilterName}<br/>
*RouteFiltersApi* | [**route_filters_list**](docs/RouteFiltersApi.md#route_filters_list)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Network/routeFilters<br/>
*RouteFiltersApi* | [**route_filters_list_by_resource_group**](docs/RouteFiltersApi.md#route_filters_list_by_resource_group)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/routeFilters<br/>
*RouteFiltersApi* | [**route_filters_update_tags**](docs/RouteFiltersApi.md#route_filters_update_tags)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/routeFilters/{routeFilterName}<br/>


## Models

 - [Access](docs/Access.md)
 - [CircuitConnectionStatus](docs/CircuitConnectionStatus.md)
 - [CloudError](docs/CloudError.md)
 - [CloudErrorBody](docs/CloudErrorBody.md)
 - [ExpressRouteCircuitConnection](docs/ExpressRouteCircuitConnection.md)
 - [ExpressRouteCircuitConnectionPropertiesFormat](docs/ExpressRouteCircuitConnectionPropertiesFormat.md)
 - [ExpressRouteCircuitPeering](docs/ExpressRouteCircuitPeering.md)
 - [ExpressRouteCircuitPeeringConfig](docs/ExpressRouteCircuitPeeringConfig.md)
 - [ExpressRouteCircuitPeeringPropertiesFormat](docs/ExpressRouteCircuitPeeringPropertiesFormat.md)
 - [ExpressRouteCircuitStats](docs/ExpressRouteCircuitStats.md)
 - [ExpressRouteConnectionId](docs/ExpressRouteConnectionId.md)
 - [ExpressRoutePeeringState](docs/ExpressRoutePeeringState.md)
 - [ExpressRoutePeeringType](docs/ExpressRoutePeeringType.md)
 - [Ipv6CircuitConnectionConfig](docs/Ipv6CircuitConnectionConfig.md)
 - [Ipv6ExpressRouteCircuitPeeringConfig](docs/Ipv6ExpressRouteCircuitPeeringConfig.md)
 - [PatchRouteFilter](docs/PatchRouteFilter.md)
 - [PatchRouteFilterRule](docs/PatchRouteFilterRule.md)
 - [PeerExpressRouteCircuitConnection](docs/PeerExpressRouteCircuitConnection.md)
 - [PeerExpressRouteCircuitConnectionPropertiesFormat](docs/PeerExpressRouteCircuitConnectionPropertiesFormat.md)
 - [ProvisioningState](docs/ProvisioningState.md)
 - [Resource](docs/Resource.md)
 - [RouteFilter](docs/RouteFilter.md)
 - [RouteFilterListResult](docs/RouteFilterListResult.md)
 - [RouteFilterPropertiesFormat](docs/RouteFilterPropertiesFormat.md)
 - [RouteFilterRule](docs/RouteFilterRule.md)
 - [RouteFilterRuleListResult](docs/RouteFilterRuleListResult.md)
 - [RouteFilterRulePropertiesFormat](docs/RouteFilterRulePropertiesFormat.md)
 - [SubResource](docs/SubResource.md)
 - [TagsObject](docs/TagsObject.md)


## Authorization

## azure_auth
- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://login.microsoftonline.com/common/oauth2/authorize
- **Scopes**: 
 - **user_impersonation**: impersonate your user account

Example
```
    using OpenAPI
    using OpenAPI.Clients
    import OpenAPI.Clients: Client, set_header
    client = Client(server_uri)
    set_header(client, "Authorization", "Bearer $bearer_auth")
    api = MyApi(client)
    result = callApi(api, args...; api_key)
```

## Author



