# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct RouteFiltersApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `RouteFiltersApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ RouteFiltersApi }) = "https://management.azure.com"

const _returntypes_route_filters_create_or_update_RouteFiltersApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => RouteFilter,
    Regex("^" * replace("201", "x"=>".") * "\$") => RouteFilter,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_route_filters_create_or_update(_api::RouteFiltersApi, resource_group_name::String, route_filter_name::String, api_version::String, subscription_id::String, route_filter_parameters::RouteFilter; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_route_filters_create_or_update_RouteFiltersApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/routeFilters/{routeFilterName}", ["azure_auth", ], route_filter_parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "routeFilterName", route_filter_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Creates or updates a route filter in a specified resource group.

Params:
- resource_group_name::String (required)
- route_filter_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- route_filter_parameters::RouteFilter (required)

Return: RouteFilter, OpenAPI.Clients.ApiResponse
"""
function route_filters_create_or_update(_api::RouteFiltersApi, resource_group_name::String, route_filter_name::String, api_version::String, subscription_id::String, route_filter_parameters::RouteFilter; _mediaType=nothing)
    _ctx = _oacinternal_route_filters_create_or_update(_api, resource_group_name, route_filter_name, api_version, subscription_id, route_filter_parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function route_filters_create_or_update(_api::RouteFiltersApi, response_stream::Channel, resource_group_name::String, route_filter_name::String, api_version::String, subscription_id::String, route_filter_parameters::RouteFilter; _mediaType=nothing)
    _ctx = _oacinternal_route_filters_create_or_update(_api, resource_group_name, route_filter_name, api_version, subscription_id, route_filter_parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_route_filters_delete_RouteFiltersApi = Dict{Regex,Type}(
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_route_filters_delete(_api::RouteFiltersApi, resource_group_name::String, route_filter_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_route_filters_delete_RouteFiltersApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/routeFilters/{routeFilterName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "routeFilterName", route_filter_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Deletes the specified route filter.

Params:
- resource_group_name::String (required)
- route_filter_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function route_filters_delete(_api::RouteFiltersApi, resource_group_name::String, route_filter_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_route_filters_delete(_api, resource_group_name, route_filter_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function route_filters_delete(_api::RouteFiltersApi, response_stream::Channel, resource_group_name::String, route_filter_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_route_filters_delete(_api, resource_group_name, route_filter_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_route_filters_get_RouteFiltersApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => RouteFilter,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_route_filters_get(_api::RouteFiltersApi, resource_group_name::String, route_filter_name::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_route_filters_get_RouteFiltersApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/routeFilters/{routeFilterName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "routeFilterName", route_filter_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "\$expand", expand)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets the specified route filter.

Params:
- resource_group_name::String (required)
- route_filter_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- expand::String

Return: RouteFilter, OpenAPI.Clients.ApiResponse
"""
function route_filters_get(_api::RouteFiltersApi, resource_group_name::String, route_filter_name::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = _oacinternal_route_filters_get(_api, resource_group_name, route_filter_name, api_version, subscription_id; expand=expand, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function route_filters_get(_api::RouteFiltersApi, response_stream::Channel, resource_group_name::String, route_filter_name::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = _oacinternal_route_filters_get(_api, resource_group_name, route_filter_name, api_version, subscription_id; expand=expand, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_route_filters_list_RouteFiltersApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => RouteFilterListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_route_filters_list(_api::RouteFiltersApi, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_route_filters_list_RouteFiltersApi, "/subscriptions/{subscriptionId}/providers/Microsoft.Network/routeFilters", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets all route filters in a subscription.

Params:
- api_version::String (required)
- subscription_id::String (required)

Return: RouteFilterListResult, OpenAPI.Clients.ApiResponse
"""
function route_filters_list(_api::RouteFiltersApi, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_route_filters_list(_api, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function route_filters_list(_api::RouteFiltersApi, response_stream::Channel, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_route_filters_list(_api, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_route_filters_list_by_resource_group_RouteFiltersApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => RouteFilterListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_route_filters_list_by_resource_group(_api::RouteFiltersApi, resource_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_route_filters_list_by_resource_group_RouteFiltersApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/routeFilters", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets all route filters in a resource group.

Params:
- resource_group_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: RouteFilterListResult, OpenAPI.Clients.ApiResponse
"""
function route_filters_list_by_resource_group(_api::RouteFiltersApi, resource_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_route_filters_list_by_resource_group(_api, resource_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function route_filters_list_by_resource_group(_api::RouteFiltersApi, response_stream::Channel, resource_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_route_filters_list_by_resource_group(_api, resource_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_route_filters_update_tags_RouteFiltersApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => RouteFilter,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_route_filters_update_tags(_api::RouteFiltersApi, resource_group_name::String, route_filter_name::String, api_version::String, subscription_id::String, parameters::TagsObject; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PATCH", _returntypes_route_filters_update_tags_RouteFiltersApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/routeFilters/{routeFilterName}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "routeFilterName", route_filter_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Updates tags of a route filter.

Params:
- resource_group_name::String (required)
- route_filter_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::TagsObject (required)

Return: RouteFilter, OpenAPI.Clients.ApiResponse
"""
function route_filters_update_tags(_api::RouteFiltersApi, resource_group_name::String, route_filter_name::String, api_version::String, subscription_id::String, parameters::TagsObject; _mediaType=nothing)
    _ctx = _oacinternal_route_filters_update_tags(_api, resource_group_name, route_filter_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function route_filters_update_tags(_api::RouteFiltersApi, response_stream::Channel, resource_group_name::String, route_filter_name::String, api_version::String, subscription_id::String, parameters::TagsObject; _mediaType=nothing)
    _ctx = _oacinternal_route_filters_update_tags(_api, resource_group_name, route_filter_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export route_filters_create_or_update
export route_filters_delete
export route_filters_get
export route_filters_list
export route_filters_list_by_resource_group
export route_filters_update_tags
