# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct LocalNetworkGatewaysApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `LocalNetworkGatewaysApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ LocalNetworkGatewaysApi }) = "https://management.azure.com"

const _returntypes_local_network_gateways_create_or_update_LocalNetworkGatewaysApi = Dict{Regex,Type}(
    Regex("^" * replace("201", "x"=>".") * "\$") => LocalNetworkGateway,
    Regex("^" * replace("200", "x"=>".") * "\$") => LocalNetworkGateway,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_local_network_gateways_create_or_update(_api::LocalNetworkGatewaysApi, resource_group_name::String, local_network_gateway_name::String, api_version::String, subscription_id::String, parameters::LocalNetworkGateway; _mediaType=nothing)
    OpenAPI.validate_param("local_network_gateway_name", "local_network_gateways_create_or_update", :minLength, local_network_gateway_name, 1)

    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_local_network_gateways_create_or_update_LocalNetworkGatewaysApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/localNetworkGateways/{localNetworkGatewayName}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "localNetworkGatewayName", local_network_gateway_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Creates or updates a local network gateway in the specified resource group.

Params:
- resource_group_name::String (required)
- local_network_gateway_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::LocalNetworkGateway (required)

Return: LocalNetworkGateway, OpenAPI.Clients.ApiResponse
"""
function local_network_gateways_create_or_update(_api::LocalNetworkGatewaysApi, resource_group_name::String, local_network_gateway_name::String, api_version::String, subscription_id::String, parameters::LocalNetworkGateway; _mediaType=nothing)
    _ctx = _oacinternal_local_network_gateways_create_or_update(_api, resource_group_name, local_network_gateway_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function local_network_gateways_create_or_update(_api::LocalNetworkGatewaysApi, response_stream::Channel, resource_group_name::String, local_network_gateway_name::String, api_version::String, subscription_id::String, parameters::LocalNetworkGateway; _mediaType=nothing)
    _ctx = _oacinternal_local_network_gateways_create_or_update(_api, resource_group_name, local_network_gateway_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_local_network_gateways_delete_LocalNetworkGatewaysApi = Dict{Regex,Type}(
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_local_network_gateways_delete(_api::LocalNetworkGatewaysApi, resource_group_name::String, local_network_gateway_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    OpenAPI.validate_param("local_network_gateway_name", "local_network_gateways_delete", :minLength, local_network_gateway_name, 1)

    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_local_network_gateways_delete_LocalNetworkGatewaysApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/localNetworkGateways/{localNetworkGatewayName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "localNetworkGatewayName", local_network_gateway_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Deletes the specified local network gateway.

Params:
- resource_group_name::String (required)
- local_network_gateway_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function local_network_gateways_delete(_api::LocalNetworkGatewaysApi, resource_group_name::String, local_network_gateway_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_local_network_gateways_delete(_api, resource_group_name, local_network_gateway_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function local_network_gateways_delete(_api::LocalNetworkGatewaysApi, response_stream::Channel, resource_group_name::String, local_network_gateway_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_local_network_gateways_delete(_api, resource_group_name, local_network_gateway_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_local_network_gateways_get_LocalNetworkGatewaysApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => LocalNetworkGateway,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_local_network_gateways_get(_api::LocalNetworkGatewaysApi, resource_group_name::String, local_network_gateway_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    OpenAPI.validate_param("local_network_gateway_name", "local_network_gateways_get", :minLength, local_network_gateway_name, 1)

    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_local_network_gateways_get_LocalNetworkGatewaysApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/localNetworkGateways/{localNetworkGatewayName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "localNetworkGatewayName", local_network_gateway_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets the specified local network gateway in a resource group.

Params:
- resource_group_name::String (required)
- local_network_gateway_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: LocalNetworkGateway, OpenAPI.Clients.ApiResponse
"""
function local_network_gateways_get(_api::LocalNetworkGatewaysApi, resource_group_name::String, local_network_gateway_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_local_network_gateways_get(_api, resource_group_name, local_network_gateway_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function local_network_gateways_get(_api::LocalNetworkGatewaysApi, response_stream::Channel, resource_group_name::String, local_network_gateway_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_local_network_gateways_get(_api, resource_group_name, local_network_gateway_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_local_network_gateways_list_LocalNetworkGatewaysApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => LocalNetworkGatewayListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_local_network_gateways_list(_api::LocalNetworkGatewaysApi, resource_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_local_network_gateways_list_LocalNetworkGatewaysApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/localNetworkGateways", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets all the local network gateways in a resource group.

Params:
- resource_group_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: LocalNetworkGatewayListResult, OpenAPI.Clients.ApiResponse
"""
function local_network_gateways_list(_api::LocalNetworkGatewaysApi, resource_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_local_network_gateways_list(_api, resource_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function local_network_gateways_list(_api::LocalNetworkGatewaysApi, response_stream::Channel, resource_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_local_network_gateways_list(_api, resource_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_local_network_gateways_update_tags_LocalNetworkGatewaysApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => LocalNetworkGateway,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_local_network_gateways_update_tags(_api::LocalNetworkGatewaysApi, resource_group_name::String, local_network_gateway_name::String, api_version::String, subscription_id::String, parameters::TagsObject; _mediaType=nothing)
    OpenAPI.validate_param("local_network_gateway_name", "local_network_gateways_update_tags", :minLength, local_network_gateway_name, 1)

    _ctx = OpenAPI.Clients.Ctx(_api.client, "PATCH", _returntypes_local_network_gateways_update_tags_LocalNetworkGatewaysApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/localNetworkGateways/{localNetworkGatewayName}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "localNetworkGatewayName", local_network_gateway_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Updates a local network gateway tags.

Params:
- resource_group_name::String (required)
- local_network_gateway_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::TagsObject (required)

Return: LocalNetworkGateway, OpenAPI.Clients.ApiResponse
"""
function local_network_gateways_update_tags(_api::LocalNetworkGatewaysApi, resource_group_name::String, local_network_gateway_name::String, api_version::String, subscription_id::String, parameters::TagsObject; _mediaType=nothing)
    _ctx = _oacinternal_local_network_gateways_update_tags(_api, resource_group_name, local_network_gateway_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function local_network_gateways_update_tags(_api::LocalNetworkGatewaysApi, response_stream::Channel, resource_group_name::String, local_network_gateway_name::String, api_version::String, subscription_id::String, parameters::TagsObject; _mediaType=nothing)
    _ctx = _oacinternal_local_network_gateways_update_tags(_api, resource_group_name, local_network_gateway_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export local_network_gateways_create_or_update
export local_network_gateways_delete
export local_network_gateways_get
export local_network_gateways_list
export local_network_gateways_update_tags
