# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct VirtualNetworkGatewayConnectionsApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `VirtualNetworkGatewayConnectionsApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ VirtualNetworkGatewayConnectionsApi }) = "https://management.azure.com"

const _returntypes_virtual_network_gateway_connections_create_or_update_VirtualNetworkGatewayConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualNetworkGatewayConnection,
    Regex("^" * replace("201", "x"=>".") * "\$") => VirtualNetworkGatewayConnection,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_virtual_network_gateway_connections_create_or_update(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String, parameters::VirtualNetworkGatewayConnection; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_virtual_network_gateway_connections_create_or_update_VirtualNetworkGatewayConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/connections/{virtualNetworkGatewayConnectionName}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualNetworkGatewayConnectionName", virtual_network_gateway_connection_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Creates or updates a virtual network gateway connection in the specified resource group.

Params:
- resource_group_name::String (required)
- virtual_network_gateway_connection_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::VirtualNetworkGatewayConnection (required)

Return: VirtualNetworkGatewayConnection, OpenAPI.Clients.ApiResponse
"""
function virtual_network_gateway_connections_create_or_update(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String, parameters::VirtualNetworkGatewayConnection; _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_create_or_update(_api, resource_group_name, virtual_network_gateway_connection_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_network_gateway_connections_create_or_update(_api::VirtualNetworkGatewayConnectionsApi, response_stream::Channel, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String, parameters::VirtualNetworkGatewayConnection; _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_create_or_update(_api, resource_group_name, virtual_network_gateway_connection_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_network_gateway_connections_delete_VirtualNetworkGatewayConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_virtual_network_gateway_connections_delete(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_virtual_network_gateway_connections_delete_VirtualNetworkGatewayConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/connections/{virtualNetworkGatewayConnectionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualNetworkGatewayConnectionName", virtual_network_gateway_connection_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Deletes the specified virtual network Gateway connection.

Params:
- resource_group_name::String (required)
- virtual_network_gateway_connection_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function virtual_network_gateway_connections_delete(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_delete(_api, resource_group_name, virtual_network_gateway_connection_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_network_gateway_connections_delete(_api::VirtualNetworkGatewayConnectionsApi, response_stream::Channel, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_delete(_api, resource_group_name, virtual_network_gateway_connection_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_network_gateway_connections_get_VirtualNetworkGatewayConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualNetworkGatewayConnection,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_virtual_network_gateway_connections_get(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_virtual_network_gateway_connections_get_VirtualNetworkGatewayConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/connections/{virtualNetworkGatewayConnectionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualNetworkGatewayConnectionName", virtual_network_gateway_connection_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets the specified virtual network gateway connection by resource group.

Params:
- resource_group_name::String (required)
- virtual_network_gateway_connection_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: VirtualNetworkGatewayConnection, OpenAPI.Clients.ApiResponse
"""
function virtual_network_gateway_connections_get(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_get(_api, resource_group_name, virtual_network_gateway_connection_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_network_gateway_connections_get(_api::VirtualNetworkGatewayConnectionsApi, response_stream::Channel, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_get(_api, resource_group_name, virtual_network_gateway_connection_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_network_gateway_connections_get_shared_key_VirtualNetworkGatewayConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ConnectionSharedKey,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_virtual_network_gateway_connections_get_shared_key(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_virtual_network_gateway_connections_get_shared_key_VirtualNetworkGatewayConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/connections/{virtualNetworkGatewayConnectionName}/sharedkey", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualNetworkGatewayConnectionName", virtual_network_gateway_connection_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""The Get VirtualNetworkGatewayConnectionSharedKey operation retrieves information about the specified virtual network gateway connection shared key through Network resource provider.

Params:
- resource_group_name::String (required)
- virtual_network_gateway_connection_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: ConnectionSharedKey, OpenAPI.Clients.ApiResponse
"""
function virtual_network_gateway_connections_get_shared_key(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_get_shared_key(_api, resource_group_name, virtual_network_gateway_connection_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_network_gateway_connections_get_shared_key(_api::VirtualNetworkGatewayConnectionsApi, response_stream::Channel, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_get_shared_key(_api, resource_group_name, virtual_network_gateway_connection_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_network_gateway_connections_list_VirtualNetworkGatewayConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualNetworkGatewayConnectionListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_virtual_network_gateway_connections_list(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_virtual_network_gateway_connections_list_VirtualNetworkGatewayConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/connections", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""The List VirtualNetworkGatewayConnections operation retrieves all the virtual network gateways connections created.

Params:
- resource_group_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: VirtualNetworkGatewayConnectionListResult, OpenAPI.Clients.ApiResponse
"""
function virtual_network_gateway_connections_list(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_list(_api, resource_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_network_gateway_connections_list(_api::VirtualNetworkGatewayConnectionsApi, response_stream::Channel, resource_group_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_list(_api, resource_group_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_network_gateway_connections_reset_shared_key_VirtualNetworkGatewayConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ConnectionResetSharedKey,
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_virtual_network_gateway_connections_reset_shared_key(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String, parameters::ConnectionResetSharedKey; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_network_gateway_connections_reset_shared_key_VirtualNetworkGatewayConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/connections/{virtualNetworkGatewayConnectionName}/sharedkey/reset", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualNetworkGatewayConnectionName", virtual_network_gateway_connection_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""The VirtualNetworkGatewayConnectionResetSharedKey operation resets the virtual network gateway connection shared key for passed virtual network gateway connection in the specified resource group through Network resource provider.

Params:
- resource_group_name::String (required)
- virtual_network_gateway_connection_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::ConnectionResetSharedKey (required)

Return: ConnectionResetSharedKey, OpenAPI.Clients.ApiResponse
"""
function virtual_network_gateway_connections_reset_shared_key(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String, parameters::ConnectionResetSharedKey; _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_reset_shared_key(_api, resource_group_name, virtual_network_gateway_connection_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_network_gateway_connections_reset_shared_key(_api::VirtualNetworkGatewayConnectionsApi, response_stream::Channel, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String, parameters::ConnectionResetSharedKey; _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_reset_shared_key(_api, resource_group_name, virtual_network_gateway_connection_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_network_gateway_connections_set_shared_key_VirtualNetworkGatewayConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("201", "x"=>".") * "\$") => ConnectionSharedKey,
    Regex("^" * replace("200", "x"=>".") * "\$") => ConnectionSharedKey,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_virtual_network_gateway_connections_set_shared_key(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String, parameters::ConnectionSharedKey; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_virtual_network_gateway_connections_set_shared_key_VirtualNetworkGatewayConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/connections/{virtualNetworkGatewayConnectionName}/sharedkey", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualNetworkGatewayConnectionName", virtual_network_gateway_connection_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""The Put VirtualNetworkGatewayConnectionSharedKey operation sets the virtual network gateway connection shared key for passed virtual network gateway connection in the specified resource group through Network resource provider.

Params:
- resource_group_name::String (required)
- virtual_network_gateway_connection_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::ConnectionSharedKey (required)

Return: ConnectionSharedKey, OpenAPI.Clients.ApiResponse
"""
function virtual_network_gateway_connections_set_shared_key(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String, parameters::ConnectionSharedKey; _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_set_shared_key(_api, resource_group_name, virtual_network_gateway_connection_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_network_gateway_connections_set_shared_key(_api::VirtualNetworkGatewayConnectionsApi, response_stream::Channel, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String, parameters::ConnectionSharedKey; _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_set_shared_key(_api, resource_group_name, virtual_network_gateway_connection_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_network_gateway_connections_start_packet_capture_VirtualNetworkGatewayConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("200", "x"=>".") * "\$") => String,
    Regex("^" * replace("0", "x"=>".") * "\$") => Error,
)

function _oacinternal_virtual_network_gateway_connections_start_packet_capture(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String; parameters=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_network_gateway_connections_start_packet_capture_VirtualNetworkGatewayConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/connections/{virtualNetworkGatewayConnectionName}/startPacketCapture", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualNetworkGatewayConnectionName", virtual_network_gateway_connection_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Starts packet capture on virtual network gateway connection in the specified resource group.

Params:
- resource_group_name::String (required)
- virtual_network_gateway_connection_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::VpnPacketCaptureStartParameters

Return: String, OpenAPI.Clients.ApiResponse
"""
function virtual_network_gateway_connections_start_packet_capture(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String; parameters=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_start_packet_capture(_api, resource_group_name, virtual_network_gateway_connection_name, api_version, subscription_id; parameters=parameters, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_network_gateway_connections_start_packet_capture(_api::VirtualNetworkGatewayConnectionsApi, response_stream::Channel, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String; parameters=nothing, _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_start_packet_capture(_api, resource_group_name, virtual_network_gateway_connection_name, api_version, subscription_id; parameters=parameters, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_network_gateway_connections_stop_packet_capture_VirtualNetworkGatewayConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("200", "x"=>".") * "\$") => String,
    Regex("^" * replace("0", "x"=>".") * "\$") => Error,
)

function _oacinternal_virtual_network_gateway_connections_stop_packet_capture(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String, parameters::VpnPacketCaptureStopParameters; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_virtual_network_gateway_connections_stop_packet_capture_VirtualNetworkGatewayConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/connections/{virtualNetworkGatewayConnectionName}/stopPacketCapture", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualNetworkGatewayConnectionName", virtual_network_gateway_connection_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Stops packet capture on virtual network gateway connection in the specified resource group.

Params:
- resource_group_name::String (required)
- virtual_network_gateway_connection_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::VpnPacketCaptureStopParameters (required)

Return: String, OpenAPI.Clients.ApiResponse
"""
function virtual_network_gateway_connections_stop_packet_capture(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String, parameters::VpnPacketCaptureStopParameters; _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_stop_packet_capture(_api, resource_group_name, virtual_network_gateway_connection_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_network_gateway_connections_stop_packet_capture(_api::VirtualNetworkGatewayConnectionsApi, response_stream::Channel, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String, parameters::VpnPacketCaptureStopParameters; _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_stop_packet_capture(_api, resource_group_name, virtual_network_gateway_connection_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_virtual_network_gateway_connections_update_tags_VirtualNetworkGatewayConnectionsApi = Dict{Regex,Type}(
    Regex("^" * replace("202", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("200", "x"=>".") * "\$") => VirtualNetworkGatewayConnection,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_virtual_network_gateway_connections_update_tags(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String, parameters::TagsObject; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PATCH", _returntypes_virtual_network_gateway_connections_update_tags_VirtualNetworkGatewayConnectionsApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/connections/{virtualNetworkGatewayConnectionName}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualNetworkGatewayConnectionName", virtual_network_gateway_connection_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Updates a virtual network gateway connection tags.

Params:
- resource_group_name::String (required)
- virtual_network_gateway_connection_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::TagsObject (required)

Return: VirtualNetworkGatewayConnection, OpenAPI.Clients.ApiResponse
"""
function virtual_network_gateway_connections_update_tags(_api::VirtualNetworkGatewayConnectionsApi, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String, parameters::TagsObject; _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_update_tags(_api, resource_group_name, virtual_network_gateway_connection_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function virtual_network_gateway_connections_update_tags(_api::VirtualNetworkGatewayConnectionsApi, response_stream::Channel, resource_group_name::String, virtual_network_gateway_connection_name::String, api_version::String, subscription_id::String, parameters::TagsObject; _mediaType=nothing)
    _ctx = _oacinternal_virtual_network_gateway_connections_update_tags(_api, resource_group_name, virtual_network_gateway_connection_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export virtual_network_gateway_connections_create_or_update
export virtual_network_gateway_connections_delete
export virtual_network_gateway_connections_get
export virtual_network_gateway_connections_get_shared_key
export virtual_network_gateway_connections_list
export virtual_network_gateway_connections_reset_shared_key
export virtual_network_gateway_connections_set_shared_key
export virtual_network_gateway_connections_start_packet_capture
export virtual_network_gateway_connections_stop_packet_capture
export virtual_network_gateway_connections_update_tags
