# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""VpnClientConfiguration
VpnClientConfiguration for P2S client.

    VpnClientConfiguration(;
        vpnClientAddressPool=nothing,
        vpnClientRootCertificates=nothing,
        vpnClientRevokedCertificates=nothing,
        vpnClientProtocols=nothing,
        vpnClientIpsecPolicies=nothing,
        radiusServerAddress=nothing,
        radiusServerSecret=nothing,
        radiusServers=nothing,
        aadTenant=nothing,
        aadAudience=nothing,
        aadIssuer=nothing,
    )

    - vpnClientAddressPool::AddressSpace
    - vpnClientRootCertificates::Vector{VpnClientRootCertificate} : VpnClientRootCertificate for virtual network gateway.
    - vpnClientRevokedCertificates::Vector{VpnClientRevokedCertificate} : VpnClientRevokedCertificate for Virtual network gateway.
    - vpnClientProtocols::Vector{String} : VpnClientProtocols for Virtual network gateway.
    - vpnClientIpsecPolicies::Vector{IpsecPolicy} : VpnClientIpsecPolicies for virtual network gateway P2S client.
    - radiusServerAddress::String : The radius server address property of the VirtualNetworkGateway resource for vpn client connection.
    - radiusServerSecret::String : The radius secret property of the VirtualNetworkGateway resource for vpn client connection.
    - radiusServers::Vector{RadiusServer} : The radiusServers property for multiple radius server configuration.
    - aadTenant::String : The AADTenant property of the VirtualNetworkGateway resource for vpn client connection used for AAD authentication.
    - aadAudience::String : The AADAudience property of the VirtualNetworkGateway resource for vpn client connection used for AAD authentication.
    - aadIssuer::String : The AADIssuer property of the VirtualNetworkGateway resource for vpn client connection used for AAD authentication.
"""
Base.@kwdef mutable struct VpnClientConfiguration <: OpenAPI.APIModel
    vpnClientAddressPool = nothing # spec type: Union{ Nothing, AddressSpace }
    vpnClientRootCertificates::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{VpnClientRootCertificate} }
    vpnClientRevokedCertificates::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{VpnClientRevokedCertificate} }
    vpnClientProtocols::Union{Nothing, Vector{String}} = nothing
    vpnClientIpsecPolicies::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{IpsecPolicy} }
    radiusServerAddress::Union{Nothing, String} = nothing
    radiusServerSecret::Union{Nothing, String} = nothing
    radiusServers::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{RadiusServer} }
    aadTenant::Union{Nothing, String} = nothing
    aadAudience::Union{Nothing, String} = nothing
    aadIssuer::Union{Nothing, String} = nothing

    function VpnClientConfiguration(vpnClientAddressPool, vpnClientRootCertificates, vpnClientRevokedCertificates, vpnClientProtocols, vpnClientIpsecPolicies, radiusServerAddress, radiusServerSecret, radiusServers, aadTenant, aadAudience, aadIssuer, )
        OpenAPI.validate_property(VpnClientConfiguration, Symbol("vpnClientAddressPool"), vpnClientAddressPool)
        OpenAPI.validate_property(VpnClientConfiguration, Symbol("vpnClientRootCertificates"), vpnClientRootCertificates)
        OpenAPI.validate_property(VpnClientConfiguration, Symbol("vpnClientRevokedCertificates"), vpnClientRevokedCertificates)
        OpenAPI.validate_property(VpnClientConfiguration, Symbol("vpnClientProtocols"), vpnClientProtocols)
        OpenAPI.validate_property(VpnClientConfiguration, Symbol("vpnClientIpsecPolicies"), vpnClientIpsecPolicies)
        OpenAPI.validate_property(VpnClientConfiguration, Symbol("radiusServerAddress"), radiusServerAddress)
        OpenAPI.validate_property(VpnClientConfiguration, Symbol("radiusServerSecret"), radiusServerSecret)
        OpenAPI.validate_property(VpnClientConfiguration, Symbol("radiusServers"), radiusServers)
        OpenAPI.validate_property(VpnClientConfiguration, Symbol("aadTenant"), aadTenant)
        OpenAPI.validate_property(VpnClientConfiguration, Symbol("aadAudience"), aadAudience)
        OpenAPI.validate_property(VpnClientConfiguration, Symbol("aadIssuer"), aadIssuer)
        return new(vpnClientAddressPool, vpnClientRootCertificates, vpnClientRevokedCertificates, vpnClientProtocols, vpnClientIpsecPolicies, radiusServerAddress, radiusServerSecret, radiusServers, aadTenant, aadAudience, aadIssuer, )
    end
end # type VpnClientConfiguration

const _property_types_VpnClientConfiguration = Dict{Symbol,String}(Symbol("vpnClientAddressPool")=>"AddressSpace", Symbol("vpnClientRootCertificates")=>"Vector{VpnClientRootCertificate}", Symbol("vpnClientRevokedCertificates")=>"Vector{VpnClientRevokedCertificate}", Symbol("vpnClientProtocols")=>"Vector{String}", Symbol("vpnClientIpsecPolicies")=>"Vector{IpsecPolicy}", Symbol("radiusServerAddress")=>"String", Symbol("radiusServerSecret")=>"String", Symbol("radiusServers")=>"Vector{RadiusServer}", Symbol("aadTenant")=>"String", Symbol("aadAudience")=>"String", Symbol("aadIssuer")=>"String", )
OpenAPI.property_type(::Type{ VpnClientConfiguration }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_VpnClientConfiguration[name]))}

function check_required(o::VpnClientConfiguration)
    true
end

function OpenAPI.validate_property(::Type{ VpnClientConfiguration }, name::Symbol, val)
    if name === Symbol("vpnClientProtocols")
        OpenAPI.validate_param(name, "VpnClientConfiguration", :enum, val, [])
    end
end
