# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""VpnClientIPsecParameters
An IPSec parameters for a virtual network gateway P2S connection.

    VpnClientIPsecParameters(;
        saLifeTimeSeconds=nothing,
        saDataSizeKilobytes=nothing,
        ipsecEncryption=nothing,
        ipsecIntegrity=nothing,
        ikeEncryption=nothing,
        ikeIntegrity=nothing,
        dhGroup=nothing,
        pfsGroup=nothing,
    )

    - saLifeTimeSeconds::Int64 : The IPSec Security Association (also called Quick Mode or Phase 2 SA) lifetime in seconds for P2S client.
    - saDataSizeKilobytes::Int64 : The IPSec Security Association (also called Quick Mode or Phase 2 SA) payload size in KB for P2S client..
    - ipsecEncryption::IpsecEncryption
    - ipsecIntegrity::IpsecIntegrity
    - ikeEncryption::IkeEncryption
    - ikeIntegrity::IkeIntegrity
    - dhGroup::DhGroup
    - pfsGroup::PfsGroup
"""
Base.@kwdef mutable struct VpnClientIPsecParameters <: OpenAPI.APIModel
    saLifeTimeSeconds::Union{Nothing, Int64} = nothing
    saDataSizeKilobytes::Union{Nothing, Int64} = nothing
    ipsecEncryption = nothing # spec type: Union{ Nothing, IpsecEncryption }
    ipsecIntegrity = nothing # spec type: Union{ Nothing, IpsecIntegrity }
    ikeEncryption = nothing # spec type: Union{ Nothing, IkeEncryption }
    ikeIntegrity = nothing # spec type: Union{ Nothing, IkeIntegrity }
    dhGroup = nothing # spec type: Union{ Nothing, DhGroup }
    pfsGroup = nothing # spec type: Union{ Nothing, PfsGroup }

    function VpnClientIPsecParameters(saLifeTimeSeconds, saDataSizeKilobytes, ipsecEncryption, ipsecIntegrity, ikeEncryption, ikeIntegrity, dhGroup, pfsGroup, )
        OpenAPI.validate_property(VpnClientIPsecParameters, Symbol("saLifeTimeSeconds"), saLifeTimeSeconds)
        OpenAPI.validate_property(VpnClientIPsecParameters, Symbol("saDataSizeKilobytes"), saDataSizeKilobytes)
        OpenAPI.validate_property(VpnClientIPsecParameters, Symbol("ipsecEncryption"), ipsecEncryption)
        OpenAPI.validate_property(VpnClientIPsecParameters, Symbol("ipsecIntegrity"), ipsecIntegrity)
        OpenAPI.validate_property(VpnClientIPsecParameters, Symbol("ikeEncryption"), ikeEncryption)
        OpenAPI.validate_property(VpnClientIPsecParameters, Symbol("ikeIntegrity"), ikeIntegrity)
        OpenAPI.validate_property(VpnClientIPsecParameters, Symbol("dhGroup"), dhGroup)
        OpenAPI.validate_property(VpnClientIPsecParameters, Symbol("pfsGroup"), pfsGroup)
        return new(saLifeTimeSeconds, saDataSizeKilobytes, ipsecEncryption, ipsecIntegrity, ikeEncryption, ikeIntegrity, dhGroup, pfsGroup, )
    end
end # type VpnClientIPsecParameters

const _property_types_VpnClientIPsecParameters = Dict{Symbol,String}(Symbol("saLifeTimeSeconds")=>"Int64", Symbol("saDataSizeKilobytes")=>"Int64", Symbol("ipsecEncryption")=>"IpsecEncryption", Symbol("ipsecIntegrity")=>"IpsecIntegrity", Symbol("ikeEncryption")=>"IkeEncryption", Symbol("ikeIntegrity")=>"IkeIntegrity", Symbol("dhGroup")=>"DhGroup", Symbol("pfsGroup")=>"PfsGroup", )
OpenAPI.property_type(::Type{ VpnClientIPsecParameters }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_VpnClientIPsecParameters[name]))}

function check_required(o::VpnClientIPsecParameters)
    o.saLifeTimeSeconds === nothing && (return false)
    o.saDataSizeKilobytes === nothing && (return false)
    o.ipsecEncryption === nothing && (return false)
    o.ipsecIntegrity === nothing && (return false)
    o.ikeEncryption === nothing && (return false)
    o.ikeIntegrity === nothing && (return false)
    o.dhGroup === nothing && (return false)
    o.pfsGroup === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ VpnClientIPsecParameters }, name::Symbol, val)
    if name === Symbol("saLifeTimeSeconds")
        OpenAPI.validate_param(name, "VpnClientIPsecParameters", :format, val, "int32")
    end
    if name === Symbol("saDataSizeKilobytes")
        OpenAPI.validate_param(name, "VpnClientIPsecParameters", :format, val, "int32")
    end
end
