# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct NetworkInterfacesApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `NetworkInterfacesApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ NetworkInterfacesApi }) = "https://management.azure.com"

const _returntypes_network_interfaces_get_virtual_machine_scale_set_ip_configuration_NetworkInterfacesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => NetworkInterfaceIPConfiguration,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_network_interfaces_get_virtual_machine_scale_set_ip_configuration(_api::NetworkInterfacesApi, resource_group_name::String, virtual_machine_scale_set_name::String, virtualmachine_index::String, network_interface_name::String, ip_configuration_name::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_network_interfaces_get_virtual_machine_scale_set_ip_configuration_NetworkInterfacesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/microsoft.Compute/virtualMachineScaleSets/{virtualMachineScaleSetName}/virtualMachines/{virtualmachineIndex}/networkInterfaces/{networkInterfaceName}/ipConfigurations/{ipConfigurationName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualMachineScaleSetName", virtual_machine_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualmachineIndex", virtualmachine_index)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "networkInterfaceName", network_interface_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "ipConfigurationName", ip_configuration_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "\$expand", expand)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Get the specified network interface ip configuration in a virtual machine scale set.

Params:
- resource_group_name::String (required)
- virtual_machine_scale_set_name::String (required)
- virtualmachine_index::String (required)
- network_interface_name::String (required)
- ip_configuration_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- expand::String

Return: NetworkInterfaceIPConfiguration, OpenAPI.Clients.ApiResponse
"""
function network_interfaces_get_virtual_machine_scale_set_ip_configuration(_api::NetworkInterfacesApi, resource_group_name::String, virtual_machine_scale_set_name::String, virtualmachine_index::String, network_interface_name::String, ip_configuration_name::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = _oacinternal_network_interfaces_get_virtual_machine_scale_set_ip_configuration(_api, resource_group_name, virtual_machine_scale_set_name, virtualmachine_index, network_interface_name, ip_configuration_name, api_version, subscription_id; expand=expand, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function network_interfaces_get_virtual_machine_scale_set_ip_configuration(_api::NetworkInterfacesApi, response_stream::Channel, resource_group_name::String, virtual_machine_scale_set_name::String, virtualmachine_index::String, network_interface_name::String, ip_configuration_name::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = _oacinternal_network_interfaces_get_virtual_machine_scale_set_ip_configuration(_api, resource_group_name, virtual_machine_scale_set_name, virtualmachine_index, network_interface_name, ip_configuration_name, api_version, subscription_id; expand=expand, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_network_interfaces_get_virtual_machine_scale_set_network_interface_NetworkInterfacesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => NetworkInterface,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_network_interfaces_get_virtual_machine_scale_set_network_interface(_api::NetworkInterfacesApi, resource_group_name::String, virtual_machine_scale_set_name::String, virtualmachine_index::String, network_interface_name::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_network_interfaces_get_virtual_machine_scale_set_network_interface_NetworkInterfacesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/microsoft.Compute/virtualMachineScaleSets/{virtualMachineScaleSetName}/virtualMachines/{virtualmachineIndex}/networkInterfaces/{networkInterfaceName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualMachineScaleSetName", virtual_machine_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualmachineIndex", virtualmachine_index)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "networkInterfaceName", network_interface_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "\$expand", expand)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Get the specified network interface in a virtual machine scale set.

Params:
- resource_group_name::String (required)
- virtual_machine_scale_set_name::String (required)
- virtualmachine_index::String (required)
- network_interface_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- expand::String

Return: NetworkInterface, OpenAPI.Clients.ApiResponse
"""
function network_interfaces_get_virtual_machine_scale_set_network_interface(_api::NetworkInterfacesApi, resource_group_name::String, virtual_machine_scale_set_name::String, virtualmachine_index::String, network_interface_name::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = _oacinternal_network_interfaces_get_virtual_machine_scale_set_network_interface(_api, resource_group_name, virtual_machine_scale_set_name, virtualmachine_index, network_interface_name, api_version, subscription_id; expand=expand, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function network_interfaces_get_virtual_machine_scale_set_network_interface(_api::NetworkInterfacesApi, response_stream::Channel, resource_group_name::String, virtual_machine_scale_set_name::String, virtualmachine_index::String, network_interface_name::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = _oacinternal_network_interfaces_get_virtual_machine_scale_set_network_interface(_api, resource_group_name, virtual_machine_scale_set_name, virtualmachine_index, network_interface_name, api_version, subscription_id; expand=expand, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_network_interfaces_list_virtual_machine_scale_set_ip_configurations_NetworkInterfacesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => NetworkInterfaceIPConfigurationListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_network_interfaces_list_virtual_machine_scale_set_ip_configurations(_api::NetworkInterfacesApi, resource_group_name::String, virtual_machine_scale_set_name::String, virtualmachine_index::String, network_interface_name::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_network_interfaces_list_virtual_machine_scale_set_ip_configurations_NetworkInterfacesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/microsoft.Compute/virtualMachineScaleSets/{virtualMachineScaleSetName}/virtualMachines/{virtualmachineIndex}/networkInterfaces/{networkInterfaceName}/ipConfigurations", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualMachineScaleSetName", virtual_machine_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualmachineIndex", virtualmachine_index)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "networkInterfaceName", network_interface_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "\$expand", expand)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Get the specified network interface ip configuration in a virtual machine scale set.

Params:
- resource_group_name::String (required)
- virtual_machine_scale_set_name::String (required)
- virtualmachine_index::String (required)
- network_interface_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- expand::String

Return: NetworkInterfaceIPConfigurationListResult, OpenAPI.Clients.ApiResponse
"""
function network_interfaces_list_virtual_machine_scale_set_ip_configurations(_api::NetworkInterfacesApi, resource_group_name::String, virtual_machine_scale_set_name::String, virtualmachine_index::String, network_interface_name::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = _oacinternal_network_interfaces_list_virtual_machine_scale_set_ip_configurations(_api, resource_group_name, virtual_machine_scale_set_name, virtualmachine_index, network_interface_name, api_version, subscription_id; expand=expand, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function network_interfaces_list_virtual_machine_scale_set_ip_configurations(_api::NetworkInterfacesApi, response_stream::Channel, resource_group_name::String, virtual_machine_scale_set_name::String, virtualmachine_index::String, network_interface_name::String, api_version::String, subscription_id::String; expand=nothing, _mediaType=nothing)
    _ctx = _oacinternal_network_interfaces_list_virtual_machine_scale_set_ip_configurations(_api, resource_group_name, virtual_machine_scale_set_name, virtualmachine_index, network_interface_name, api_version, subscription_id; expand=expand, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_network_interfaces_list_virtual_machine_scale_set_network_interfaces_NetworkInterfacesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => NetworkInterfaceListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_network_interfaces_list_virtual_machine_scale_set_network_interfaces(_api::NetworkInterfacesApi, resource_group_name::String, virtual_machine_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_network_interfaces_list_virtual_machine_scale_set_network_interfaces_NetworkInterfacesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/microsoft.Compute/virtualMachineScaleSets/{virtualMachineScaleSetName}/networkInterfaces", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualMachineScaleSetName", virtual_machine_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets all network interfaces in a virtual machine scale set.

Params:
- resource_group_name::String (required)
- virtual_machine_scale_set_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: NetworkInterfaceListResult, OpenAPI.Clients.ApiResponse
"""
function network_interfaces_list_virtual_machine_scale_set_network_interfaces(_api::NetworkInterfacesApi, resource_group_name::String, virtual_machine_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_network_interfaces_list_virtual_machine_scale_set_network_interfaces(_api, resource_group_name, virtual_machine_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function network_interfaces_list_virtual_machine_scale_set_network_interfaces(_api::NetworkInterfacesApi, response_stream::Channel, resource_group_name::String, virtual_machine_scale_set_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_network_interfaces_list_virtual_machine_scale_set_network_interfaces(_api, resource_group_name, virtual_machine_scale_set_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_network_interfaces_list_virtual_machine_scale_set_v_m_network_interfaces_NetworkInterfacesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => NetworkInterfaceListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_network_interfaces_list_virtual_machine_scale_set_v_m_network_interfaces(_api::NetworkInterfacesApi, resource_group_name::String, virtual_machine_scale_set_name::String, virtualmachine_index::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_network_interfaces_list_virtual_machine_scale_set_v_m_network_interfaces_NetworkInterfacesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/microsoft.Compute/virtualMachineScaleSets/{virtualMachineScaleSetName}/virtualMachines/{virtualmachineIndex}/networkInterfaces", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualMachineScaleSetName", virtual_machine_scale_set_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "virtualmachineIndex", virtualmachine_index)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Gets information about all network interfaces in a virtual machine in a virtual machine scale set.

Params:
- resource_group_name::String (required)
- virtual_machine_scale_set_name::String (required)
- virtualmachine_index::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: NetworkInterfaceListResult, OpenAPI.Clients.ApiResponse
"""
function network_interfaces_list_virtual_machine_scale_set_v_m_network_interfaces(_api::NetworkInterfacesApi, resource_group_name::String, virtual_machine_scale_set_name::String, virtualmachine_index::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_network_interfaces_list_virtual_machine_scale_set_v_m_network_interfaces(_api, resource_group_name, virtual_machine_scale_set_name, virtualmachine_index, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function network_interfaces_list_virtual_machine_scale_set_v_m_network_interfaces(_api::NetworkInterfacesApi, response_stream::Channel, resource_group_name::String, virtual_machine_scale_set_name::String, virtualmachine_index::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_network_interfaces_list_virtual_machine_scale_set_v_m_network_interfaces(_api, resource_group_name, virtual_machine_scale_set_name, virtualmachine_index, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export network_interfaces_get_virtual_machine_scale_set_ip_configuration
export network_interfaces_get_virtual_machine_scale_set_network_interface
export network_interfaces_list_virtual_machine_scale_set_ip_configurations
export network_interfaces_list_virtual_machine_scale_set_network_interfaces
export network_interfaces_list_virtual_machine_scale_set_v_m_network_interfaces
