# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""RoutePropertiesFormat
Route resource.

    RoutePropertiesFormat(;
        addressPrefix=nothing,
        nextHopType=nothing,
        nextHopIpAddress=nothing,
        provisioningState=nothing,
    )

    - addressPrefix::String : The destination CIDR to which the route applies.
    - nextHopType::RouteNextHopType
    - nextHopIpAddress::String : The IP address packets should be forwarded to. Next hop values are only allowed in routes where the next hop type is VirtualAppliance.
    - provisioningState::ProvisioningState
"""
Base.@kwdef mutable struct RoutePropertiesFormat <: OpenAPI.APIModel
    addressPrefix::Union{Nothing, String} = nothing
    nextHopType = nothing # spec type: Union{ Nothing, RouteNextHopType }
    nextHopIpAddress::Union{Nothing, String} = nothing
    provisioningState = nothing # spec type: Union{ Nothing, ProvisioningState }

    function RoutePropertiesFormat(addressPrefix, nextHopType, nextHopIpAddress, provisioningState, )
        OpenAPI.validate_property(RoutePropertiesFormat, Symbol("addressPrefix"), addressPrefix)
        OpenAPI.validate_property(RoutePropertiesFormat, Symbol("nextHopType"), nextHopType)
        OpenAPI.validate_property(RoutePropertiesFormat, Symbol("nextHopIpAddress"), nextHopIpAddress)
        OpenAPI.validate_property(RoutePropertiesFormat, Symbol("provisioningState"), provisioningState)
        return new(addressPrefix, nextHopType, nextHopIpAddress, provisioningState, )
    end
end # type RoutePropertiesFormat

const _property_types_RoutePropertiesFormat = Dict{Symbol,String}(Symbol("addressPrefix")=>"String", Symbol("nextHopType")=>"RouteNextHopType", Symbol("nextHopIpAddress")=>"String", Symbol("provisioningState")=>"ProvisioningState", )
OpenAPI.property_type(::Type{ RoutePropertiesFormat }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_RoutePropertiesFormat[name]))}

function check_required(o::RoutePropertiesFormat)
    o.nextHopType === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ RoutePropertiesFormat }, name::Symbol, val)
end
