# Julia API client for PolicyDefinitionsClient

To manage and control access to your resources, you can define customized policies and assign them at a scope.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 2019-09-01
- Build package: org.openapitools.codegen.languages.JuliaClientCodegen


## Installation
Place the Julia files generated under the `src` folder in your Julia project. Include PolicyDefinitionsClient.jl in the project code.
It would include the module named PolicyDefinitionsClient.

Documentation is generated as markdown files under the `docs` folder. You can include them in your project documentation.
Documentation is also embedded in Julia which can be used with a Julia specific documentation generator.

## API Endpoints

Class | Method
------------ | -------------
*PolicyDefinitionsApi* | [**policy_definitions_create_or_update**](docs/PolicyDefinitionsApi.md#policy_definitions_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}<br/>Creates or updates a policy definition in a subscription.
*PolicyDefinitionsApi* | [**policy_definitions_create_or_update_at_management_group**](docs/PolicyDefinitionsApi.md#policy_definitions_create_or_update_at_management_group)<br/>**PUT** /providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}<br/>Creates or updates a policy definition in a management group.
*PolicyDefinitionsApi* | [**policy_definitions_delete**](docs/PolicyDefinitionsApi.md#policy_definitions_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}<br/>Deletes a policy definition in a subscription.
*PolicyDefinitionsApi* | [**policy_definitions_delete_at_management_group**](docs/PolicyDefinitionsApi.md#policy_definitions_delete_at_management_group)<br/>**DELETE** /providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}<br/>Deletes a policy definition in a management group.
*PolicyDefinitionsApi* | [**policy_definitions_get**](docs/PolicyDefinitionsApi.md#policy_definitions_get)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}<br/>Retrieves a policy definition in a subscription.
*PolicyDefinitionsApi* | [**policy_definitions_get_at_management_group**](docs/PolicyDefinitionsApi.md#policy_definitions_get_at_management_group)<br/>**GET** /providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}<br/>Retrieve a policy definition in a management group.
*PolicyDefinitionsApi* | [**policy_definitions_get_built_in**](docs/PolicyDefinitionsApi.md#policy_definitions_get_built_in)<br/>**GET** /providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}<br/>Retrieves a built-in policy definition.
*PolicyDefinitionsApi* | [**policy_definitions_list**](docs/PolicyDefinitionsApi.md#policy_definitions_list)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policyDefinitions<br/>Retrieves policy definitions in a subscription
*PolicyDefinitionsApi* | [**policy_definitions_list_built_in**](docs/PolicyDefinitionsApi.md#policy_definitions_list_built_in)<br/>**GET** /providers/Microsoft.Authorization/policyDefinitions<br/>Retrieve built-in policy definitions
*PolicyDefinitionsApi* | [**policy_definitions_list_by_management_group**](docs/PolicyDefinitionsApi.md#policy_definitions_list_by_management_group)<br/>**GET** /providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policyDefinitions<br/>Retrieve policy definitions in a management group


## Models

 - [CloudError](docs/CloudError.md)
 - [ErrorAdditionalInfo](docs/ErrorAdditionalInfo.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [ParameterDefinitionsValue](docs/ParameterDefinitionsValue.md)
 - [PolicyDefinition](docs/PolicyDefinition.md)
 - [PolicyDefinitionListResult](docs/PolicyDefinitionListResult.md)
 - [PolicyDefinitionProperties](docs/PolicyDefinitionProperties.md)


## Authorization

## azure_auth
- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://login.microsoftonline.com/common/oauth2/authorize
- **Scopes**: 
 - **user_impersonation**: impersonate your user account

Example
```
    using OpenAPI
    using OpenAPI.Clients
    import OpenAPI.Clients: Client, set_header
    client = Client(server_uri)
    set_header(client, "Authorization", "Bearer $bearer_auth")
    api = MyApi(client)
    result = callApi(api, args...; api_key)
```

## Author



