# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct PolicyDefinitionsApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `PolicyDefinitionsApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ PolicyDefinitionsApi }) = "https://management.azure.com"

const _returntypes_policy_definitions_create_or_update_PolicyDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("201", "x"=>".") * "\$") => PolicyDefinition,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_definitions_create_or_update(_api::PolicyDefinitionsApi, policy_definition_name::String, api_version::String, subscription_id::String, parameters::PolicyDefinition; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_policy_definitions_create_or_update_PolicyDefinitionsApi, "/subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "policyDefinitionName", policy_definition_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Creates or updates a policy definition in a subscription.

This operation creates or updates a policy definition in the given subscription with the given name.

Params:
- policy_definition_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::PolicyDefinition (required)

Return: PolicyDefinition, OpenAPI.Clients.ApiResponse
"""
function policy_definitions_create_or_update(_api::PolicyDefinitionsApi, policy_definition_name::String, api_version::String, subscription_id::String, parameters::PolicyDefinition; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_create_or_update(_api, policy_definition_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_definitions_create_or_update(_api::PolicyDefinitionsApi, response_stream::Channel, policy_definition_name::String, api_version::String, subscription_id::String, parameters::PolicyDefinition; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_create_or_update(_api, policy_definition_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_policy_definitions_create_or_update_at_management_group_PolicyDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("201", "x"=>".") * "\$") => PolicyDefinition,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_definitions_create_or_update_at_management_group(_api::PolicyDefinitionsApi, policy_definition_name::String, api_version::String, management_group_id::String, parameters::PolicyDefinition; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_policy_definitions_create_or_update_at_management_group_PolicyDefinitionsApi, "/providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "policyDefinitionName", policy_definition_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "managementGroupId", management_group_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Creates or updates a policy definition in a management group.

This operation creates or updates a policy definition in the given management group with the given name.

Params:
- policy_definition_name::String (required)
- api_version::String (required)
- management_group_id::String (required)
- parameters::PolicyDefinition (required)

Return: PolicyDefinition, OpenAPI.Clients.ApiResponse
"""
function policy_definitions_create_or_update_at_management_group(_api::PolicyDefinitionsApi, policy_definition_name::String, api_version::String, management_group_id::String, parameters::PolicyDefinition; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_create_or_update_at_management_group(_api, policy_definition_name, api_version, management_group_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_definitions_create_or_update_at_management_group(_api::PolicyDefinitionsApi, response_stream::Channel, policy_definition_name::String, api_version::String, management_group_id::String, parameters::PolicyDefinition; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_create_or_update_at_management_group(_api, policy_definition_name, api_version, management_group_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_policy_definitions_delete_PolicyDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_definitions_delete(_api::PolicyDefinitionsApi, policy_definition_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_policy_definitions_delete_PolicyDefinitionsApi, "/subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "policyDefinitionName", policy_definition_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Deletes a policy definition in a subscription.

This operation deletes the policy definition in the given subscription with the given name.

Params:
- policy_definition_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function policy_definitions_delete(_api::PolicyDefinitionsApi, policy_definition_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_delete(_api, policy_definition_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_definitions_delete(_api::PolicyDefinitionsApi, response_stream::Channel, policy_definition_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_delete(_api, policy_definition_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_policy_definitions_delete_at_management_group_PolicyDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_definitions_delete_at_management_group(_api::PolicyDefinitionsApi, policy_definition_name::String, api_version::String, management_group_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_policy_definitions_delete_at_management_group_PolicyDefinitionsApi, "/providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "policyDefinitionName", policy_definition_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "managementGroupId", management_group_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Deletes a policy definition in a management group.

This operation deletes the policy definition in the given management group with the given name.

Params:
- policy_definition_name::String (required)
- api_version::String (required)
- management_group_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function policy_definitions_delete_at_management_group(_api::PolicyDefinitionsApi, policy_definition_name::String, api_version::String, management_group_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_delete_at_management_group(_api, policy_definition_name, api_version, management_group_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_definitions_delete_at_management_group(_api::PolicyDefinitionsApi, response_stream::Channel, policy_definition_name::String, api_version::String, management_group_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_delete_at_management_group(_api, policy_definition_name, api_version, management_group_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_policy_definitions_get_PolicyDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => PolicyDefinition,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_definitions_get(_api::PolicyDefinitionsApi, policy_definition_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_policy_definitions_get_PolicyDefinitionsApi, "/subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "policyDefinitionName", policy_definition_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Retrieves a policy definition in a subscription.

This operation retrieves the policy definition in the given subscription with the given name.

Params:
- policy_definition_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: PolicyDefinition, OpenAPI.Clients.ApiResponse
"""
function policy_definitions_get(_api::PolicyDefinitionsApi, policy_definition_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_get(_api, policy_definition_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_definitions_get(_api::PolicyDefinitionsApi, response_stream::Channel, policy_definition_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_get(_api, policy_definition_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_policy_definitions_get_at_management_group_PolicyDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => PolicyDefinition,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_definitions_get_at_management_group(_api::PolicyDefinitionsApi, policy_definition_name::String, api_version::String, management_group_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_policy_definitions_get_at_management_group_PolicyDefinitionsApi, "/providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "policyDefinitionName", policy_definition_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "managementGroupId", management_group_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Retrieve a policy definition in a management group.

This operation retrieves the policy definition in the given management group with the given name.

Params:
- policy_definition_name::String (required)
- api_version::String (required)
- management_group_id::String (required)

Return: PolicyDefinition, OpenAPI.Clients.ApiResponse
"""
function policy_definitions_get_at_management_group(_api::PolicyDefinitionsApi, policy_definition_name::String, api_version::String, management_group_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_get_at_management_group(_api, policy_definition_name, api_version, management_group_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_definitions_get_at_management_group(_api::PolicyDefinitionsApi, response_stream::Channel, policy_definition_name::String, api_version::String, management_group_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_get_at_management_group(_api, policy_definition_name, api_version, management_group_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_policy_definitions_get_built_in_PolicyDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => PolicyDefinition,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_definitions_get_built_in(_api::PolicyDefinitionsApi, policy_definition_name::String, api_version::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_policy_definitions_get_built_in_PolicyDefinitionsApi, "/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "policyDefinitionName", policy_definition_name)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Retrieves a built-in policy definition.

This operation retrieves the built-in policy definition with the given name.

Params:
- policy_definition_name::String (required)
- api_version::String (required)

Return: PolicyDefinition, OpenAPI.Clients.ApiResponse
"""
function policy_definitions_get_built_in(_api::PolicyDefinitionsApi, policy_definition_name::String, api_version::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_get_built_in(_api, policy_definition_name, api_version; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_definitions_get_built_in(_api::PolicyDefinitionsApi, response_stream::Channel, policy_definition_name::String, api_version::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_get_built_in(_api, policy_definition_name, api_version; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_policy_definitions_list_PolicyDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => PolicyDefinitionListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_definitions_list(_api::PolicyDefinitionsApi, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_policy_definitions_list_PolicyDefinitionsApi, "/subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policyDefinitions", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Retrieves policy definitions in a subscription

This operation retrieves a list of all the policy definitions in a given subscription.

Params:
- api_version::String (required)
- subscription_id::String (required)

Return: PolicyDefinitionListResult, OpenAPI.Clients.ApiResponse
"""
function policy_definitions_list(_api::PolicyDefinitionsApi, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_list(_api, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_definitions_list(_api::PolicyDefinitionsApi, response_stream::Channel, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_list(_api, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_policy_definitions_list_built_in_PolicyDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => PolicyDefinitionListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_definitions_list_built_in(_api::PolicyDefinitionsApi, api_version::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_policy_definitions_list_built_in_PolicyDefinitionsApi, "/providers/Microsoft.Authorization/policyDefinitions", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Retrieve built-in policy definitions

This operation retrieves a list of all the built-in policy definitions.

Params:
- api_version::String (required)

Return: PolicyDefinitionListResult, OpenAPI.Clients.ApiResponse
"""
function policy_definitions_list_built_in(_api::PolicyDefinitionsApi, api_version::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_list_built_in(_api, api_version; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_definitions_list_built_in(_api::PolicyDefinitionsApi, response_stream::Channel, api_version::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_list_built_in(_api, api_version; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_policy_definitions_list_by_management_group_PolicyDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => PolicyDefinitionListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_definitions_list_by_management_group(_api::PolicyDefinitionsApi, api_version::String, management_group_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_policy_definitions_list_by_management_group_PolicyDefinitionsApi, "/providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policyDefinitions", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "managementGroupId", management_group_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Retrieve policy definitions in a management group

This operation retrieves a list of all the policy definitions in a given management group.

Params:
- api_version::String (required)
- management_group_id::String (required)

Return: PolicyDefinitionListResult, OpenAPI.Clients.ApiResponse
"""
function policy_definitions_list_by_management_group(_api::PolicyDefinitionsApi, api_version::String, management_group_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_list_by_management_group(_api, api_version, management_group_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_definitions_list_by_management_group(_api::PolicyDefinitionsApi, response_stream::Channel, api_version::String, management_group_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_definitions_list_by_management_group(_api, api_version, management_group_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export policy_definitions_create_or_update
export policy_definitions_create_or_update_at_management_group
export policy_definitions_delete
export policy_definitions_delete_at_management_group
export policy_definitions_get
export policy_definitions_get_at_management_group
export policy_definitions_get_built_in
export policy_definitions_list
export policy_definitions_list_built_in
export policy_definitions_list_by_management_group
