# Julia API client for PolicySetDefinitionsClient

To manage and control access to your resources, you can define customized policies and assign them at a scope.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 2019-09-01
- Build package: org.openapitools.codegen.languages.JuliaClientCodegen


## Installation
Place the Julia files generated under the `src` folder in your Julia project. Include PolicySetDefinitionsClient.jl in the project code.
It would include the module named PolicySetDefinitionsClient.

Documentation is generated as markdown files under the `docs` folder. You can include them in your project documentation.
Documentation is also embedded in Julia which can be used with a Julia specific documentation generator.

## API Endpoints

Class | Method
------------ | -------------
*PolicySetDefinitionsApi* | [**policy_set_definitions_create_or_update**](docs/PolicySetDefinitionsApi.md#policy_set_definitions_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policySetDefinitions/{policySetDefinitionName}<br/>Creates or updates a policy set definition.
*PolicySetDefinitionsApi* | [**policy_set_definitions_create_or_update_at_management_group**](docs/PolicySetDefinitionsApi.md#policy_set_definitions_create_or_update_at_management_group)<br/>**PUT** /providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policySetDefinitions/{policySetDefinitionName}<br/>Creates or updates a policy set definition.
*PolicySetDefinitionsApi* | [**policy_set_definitions_delete**](docs/PolicySetDefinitionsApi.md#policy_set_definitions_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policySetDefinitions/{policySetDefinitionName}<br/>Deletes a policy set definition.
*PolicySetDefinitionsApi* | [**policy_set_definitions_delete_at_management_group**](docs/PolicySetDefinitionsApi.md#policy_set_definitions_delete_at_management_group)<br/>**DELETE** /providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policySetDefinitions/{policySetDefinitionName}<br/>Deletes a policy set definition.
*PolicySetDefinitionsApi* | [**policy_set_definitions_get**](docs/PolicySetDefinitionsApi.md#policy_set_definitions_get)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policySetDefinitions/{policySetDefinitionName}<br/>Retrieves a policy set definition.
*PolicySetDefinitionsApi* | [**policy_set_definitions_get_at_management_group**](docs/PolicySetDefinitionsApi.md#policy_set_definitions_get_at_management_group)<br/>**GET** /providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policySetDefinitions/{policySetDefinitionName}<br/>Retrieves a policy set definition.
*PolicySetDefinitionsApi* | [**policy_set_definitions_get_built_in**](docs/PolicySetDefinitionsApi.md#policy_set_definitions_get_built_in)<br/>**GET** /providers/Microsoft.Authorization/policySetDefinitions/{policySetDefinitionName}<br/>Retrieves a built in policy set definition.
*PolicySetDefinitionsApi* | [**policy_set_definitions_list**](docs/PolicySetDefinitionsApi.md#policy_set_definitions_list)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policySetDefinitions<br/>Retrieves the policy set definitions for a subscription.
*PolicySetDefinitionsApi* | [**policy_set_definitions_list_built_in**](docs/PolicySetDefinitionsApi.md#policy_set_definitions_list_built_in)<br/>**GET** /providers/Microsoft.Authorization/policySetDefinitions<br/>Retrieves built-in policy set definitions.
*PolicySetDefinitionsApi* | [**policy_set_definitions_list_by_management_group**](docs/PolicySetDefinitionsApi.md#policy_set_definitions_list_by_management_group)<br/>**GET** /providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policySetDefinitions<br/>Retrieves all policy set definitions in management group.


## Models

 - [CloudError](docs/CloudError.md)
 - [ErrorAdditionalInfo](docs/ErrorAdditionalInfo.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [ParameterDefinitionsValue](docs/ParameterDefinitionsValue.md)
 - [ParameterValuesValue](docs/ParameterValuesValue.md)
 - [PolicyDefinitionGroup](docs/PolicyDefinitionGroup.md)
 - [PolicyDefinitionReference](docs/PolicyDefinitionReference.md)
 - [PolicySetDefinition](docs/PolicySetDefinition.md)
 - [PolicySetDefinitionListResult](docs/PolicySetDefinitionListResult.md)
 - [PolicySetDefinitionProperties](docs/PolicySetDefinitionProperties.md)


## Authorization

## azure_auth
- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://login.microsoftonline.com/common/oauth2/authorize
- **Scopes**: 
 - **user_impersonation**: impersonate your user account

Example
```
    using OpenAPI
    using OpenAPI.Clients
    import OpenAPI.Clients: Client, set_header
    client = Client(server_uri)
    set_header(client, "Authorization", "Bearer $bearer_auth")
    api = MyApi(client)
    result = callApi(api, args...; api_key)
```

## Author



