# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct PolicySetDefinitionsApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `PolicySetDefinitionsApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ PolicySetDefinitionsApi }) = "https://management.azure.com"

const _returntypes_policy_set_definitions_create_or_update_PolicySetDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("201", "x"=>".") * "\$") => PolicySetDefinition,
    Regex("^" * replace("200", "x"=>".") * "\$") => PolicySetDefinition,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_set_definitions_create_or_update(_api::PolicySetDefinitionsApi, policy_set_definition_name::String, api_version::String, subscription_id::String, parameters::PolicySetDefinition; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_policy_set_definitions_create_or_update_PolicySetDefinitionsApi, "/subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policySetDefinitions/{policySetDefinitionName}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "policySetDefinitionName", policy_set_definition_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Creates or updates a policy set definition.

This operation creates or updates a policy set definition in the given subscription with the given name.

Params:
- policy_set_definition_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- parameters::PolicySetDefinition (required)

Return: PolicySetDefinition, OpenAPI.Clients.ApiResponse
"""
function policy_set_definitions_create_or_update(_api::PolicySetDefinitionsApi, policy_set_definition_name::String, api_version::String, subscription_id::String, parameters::PolicySetDefinition; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_create_or_update(_api, policy_set_definition_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_set_definitions_create_or_update(_api::PolicySetDefinitionsApi, response_stream::Channel, policy_set_definition_name::String, api_version::String, subscription_id::String, parameters::PolicySetDefinition; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_create_or_update(_api, policy_set_definition_name, api_version, subscription_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_policy_set_definitions_create_or_update_at_management_group_PolicySetDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("201", "x"=>".") * "\$") => PolicySetDefinition,
    Regex("^" * replace("200", "x"=>".") * "\$") => PolicySetDefinition,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_set_definitions_create_or_update_at_management_group(_api::PolicySetDefinitionsApi, policy_set_definition_name::String, api_version::String, management_group_id::String, parameters::PolicySetDefinition; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_policy_set_definitions_create_or_update_at_management_group_PolicySetDefinitionsApi, "/providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policySetDefinitions/{policySetDefinitionName}", ["azure_auth", ], parameters)
    OpenAPI.Clients.set_param(_ctx.path, "policySetDefinitionName", policy_set_definition_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "managementGroupId", management_group_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Creates or updates a policy set definition.

This operation creates or updates a policy set definition in the given management group with the given name.

Params:
- policy_set_definition_name::String (required)
- api_version::String (required)
- management_group_id::String (required)
- parameters::PolicySetDefinition (required)

Return: PolicySetDefinition, OpenAPI.Clients.ApiResponse
"""
function policy_set_definitions_create_or_update_at_management_group(_api::PolicySetDefinitionsApi, policy_set_definition_name::String, api_version::String, management_group_id::String, parameters::PolicySetDefinition; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_create_or_update_at_management_group(_api, policy_set_definition_name, api_version, management_group_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_set_definitions_create_or_update_at_management_group(_api::PolicySetDefinitionsApi, response_stream::Channel, policy_set_definition_name::String, api_version::String, management_group_id::String, parameters::PolicySetDefinition; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_create_or_update_at_management_group(_api, policy_set_definition_name, api_version, management_group_id, parameters; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_policy_set_definitions_delete_PolicySetDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_set_definitions_delete(_api::PolicySetDefinitionsApi, policy_set_definition_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_policy_set_definitions_delete_PolicySetDefinitionsApi, "/subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policySetDefinitions/{policySetDefinitionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "policySetDefinitionName", policy_set_definition_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Deletes a policy set definition.

This operation deletes the policy set definition in the given subscription with the given name.

Params:
- policy_set_definition_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function policy_set_definitions_delete(_api::PolicySetDefinitionsApi, policy_set_definition_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_delete(_api, policy_set_definition_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_set_definitions_delete(_api::PolicySetDefinitionsApi, response_stream::Channel, policy_set_definition_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_delete(_api, policy_set_definition_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_policy_set_definitions_delete_at_management_group_PolicySetDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_set_definitions_delete_at_management_group(_api::PolicySetDefinitionsApi, policy_set_definition_name::String, api_version::String, management_group_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_policy_set_definitions_delete_at_management_group_PolicySetDefinitionsApi, "/providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policySetDefinitions/{policySetDefinitionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "policySetDefinitionName", policy_set_definition_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "managementGroupId", management_group_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Deletes a policy set definition.

This operation deletes the policy set definition in the given management group with the given name.

Params:
- policy_set_definition_name::String (required)
- api_version::String (required)
- management_group_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function policy_set_definitions_delete_at_management_group(_api::PolicySetDefinitionsApi, policy_set_definition_name::String, api_version::String, management_group_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_delete_at_management_group(_api, policy_set_definition_name, api_version, management_group_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_set_definitions_delete_at_management_group(_api::PolicySetDefinitionsApi, response_stream::Channel, policy_set_definition_name::String, api_version::String, management_group_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_delete_at_management_group(_api, policy_set_definition_name, api_version, management_group_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_policy_set_definitions_get_PolicySetDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => PolicySetDefinition,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_set_definitions_get(_api::PolicySetDefinitionsApi, policy_set_definition_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_policy_set_definitions_get_PolicySetDefinitionsApi, "/subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policySetDefinitions/{policySetDefinitionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "policySetDefinitionName", policy_set_definition_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Retrieves a policy set definition.

This operation retrieves the policy set definition in the given subscription with the given name.

Params:
- policy_set_definition_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: PolicySetDefinition, OpenAPI.Clients.ApiResponse
"""
function policy_set_definitions_get(_api::PolicySetDefinitionsApi, policy_set_definition_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_get(_api, policy_set_definition_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_set_definitions_get(_api::PolicySetDefinitionsApi, response_stream::Channel, policy_set_definition_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_get(_api, policy_set_definition_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_policy_set_definitions_get_at_management_group_PolicySetDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => PolicySetDefinition,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_set_definitions_get_at_management_group(_api::PolicySetDefinitionsApi, policy_set_definition_name::String, api_version::String, management_group_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_policy_set_definitions_get_at_management_group_PolicySetDefinitionsApi, "/providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policySetDefinitions/{policySetDefinitionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "policySetDefinitionName", policy_set_definition_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "managementGroupId", management_group_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Retrieves a policy set definition.

This operation retrieves the policy set definition in the given management group with the given name.

Params:
- policy_set_definition_name::String (required)
- api_version::String (required)
- management_group_id::String (required)

Return: PolicySetDefinition, OpenAPI.Clients.ApiResponse
"""
function policy_set_definitions_get_at_management_group(_api::PolicySetDefinitionsApi, policy_set_definition_name::String, api_version::String, management_group_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_get_at_management_group(_api, policy_set_definition_name, api_version, management_group_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_set_definitions_get_at_management_group(_api::PolicySetDefinitionsApi, response_stream::Channel, policy_set_definition_name::String, api_version::String, management_group_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_get_at_management_group(_api, policy_set_definition_name, api_version, management_group_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_policy_set_definitions_get_built_in_PolicySetDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => PolicySetDefinition,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_set_definitions_get_built_in(_api::PolicySetDefinitionsApi, policy_set_definition_name::String, api_version::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_policy_set_definitions_get_built_in_PolicySetDefinitionsApi, "/providers/Microsoft.Authorization/policySetDefinitions/{policySetDefinitionName}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "policySetDefinitionName", policy_set_definition_name)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Retrieves a built in policy set definition.

This operation retrieves the built-in policy set definition with the given name.

Params:
- policy_set_definition_name::String (required)
- api_version::String (required)

Return: PolicySetDefinition, OpenAPI.Clients.ApiResponse
"""
function policy_set_definitions_get_built_in(_api::PolicySetDefinitionsApi, policy_set_definition_name::String, api_version::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_get_built_in(_api, policy_set_definition_name, api_version; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_set_definitions_get_built_in(_api::PolicySetDefinitionsApi, response_stream::Channel, policy_set_definition_name::String, api_version::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_get_built_in(_api, policy_set_definition_name, api_version; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_policy_set_definitions_list_PolicySetDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => PolicySetDefinitionListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_set_definitions_list(_api::PolicySetDefinitionsApi, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_policy_set_definitions_list_PolicySetDefinitionsApi, "/subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policySetDefinitions", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Retrieves the policy set definitions for a subscription.

This operation retrieves a list of all the policy set definitions in the given subscription.

Params:
- api_version::String (required)
- subscription_id::String (required)

Return: PolicySetDefinitionListResult, OpenAPI.Clients.ApiResponse
"""
function policy_set_definitions_list(_api::PolicySetDefinitionsApi, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_list(_api, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_set_definitions_list(_api::PolicySetDefinitionsApi, response_stream::Channel, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_list(_api, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_policy_set_definitions_list_built_in_PolicySetDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => PolicySetDefinitionListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_set_definitions_list_built_in(_api::PolicySetDefinitionsApi, api_version::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_policy_set_definitions_list_built_in_PolicySetDefinitionsApi, "/providers/Microsoft.Authorization/policySetDefinitions", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Retrieves built-in policy set definitions.

This operation retrieves a list of all the built-in policy set definitions.

Params:
- api_version::String (required)

Return: PolicySetDefinitionListResult, OpenAPI.Clients.ApiResponse
"""
function policy_set_definitions_list_built_in(_api::PolicySetDefinitionsApi, api_version::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_list_built_in(_api, api_version; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_set_definitions_list_built_in(_api::PolicySetDefinitionsApi, response_stream::Channel, api_version::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_list_built_in(_api, api_version; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_policy_set_definitions_list_by_management_group_PolicySetDefinitionsApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => PolicySetDefinitionListResult,
    Regex("^" * replace("0", "x"=>".") * "\$") => CloudError,
)

function _oacinternal_policy_set_definitions_list_by_management_group(_api::PolicySetDefinitionsApi, api_version::String, management_group_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_policy_set_definitions_list_by_management_group_PolicySetDefinitionsApi, "/providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policySetDefinitions", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "managementGroupId", management_group_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Retrieves all policy set definitions in management group.

This operation retrieves a list of all the a policy set definition in the given management group.

Params:
- api_version::String (required)
- management_group_id::String (required)

Return: PolicySetDefinitionListResult, OpenAPI.Clients.ApiResponse
"""
function policy_set_definitions_list_by_management_group(_api::PolicySetDefinitionsApi, api_version::String, management_group_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_list_by_management_group(_api, api_version, management_group_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function policy_set_definitions_list_by_management_group(_api::PolicySetDefinitionsApi, response_stream::Channel, api_version::String, management_group_id::String; _mediaType=nothing)
    _ctx = _oacinternal_policy_set_definitions_list_by_management_group(_api, api_version, management_group_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export policy_set_definitions_create_or_update
export policy_set_definitions_create_or_update_at_management_group
export policy_set_definitions_delete
export policy_set_definitions_delete_at_management_group
export policy_set_definitions_get
export policy_set_definitions_get_at_management_group
export policy_set_definitions_get_built_in
export policy_set_definitions_list
export policy_set_definitions_list_built_in
export policy_set_definitions_list_by_management_group
