# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""PolicySetDefinitionProperties
The policy set definition properties.

    PolicySetDefinitionProperties(;
        policyType=nothing,
        displayName=nothing,
        description=nothing,
        metadata=nothing,
        parameters=nothing,
        policyDefinitions=nothing,
        policyDefinitionGroups=nothing,
    )

    - policyType::String : The type of policy definition. Possible values are NotSpecified, BuiltIn, Custom, and Static.
    - displayName::String : The display name of the policy set definition.
    - description::String : The policy set definition description.
    - metadata::Any : The policy set definition metadata.  Metadata is an open ended object and is typically a collection of key value pairs.
    - parameters::Dict{String, ParameterDefinitionsValue} : The parameter definitions for parameters used in the policy. The keys are the parameter names.
    - policyDefinitions::Vector{PolicyDefinitionReference} : An array of policy definition references.
    - policyDefinitionGroups::Vector{PolicyDefinitionGroup} : The metadata describing groups of policy definition references within the policy set definition.
"""
Base.@kwdef mutable struct PolicySetDefinitionProperties <: OpenAPI.APIModel
    policyType::Union{Nothing, String} = nothing
    displayName::Union{Nothing, String} = nothing
    description::Union{Nothing, String} = nothing
    metadata::Union{Nothing, Any} = nothing
    parameters::Union{Nothing, Dict} = nothing # spec type: Union{ Nothing, Dict{String, ParameterDefinitionsValue} }
    policyDefinitions::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{PolicyDefinitionReference} }
    policyDefinitionGroups::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{PolicyDefinitionGroup} }

    function PolicySetDefinitionProperties(policyType, displayName, description, metadata, parameters, policyDefinitions, policyDefinitionGroups, )
        OpenAPI.validate_property(PolicySetDefinitionProperties, Symbol("policyType"), policyType)
        OpenAPI.validate_property(PolicySetDefinitionProperties, Symbol("displayName"), displayName)
        OpenAPI.validate_property(PolicySetDefinitionProperties, Symbol("description"), description)
        OpenAPI.validate_property(PolicySetDefinitionProperties, Symbol("metadata"), metadata)
        OpenAPI.validate_property(PolicySetDefinitionProperties, Symbol("parameters"), parameters)
        OpenAPI.validate_property(PolicySetDefinitionProperties, Symbol("policyDefinitions"), policyDefinitions)
        OpenAPI.validate_property(PolicySetDefinitionProperties, Symbol("policyDefinitionGroups"), policyDefinitionGroups)
        return new(policyType, displayName, description, metadata, parameters, policyDefinitions, policyDefinitionGroups, )
    end
end # type PolicySetDefinitionProperties

const _property_types_PolicySetDefinitionProperties = Dict{Symbol,String}(Symbol("policyType")=>"String", Symbol("displayName")=>"String", Symbol("description")=>"String", Symbol("metadata")=>"Any", Symbol("parameters")=>"Dict{String, ParameterDefinitionsValue}", Symbol("policyDefinitions")=>"Vector{PolicyDefinitionReference}", Symbol("policyDefinitionGroups")=>"Vector{PolicyDefinitionGroup}", )
OpenAPI.property_type(::Type{ PolicySetDefinitionProperties }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_PolicySetDefinitionProperties[name]))}

function check_required(o::PolicySetDefinitionProperties)
    o.policyDefinitions === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ PolicySetDefinitionProperties }, name::Symbol, val)
    if name === Symbol("policyType")
        OpenAPI.validate_param(name, "PolicySetDefinitionProperties", :enum, val, ["NotSpecified", "BuiltIn", "Custom", "Static"])
    end
end
