# Julia API client for ResourceManagementClient

Provides operations for working with resources and resource groups.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 2020-06-01
- Build package: org.openapitools.codegen.languages.JuliaClientCodegen


## Installation
Place the Julia files generated under the `src` folder in your Julia project. Include ResourceManagementClient.jl in the project code.
It would include the module named ResourceManagementClient.

Documentation is generated as markdown files under the `docs` folder. You can include them in your project documentation.
Documentation is also embedded in Julia which can be used with a Julia specific documentation generator.

## API Endpoints

Class | Method
------------ | -------------
*DeploymentOperationsApi* | [**deployment_operations_get**](docs/DeploymentOperationsApi.md#deployment_operations_get)<br/>**GET** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/deployments/{deploymentName}/operations/{operationId}<br/>
*DeploymentOperationsApi* | [**deployment_operations_get_at_management_group_scope**](docs/DeploymentOperationsApi.md#deployment_operations_get_at_management_group_scope)<br/>**GET** /providers/Microsoft.Management/managementGroups/{groupId}/providers/Microsoft.Resources/deployments/{deploymentName}/operations/{operationId}<br/>
*DeploymentOperationsApi* | [**deployment_operations_get_at_scope**](docs/DeploymentOperationsApi.md#deployment_operations_get_at_scope)<br/>**GET** /{scope}/providers/Microsoft.Resources/deployments/{deploymentName}/operations/{operationId}<br/>
*DeploymentOperationsApi* | [**deployment_operations_get_at_subscription_scope**](docs/DeploymentOperationsApi.md#deployment_operations_get_at_subscription_scope)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Resources/deployments/{deploymentName}/operations/{operationId}<br/>
*DeploymentOperationsApi* | [**deployment_operations_get_at_tenant_scope**](docs/DeploymentOperationsApi.md#deployment_operations_get_at_tenant_scope)<br/>**GET** /providers/Microsoft.Resources/deployments/{deploymentName}/operations/{operationId}<br/>
*DeploymentOperationsApi* | [**deployment_operations_list**](docs/DeploymentOperationsApi.md#deployment_operations_list)<br/>**GET** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/deployments/{deploymentName}/operations<br/>
*DeploymentOperationsApi* | [**deployment_operations_list_at_management_group_scope**](docs/DeploymentOperationsApi.md#deployment_operations_list_at_management_group_scope)<br/>**GET** /providers/Microsoft.Management/managementGroups/{groupId}/providers/Microsoft.Resources/deployments/{deploymentName}/operations<br/>
*DeploymentOperationsApi* | [**deployment_operations_list_at_scope**](docs/DeploymentOperationsApi.md#deployment_operations_list_at_scope)<br/>**GET** /{scope}/providers/Microsoft.Resources/deployments/{deploymentName}/operations<br/>
*DeploymentOperationsApi* | [**deployment_operations_list_at_subscription_scope**](docs/DeploymentOperationsApi.md#deployment_operations_list_at_subscription_scope)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Resources/deployments/{deploymentName}/operations<br/>
*DeploymentOperationsApi* | [**deployment_operations_list_at_tenant_scope**](docs/DeploymentOperationsApi.md#deployment_operations_list_at_tenant_scope)<br/>**GET** /providers/Microsoft.Resources/deployments/{deploymentName}/operations<br/>
*DeploymentsApi* | [**deployments_calculate_template_hash**](docs/DeploymentsApi.md#deployments_calculate_template_hash)<br/>**POST** /providers/Microsoft.Resources/calculateTemplateHash<br/>
*DeploymentsApi* | [**deployments_cancel**](docs/DeploymentsApi.md#deployments_cancel)<br/>**POST** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/Microsoft.Resources/deployments/{deploymentName}/cancel<br/>Cancels a currently running template deployment.
*DeploymentsApi* | [**deployments_cancel_at_management_group_scope**](docs/DeploymentsApi.md#deployments_cancel_at_management_group_scope)<br/>**POST** /providers/Microsoft.Management/managementGroups/{groupId}/providers/Microsoft.Resources/deployments/{deploymentName}/cancel<br/>Cancels a currently running template deployment.
*DeploymentsApi* | [**deployments_cancel_at_scope**](docs/DeploymentsApi.md#deployments_cancel_at_scope)<br/>**POST** /{scope}/providers/Microsoft.Resources/deployments/{deploymentName}/cancel<br/>Cancels a currently running template deployment.
*DeploymentsApi* | [**deployments_cancel_at_subscription_scope**](docs/DeploymentsApi.md#deployments_cancel_at_subscription_scope)<br/>**POST** /subscriptions/{subscriptionId}/providers/Microsoft.Resources/deployments/{deploymentName}/cancel<br/>Cancels a currently running template deployment.
*DeploymentsApi* | [**deployments_cancel_at_tenant_scope**](docs/DeploymentsApi.md#deployments_cancel_at_tenant_scope)<br/>**POST** /providers/Microsoft.Resources/deployments/{deploymentName}/cancel<br/>Cancels a currently running template deployment.
*DeploymentsApi* | [**deployments_check_existence**](docs/DeploymentsApi.md#deployments_check_existence)<br/>**HEAD** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/Microsoft.Resources/deployments/{deploymentName}<br/>
*DeploymentsApi* | [**deployments_check_existence_at_management_group_scope**](docs/DeploymentsApi.md#deployments_check_existence_at_management_group_scope)<br/>**HEAD** /providers/Microsoft.Management/managementGroups/{groupId}/providers/Microsoft.Resources/deployments/{deploymentName}<br/>
*DeploymentsApi* | [**deployments_check_existence_at_scope**](docs/DeploymentsApi.md#deployments_check_existence_at_scope)<br/>**HEAD** /{scope}/providers/Microsoft.Resources/deployments/{deploymentName}<br/>
*DeploymentsApi* | [**deployments_check_existence_at_subscription_scope**](docs/DeploymentsApi.md#deployments_check_existence_at_subscription_scope)<br/>**HEAD** /subscriptions/{subscriptionId}/providers/Microsoft.Resources/deployments/{deploymentName}<br/>
*DeploymentsApi* | [**deployments_check_existence_at_tenant_scope**](docs/DeploymentsApi.md#deployments_check_existence_at_tenant_scope)<br/>**HEAD** /providers/Microsoft.Resources/deployments/{deploymentName}<br/>
*DeploymentsApi* | [**deployments_create_or_update**](docs/DeploymentsApi.md#deployments_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/Microsoft.Resources/deployments/{deploymentName}<br/>Deploys resources to a resource group.
*DeploymentsApi* | [**deployments_create_or_update_at_management_group_scope**](docs/DeploymentsApi.md#deployments_create_or_update_at_management_group_scope)<br/>**PUT** /providers/Microsoft.Management/managementGroups/{groupId}/providers/Microsoft.Resources/deployments/{deploymentName}<br/>Deploys resources at management group scope.
*DeploymentsApi* | [**deployments_create_or_update_at_scope**](docs/DeploymentsApi.md#deployments_create_or_update_at_scope)<br/>**PUT** /{scope}/providers/Microsoft.Resources/deployments/{deploymentName}<br/>Deploys resources at a given scope.
*DeploymentsApi* | [**deployments_create_or_update_at_subscription_scope**](docs/DeploymentsApi.md#deployments_create_or_update_at_subscription_scope)<br/>**PUT** /subscriptions/{subscriptionId}/providers/Microsoft.Resources/deployments/{deploymentName}<br/>Deploys resources at subscription scope.
*DeploymentsApi* | [**deployments_create_or_update_at_tenant_scope**](docs/DeploymentsApi.md#deployments_create_or_update_at_tenant_scope)<br/>**PUT** /providers/Microsoft.Resources/deployments/{deploymentName}<br/>Deploys resources at tenant scope.
*DeploymentsApi* | [**deployments_delete**](docs/DeploymentsApi.md#deployments_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/Microsoft.Resources/deployments/{deploymentName}<br/>Deletes a deployment from the deployment history.
*DeploymentsApi* | [**deployments_delete_at_management_group_scope**](docs/DeploymentsApi.md#deployments_delete_at_management_group_scope)<br/>**DELETE** /providers/Microsoft.Management/managementGroups/{groupId}/providers/Microsoft.Resources/deployments/{deploymentName}<br/>Deletes a deployment from the deployment history.
*DeploymentsApi* | [**deployments_delete_at_scope**](docs/DeploymentsApi.md#deployments_delete_at_scope)<br/>**DELETE** /{scope}/providers/Microsoft.Resources/deployments/{deploymentName}<br/>Deletes a deployment from the deployment history.
*DeploymentsApi* | [**deployments_delete_at_subscription_scope**](docs/DeploymentsApi.md#deployments_delete_at_subscription_scope)<br/>**DELETE** /subscriptions/{subscriptionId}/providers/Microsoft.Resources/deployments/{deploymentName}<br/>Deletes a deployment from the deployment history.
*DeploymentsApi* | [**deployments_delete_at_tenant_scope**](docs/DeploymentsApi.md#deployments_delete_at_tenant_scope)<br/>**DELETE** /providers/Microsoft.Resources/deployments/{deploymentName}<br/>Deletes a deployment from the deployment history.
*DeploymentsApi* | [**deployments_export_template**](docs/DeploymentsApi.md#deployments_export_template)<br/>**POST** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/Microsoft.Resources/deployments/{deploymentName}/exportTemplate<br/>
*DeploymentsApi* | [**deployments_export_template_at_management_group_scope**](docs/DeploymentsApi.md#deployments_export_template_at_management_group_scope)<br/>**POST** /providers/Microsoft.Management/managementGroups/{groupId}/providers/Microsoft.Resources/deployments/{deploymentName}/exportTemplate<br/>
*DeploymentsApi* | [**deployments_export_template_at_scope**](docs/DeploymentsApi.md#deployments_export_template_at_scope)<br/>**POST** /{scope}/providers/Microsoft.Resources/deployments/{deploymentName}/exportTemplate<br/>
*DeploymentsApi* | [**deployments_export_template_at_subscription_scope**](docs/DeploymentsApi.md#deployments_export_template_at_subscription_scope)<br/>**POST** /subscriptions/{subscriptionId}/providers/Microsoft.Resources/deployments/{deploymentName}/exportTemplate<br/>
*DeploymentsApi* | [**deployments_export_template_at_tenant_scope**](docs/DeploymentsApi.md#deployments_export_template_at_tenant_scope)<br/>**POST** /providers/Microsoft.Resources/deployments/{deploymentName}/exportTemplate<br/>
*DeploymentsApi* | [**deployments_get**](docs/DeploymentsApi.md#deployments_get)<br/>**GET** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/Microsoft.Resources/deployments/{deploymentName}<br/>
*DeploymentsApi* | [**deployments_get_at_management_group_scope**](docs/DeploymentsApi.md#deployments_get_at_management_group_scope)<br/>**GET** /providers/Microsoft.Management/managementGroups/{groupId}/providers/Microsoft.Resources/deployments/{deploymentName}<br/>
*DeploymentsApi* | [**deployments_get_at_scope**](docs/DeploymentsApi.md#deployments_get_at_scope)<br/>**GET** /{scope}/providers/Microsoft.Resources/deployments/{deploymentName}<br/>
*DeploymentsApi* | [**deployments_get_at_subscription_scope**](docs/DeploymentsApi.md#deployments_get_at_subscription_scope)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Resources/deployments/{deploymentName}<br/>
*DeploymentsApi* | [**deployments_get_at_tenant_scope**](docs/DeploymentsApi.md#deployments_get_at_tenant_scope)<br/>**GET** /providers/Microsoft.Resources/deployments/{deploymentName}<br/>
*DeploymentsApi* | [**deployments_list_at_management_group_scope**](docs/DeploymentsApi.md#deployments_list_at_management_group_scope)<br/>**GET** /providers/Microsoft.Management/managementGroups/{groupId}/providers/Microsoft.Resources/deployments/<br/>
*DeploymentsApi* | [**deployments_list_at_scope**](docs/DeploymentsApi.md#deployments_list_at_scope)<br/>**GET** /{scope}/providers/Microsoft.Resources/deployments/<br/>
*DeploymentsApi* | [**deployments_list_at_subscription_scope**](docs/DeploymentsApi.md#deployments_list_at_subscription_scope)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Resources/deployments/<br/>
*DeploymentsApi* | [**deployments_list_at_tenant_scope**](docs/DeploymentsApi.md#deployments_list_at_tenant_scope)<br/>**GET** /providers/Microsoft.Resources/deployments/<br/>
*DeploymentsApi* | [**deployments_list_by_resource_group**](docs/DeploymentsApi.md#deployments_list_by_resource_group)<br/>**GET** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/Microsoft.Resources/deployments/<br/>
*DeploymentsApi* | [**deployments_validate**](docs/DeploymentsApi.md#deployments_validate)<br/>**POST** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/Microsoft.Resources/deployments/{deploymentName}/validate<br/>
*DeploymentsApi* | [**deployments_validate_at_management_group_scope**](docs/DeploymentsApi.md#deployments_validate_at_management_group_scope)<br/>**POST** /providers/Microsoft.Management/managementGroups/{groupId}/providers/Microsoft.Resources/deployments/{deploymentName}/validate<br/>
*DeploymentsApi* | [**deployments_validate_at_scope**](docs/DeploymentsApi.md#deployments_validate_at_scope)<br/>**POST** /{scope}/providers/Microsoft.Resources/deployments/{deploymentName}/validate<br/>
*DeploymentsApi* | [**deployments_validate_at_subscription_scope**](docs/DeploymentsApi.md#deployments_validate_at_subscription_scope)<br/>**POST** /subscriptions/{subscriptionId}/providers/Microsoft.Resources/deployments/{deploymentName}/validate<br/>
*DeploymentsApi* | [**deployments_validate_at_tenant_scope**](docs/DeploymentsApi.md#deployments_validate_at_tenant_scope)<br/>**POST** /providers/Microsoft.Resources/deployments/{deploymentName}/validate<br/>
*DeploymentsApi* | [**deployments_what_if**](docs/DeploymentsApi.md#deployments_what_if)<br/>**POST** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/Microsoft.Resources/deployments/{deploymentName}/whatIf<br/>
*DeploymentsApi* | [**deployments_what_if_at_management_group_scope**](docs/DeploymentsApi.md#deployments_what_if_at_management_group_scope)<br/>**POST** /providers/Microsoft.Management/managementGroups/{groupId}/providers/Microsoft.Resources/deployments/{deploymentName}/whatIf<br/>
*DeploymentsApi* | [**deployments_what_if_at_subscription_scope**](docs/DeploymentsApi.md#deployments_what_if_at_subscription_scope)<br/>**POST** /subscriptions/{subscriptionId}/providers/Microsoft.Resources/deployments/{deploymentName}/whatIf<br/>
*DeploymentsApi* | [**deployments_what_if_at_tenant_scope**](docs/DeploymentsApi.md#deployments_what_if_at_tenant_scope)<br/>**POST** /providers/Microsoft.Resources/deployments/{deploymentName}/whatIf<br/>
*OperationsApi* | [**operations_list**](docs/OperationsApi.md#operations_list)<br/>**GET** /providers/Microsoft.Resources/operations<br/>
*ProvidersApi* | [**providers_get**](docs/ProvidersApi.md#providers_get)<br/>**GET** /subscriptions/{subscriptionId}/providers/{resourceProviderNamespace}<br/>
*ProvidersApi* | [**providers_get_at_tenant_scope**](docs/ProvidersApi.md#providers_get_at_tenant_scope)<br/>**GET** /providers/{resourceProviderNamespace}<br/>
*ProvidersApi* | [**providers_list**](docs/ProvidersApi.md#providers_list)<br/>**GET** /subscriptions/{subscriptionId}/providers<br/>
*ProvidersApi* | [**providers_list_at_tenant_scope**](docs/ProvidersApi.md#providers_list_at_tenant_scope)<br/>**GET** /providers<br/>
*ProvidersApi* | [**providers_register**](docs/ProvidersApi.md#providers_register)<br/>**POST** /subscriptions/{subscriptionId}/providers/{resourceProviderNamespace}/register<br/>
*ProvidersApi* | [**providers_unregister**](docs/ProvidersApi.md#providers_unregister)<br/>**POST** /subscriptions/{subscriptionId}/providers/{resourceProviderNamespace}/unregister<br/>
*ResourceGroupsApi* | [**resource_groups_check_existence**](docs/ResourceGroupsApi.md#resource_groups_check_existence)<br/>**HEAD** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}<br/>
*ResourceGroupsApi* | [**resource_groups_create_or_update**](docs/ResourceGroupsApi.md#resource_groups_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}<br/>
*ResourceGroupsApi* | [**resource_groups_delete**](docs/ResourceGroupsApi.md#resource_groups_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}<br/>Deletes a resource group.
*ResourceGroupsApi* | [**resource_groups_export_template**](docs/ResourceGroupsApi.md#resource_groups_export_template)<br/>**POST** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/exportTemplate<br/>
*ResourceGroupsApi* | [**resource_groups_get**](docs/ResourceGroupsApi.md#resource_groups_get)<br/>**GET** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}<br/>
*ResourceGroupsApi* | [**resource_groups_list**](docs/ResourceGroupsApi.md#resource_groups_list)<br/>**GET** /subscriptions/{subscriptionId}/resourcegroups<br/>
*ResourceGroupsApi* | [**resource_groups_update**](docs/ResourceGroupsApi.md#resource_groups_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}<br/>Updates a resource group.
*ResourceGroupsApi* | [**resources_list_by_resource_group**](docs/ResourceGroupsApi.md#resources_list_by_resource_group)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/resources<br/>
*ResourcesApi* | [**resources_check_existence**](docs/ResourcesApi.md#resources_check_existence)<br/>**HEAD** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{parentResourcePath}/{resourceType}/{resourceName}<br/>
*ResourcesApi* | [**resources_check_existence_by_id**](docs/ResourcesApi.md#resources_check_existence_by_id)<br/>**HEAD** /{resourceId}<br/>
*ResourcesApi* | [**resources_create_or_update**](docs/ResourcesApi.md#resources_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{parentResourcePath}/{resourceType}/{resourceName}<br/>
*ResourcesApi* | [**resources_create_or_update_by_id**](docs/ResourcesApi.md#resources_create_or_update_by_id)<br/>**PUT** /{resourceId}<br/>
*ResourcesApi* | [**resources_delete**](docs/ResourcesApi.md#resources_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{parentResourcePath}/{resourceType}/{resourceName}<br/>
*ResourcesApi* | [**resources_delete_by_id**](docs/ResourcesApi.md#resources_delete_by_id)<br/>**DELETE** /{resourceId}<br/>
*ResourcesApi* | [**resources_get**](docs/ResourcesApi.md#resources_get)<br/>**GET** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{parentResourcePath}/{resourceType}/{resourceName}<br/>
*ResourcesApi* | [**resources_get_by_id**](docs/ResourcesApi.md#resources_get_by_id)<br/>**GET** /{resourceId}<br/>
*ResourcesApi* | [**resources_list**](docs/ResourcesApi.md#resources_list)<br/>**GET** /subscriptions/{subscriptionId}/resources<br/>
*ResourcesApi* | [**resources_move_resources**](docs/ResourcesApi.md#resources_move_resources)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{sourceResourceGroupName}/moveResources<br/>Moves resources from one resource group to another resource group.
*ResourcesApi* | [**resources_update**](docs/ResourcesApi.md#resources_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourcegroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{parentResourcePath}/{resourceType}/{resourceName}<br/>
*ResourcesApi* | [**resources_update_by_id**](docs/ResourcesApi.md#resources_update_by_id)<br/>**PATCH** /{resourceId}<br/>
*ResourcesApi* | [**resources_validate_move_resources**](docs/ResourcesApi.md#resources_validate_move_resources)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{sourceResourceGroupName}/validateMoveResources<br/>Validates whether resources can be moved from one resource group to another resource group.
*TagsApi* | [**tags_create_or_update**](docs/TagsApi.md#tags_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/tagNames/{tagName}<br/>Creates a predefined tag name.
*TagsApi* | [**tags_create_or_update_at_scope**](docs/TagsApi.md#tags_create_or_update_at_scope)<br/>**PUT** /{scope}/providers/Microsoft.Resources/tags/default<br/>Creates or updates the entire set of tags on a resource or subscription.
*TagsApi* | [**tags_create_or_update_value**](docs/TagsApi.md#tags_create_or_update_value)<br/>**PUT** /subscriptions/{subscriptionId}/tagNames/{tagName}/tagValues/{tagValue}<br/>Creates a predefined value for a predefined tag name.
*TagsApi* | [**tags_delete**](docs/TagsApi.md#tags_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/tagNames/{tagName}<br/>Deletes a predefined tag name.
*TagsApi* | [**tags_delete_at_scope**](docs/TagsApi.md#tags_delete_at_scope)<br/>**DELETE** /{scope}/providers/Microsoft.Resources/tags/default<br/>Deletes the entire set of tags on a resource or subscription.
*TagsApi* | [**tags_delete_value**](docs/TagsApi.md#tags_delete_value)<br/>**DELETE** /subscriptions/{subscriptionId}/tagNames/{tagName}/tagValues/{tagValue}<br/>Deletes a predefined tag value for a predefined tag name.
*TagsApi* | [**tags_get_at_scope**](docs/TagsApi.md#tags_get_at_scope)<br/>**GET** /{scope}/providers/Microsoft.Resources/tags/default<br/>Gets the entire set of tags on a resource or subscription.
*TagsApi* | [**tags_list**](docs/TagsApi.md#tags_list)<br/>**GET** /subscriptions/{subscriptionId}/tagNames<br/>Gets a summary of tag usage under the subscription.
*TagsApi* | [**tags_update_at_scope**](docs/TagsApi.md#tags_update_at_scope)<br/>**PATCH** /{scope}/providers/Microsoft.Resources/tags/default<br/>Selectively updates the set of tags on a resource or subscription.


## Models

 - [Alias](docs/Alias.md)
 - [AliasPath](docs/AliasPath.md)
 - [AliasPattern](docs/AliasPattern.md)
 - [BasicDependency](docs/BasicDependency.md)
 - [CloudError](docs/CloudError.md)
 - [DebugSetting](docs/DebugSetting.md)
 - [Dependency](docs/Dependency.md)
 - [Deployment](docs/Deployment.md)
 - [DeploymentExportResult](docs/DeploymentExportResult.md)
 - [DeploymentExtended](docs/DeploymentExtended.md)
 - [DeploymentExtendedFilter](docs/DeploymentExtendedFilter.md)
 - [DeploymentListResult](docs/DeploymentListResult.md)
 - [DeploymentOperation](docs/DeploymentOperation.md)
 - [DeploymentOperationProperties](docs/DeploymentOperationProperties.md)
 - [DeploymentOperationsListResult](docs/DeploymentOperationsListResult.md)
 - [DeploymentProperties](docs/DeploymentProperties.md)
 - [DeploymentPropertiesExtended](docs/DeploymentPropertiesExtended.md)
 - [DeploymentValidateResult](docs/DeploymentValidateResult.md)
 - [DeploymentWhatIf](docs/DeploymentWhatIf.md)
 - [DeploymentWhatIfProperties](docs/DeploymentWhatIfProperties.md)
 - [DeploymentWhatIfSettings](docs/DeploymentWhatIfSettings.md)
 - [ErrorAdditionalInfo](docs/ErrorAdditionalInfo.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [ExportTemplateRequest](docs/ExportTemplateRequest.md)
 - [GenericResource](docs/GenericResource.md)
 - [GenericResourceExpanded](docs/GenericResourceExpanded.md)
 - [GenericResourceFilter](docs/GenericResourceFilter.md)
 - [HttpMessage](docs/HttpMessage.md)
 - [Identity](docs/Identity.md)
 - [IdentityUserAssignedIdentitiesValue](docs/IdentityUserAssignedIdentitiesValue.md)
 - [OnErrorDeployment](docs/OnErrorDeployment.md)
 - [OnErrorDeploymentExtended](docs/OnErrorDeploymentExtended.md)
 - [Operation](docs/Operation.md)
 - [OperationDisplay](docs/OperationDisplay.md)
 - [OperationListResult](docs/OperationListResult.md)
 - [ParametersLink](docs/ParametersLink.md)
 - [Plan](docs/Plan.md)
 - [Provider](docs/Provider.md)
 - [ProviderListResult](docs/ProviderListResult.md)
 - [ProviderResourceType](docs/ProviderResourceType.md)
 - [Resource](docs/Resource.md)
 - [ResourceGroup](docs/ResourceGroup.md)
 - [ResourceGroupExportResult](docs/ResourceGroupExportResult.md)
 - [ResourceGroupFilter](docs/ResourceGroupFilter.md)
 - [ResourceGroupListResult](docs/ResourceGroupListResult.md)
 - [ResourceGroupPatchable](docs/ResourceGroupPatchable.md)
 - [ResourceGroupProperties](docs/ResourceGroupProperties.md)
 - [ResourceListResult](docs/ResourceListResult.md)
 - [ResourceProviderOperationDisplayProperties](docs/ResourceProviderOperationDisplayProperties.md)
 - [ResourceReference](docs/ResourceReference.md)
 - [ResourcesMoveInfo](docs/ResourcesMoveInfo.md)
 - [ScopedDeployment](docs/ScopedDeployment.md)
 - [ScopedDeploymentWhatIf](docs/ScopedDeploymentWhatIf.md)
 - [Sku](docs/Sku.md)
 - [StatusMessage](docs/StatusMessage.md)
 - [SubResource](docs/SubResource.md)
 - [TagCount](docs/TagCount.md)
 - [TagDetails](docs/TagDetails.md)
 - [TagValue](docs/TagValue.md)
 - [Tags](docs/Tags.md)
 - [TagsListResult](docs/TagsListResult.md)
 - [TagsPatchResource](docs/TagsPatchResource.md)
 - [TagsResource](docs/TagsResource.md)
 - [TargetResource](docs/TargetResource.md)
 - [TemplateHashResult](docs/TemplateHashResult.md)
 - [TemplateLink](docs/TemplateLink.md)
 - [WhatIfChange](docs/WhatIfChange.md)
 - [WhatIfOperationProperties](docs/WhatIfOperationProperties.md)
 - [WhatIfOperationResult](docs/WhatIfOperationResult.md)
 - [WhatIfPropertyChange](docs/WhatIfPropertyChange.md)


## Authorization

## azure_auth
- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://login.microsoftonline.com/common/oauth2/authorize
- **Scopes**: 
 - **user_impersonation**: impersonate your user account

Example
```
    using OpenAPI
    using OpenAPI.Clients
    import OpenAPI.Clients: Client, set_header
    client = Client(server_uri)
    set_header(client, "Authorization", "Bearer $bearer_auth")
    api = MyApi(client)
    result = callApi(api, args...; api_key)
```

## Author



