# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""GenericResource
Resource information.

    GenericResource(;
        plan=nothing,
        properties=nothing,
        kind=nothing,
        managedBy=nothing,
        sku=nothing,
        identity=nothing,
        id=nothing,
        name=nothing,
        type=nothing,
        location=nothing,
        tags=nothing,
    )

    - plan::Plan
    - properties::Any : The resource properties.
    - kind::String : The kind of the resource.
    - managedBy::String : ID of the resource that manages this resource.
    - sku::Sku
    - identity::Identity
    - id::String : Resource ID
    - name::String : Resource name
    - type::String : Resource type
    - location::String : Resource location
    - tags::Dict{String, String} : Resource tags
"""
Base.@kwdef mutable struct GenericResource <: OpenAPI.APIModel
    plan = nothing # spec type: Union{ Nothing, Plan }
    properties::Union{Nothing, Any} = nothing
    kind::Union{Nothing, String} = nothing
    managedBy::Union{Nothing, String} = nothing
    sku = nothing # spec type: Union{ Nothing, Sku }
    identity = nothing # spec type: Union{ Nothing, Identity }
    id::Union{Nothing, String} = nothing
    name::Union{Nothing, String} = nothing
    type::Union{Nothing, String} = nothing
    location::Union{Nothing, String} = nothing
    tags::Union{Nothing, Dict{String, String}} = nothing

    function GenericResource(plan, properties, kind, managedBy, sku, identity, id, name, type, location, tags, )
        OpenAPI.validate_property(GenericResource, Symbol("plan"), plan)
        OpenAPI.validate_property(GenericResource, Symbol("properties"), properties)
        OpenAPI.validate_property(GenericResource, Symbol("kind"), kind)
        OpenAPI.validate_property(GenericResource, Symbol("managedBy"), managedBy)
        OpenAPI.validate_property(GenericResource, Symbol("sku"), sku)
        OpenAPI.validate_property(GenericResource, Symbol("identity"), identity)
        OpenAPI.validate_property(GenericResource, Symbol("id"), id)
        OpenAPI.validate_property(GenericResource, Symbol("name"), name)
        OpenAPI.validate_property(GenericResource, Symbol("type"), type)
        OpenAPI.validate_property(GenericResource, Symbol("location"), location)
        OpenAPI.validate_property(GenericResource, Symbol("tags"), tags)
        return new(plan, properties, kind, managedBy, sku, identity, id, name, type, location, tags, )
    end
end # type GenericResource

const _property_types_GenericResource = Dict{Symbol,String}(Symbol("plan")=>"Plan", Symbol("properties")=>"Any", Symbol("kind")=>"String", Symbol("managedBy")=>"String", Symbol("sku")=>"Sku", Symbol("identity")=>"Identity", Symbol("id")=>"String", Symbol("name")=>"String", Symbol("type")=>"String", Symbol("location")=>"String", Symbol("tags")=>"Dict{String, String}", )
OpenAPI.property_type(::Type{ GenericResource }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_GenericResource[name]))}

function check_required(o::GenericResource)
    true
end

function OpenAPI.validate_property(::Type{ GenericResource }, name::Symbol, val)
    if name === Symbol("kind")
        OpenAPI.validate_param(name, "GenericResource", :pattern, val, r"^[-\w\._,\(\)]+$")
    end
end
