# Julia API client for SubscriptionClient

All resource groups and resources exist within subscriptions. These operation enable you get information about your subscriptions and tenants. A tenant is a dedicated instance of Azure Active Directory (Azure AD) for your organization.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 2020-01-01
- Build package: org.openapitools.codegen.languages.JuliaClientCodegen


## Installation
Place the Julia files generated under the `src` folder in your Julia project. Include SubscriptionClient.jl in the project code.
It would include the module named SubscriptionClient.

Documentation is generated as markdown files under the `docs` folder. You can include them in your project documentation.
Documentation is also embedded in Julia which can be used with a Julia specific documentation generator.

## API Endpoints

Class | Method
------------ | -------------
*OperationsApi* | [**operations_list**](docs/OperationsApi.md#operations_list)<br/>**GET** /providers/Microsoft.Resources/operations<br/>
*SubscriptionsApi* | [**subscriptions_get**](docs/SubscriptionsApi.md#subscriptions_get)<br/>**GET** /subscriptions/{subscriptionId}<br/>
*SubscriptionsApi* | [**subscriptions_list**](docs/SubscriptionsApi.md#subscriptions_list)<br/>**GET** /subscriptions<br/>
*SubscriptionsApi* | [**subscriptions_list_locations**](docs/SubscriptionsApi.md#subscriptions_list_locations)<br/>**GET** /subscriptions/{subscriptionId}/locations<br/>Gets all available geo-locations.
*TenantsApi* | [**tenants_list**](docs/TenantsApi.md#tenants_list)<br/>**GET** /tenants<br/>


## Models

 - [Location](docs/Location.md)
 - [LocationListResult](docs/LocationListResult.md)
 - [LocationMetadata](docs/LocationMetadata.md)
 - [ManagedByTenant](docs/ManagedByTenant.md)
 - [Operation](docs/Operation.md)
 - [OperationDisplay](docs/OperationDisplay.md)
 - [OperationListResult](docs/OperationListResult.md)
 - [PairedRegion](docs/PairedRegion.md)
 - [Subscription](docs/Subscription.md)
 - [SubscriptionListResult](docs/SubscriptionListResult.md)
 - [SubscriptionPolicies](docs/SubscriptionPolicies.md)
 - [TenantIdDescription](docs/TenantIdDescription.md)
 - [TenantListResult](docs/TenantListResult.md)


## Authorization

## azure_auth
- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://login.microsoftonline.com/common/oauth2/authorize
- **Scopes**: 
 - **user_impersonation**: impersonate your user account

Example
```
    using OpenAPI
    using OpenAPI.Clients
    import OpenAPI.Clients: Client, set_header
    client = Client(server_uri)
    set_header(client, "Authorization", "Bearer $bearer_auth")
    api = MyApi(client)
    result = callApi(api, args...; api_key)
```

## Author



