# Julia API client for StorageManagementClient

The Azure Storage Management API.

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 2019-06-01
- Build package: org.openapitools.codegen.languages.JuliaClientCodegen


## Installation
Place the Julia files generated under the `src` folder in your Julia project. Include StorageManagementClient.jl in the project code.
It would include the module named StorageManagementClient.

Documentation is generated as markdown files under the `docs` folder. You can include them in your project documentation.
Documentation is also embedded in Julia which can be used with a Julia specific documentation generator.

## API Endpoints

Class | Method
------------ | -------------
*EncryptionScopesApi* | [**encryption_scopes_get**](docs/EncryptionScopesApi.md#encryption_scopes_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/encryptionScopes/{encryptionScopeName}<br/>
*EncryptionScopesApi* | [**encryption_scopes_list**](docs/EncryptionScopesApi.md#encryption_scopes_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/encryptionScopes<br/>
*EncryptionScopesApi* | [**encryption_scopes_patch**](docs/EncryptionScopesApi.md#encryption_scopes_patch)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/encryptionScopes/{encryptionScopeName}<br/>
*EncryptionScopesApi* | [**encryption_scopes_put**](docs/EncryptionScopesApi.md#encryption_scopes_put)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/encryptionScopes/{encryptionScopeName}<br/>
*LocationUsageApi* | [**usages_list_by_location**](docs/LocationUsageApi.md#usages_list_by_location)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Storage/locations/{location}/usages<br/>
*ManagementPoliciesApi* | [**management_policies_create_or_update**](docs/ManagementPoliciesApi.md#management_policies_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/managementPolicies/{managementPolicyName}<br/>
*ManagementPoliciesApi* | [**management_policies_delete**](docs/ManagementPoliciesApi.md#management_policies_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/managementPolicies/{managementPolicyName}<br/>
*ManagementPoliciesApi* | [**management_policies_get**](docs/ManagementPoliciesApi.md#management_policies_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/managementPolicies/{managementPolicyName}<br/>
*ObjectReplicationPoliciesApi* | [**object_replication_policies_create_or_update**](docs/ObjectReplicationPoliciesApi.md#object_replication_policies_create_or_update)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/objectReplicationPolicies/{objectReplicationPolicyId}<br/>
*ObjectReplicationPoliciesApi* | [**object_replication_policies_delete**](docs/ObjectReplicationPoliciesApi.md#object_replication_policies_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/objectReplicationPolicies/{objectReplicationPolicyId}<br/>
*ObjectReplicationPoliciesApi* | [**object_replication_policies_get**](docs/ObjectReplicationPoliciesApi.md#object_replication_policies_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/objectReplicationPolicies/{objectReplicationPolicyId}<br/>
*ObjectReplicationPoliciesApi* | [**object_replication_policies_list**](docs/ObjectReplicationPoliciesApi.md#object_replication_policies_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/objectReplicationPolicies<br/>
*OperationsApi* | [**operations_list**](docs/OperationsApi.md#operations_list)<br/>**GET** /providers/Microsoft.Storage/operations<br/>
*PrivateEndpointConnectionsApi* | [**private_endpoint_connections_delete**](docs/PrivateEndpointConnectionsApi.md#private_endpoint_connections_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/privateEndpointConnections/{privateEndpointConnectionName}<br/>
*PrivateEndpointConnectionsApi* | [**private_endpoint_connections_get**](docs/PrivateEndpointConnectionsApi.md#private_endpoint_connections_get)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/privateEndpointConnections/{privateEndpointConnectionName}<br/>
*PrivateEndpointConnectionsApi* | [**private_endpoint_connections_list**](docs/PrivateEndpointConnectionsApi.md#private_endpoint_connections_list)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/privateEndpointConnections<br/>
*PrivateEndpointConnectionsApi* | [**private_endpoint_connections_put**](docs/PrivateEndpointConnectionsApi.md#private_endpoint_connections_put)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/privateEndpointConnections/{privateEndpointConnectionName}<br/>
*PrivateLinkResourcesApi* | [**private_link_resources_list_by_storage_account**](docs/PrivateLinkResourcesApi.md#private_link_resources_list_by_storage_account)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/privateLinkResources<br/>
*SkusApi* | [**skus_list**](docs/SkusApi.md#skus_list)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Storage/skus<br/>
*StorageAccountsApi* | [**storage_accounts_check_name_availability**](docs/StorageAccountsApi.md#storage_accounts_check_name_availability)<br/>**POST** /subscriptions/{subscriptionId}/providers/Microsoft.Storage/checkNameAvailability<br/>
*StorageAccountsApi* | [**storage_accounts_create**](docs/StorageAccountsApi.md#storage_accounts_create)<br/>**PUT** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}<br/>
*StorageAccountsApi* | [**storage_accounts_delete**](docs/StorageAccountsApi.md#storage_accounts_delete)<br/>**DELETE** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}<br/>
*StorageAccountsApi* | [**storage_accounts_failover**](docs/StorageAccountsApi.md#storage_accounts_failover)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/failover<br/>
*StorageAccountsApi* | [**storage_accounts_get_properties**](docs/StorageAccountsApi.md#storage_accounts_get_properties)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}<br/>
*StorageAccountsApi* | [**storage_accounts_list**](docs/StorageAccountsApi.md#storage_accounts_list)<br/>**GET** /subscriptions/{subscriptionId}/providers/Microsoft.Storage/storageAccounts<br/>
*StorageAccountsApi* | [**storage_accounts_list_account_s_a_s**](docs/StorageAccountsApi.md#storage_accounts_list_account_s_a_s)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/ListAccountSas<br/>
*StorageAccountsApi* | [**storage_accounts_list_by_resource_group**](docs/StorageAccountsApi.md#storage_accounts_list_by_resource_group)<br/>**GET** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts<br/>
*StorageAccountsApi* | [**storage_accounts_list_keys**](docs/StorageAccountsApi.md#storage_accounts_list_keys)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/listKeys<br/>
*StorageAccountsApi* | [**storage_accounts_list_service_s_a_s**](docs/StorageAccountsApi.md#storage_accounts_list_service_s_a_s)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/ListServiceSas<br/>
*StorageAccountsApi* | [**storage_accounts_regenerate_key**](docs/StorageAccountsApi.md#storage_accounts_regenerate_key)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/regenerateKey<br/>
*StorageAccountsApi* | [**storage_accounts_restore_blob_ranges**](docs/StorageAccountsApi.md#storage_accounts_restore_blob_ranges)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/restoreBlobRanges<br/>
*StorageAccountsApi* | [**storage_accounts_revoke_user_delegation_keys**](docs/StorageAccountsApi.md#storage_accounts_revoke_user_delegation_keys)<br/>**POST** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/revokeUserDelegationKeys<br/>
*StorageAccountsApi* | [**storage_accounts_update**](docs/StorageAccountsApi.md#storage_accounts_update)<br/>**PATCH** /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}<br/>


## Models

 - [AccountSasParameters](docs/AccountSasParameters.md)
 - [ActiveDirectoryProperties](docs/ActiveDirectoryProperties.md)
 - [AzureFilesIdentityBasedAuthentication](docs/AzureFilesIdentityBasedAuthentication.md)
 - [BlobRestoreParameters](docs/BlobRestoreParameters.md)
 - [BlobRestoreRange](docs/BlobRestoreRange.md)
 - [BlobRestoreStatus](docs/BlobRestoreStatus.md)
 - [CheckNameAvailabilityResult](docs/CheckNameAvailabilityResult.md)
 - [CustomDomain](docs/CustomDomain.md)
 - [DateAfterCreation](docs/DateAfterCreation.md)
 - [DateAfterModification](docs/DateAfterModification.md)
 - [Dimension](docs/Dimension.md)
 - [Encryption](docs/Encryption.md)
 - [EncryptionScope](docs/EncryptionScope.md)
 - [EncryptionScopeKeyVaultProperties](docs/EncryptionScopeKeyVaultProperties.md)
 - [EncryptionScopeListResult](docs/EncryptionScopeListResult.md)
 - [EncryptionScopeProperties](docs/EncryptionScopeProperties.md)
 - [EncryptionService](docs/EncryptionService.md)
 - [EncryptionServices](docs/EncryptionServices.md)
 - [Endpoints](docs/Endpoints.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [GeoReplicationStats](docs/GeoReplicationStats.md)
 - [IPRule](docs/IPRule.md)
 - [Identity](docs/Identity.md)
 - [KeyVaultProperties](docs/KeyVaultProperties.md)
 - [ListAccountSasResponse](docs/ListAccountSasResponse.md)
 - [ListServiceSasResponse](docs/ListServiceSasResponse.md)
 - [ManagementPolicy](docs/ManagementPolicy.md)
 - [ManagementPolicyAction](docs/ManagementPolicyAction.md)
 - [ManagementPolicyBaseBlob](docs/ManagementPolicyBaseBlob.md)
 - [ManagementPolicyDefinition](docs/ManagementPolicyDefinition.md)
 - [ManagementPolicyFilter](docs/ManagementPolicyFilter.md)
 - [ManagementPolicyProperties](docs/ManagementPolicyProperties.md)
 - [ManagementPolicyRule](docs/ManagementPolicyRule.md)
 - [ManagementPolicySchema](docs/ManagementPolicySchema.md)
 - [ManagementPolicySnapShot](docs/ManagementPolicySnapShot.md)
 - [MetricSpecification](docs/MetricSpecification.md)
 - [NetworkRuleSet](docs/NetworkRuleSet.md)
 - [ObjectReplicationPolicies](docs/ObjectReplicationPolicies.md)
 - [ObjectReplicationPolicy](docs/ObjectReplicationPolicy.md)
 - [ObjectReplicationPolicyFilter](docs/ObjectReplicationPolicyFilter.md)
 - [ObjectReplicationPolicyProperties](docs/ObjectReplicationPolicyProperties.md)
 - [ObjectReplicationPolicyRule](docs/ObjectReplicationPolicyRule.md)
 - [Operation](docs/Operation.md)
 - [OperationDisplay](docs/OperationDisplay.md)
 - [OperationListResult](docs/OperationListResult.md)
 - [OperationProperties](docs/OperationProperties.md)
 - [PrivateEndpoint](docs/PrivateEndpoint.md)
 - [PrivateEndpointConnection](docs/PrivateEndpointConnection.md)
 - [PrivateEndpointConnectionListResult](docs/PrivateEndpointConnectionListResult.md)
 - [PrivateEndpointConnectionProperties](docs/PrivateEndpointConnectionProperties.md)
 - [PrivateEndpointConnectionProvisioningState](docs/PrivateEndpointConnectionProvisioningState.md)
 - [PrivateEndpointServiceConnectionStatus](docs/PrivateEndpointServiceConnectionStatus.md)
 - [PrivateLinkResource](docs/PrivateLinkResource.md)
 - [PrivateLinkResourceListResult](docs/PrivateLinkResourceListResult.md)
 - [PrivateLinkResourceProperties](docs/PrivateLinkResourceProperties.md)
 - [PrivateLinkServiceConnectionState](docs/PrivateLinkServiceConnectionState.md)
 - [Resource](docs/Resource.md)
 - [Restriction](docs/Restriction.md)
 - [RoutingPreference](docs/RoutingPreference.md)
 - [SKUCapability](docs/SKUCapability.md)
 - [ServiceSasParameters](docs/ServiceSasParameters.md)
 - [ServiceSpecification](docs/ServiceSpecification.md)
 - [Sku](docs/Sku.md)
 - [SkuInformation](docs/SkuInformation.md)
 - [SkuName](docs/SkuName.md)
 - [StorageAccount](docs/StorageAccount.md)
 - [StorageAccountCheckNameAvailabilityParameters](docs/StorageAccountCheckNameAvailabilityParameters.md)
 - [StorageAccountCreateParameters](docs/StorageAccountCreateParameters.md)
 - [StorageAccountInternetEndpoints](docs/StorageAccountInternetEndpoints.md)
 - [StorageAccountKey](docs/StorageAccountKey.md)
 - [StorageAccountListKeysResult](docs/StorageAccountListKeysResult.md)
 - [StorageAccountListResult](docs/StorageAccountListResult.md)
 - [StorageAccountMicrosoftEndpoints](docs/StorageAccountMicrosoftEndpoints.md)
 - [StorageAccountProperties](docs/StorageAccountProperties.md)
 - [StorageAccountPropertiesCreateParameters](docs/StorageAccountPropertiesCreateParameters.md)
 - [StorageAccountPropertiesUpdateParameters](docs/StorageAccountPropertiesUpdateParameters.md)
 - [StorageAccountRegenerateKeyParameters](docs/StorageAccountRegenerateKeyParameters.md)
 - [StorageAccountUpdateParameters](docs/StorageAccountUpdateParameters.md)
 - [StorageSkuListResult](docs/StorageSkuListResult.md)
 - [TagFilter](docs/TagFilter.md)
 - [Tier](docs/Tier.md)
 - [TrackedResource](docs/TrackedResource.md)
 - [Usage](docs/Usage.md)
 - [UsageListResult](docs/UsageListResult.md)
 - [UsageName](docs/UsageName.md)
 - [VirtualNetworkRule](docs/VirtualNetworkRule.md)


## Authorization

## azure_auth
- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://login.microsoftonline.com/common/oauth2/authorize
- **Scopes**: 
 - **user_impersonation**: impersonate your user account

Example
```
    using OpenAPI
    using OpenAPI.Clients
    import OpenAPI.Clients: Client, set_header
    client = Client(server_uri)
    set_header(client, "Authorization", "Bearer $bearer_auth")
    api = MyApi(client)
    result = callApi(api, args...; api_key)
```

## Author



