# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct ObjectReplicationPoliciesApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `ObjectReplicationPoliciesApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ ObjectReplicationPoliciesApi }) = "https://management.azure.com"

const _returntypes_object_replication_policies_create_or_update_ObjectReplicationPoliciesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ObjectReplicationPolicy,
    Regex("^" * replace("0", "x"=>".") * "\$") => ErrorResponse,
)

function _oacinternal_object_replication_policies_create_or_update(_api::ObjectReplicationPoliciesApi, resource_group_name::String, account_name::String, api_version::String, subscription_id::String, object_replication_policy_id::String, properties::ObjectReplicationPolicy; _mediaType=nothing)
    OpenAPI.validate_param("resource_group_name", "object_replication_policies_create_or_update", :maxLength, resource_group_name, 90)
    OpenAPI.validate_param("resource_group_name", "object_replication_policies_create_or_update", :minLength, resource_group_name, 1)

    OpenAPI.validate_param("account_name", "object_replication_policies_create_or_update", :maxLength, account_name, 24)
    OpenAPI.validate_param("account_name", "object_replication_policies_create_or_update", :minLength, account_name, 3)

    OpenAPI.validate_param("api_version", "object_replication_policies_create_or_update", :minLength, api_version, 1)

    OpenAPI.validate_param("subscription_id", "object_replication_policies_create_or_update", :minLength, subscription_id, 1)

    OpenAPI.validate_param("object_replication_policy_id", "object_replication_policies_create_or_update", :minLength, object_replication_policy_id, 1)

    _ctx = OpenAPI.Clients.Ctx(_api.client, "PUT", _returntypes_object_replication_policies_create_or_update_ObjectReplicationPoliciesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/objectReplicationPolicies/{objectReplicationPolicyId}", ["azure_auth", ], properties)
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "accountName", account_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "objectReplicationPolicyId", object_replication_policy_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Create or update the object replication policy of the storage account.

Params:
- resource_group_name::String (required)
- account_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- object_replication_policy_id::String (required)
- properties::ObjectReplicationPolicy (required)

Return: ObjectReplicationPolicy, OpenAPI.Clients.ApiResponse
"""
function object_replication_policies_create_or_update(_api::ObjectReplicationPoliciesApi, resource_group_name::String, account_name::String, api_version::String, subscription_id::String, object_replication_policy_id::String, properties::ObjectReplicationPolicy; _mediaType=nothing)
    _ctx = _oacinternal_object_replication_policies_create_or_update(_api, resource_group_name, account_name, api_version, subscription_id, object_replication_policy_id, properties; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function object_replication_policies_create_or_update(_api::ObjectReplicationPoliciesApi, response_stream::Channel, resource_group_name::String, account_name::String, api_version::String, subscription_id::String, object_replication_policy_id::String, properties::ObjectReplicationPolicy; _mediaType=nothing)
    _ctx = _oacinternal_object_replication_policies_create_or_update(_api, resource_group_name, account_name, api_version, subscription_id, object_replication_policy_id, properties; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_object_replication_policies_delete_ObjectReplicationPoliciesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("0", "x"=>".") * "\$") => ErrorResponse,
)

function _oacinternal_object_replication_policies_delete(_api::ObjectReplicationPoliciesApi, resource_group_name::String, account_name::String, api_version::String, subscription_id::String, object_replication_policy_id::String; _mediaType=nothing)
    OpenAPI.validate_param("resource_group_name", "object_replication_policies_delete", :maxLength, resource_group_name, 90)
    OpenAPI.validate_param("resource_group_name", "object_replication_policies_delete", :minLength, resource_group_name, 1)

    OpenAPI.validate_param("account_name", "object_replication_policies_delete", :maxLength, account_name, 24)
    OpenAPI.validate_param("account_name", "object_replication_policies_delete", :minLength, account_name, 3)

    OpenAPI.validate_param("api_version", "object_replication_policies_delete", :minLength, api_version, 1)

    OpenAPI.validate_param("subscription_id", "object_replication_policies_delete", :minLength, subscription_id, 1)

    OpenAPI.validate_param("object_replication_policy_id", "object_replication_policies_delete", :minLength, object_replication_policy_id, 1)

    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_object_replication_policies_delete_ObjectReplicationPoliciesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/objectReplicationPolicies/{objectReplicationPolicyId}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "accountName", account_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "objectReplicationPolicyId", object_replication_policy_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Deletes the object replication policy associated with the specified storage account.

Params:
- resource_group_name::String (required)
- account_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- object_replication_policy_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function object_replication_policies_delete(_api::ObjectReplicationPoliciesApi, resource_group_name::String, account_name::String, api_version::String, subscription_id::String, object_replication_policy_id::String; _mediaType=nothing)
    _ctx = _oacinternal_object_replication_policies_delete(_api, resource_group_name, account_name, api_version, subscription_id, object_replication_policy_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function object_replication_policies_delete(_api::ObjectReplicationPoliciesApi, response_stream::Channel, resource_group_name::String, account_name::String, api_version::String, subscription_id::String, object_replication_policy_id::String; _mediaType=nothing)
    _ctx = _oacinternal_object_replication_policies_delete(_api, resource_group_name, account_name, api_version, subscription_id, object_replication_policy_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_object_replication_policies_get_ObjectReplicationPoliciesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ObjectReplicationPolicy,
    Regex("^" * replace("0", "x"=>".") * "\$") => ErrorResponse,
)

function _oacinternal_object_replication_policies_get(_api::ObjectReplicationPoliciesApi, resource_group_name::String, account_name::String, api_version::String, subscription_id::String, object_replication_policy_id::String; _mediaType=nothing)
    OpenAPI.validate_param("resource_group_name", "object_replication_policies_get", :maxLength, resource_group_name, 90)
    OpenAPI.validate_param("resource_group_name", "object_replication_policies_get", :minLength, resource_group_name, 1)

    OpenAPI.validate_param("account_name", "object_replication_policies_get", :maxLength, account_name, 24)
    OpenAPI.validate_param("account_name", "object_replication_policies_get", :minLength, account_name, 3)

    OpenAPI.validate_param("api_version", "object_replication_policies_get", :minLength, api_version, 1)

    OpenAPI.validate_param("subscription_id", "object_replication_policies_get", :minLength, subscription_id, 1)

    OpenAPI.validate_param("object_replication_policy_id", "object_replication_policies_get", :minLength, object_replication_policy_id, 1)

    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_object_replication_policies_get_ObjectReplicationPoliciesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/objectReplicationPolicies/{objectReplicationPolicyId}", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "accountName", account_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "objectReplicationPolicyId", object_replication_policy_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Get the object replication policy of the storage account by policy ID.

Params:
- resource_group_name::String (required)
- account_name::String (required)
- api_version::String (required)
- subscription_id::String (required)
- object_replication_policy_id::String (required)

Return: ObjectReplicationPolicy, OpenAPI.Clients.ApiResponse
"""
function object_replication_policies_get(_api::ObjectReplicationPoliciesApi, resource_group_name::String, account_name::String, api_version::String, subscription_id::String, object_replication_policy_id::String; _mediaType=nothing)
    _ctx = _oacinternal_object_replication_policies_get(_api, resource_group_name, account_name, api_version, subscription_id, object_replication_policy_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function object_replication_policies_get(_api::ObjectReplicationPoliciesApi, response_stream::Channel, resource_group_name::String, account_name::String, api_version::String, subscription_id::String, object_replication_policy_id::String; _mediaType=nothing)
    _ctx = _oacinternal_object_replication_policies_get(_api, resource_group_name, account_name, api_version, subscription_id, object_replication_policy_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_object_replication_policies_list_ObjectReplicationPoliciesApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => ObjectReplicationPolicies,
    Regex("^" * replace("0", "x"=>".") * "\$") => ErrorResponse,
)

function _oacinternal_object_replication_policies_list(_api::ObjectReplicationPoliciesApi, resource_group_name::String, account_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    OpenAPI.validate_param("resource_group_name", "object_replication_policies_list", :maxLength, resource_group_name, 90)
    OpenAPI.validate_param("resource_group_name", "object_replication_policies_list", :minLength, resource_group_name, 1)

    OpenAPI.validate_param("account_name", "object_replication_policies_list", :maxLength, account_name, 24)
    OpenAPI.validate_param("account_name", "object_replication_policies_list", :minLength, account_name, 3)

    OpenAPI.validate_param("api_version", "object_replication_policies_list", :minLength, api_version, 1)

    OpenAPI.validate_param("subscription_id", "object_replication_policies_list", :minLength, subscription_id, 1)

    _ctx = OpenAPI.Clients.Ctx(_api.client, "GET", _returntypes_object_replication_policies_list_ObjectReplicationPoliciesApi, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Storage/storageAccounts/{accountName}/objectReplicationPolicies", ["azure_auth", ])
    OpenAPI.Clients.set_param(_ctx.path, "resourceGroupName", resource_group_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "accountName", account_name)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "subscriptionId", subscription_id)  # type String
    OpenAPI.Clients.set_param(_ctx.query, "api-version", api_version)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""List the object replication policies associated with the storage account.

Params:
- resource_group_name::String (required)
- account_name::String (required)
- api_version::String (required)
- subscription_id::String (required)

Return: ObjectReplicationPolicies, OpenAPI.Clients.ApiResponse
"""
function object_replication_policies_list(_api::ObjectReplicationPoliciesApi, resource_group_name::String, account_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_object_replication_policies_list(_api, resource_group_name, account_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function object_replication_policies_list(_api::ObjectReplicationPoliciesApi, response_stream::Channel, resource_group_name::String, account_name::String, api_version::String, subscription_id::String; _mediaType=nothing)
    _ctx = _oacinternal_object_replication_policies_list(_api, resource_group_name, account_name, api_version, subscription_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export object_replication_policies_create_or_update
export object_replication_policies_delete
export object_replication_policies_get
export object_replication_policies_list
