# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""BlobRestoreStatus
Blob restore status.

    BlobRestoreStatus(;
        status=nothing,
        failureReason=nothing,
        restoreId=nothing,
        parameters=nothing,
    )

    - status::String : The status of blob restore progress. Possible values are: - InProgress: Indicates that blob restore is ongoing. - Complete: Indicates that blob restore has been completed successfully. - Failed: Indicates that blob restore is failed.
    - failureReason::String : Failure reason when blob restore is failed.
    - restoreId::String : Id for tracking blob restore request.
    - parameters::BlobRestoreParameters
"""
Base.@kwdef mutable struct BlobRestoreStatus <: OpenAPI.APIModel
    status::Union{Nothing, String} = nothing
    failureReason::Union{Nothing, String} = nothing
    restoreId::Union{Nothing, String} = nothing
    parameters = nothing # spec type: Union{ Nothing, BlobRestoreParameters }

    function BlobRestoreStatus(status, failureReason, restoreId, parameters, )
        OpenAPI.validate_property(BlobRestoreStatus, Symbol("status"), status)
        OpenAPI.validate_property(BlobRestoreStatus, Symbol("failureReason"), failureReason)
        OpenAPI.validate_property(BlobRestoreStatus, Symbol("restoreId"), restoreId)
        OpenAPI.validate_property(BlobRestoreStatus, Symbol("parameters"), parameters)
        return new(status, failureReason, restoreId, parameters, )
    end
end # type BlobRestoreStatus

const _property_types_BlobRestoreStatus = Dict{Symbol,String}(Symbol("status")=>"String", Symbol("failureReason")=>"String", Symbol("restoreId")=>"String", Symbol("parameters")=>"BlobRestoreParameters", )
OpenAPI.property_type(::Type{ BlobRestoreStatus }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_BlobRestoreStatus[name]))}

function check_required(o::BlobRestoreStatus)
    true
end

function OpenAPI.validate_property(::Type{ BlobRestoreStatus }, name::Symbol, val)
    if name === Symbol("status")
        OpenAPI.validate_param(name, "BlobRestoreStatus", :enum, val, ["InProgress", "Complete", "Failed"])
    end
end
