# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""ObjectReplicationPolicyProperties
The Storage Account ObjectReplicationPolicy properties.

    ObjectReplicationPolicyProperties(;
        policyId=nothing,
        enabledTime=nothing,
        sourceAccount=nothing,
        destinationAccount=nothing,
        rules=nothing,
    )

    - policyId::String : A unique id for object replication policy.
    - enabledTime::ZonedDateTime : Indicates when the policy is enabled on the source account.
    - sourceAccount::String : Required. Source account name.
    - destinationAccount::String : Required. Destination account name.
    - rules::Vector{ObjectReplicationPolicyRule} : The storage account object replication rules.
"""
Base.@kwdef mutable struct ObjectReplicationPolicyProperties <: OpenAPI.APIModel
    policyId::Union{Nothing, String} = nothing
    enabledTime::Union{Nothing, ZonedDateTime} = nothing
    sourceAccount::Union{Nothing, String} = nothing
    destinationAccount::Union{Nothing, String} = nothing
    rules::Union{Nothing, Vector} = nothing # spec type: Union{ Nothing, Vector{ObjectReplicationPolicyRule} }

    function ObjectReplicationPolicyProperties(policyId, enabledTime, sourceAccount, destinationAccount, rules, )
        OpenAPI.validate_property(ObjectReplicationPolicyProperties, Symbol("policyId"), policyId)
        OpenAPI.validate_property(ObjectReplicationPolicyProperties, Symbol("enabledTime"), enabledTime)
        OpenAPI.validate_property(ObjectReplicationPolicyProperties, Symbol("sourceAccount"), sourceAccount)
        OpenAPI.validate_property(ObjectReplicationPolicyProperties, Symbol("destinationAccount"), destinationAccount)
        OpenAPI.validate_property(ObjectReplicationPolicyProperties, Symbol("rules"), rules)
        return new(policyId, enabledTime, sourceAccount, destinationAccount, rules, )
    end
end # type ObjectReplicationPolicyProperties

const _property_types_ObjectReplicationPolicyProperties = Dict{Symbol,String}(Symbol("policyId")=>"String", Symbol("enabledTime")=>"ZonedDateTime", Symbol("sourceAccount")=>"String", Symbol("destinationAccount")=>"String", Symbol("rules")=>"Vector{ObjectReplicationPolicyRule}", )
OpenAPI.property_type(::Type{ ObjectReplicationPolicyProperties }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_ObjectReplicationPolicyProperties[name]))}

function check_required(o::ObjectReplicationPolicyProperties)
    o.sourceAccount === nothing && (return false)
    o.destinationAccount === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ ObjectReplicationPolicyProperties }, name::Symbol, val)
    if name === Symbol("enabledTime")
        OpenAPI.validate_param(name, "ObjectReplicationPolicyProperties", :format, val, "date-time")
    end
end
