# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""StorageAccountPropertiesUpdateParameters
The parameters used when updating a storage account.

    StorageAccountPropertiesUpdateParameters(;
        customDomain=nothing,
        encryption=nothing,
        accessTier=nothing,
        azureFilesIdentityBasedAuthentication=nothing,
        supportsHttpsTrafficOnly=nothing,
        networkAcls=nothing,
        largeFileSharesState=nothing,
        routingPreference=nothing,
        allowBlobPublicAccess=nothing,
        minimumTlsVersion=nothing,
    )

    - customDomain::CustomDomain
    - encryption::Encryption
    - accessTier::String : Required for storage accounts where kind &#x3D; BlobStorage. The access tier used for billing.
    - azureFilesIdentityBasedAuthentication::AzureFilesIdentityBasedAuthentication
    - supportsHttpsTrafficOnly::Bool : Allows https traffic only to storage service if sets to true.
    - networkAcls::NetworkRuleSet
    - largeFileSharesState::String : Allow large file shares if sets to Enabled. It cannot be disabled once it is enabled.
    - routingPreference::RoutingPreference
    - allowBlobPublicAccess::Bool : Allow or disallow public access to all blobs or containers in the storage account. The default interpretation is true for this property.
    - minimumTlsVersion::String : Set the minimum TLS version to be permitted on requests to storage. The default interpretation is TLS 1.0 for this property.
"""
Base.@kwdef mutable struct StorageAccountPropertiesUpdateParameters <: OpenAPI.APIModel
    customDomain = nothing # spec type: Union{ Nothing, CustomDomain }
    encryption = nothing # spec type: Union{ Nothing, Encryption }
    accessTier::Union{Nothing, String} = nothing
    azureFilesIdentityBasedAuthentication = nothing # spec type: Union{ Nothing, AzureFilesIdentityBasedAuthentication }
    supportsHttpsTrafficOnly::Union{Nothing, Bool} = nothing
    networkAcls = nothing # spec type: Union{ Nothing, NetworkRuleSet }
    largeFileSharesState::Union{Nothing, String} = nothing
    routingPreference = nothing # spec type: Union{ Nothing, RoutingPreference }
    allowBlobPublicAccess::Union{Nothing, Bool} = nothing
    minimumTlsVersion::Union{Nothing, String} = nothing

    function StorageAccountPropertiesUpdateParameters(customDomain, encryption, accessTier, azureFilesIdentityBasedAuthentication, supportsHttpsTrafficOnly, networkAcls, largeFileSharesState, routingPreference, allowBlobPublicAccess, minimumTlsVersion, )
        OpenAPI.validate_property(StorageAccountPropertiesUpdateParameters, Symbol("customDomain"), customDomain)
        OpenAPI.validate_property(StorageAccountPropertiesUpdateParameters, Symbol("encryption"), encryption)
        OpenAPI.validate_property(StorageAccountPropertiesUpdateParameters, Symbol("accessTier"), accessTier)
        OpenAPI.validate_property(StorageAccountPropertiesUpdateParameters, Symbol("azureFilesIdentityBasedAuthentication"), azureFilesIdentityBasedAuthentication)
        OpenAPI.validate_property(StorageAccountPropertiesUpdateParameters, Symbol("supportsHttpsTrafficOnly"), supportsHttpsTrafficOnly)
        OpenAPI.validate_property(StorageAccountPropertiesUpdateParameters, Symbol("networkAcls"), networkAcls)
        OpenAPI.validate_property(StorageAccountPropertiesUpdateParameters, Symbol("largeFileSharesState"), largeFileSharesState)
        OpenAPI.validate_property(StorageAccountPropertiesUpdateParameters, Symbol("routingPreference"), routingPreference)
        OpenAPI.validate_property(StorageAccountPropertiesUpdateParameters, Symbol("allowBlobPublicAccess"), allowBlobPublicAccess)
        OpenAPI.validate_property(StorageAccountPropertiesUpdateParameters, Symbol("minimumTlsVersion"), minimumTlsVersion)
        return new(customDomain, encryption, accessTier, azureFilesIdentityBasedAuthentication, supportsHttpsTrafficOnly, networkAcls, largeFileSharesState, routingPreference, allowBlobPublicAccess, minimumTlsVersion, )
    end
end # type StorageAccountPropertiesUpdateParameters

const _property_types_StorageAccountPropertiesUpdateParameters = Dict{Symbol,String}(Symbol("customDomain")=>"CustomDomain", Symbol("encryption")=>"Encryption", Symbol("accessTier")=>"String", Symbol("azureFilesIdentityBasedAuthentication")=>"AzureFilesIdentityBasedAuthentication", Symbol("supportsHttpsTrafficOnly")=>"Bool", Symbol("networkAcls")=>"NetworkRuleSet", Symbol("largeFileSharesState")=>"String", Symbol("routingPreference")=>"RoutingPreference", Symbol("allowBlobPublicAccess")=>"Bool", Symbol("minimumTlsVersion")=>"String", )
OpenAPI.property_type(::Type{ StorageAccountPropertiesUpdateParameters }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_StorageAccountPropertiesUpdateParameters[name]))}

function check_required(o::StorageAccountPropertiesUpdateParameters)
    true
end

function OpenAPI.validate_property(::Type{ StorageAccountPropertiesUpdateParameters }, name::Symbol, val)
    if name === Symbol("accessTier")
        OpenAPI.validate_param(name, "StorageAccountPropertiesUpdateParameters", :enum, val, ["Hot", "Cool"])
    end
    if name === Symbol("largeFileSharesState")
        OpenAPI.validate_param(name, "StorageAccountPropertiesUpdateParameters", :enum, val, ["Disabled", "Enabled"])
    end
    if name === Symbol("minimumTlsVersion")
        OpenAPI.validate_param(name, "StorageAccountPropertiesUpdateParameters", :enum, val, ["TLS1_0", "TLS1_1", "TLS1_2"])
    end
end
