# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""TagFilter
Blob index tag based filtering for blob objects

    TagFilter(;
        name=nothing,
        op=nothing,
        value=nothing,
    )

    - name::String : This is the filter tag name, it can have 1 - 128 characters
    - op::String : This is the comparison operator which is used for object comparison and filtering. Only &#x3D;&#x3D; (equality operator) is currently supported
    - value::String : This is the filter tag value field used for tag based filtering, it can have 0 - 256 characters
"""
Base.@kwdef mutable struct TagFilter <: OpenAPI.APIModel
    name::Union{Nothing, String} = nothing
    op::Union{Nothing, String} = nothing
    value::Union{Nothing, String} = nothing

    function TagFilter(name, op, value, )
        OpenAPI.validate_property(TagFilter, Symbol("name"), name)
        OpenAPI.validate_property(TagFilter, Symbol("op"), op)
        OpenAPI.validate_property(TagFilter, Symbol("value"), value)
        return new(name, op, value, )
    end
end # type TagFilter

const _property_types_TagFilter = Dict{Symbol,String}(Symbol("name")=>"String", Symbol("op")=>"String", Symbol("value")=>"String", )
OpenAPI.property_type(::Type{ TagFilter }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_TagFilter[name]))}

function check_required(o::TagFilter)
    o.name === nothing && (return false)
    o.op === nothing && (return false)
    o.value === nothing && (return false)
    true
end

function OpenAPI.validate_property(::Type{ TagFilter }, name::Symbol, val)
    if name === Symbol("name")
        OpenAPI.validate_param(name, "TagFilter", :maxLength, val, 128)
        OpenAPI.validate_param(name, "TagFilter", :minLength, val, 1)
    end
    if name === Symbol("value")
        OpenAPI.validate_param(name, "TagFilter", :maxLength, val, 256)
        OpenAPI.validate_param(name, "TagFilter", :minLength, val, 0)
    end
end
