# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.


@doc raw"""Usage
Describes Storage Resource Usage.

    Usage(;
        unit=nothing,
        currentValue=nothing,
        limit=nothing,
        name=nothing,
    )

    - unit::String : Gets the unit of measurement.
    - currentValue::Int64 : Gets the current count of the allocated resources in the subscription.
    - limit::Int64 : Gets the maximum count of the resources that can be allocated in the subscription.
    - name::UsageName
"""
Base.@kwdef mutable struct Usage <: OpenAPI.APIModel
    unit::Union{Nothing, String} = nothing
    currentValue::Union{Nothing, Int64} = nothing
    limit::Union{Nothing, Int64} = nothing
    name = nothing # spec type: Union{ Nothing, UsageName }

    function Usage(unit, currentValue, limit, name, )
        OpenAPI.validate_property(Usage, Symbol("unit"), unit)
        OpenAPI.validate_property(Usage, Symbol("currentValue"), currentValue)
        OpenAPI.validate_property(Usage, Symbol("limit"), limit)
        OpenAPI.validate_property(Usage, Symbol("name"), name)
        return new(unit, currentValue, limit, name, )
    end
end # type Usage

const _property_types_Usage = Dict{Symbol,String}(Symbol("unit")=>"String", Symbol("currentValue")=>"Int64", Symbol("limit")=>"Int64", Symbol("name")=>"UsageName", )
OpenAPI.property_type(::Type{ Usage }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_Usage[name]))}

function check_required(o::Usage)
    true
end

function OpenAPI.validate_property(::Type{ Usage }, name::Symbol, val)
    if name === Symbol("unit")
        OpenAPI.validate_param(name, "Usage", :enum, val, ["Count", "Bytes", "Seconds", "Percent", "CountsPerSecond", "BytesPerSecond"])
    end
    if name === Symbol("currentValue")
        OpenAPI.validate_param(name, "Usage", :format, val, "int32")
    end
    if name === Symbol("limit")
        OpenAPI.validate_param(name, "Usage", :format, val, "int32")
    end
end
